      subroutine acor(ioe,alder,gder,aader,adv)
c
c     ROA tensor derivatives / sum rules - corrected
c
      implicit real*8(a-h,o-z)
      implicit integer*4(i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15,ndm=3,
     1                nortt=500,N30=3*nat0)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nortt  maximum number of orbitals in this routine
c     nel    dimension of the buffer dmo with MO matrix elements
c     nr     something for fitro1
c     ndm    degeneracy of MO's
c
      dimension alder(N30,3,3),gder(N30,3,3),aader(N30,3,3,3)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
c
c      coeff for debugging
       dimension c_d(26,3,122,122)
c
c
      dimension dmo(nel,nortt),t(3,6),wi(nortt,nortt),
     1bu(nortt,nortt,3),grade(3),gradn(3),
     2bq(nortt,nortt,6),bm(nortt,nortt,3),do(nortt,nortt),
     3ud(3),ndeg(nort),jdeg(nort,ndm),temi(nort),temj(nort),
     4buff(nort,nort),bv(nortt,nortt,3),adv(N30,3,3),tg(3),
     5th(3,3),am(3,3),bbm(3,3,3,3),cv(18),bim(18,18),em(3,3,nort),
     6ete(3,3,nort),gm(3,3,nort),einv(18,36),alt(3,3),alr(3,3),
     7al(18),cd(nort,nort),bimi(18,18)
      character*1 strx(3)
      logical ni,loj
      data strx,ione,etol,ctol,w,i6,i3,i2/'X','Y','Z',1,0.0001D0,
     11.0D-5,514.5D0,6,3,2/
c    11.0D-5,6014.5D0,6,3,2/
      loj=.true.
      loj=.false.
      rnoa=dble(noa)
      v=1.0d7/w
      ew=v*4.5563d-6
      write(3,4001)nmo,nori,nao,w,v,ew,ioe,noa
      write(6,4001)nmo,nori,nao,w,v,ew,ioe,noa
4001  format(' A,alpha,G',1H',' derivatives; NMO = ',I3,' NAO = ',I3,
     1' nori = ',I3,
     1/,' Light frequency ',F7.2,'nm = ',F10.2,'cm-1 = ',f10.8,'au.',
     2/,' ioe= ',I3,' noa = ',I3)
      if(nmo.gt.nortt)call report('Too many orbitals for ADER')
c
c     init error functions for nuclear gradient calculation:
      if(ioe.eq.0)call inibe4
c
      if(ioe.ne.0)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(6,*)'J,K read from scratch'
       write(3,*)'J,K read from scratch'
      endif
c
c     calculate degeneracies of all MOs
      do 551 j=1,nmo
      wj=e(j)
      ndeg(j)=0
      do 552 jj=1,nmo
      if(abs(wj-e(jj)).lt.etol)then
       ndeg(j)=ndeg(j)+1
       if(ndeg(j).gt.ndm)call report('Degeneracy > ndm')
       jdeg(j,ndeg(j))=jj
      endif
552   continue
551   continue
c
c     fill energies for the excited states kocc->junocc
      do 55 k=1,ndo
      do 55 j=ndo+1,nmo
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(j))
       do ideg=1,ndeg(j)
        ckj=ckj+aj(k,jdeg(j,ideg))*afac
        ekj=ekj+ak(k,jdeg(j,ideg))*afac
       enddo
      endif
      aex=one
      if(ioe.eq.3)aex=z0
      ejk=e(j)-e(k)-ckj+two*ekj*aex
      write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333  format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1' + 2 x ',F10.6)
      wi(k,j)=-ejk
      if(ejk.lt.etol)then
       write(3,*)k,j,ejk
       write(6,*)k,j,ejk
       call report('Frequency zero or negative')
      endif
55    wi(j,k)=ejk
c
c     MO overlaps:<I|o|J>=cIi*cJj<i|o|j>, 1-15 in MO.SCR
c         r        rr                   0.5xgr(r)     gr(r)    gr(R)
c         x  y  z  xx xy xz yy yz zz    lx ly lz   vx vy vz    ox oy oz
c     k=  1  2  3   4  5  6  7  8  9    10 11 12   13 14 15    16 17 18
c
c     write el.dip, magn dip, grad and quadrupoles to bu,bm,bv and bq
      open(36,file='MO.SCR',form='unformatted',status='old')
      do 42 i=1,nmo
      read(36)((dmo(k,j),k=1,15),j=1,nmo)
      do 42 ix=1,3
      do 42 j=1,nmo
      bu(i,j,ix)=dmo(ix,j)
      bm(i,j,ix)=dmo(ix+9,j)
      bv(i,j,ix)=dmo(ix+12,j)
      bq(i,j,ix)=dmo(ix+3,j)
42    bq(i,j,ix+3)=dmo(ix+6,j)
      close(36)
c
c     check the dipole
      do 302 ix=1,3
      ud(ix)=z0
      do 302 k=1,ndo
302   ud(ix)=ud(ix)-two*bu(k,k,ix)
      write(3,3010)(ud(ix),ix=1,3)
3010  format('Electronic dipole ',3F15.8,' (a.u.)')
c
c     Geometrical center and quadrupole
      i3=3
      call vz(tg,z0,i3)
      call vz(th,z0,i3*i3)
c
      do 1211 lat=1,noa
      do 1211 i=1,3
      tg(i)=tg(i)+xv(i,lat)/rnoa
      th(i,i)=th(i,i)+(xv(1,lat)**2+xv(2,lat)**2+xv(3,lat)**2)/rnoa
      do 1211 j=1,3
1211  th(i,j)=th(i,j)-xv(i,lat)*xv(j,lat)/rnoa
c
      call vz(em,z0,3*3*nort)
      call vz(gm,z0,3*3*nort)
c
c     First loop over atoms, to get the sums over coordinates for unoccupied
      write(3,3011)
      write(6,3011)
3011  format(/,' First loop to get sums over coordinates (e,g)',/)
c
      do 1112 lat=1,noa
c
      do 71 ia=1,3
      write(3,6767)lat,ia
      write(6,6767)lat,ia
c
c     gradient in the AO basis
      call overlagg(lat,ia,buff)
c
c     transform into MO basis and keep them in do
      call taomo(buff,do,cij,nort,nortt,nmo,nao,temi,temj,ctol)
c
c     correct the sign of do
      do 75 i=1,nmo
      do 75 j=1,nmo
75    do(i,j)=-do(i,j)
c
      do 71 ib=1,3
      do 71 n=1,nori
      ete(ia,ib,n)=z0
      do 71 l=1,nori
71    if(ni(n,l,ndo))
     1ete(ia,ib,n)=ete(ia,ib,n)+two*do(l,n)/wi(l,n)*bu(l,n,ib)
c     (ia,ib,n,l)
c
      do 73 ia=1,3
      do 73 ib=1,3
      do 73 n=1,nori
      em(ia,ib,n)=em(ia,ib,n)+ete(ia,ib,n)
      do 73 ic=1,3
      do 73 id=1,3
73    gm(ia,ib,n)=gm(ia,ib,n)+eps(ib,ic,id)*xv(ic,lat)*ete(id,ia,n)
c
1112  continue
c     (lat)
c
      do 74 n=1,nori
      do 74 ia=1,3
      em(ia,ia,n)=em(ia,ia,n)-one
      do 74 ib=1,3
      do 74 ig=1,3
74    gm(ia,ib,n)=gm(ia,ib,n)-eps(ia,ib,ig)*bu(n,n,ig)
c
      write(3,3012)' Second loop'
      write(6,3012)' Second loop'
3012  format(/,(a),/)
c
c     Loop over the atoms:
      do 1212 lat=1,noa
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
c
c     Loop over the nuclear coordinate
      do 1213 ix=1,3
      li=3*(lat-1)+ix
      write(3,6767)lat,ix
      write(6,6767)lat,ix
6767  format(I4,'. atom, ',I1,'. coordinate',/,25(1H-))
c
c     calculate ao integrals (i|grad_lat_ixH|j), keep them in buff
      call overlagg(lat,ix,buff)
c
c     transform into MO basis and keep them in do
      call taomo(buff,do,cij,nort,nortt,nmo,nao,temi,temj,ctol)
c
c     correct the sign of do
      do 76 i=1,nmo
      do 76 j=1,nmo
76    do(i,j)=-do(i,j)
c
c     calculate gradient by the electrostatic theorem
      grade(ix)=z0
      do 8 k=1,ndo
8     grade(ix)=grade(ix)-two*do(k,k)
      gradn(ix)=z0
      do 7 ia=1,noa
      r3=(sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2))**3
7     if(ia.ne.lat)gradn(ix)=gradn(ix)
     1   -z(ia)*z(lat)/r3*(xv(ix,lat)-xv(ix,ia))
c
c     Loop over molecular orbitals
      do 1214 n=1,nori
      if(loj.and.n.gt.ndo)goto 1214
c
c     sub-matrices for the Euler-Lagrange linear equation for |N>
      do 81 ia=1,3
      do 81 ib=ia,3
      sum=z0
      do 80 l=1,nori
80    if(ni(l,n,ndo))sum=sum+bu(n,l,ia)*bu(n,l,ib)
      am(ia,ib)=rnoa*(sum+sum)
81    am(ib,ia)=rnoa*(sum+sum)
c
      do 83 ia=1,3
      do 83 ib=1,3
      do 83 id=1,3
      do 83 ie=1,3
      sum=z0
      do 84 ic=1,3
84    sum=sum+eps(ie,ic,ia)*tg(ic)*am(id,ib)
83    bbm(ia,ib,id,ie)=sum
c
c     assemble big matrix
      ij=0
      do 85 i=1,3
      do 85 j=1,3
      ij=ij+1
      kl=0
      do 85 k=1,3
      do 85 l=1,3
      kl=kl+1
      if(i.eq.k)then
       bim(ij,kl)=am(l,j)
      else
       bim(ij,kl)=z0
      endif
      bim(ij+9,kl+9)=th(j,l)*am(k,i)
      bim(ij,kl+9)=bbm(i,j,k,l)
85    bim(ij+9,kl)=-bbm(j,i,l,k)
c
c     assemble right hand side
      ij=0
      do 86 i=1,3
      do 86 j=1,3
      ij=ij+1
      cv(ij  )=em(i,j,n)
86    cv(ij+9)=gm(i,j,n)
c
      do 87 i=1,18
      do 87 j=i+1,18
      if(abs(bim(i,j)-bim(j,i)).gt.1.0D-5)then
       call wmtr(bim,18,18,'matrix to invert',1)
       write(3,*)i,j,n,bim(i,j),bim(j,i)
       call report('Matrix not symmetric')
      endif
87    continue
c
      i18=18
      call inv(i18,bim,bimi,i18,1.0D-9,einv,ierr)
      do i=1,18
      do j=1,18
      bim(i,j)=bimi(i,j)
      enddo
      enddo
c
      call vz(al,z0,i18)
      if(ierr.gt.0)then
       write(6,*)'matrix cannot be inverted'
       write(3,*)'matrix cannot be inverted'
       call wmtr(bim,18,18,'matrix to invert',1)
      else
       do 61 i=1,18
       do 61 j=1,18
61     al(i)=al(i)+bim(i,j)*cv(j)
      endif
c
      iv=0
      do 62 ia=1,3
      do 62 ib=1,3
      iv=iv+1
      alt(ia,ib)=al(iv)
62    alr(ia,ib)=al(iv+9)
c
c     expansion coeffs: for the atom lat, derivative acc. ix
c
      do 66 l=1,nori
      sum=z0
      if(ni(l,n,ndo))then
       sum=do(n,l)/wi(l,n)
       do 64 ia=1,3
       sum=sum-alt(ix,ia)*bu(n,l,ia)
       do 64 ib=1,3
       do 64 ic=1,3
64     sum=sum-alr(ia,ib)*eps(ib,ic,ix)*xv(ic,lat)*bu(n,l,ia)
      endif
      c_d(lat,ix,n,l)=sum
66    cd(n,l)=sum
c     write(3,*)'orbital ',n,' expanded'
c     do 666 l=1,nori
c666   if(ni(l,n,ndo))write(3,3939)l,cd(n,l),do(n,l)/wi(l,n)
c3939  format(I3,2F10.5)
c
1214  continue
c     (N)
      if(loj)then
       do 661 n=ndo+1,nori
       do 661 l=1,nori
       cd(n,l)=z0
       if(ni(l,n,ndo))then
        cd(n,l)=-cd(l,n)
        c_d(lat,ix,n,l)=-c_d(lat,ix,l,n)
       endif
661    continue
      endif
c
c     alpha
      call ttec(nmo,ndo,nortt,t,i3,ione,bu,bu,ew,wi,do,cd)
      do 10 ia=1,3
      do 10 ib=1,3
10    alder(li,ia,ib)=t(ia,ib)
c
c     velocity alpha
      call ttec(nmo,ndo,nortt,t,i3,i2,bu,bv,ew,wi,do,cd)
      do 12 iax=1,3
      do 12 ia=1,3
      do 12 ib=1,3
12    adv(li,ia,ib)=t(ia,ib)
c
c     Gder
      call ttec(nmo,ndo,nortt,t,i3,i2,bu,bm,ew,wi,do,cd)
      do 11 ia=1,3
      do 11 ib=1,3
11    gder(li,ia,ib)=-t(ia,ib)
c
c     Ader
      call ttec(nmo,ndo,nortt,t,i6,ione,bu,bq,ew,wi,do,cd)
      do 226 ia=1,3
      xx=t(ia,1)
      xy=t(ia,2)
      xz=t(ia,3)
      yy=t(ia,4)
      yz=t(ia,5)
      zz=t(ia,6)
      aader(li,ia,1,1)=half*(two*xx-yy-zz)
      aader(li,ia,1,2)=three*half*xy
      aader(li,ia,2,1)=three*half*xy
      aader(li,ia,1,3)=three*half*xz
      aader(li,ia,3,1)=three*half*xz
      aader(li,ia,2,2)=half*(two*yy-xx-zz)
      aader(li,ia,2,3)=three*half*yz
      aader(li,ia,3,2)=three*half*yz
226   aader(li,ia,3,3)=half*(two*zz-xx-yy)
c
1213  continue
c     ix
c
      write(3,3009)(strx(i),i=1,3),lat,(grade(i),i=1,3),(gradn(i),i=1,3)
     1,grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
3009  format(/,'                       ',3(14x,A1),
     1/,'dE/dR(',I2,'): electronic: ',3F15.8,/,
     2         '              nuclear: ',3F15.8,/,/,
     3         '                total: ',3F15.8,/,/)
c
1212  continue
c     lat
c
      do 888 n=1,nori
      write(3,*)'translation ab:',n
      do 88 ia=1,3
      do 88 ib=1,3
      del=z0
      if(ib.eq.ia)del=one
      sum=0
      do 89 la=1,noa
      do 89 l=1,nori
89    sum=sum+two*c_d(la,ia,n,l)*bu(l,n,ib)
88    write(3,3456)ia,ib,del,sum
3456  format(2I4,2F15.8)
      write(3,*)'rotation ab:',n
      do 881 ia=1,3
      do 881 ib=1,3
      del=z0
      do 882 ic=1,3
882   del=del+eps(ia,ib,ic)*bu(n,n,ic)
      sum=0
      do 891 la=1,noa
      do 891 l=1,nori
      do 891 ic=1,3
      do 891 id=1,3
891   sum=sum+two*eps(ib,ic,id)*xv(ic,la)*c_d(la,id,n,l)*bu(l,n,ia)
881   write(3,3456)ia,ib,del,sum
888   continue
c
      open(2,file='AI.TTT')
      call writettt(3*nat0,noa,alder,aader,gder)
      close(2)
      WRITE(3,*)' ROA tensors written to AI.TTT'
      return
      end
c
c     ===========================================================
      subroutine ttec(nmo,ndo,nortt,t,ny,ih,x,y,w,ws,o,cd)
c
c     derivatives of a second order tensor t with respect to a nuclear coord
c     ih=1 for hermitian y and ih=2 for antihermitian y
c     w - the frequency of the incident light
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      dimension t(3,6),x(nortt,nortt,3),y(nortt,nortt,ny),
     1ws(nortt,nortt),o(nortt,nortt),cd(nortt,nortt)
c
c     ib ... electric dipolar index
c     ic ... y-index
c
      if(ih.ne.1.and.ih.ne.2)call report('check ih in tten')
c
      do 1 ib=1,3
      do 1 ic=1,ny
      sum=0.0d0
c
c     sum over K
      do 4 k=1,ndo
c
c     sum over J
      do 2 j=ndo+1,nmo
      xkj=x(k,j,ib)
      yjk=y(j,k,ic)
      wjn=ws(j,k)
      du=wjn*wjn-w*w
      if(abs(du).lt.1.0d-9)then
       write(3,*)'j = ',j,' k = ',k,w,wjn
       call report('resonance case in tten')
      endif
      if(wjn.lt.1.0d-9)then
       write(3,*)'j = ',j,' k = ',k,wjn
       call report('negative wjn')
      endif
      if(w.gt.wjn)then
       write(3,*)'j = ',j,' k = ',k,w,wjn
       write(3,*)'Excitation freq smaller than light freq.!'
      endif
      if(ih.eq.1)then
       fjn= 2.0d0*wjn/du
       gjn=-2.0d0*(wjn*wjn+w*w)/du/du
      else
       fjn=-2.0d0/du
       gjn=4.0d0*wjn/du/du
      endif
c
      sum=sum+gjn*(o(k,k)-o(j,j))*xkj*yjk
c
c     sum over J'
      do 5 l=ndo+1,nmo
5     sum=sum + fjn*cd(k,l)*(x(l,j,ib)*yjk+xkj*y(j,l,ic))
c
c     sum over K'
      do 6 l=1,ndo
6     sum=sum + fjn*cd(j,l)*(x(l,k,ib)*yjk+xkj*y(l,k,ic))
c
2     continue
c     (J)
4     continue
c     (K)
1     t(ib,ic)=sum+sum
c     ib,ic
      return
      end
c
c  ============================================================
      subroutine taomo(buff,do,cij,nort,nortt,nmo,nao,temi,temj,ctol)
c     transformation of symmetric coef
      implicit real*8(a-h,o-z)
      implicit integer*4(i-n)
      dimension buff(nort,nort),do(nortt,nortt),cij(nort,nort),
     1temi(nort),temj(nort)
      data z0/0.0d0/
c
      if(abs(ctol).gt.0.001d0)call w36('ctol in taomo unusually high!')

      do 91 imo=1,nmo
      do 92 i=1,nao
92    temi(i)=cij(imo,i)
      do 91 jmo=imo,nmo
      do 93 i=1,nao
93    temj(i)=cij(jmo,i)
      sum=z0
      do 94 i=1,nao
      cimoi=temi(i)
      cimoj=temj(i)
      sum=sum+cimoi*cimoj*buff(i,i)
      if(abs(cimoi).gt.ctol)then
       st=z0
       do 95 j=1,i-1
95     st=st+temj(j)*buff(j,i)
       sum=sum+st*cimoi
      endif
      if(abs(cimoj).gt.ctol)then
       st=z0
       do 96 j=1,i-1
96     st=st+temi(j)*buff(j,i)
       sum=sum+st*cimoj
      endif
94    continue
      do(jmo,imo)=sum
91    do(imo,jmo)=sum
      return
      end
c   ============================================================
      function ni(n,l,nd)
      logical ni
      integer*4 n,l,nd
      if((n.le.nd.and.l.gt.nd).or.(n.gt.nd.and.l.le.nd))then
       ni=.true.
      else
       ni=.false.
      endif
      return
      end
