      subroutine ader(ioe,alder,gder,aader,adv)
c
c     ROA tensor derivatives
c
      implicit real*8(a-h,o-z)
      implicit integer*4(i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15,ndm=3,
     1                nortt=500,N30=3*nat0)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nortt  maximum number of orbitals in this routine
c     nel    dimension of the buffer dmo with MO matrix elements
c     nr     something for fitro1
c     ndm    degeneracy of MO's
c
      dimension alder(N30,3,3),gder(N30,3,3),aader(N30,3,3,3)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
c
      common/alocate1/dmo(nel,nortt),wi(nortt,nortt)
      common/alocate2/bq(nortt,nortt,6),bm(nortt,nortt,3)
      common/alocate3/do(nortt,nortt),buff(nort,nort)
      common/alocate4/bv(nortt,nortt,3),bu(nortt,nortt,3)
      dimension grade(3),gradn(3),ud(3),ndeg(nort),jdeg(nort,ndm),
     1temi(nort),temj(nort),adv(N30,3,3),t(3,6)
      character*1 strx(3)
      data strx,ione,etol,ctol,w,i6,i3,i2/'X','Y','Z',1,0.0001D0,
     11.0D-5,514.5D0,6,3,2/
c    11.0D-5,6014.5D0,6,3,2/
c
      v=1.0d7/w
      ew=v*4.5563d-6
      write(3,4001)nmo,nao,w,v,ew,ioe
      write(6,4001)nmo,nao,w,v,ew,ioe
4001  format(' A,alpha,G',1H',' derivatives; NMO = ',I3,' NAO = ',I3,
     1/,' Light frequency ',F7.2,'nm = ',F10.2,'cm-1 = ',f10.8,'au.',
     2/,' ioe= ',I3)
      if(nmo.gt.nortt)call report('Too many orbitals for ADER')
c
c     init error functions for nuclear gradient calculation:
      if(ioe.eq.0)call inibe4
c
      if(ioe.ne.0)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(6,*)'J,K read from scratch'
       write(3,*)'J,K read from scratch'
      endif
c
c     calculate degeneracies of all MOs
      do 551 j=1,nmo
      wj=e(j)
      ndeg(j)=0
      do 552 jj=1,nmo
      if(abs(wj-e(jj)).lt.etol)then
       ndeg(j)=ndeg(j)+1
       if(ndeg(j).gt.ndm)call report('Degeneracy > ndm')
       jdeg(j,ndeg(j))=jj
      endif
552   continue
551   continue
c
c     fill energies for the excited states kocc->junocc
      do 55 k=1,ndo
      do 55 j=ndo+1,nmo
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(j))
       do ideg=1,ndeg(j)
        ckj=ckj+aj(k,jdeg(j,ideg))*afac
        ekj=ekj+ak(k,jdeg(j,ideg))*afac
       enddo
      endif
      aex=one
      if(ioe.eq.3)aex=z0
      ejk=e(j)-e(k)-ckj+two*ekj*aex
      write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333  format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1' + 2 x ',F10.6)
55    wi(k,j)=ejk
c
c     MO overlaps:<I|o|J>=cIi*cJj<i|o|j>, 1-15 in MO.SCR
c         r        rr                   0.5xgr(r)     gr(r)    gr(R)
c         x  y  z  xx xy xz yy yz zz    lx ly lz   vx vy vz    ox oy oz
c     k=  1  2  3   4  5  6  7  8  9    10 11 12   13 14 15    16 17 18
c
c     write el.dip, magn dip, grad and quadrupoles to bu,bm,bv and bq
      open(36,file='MO.SCR',form='unformatted',status='old')
      do 42 i=1,nmo
      read(36)((dmo(k,j),k=1,15),j=1,nmo)
      do 42 ix=1,3
      do 42 j=1,nmo
      bu(i,j,ix)=dmo(ix,j)
      bm(i,j,ix)=dmo(ix+9,j)
      bv(i,j,ix)=dmo(ix+12,j)
      bq(i,j,ix)=dmo(ix+3,j)
42    bq(i,j,ix+3)=dmo(ix+6,j)
      close(36)
c
c     check the dipole
      do 302 ix=1,3
      ud(ix)=z0
      do 302 k=1,ndo
302   ud(ix)=ud(ix)-two*bu(k,k,ix)
      write(3,3010)(ud(ix),ix=1,3)
3010  format('Electronic dipole ',3F15.8,' (a.u.)')
c
c     Loop over the atoms:
      do 1212 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      do 1 ix=1,3
      li=3*(lat-1)+ix
c
c     calculate ao integrals (i|grad_lat_ixH|j), keep them in buff
      call overlagg(lat,ix,buff)
c
c     transform into MO basis and keep them in do
      call taomo(buff,do,cij,nort,nortt,nmo,nao,temi,temj,ctol)
c
c     check the gradient from the electrostatic theorem
      grade(ix)=z0
      do 8 k=1,ndo
8     grade(ix)=grade(ix)+two*do(k,k)
      gradn(ix)=z0
      do 7 ia=1,noa
      r3=(sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2))**3
7     if(ia.ne.lat)gradn(ix)=gradn(ix)
     1   -z(ia)*z(lat)/r3*(xv(ix,lat)-xv(ix,ia))
c
c     alpha
      call tten(nmo,ndo,nortt,t,i3,ione,bu,bu,ew,wi,do)
      do 10 ia=1,3
      do 10 ib=1,3
10    alder(li,ia,ib)=-t(ia,ib)
c
c     velocity alpha
      call tten(nmo,ndo,nortt,t,i3,i2,bu,bv,ew,wi,do)
      do 12 ia=1,3
      do 12 ib=1,3
12    adv(li,ia,ib)=-t(ia,ib)
c
c     Gder
      call tten(nmo,ndo,nortt,t,i3,i2,bu,bm,ew,wi,do)
      do 11 ia=1,3
      do 11 ib=1,3
11    gder(li,ia,ib)=t(ia,ib)
c
c     Ader
      call tten(nmo,ndo,nortt,t,i6,ione,bu,bq,ew,wi,do)
      do 226 ia=1,3
      xx=-t(ia,1)
      xy=-t(ia,2)
      xz=-t(ia,3)
      yy=-t(ia,4)
      yz=-t(ia,5)
      zz=-t(ia,6)
      aader(li,ia,1,1)=half*(two*xx-yy-zz)
      aader(li,ia,1,2)=three*half*xy
      aader(li,ia,2,1)=three*half*xy
      aader(li,ia,1,3)=three*half*xz
      aader(li,ia,3,1)=three*half*xz
      aader(li,ia,2,2)=half*(two*yy-xx-zz)
      aader(li,ia,2,3)=three*half*yz
      aader(li,ia,3,2)=three*half*yz
226   aader(li,ia,3,3)=half*(two*zz-xx-yy)
c
1     continue
c     (ix)
      write(3,3009)(strx(i),i=1,3),lat,(grade(i),i=1,3),(gradn(i),i=1,3)
     1,grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
3009  format(/,'                       ',3(14x,A1),
     1/,'dE/dR(',I2,'): electronic: ',3F15.8,/,
     2         '              nuclear: ',3F15.8,/,/,
     3         '                total: ',3F15.8,/,/)
c
1212  continue
c     (lat)
c
      open(2,file='AI.TTT')
      call writettt(3*nat0,noa,alder,aader,gder)
      close(2)
      WRITE(3,*)' ROA tensors written to AI.TTT'
      return
      end
c
c     ===========================================================
      subroutine tten(nmo,ndo,nortt,t,ny,ih,x,y,w,ws,o)
c
c     derivatives of a second order tensor t with respect to a nuclear coord
c     ih=1 for hermitian y and ih=2 for antihermitian y
c     w - the frequency of the incident light
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      dimension t(3,6),x(nortt,nortt,3),y(nortt,nortt,ny),
     1ws(nortt,nortt),o(nortt,nortt)
c
c     ib ... electric dipolar index
c     ic ... y-index
c
      if(ih.ne.1.and.ih.ne.2)call report('check ih in tten')
c
      do 1 ib=1,3
      do 1 ic=1,ny
      sum=0.0d0
c
c     sum over K
      do 4 k=1,ndo
      okk=o(k,k)
      xkk=x(k,k,ib)
      ykk=y(k,k,ic)
c
c     sum over J
      do 2 j=ndo+1,nmo
      ojj=o(j,j)
      okj=o(k,j)
      xjj=x(j,j,ib)
      xkj=x(k,j,ib)
      yjj=y(j,j,ic)
      yjk=y(j,k,ic)
      wjn=ws(k,j)
      du=wjn*wjn-w*w
      if(abs(du).lt.1.0d-9)then
       write(3,*)'j = ',j,' k = ',k,w,wjn
       call report('resonance case in tten')
      endif
      if(wjn.lt.1.0d-9)then
       write(3,*)'j = ',j,' k = ',k,wjn
       call report('negative wjn')
      endif
      if(w.gt.wjn)then
       write(3,*)'j = ',j,' k = ',k,w,wjn
       write(3,*)'Excitation freq smaller than light freq.!'
      endif
      if(ih.eq.1)then
       fjn= 2.0d0*wjn/du
       gjn=-2.0d0*(wjn*wjn+w*w)/du/du
      else
       fjn=-2.0d0/du
       gjn=4.0d0*wjn/du/du
      endif

      sum=sum-fjn/wjn*okj*( (xkk-xjj)*yjk+xkj*(ykk-yjj))
     2 + gjn*(okk-ojj)*xkj*yjk
c
c     sum over J'<>J
      do 3 jp=ndo+1,nmo
      if(jp.eq.j)goto 3
      wjpn=ws(k,jp)
      dup=wjpn*wjpn-w*w
      if(ih.eq.1)then
       tjj=2.0d0*(wjn*wjpn+w*w)/(du*dup)
      else
       tjj=-2.0d0*(wjpn+wjn)/(du*dup)
c      rem tjj=(fjn-fj'n)/(wj'n-wjn)
      endif
      sum=sum+fjn/wjpn*o(jp,k)*(x(jp,j,ib)*yjk+xkj*y(j,jp,ic))
     2 +tjj*o(jp,j)*x(k,jp,ib)*yjk
3     continue
c     (J')
c
c     sum over K'<>K
      do 5 kp=1,ndo
      if(kp.eq.k)goto 5
      wjpn=ws(kp,j)
      dup=wjpn*wjpn-w*w
      if(ih.eq.1)then
       tjj=2.0d0*(wjn*wjpn+w*w)/(du*dup)
      else
       tjj=-2.0d0*(wjpn+wjn)/(du*dup)
      endif
      sum=sum+fjn/wjpn*o(j,kp)*(x(kp,k,ib)*yjk+xkj*y(k,kp,ic))
     2  +tjj*o(kp,k)*x(kp,j,ib)*yjk
5     continue
c     (K')
c
2     continue
c     (J)
c
4     continue
c     (K)
c
      t(ib,ic)=sum+sum
1     continue
c     ib,ic
      return
      end
