      subroutine aderx(ioe,alder,gder,aader,adv)
c
c     ROA tensor derivatives
c
      implicit real*8(a-h,o-z)
      implicit integer*4(i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15,ndm=3,
     1                nortt=500,N30=3*nat0)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nortt  maximum number of orbitals in this routine
c     nel    dimension of the buffer dmo with MO matrix elements
c     nr     something for fitro1
c     ndm    degeneracy of MO's
c
      dimension alder(N30,3,3),gder(N30,3,3),aader(N30,3,3,3)
      character*2 at
      character*1 ok,ty
      common/ropt/ropt(300)
      equivalence (ropt(1),wexc)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
c
      dimension dmo(nel,nortt),t(3,6),wi(nortt,nortt),
     1bu(nortt,nortt,3),grade(3),gradn(3),
     2bq(nortt,nortt,6),bm(nortt,nortt,3),do(nortt,nortt),
     3ud(3),ndeg(nort),jdeg(nort,ndm),btem(nort,nort),
     4buff(nort,nort),bv(nortt,nortt,3),adv(N30,3,3),
     5bqloc(nortt,nortt,6),bmloc(nortt,nortt,3)
      character*1 strx(3)
      logical lex
      data strx,ione,etol,i6,i3,i2/'X','Y','Z',1,0.0001D0,
     16,3,2/
c
      ew=wexc
      write(3,4001)nmo,nao,ew,ioe
      write(6,4001)nmo,nao,ew,ioe
4001  format(' A,alpha,G',1H',' derivatives; NMO = ',I3,' NAO = ',I3,
     1/,' Light frequency ',F9.6,' au; ioe= ',I3)
c
c     init error functions for nuclear gradient calculation:
      if(ioe.eq.0)call inibe4
c
      if(ioe.ne.0)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(6,*)'J,K read from scratch'
       write(3,*)'J,K read from scratch'
      endif
c
c     calculate degeneracies of all MOs
      do 551 j=1,nmo
      wj=e(j)
      ndeg(j)=0
      do 552 jj=1,nmo
      if(abs(wj-e(jj)).lt.etol)then
       ndeg(j)=ndeg(j)+1
       if(ndeg(j).gt.ndm)call report('Degeneracy > ndm')
       jdeg(j,ndeg(j))=jj
      endif
552   continue
551   continue
c
c     fill energies for the excited states kocc->junocc
      do 55 k=1,ndo
      do 55 j=ndo+1,nmo
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(j))
       do ideg=1,ndeg(j)
        ckj=ckj+aj(k,jdeg(j,ideg))*afac
        ekj=ekj+ak(k,jdeg(j,ideg))*afac
       enddo
      endif
      aex=one
      if(ioe.eq.3)aex=z0
      ejk=e(j)-e(k)-ckj+two*ekj*aex
      write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333  format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1' + 2 x ',F10.6)
55    wi(k,j)=ejk
c
c     MO overlaps:<I|o|J>=cIi*cJj<i|o|j>, 1-15 in MO.SCR
c         r        rr                   0.5xgr(r)     gr(r)    gr(R)
c         x  y  z  xx xy xz yy yz zz    lx ly lz   vx vy vz    ox oy oz
c     k=  1  2  3   4  5  6  7  8  9    10 11 12   13 14 15    16 17 18
c
c     write el.dip, magn dip, grad and quadrupoles to bu,bm,bv and bq
      open(36,file='MO.SCR',form='unformatted',status='old')
      do 42 i=1,nmo
      read(36)((dmo(k,j),k=1,15),j=1,nmo)
      do 42 ix=1,3
      do 42 j=1,nmo
      bu(i,j,ix)=dmo(ix,j)
      bm(i,j,ix)=dmo(ix+9,j)
      bv(i,j,ix)=dmo(ix+12,j)
      bq(i,j,ix)=dmo(ix+3,j)
42    bq(i,j,ix+3)=dmo(ix+6,j)
      close(36)
c
c     check the dipole
      do 302 ix=1,3
      ud(ix)=z0
      do 302 k=1,ndo
302   ud(ix)=ud(ix)-two*bu(k,k,ix)
      write(3,3010)(ud(ix),ix=1,3)
3010  format('Electronic dipole ',3F15.8,' (a.u.)')
c
c     Loop over the atoms:
      do 1212 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
c
c     put m, q into local coord
      do 101 k=1,nmo
      do 101 j=1,nmo
      do 102 ia=1,3
      bmloc(j,k,ia)=bm(j,k,ia)
      do 104 ib=1,3
      do 104 ic=1,3
104   bmloc(j,k,ia)=bmloc(j,k,ia)-eps(ia,ib,ic)*xv(ib,lat)*bv(j,k,ic)/
     12.0d0
102   continue
      ii=0
      do 103 ia=1,3
      do 103 ib=ia,3
      ii=ii+1
      bqloc(j,k,ii)=bq(j,k,ii)-xv(ia,lat)*bu(j,k,ib)
     1-xv(ib,lat)*bu(j,k,ia)
      if(k.eq.j)bqloc(j,k,ii)=bqloc(j,k,ii)+xv(ia,lat)*xv(ib,lat)
103   continue
101   continue
c
      do 1 ix=1,3
      li=3*(lat-1)+ix
c
c     calculate ao integrals (i|grad_lat_ixH|j)in buff
c     transform into MO basis and keep them in do
      call overlagg(lat,ix,buff)
      call taomo2(buff,do,cij,nort,nortt,nmo,nao,btem)
c
c     check the gradient from the electrostatic theorem
      grade(ix)=z0
      do 8 k=1,ndo
8     grade(ix)=grade(ix)+two*do(k,k)
      gradn(ix)=z0
      do 7 ia=1,noa
      r3=(sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2))**3
7     if(ia.ne.lat)gradn(ix)=gradn(ix)
     1   -z(ia)*z(lat)/r3*(xv(ix,lat)-xv(ix,ia))
c
c     alpha
      call tten(nmo,ndo,nortt,t,i3,ione,bu,bu,ew,wi,do)
      do 10 ia=1,3
      do 10 ib=1,3
10    alder(li,ia,ib)=-t(ia,ib)
c
c     velocity alpha
      call tten(nmo,ndo,nortt,t,i3,i2,bu,bv,ew,wi,do)
      do 12 ia=1,3
      do 12 ib=1,3
12    adv(li,ia,ib)=-t(ia,ib)
c
c     Gder
      call tten(nmo,ndo,nortt,t,i3,i2,bu,bmloc,ew,wi,do)
      do 11 ia=1,3
      do 11 ib=1,3
c     last index magnetic
11    gder(li,ia,ib)=t(ia,ib)
c
c     Ader
      call tten(nmo,ndo,nortt,t,i6,ione,bu,bqloc,ew,wi,do)
      do 226 ia=1,3
      xx=-t(ia,1)
      xy=-t(ia,2)
      xz=-t(ia,3)
      yy=-t(ia,4)
      yz=-t(ia,5)
      zz=-t(ia,6)
      aader(li,ia,1,1)=half*(two*xx-yy-zz)
      aader(li,ia,1,2)=three*half*xy
      aader(li,ia,2,1)=three*half*xy
      aader(li,ia,1,3)=three*half*xz
      aader(li,ia,3,1)=three*half*xz
      aader(li,ia,2,2)=half*(two*yy-xx-zz)
      aader(li,ia,2,3)=three*half*yz
      aader(li,ia,3,2)=three*half*yz
226   aader(li,ia,3,3)=half*(two*zz-xx-yy)
c
1     continue
c     (ix)
      write(3,3009)(strx(i),i=1,3),lat,(grade(i),i=1,3),(gradn(i),i=1,3)
     1,grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
3009  format(/,'                       ',3(14x,A1),
     1/,'dE/dR(',I2,'): electronic: ',3F15.8,/,
     2         '              nuclear: ',3F15.8,/,/,
     3         '                total: ',3F15.8,/,/)
c
1212  continue
c     (lat)
c
      open(2,file='LAI.TTT')
      call writetttv(3*nat0,noa,alder,aader,gder,adv)
      close(2)
      write(6,*)'Local ROA tensors written to LAI.TTT'
      write(3,*)'Local ROA tensors written to LAI.TTT'
c
c
      call ttai(N30,alder,adv,aader,gder,noa,2,xv)
      open(2,file='GAI.TTT')
      call writetttv(3*nat0,noa,alder,aader,gder,adv)
      close(2)
      write(6,*)'Global ROA tensors written to GAI.TTT'
      write(3,*)'Global ROA tensors written to GAI.TTT'
c
      inquire(file='ALPHA.TTT',exist=lex)
      if(lex)then
       call altt(N30,3*noa,alder,lex)
       write(6,*)'ALPHA.TTT found and read'
       write(3,*)'ALPHA.TTT found and read'
       call ttai(N30,alder,alder,aader,gder,noa,2,xv)
       open(2,file='NAI.TTT')
       call writetttv(3*nat0,noa,alder,aader,gder,alder)
       close(2)
       write(6,*)'Global ROA tensors with ALPHA.TTT written to NAI.TTT'
       write(3,*)'Global ROA tensors with ALPHA.TTT written to NAI.TTT'
      endif
c
      call report('ADERX finished')
      end
c
