      subroutine aoredcheck
c     check if redundancies are present in AO basis
      implicit none
      integer*4 nat0,nor,nort,nat,nao,nmo,noe,ichm,mtp,
     1ndo,nsa,nsb,noa,nori,nop,ish,i,j,k,l,ielim,ir
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700)
      real*8 escf,cc,alpha,rcp,cij,bij,e,be,
     1cot,s,sp,norm,tol,ropt
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      dimension cot(nort,nort),s(nort,nort),ir(nort)
      common/ropts/ropt(300)
c
      tol=ropt(17)
      write(3,4000)nao,noa,tol
      write(6,4000)nao,noa,tol
4000  format('Redundancy check ',I4,' orbitals read in',I4,' atoms',/,
     1' Tolerance ',g10.3)
c
c     read S-matrix
      open(33,file='SAO.SCR',form='unformatted')
      do 34 i=1,nao
34    read(33)(s(i,j),j=1,i)
      do 35 i=1,nao
      do 35 j=1,i-1
35    s(j,i)=s(i,j)
      close(33)
c
c     make trial MOs:
      do 5 i=1,nao
      do 6 j=1,nao
6     cot(i,j)=0.0d0
      ir(i)=0
5     cot(i,i)=1.0d0
C
      ielim=0
c     orthonormalize
      do 2 i=1,nao

      do 1 j=1,i-1
      if(ir(j).eq.0)then
       sp=0.0d0
       do 3 k=1,i
       do 3 l=1,i
3      sp=sp+cot(i,k)*cot(j,l)*s(k,l)
       do 11 k=1,i
11     cot(i,k)=cot(i,k)-sp*cot(j,k)
      endif
1     continue

      norm=0.0d0
      do 4 k=1,i
      do 4 l=1,i
4     norm=norm+cot(i,k)*cot(i,l)*s(k,l)
      if(norm.gt.tol)then
       write(6,6000)i,norm
       write(3,6000)i,norm
6000   format(' Orbital ',i4,' rest norm ',f12.8)
      else
       ir(i)=1
       ielim=ielim+1
       write(6,6001)i,norm
       write(3,6001)i,norm
6001   format(' Orbital ',i4,' rest norm ',f12.8,'  *** redundant **')
      endif

      do 2 k=1,i
2     cot(i,k)=cot(i,k)/dsqrt(norm)

      write(6,6003)ielim,nao-ielim
      write(3,6003)ielim,nao-ielim
6003  format(i6,' orbitals can be eliminated,',i5,' left')
      call report('Basis check only')
      end
