      subroutine boyso2(ic,IPrint,IOut,TenM6,MaxIt)
c     as boyso, make localized MOs

c     NOrb: Number of orbitals to localize:
c     ic = 0   occupied orbitals only (ndo)
c          1    for all orbitals      (nmo)
c     IPrint = 0 basic
c              1 extended
c     TenM6  convergence threshold
c     MaxIt  maximum number of iterations
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     IOut: Output unit
c     nao    number of atomic orbitals
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,NTT=nort*(nort+1)/2)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/d1009/CCO(nort,nort),CL(nort,nort),DMAO(NTT,3),
     1RIJ(NTT,3),
     1QPIX(nort),QPJX(nort),occ(nort),MOUse(1),IOrd(nort),IIR(nort)
      logical lex
c
      call w36('Starting boyso2')
      inquire(file='LOMOS.SCR',exist=lex)
      if(lex)then
       call w36('LOMS.SCR found on disk, localization skipped')
       return
      endif

c     read dipole moment AOs integrals:
      open(33,file='P.SCR',form='unformatted')
      do 1 i=1,nao
      do 1 ix=1,3
1     read(33)(DMAO(j+(i-1)*i/2,ix),j=1,i)
      close(33)
      call w36('P.SCR read')

      if(ic.eq.0)then
       NOrb=ndo
      else
       NOrb=nmo
      endif
c     Dimension for DMAO:
c     NTT=nort*(nort+1)/2
c     do not use orbital list:
      MOUse(1)=0
c     input orbitals:
      do 3 i=1,NOrb
      do 3 j=1,nao
3     CCO(j,i)=cij(i,j)
c
      call BoyLoc(IOut,IPrint,NOrb,nao,NTT,MOUse,CCO,CL,
     $     nort,DMAO,IOrd,IIR,RIJ,QPIX,QPJX,TenM6,MaxIt)
c
      if(ic.eq.0)then
c      just complete by virtual orbitals:
       do 2 j=ndo+1,nmo
       do 2 i=1,nao
2      CCO(i,j)=cij(j,i)
      endif
c
      call vz(occ,0.0d0,nmo)
      do 4 i=1,ndo
4     occ(i)=2.0d0

      open(89,file='LOMOS.SCR',form='unformatted')
      write(89)nao,nmo
      write(89)(occ(i),i=1,nmo)
      write(89)((CCO(i1,j1),i1=1,nao),j1=1,nmo)
      write(89)(occ(i),i=1,nmo)
      write(89)((CCO(i1,j1),i1=1,nao),j1=1,nmo)
      close(89)
      call w36('LOMOS.SCR has been written')
c
      return
      end
c
c
      Subroutine BoyLoc(IOut,IPrint,NOrb,NBasis,NTT,MOUse,CC,CL,
     $          nort,DMAO,IOrd,IIR,RIJ,QPIX,QPJX,TenM10,MaxIt)
      Implicit Real*8(A-H,O-Z)
      Implicit integer*4 (i-n)
C
c     Bour's changes:
c     implicit integer*4
c     fixed dimensions CC -added argument nort
c
C     Boys Localization.  This is QCPE program 354, as hacked by
C     Michel Dupuis to run in Hondo and then hacked by Mike Frisch to
C     run in Gaussian 82, and then to give reproducable results.
C     Arguments:
C
C     IOut   ... Output unit for messages.
C     IPrint ... 0 for error messages only, 1 for additional print.
C     NOrb   ... Number of orbitals to localize.
C     NBasis ... Number of basis functions.
C     NTT    ... Used for dimensioning (NBasis*(NBasis+1)/2).
C     MOUse  ... List of the NOrb orbitals to actually localize.
C                If MOUse(1)=0, the first NOrb are localized.
C     CC     ... Input and output orbitals (NBasis,).
C     CL     ... Scratch maxtrix (NBasis,NOrb).
C     DMAO   ... Vector of three lower triangular matrices holding
C                matrix elements of the dipole moment operators.
C     IOrd   ... NBasis scratch vector.
C     IIR    ... NBasis scratch vector.
C     RIJ    ... (NTT,3) scratch vector.
C     QPIX   ... NBasis scratch vector.
C     QPJX   ... NBasis scratch vector.
c     TenM10 ... convergence threshold (def 1e-10)
c     MaxIt  ... maximum number of iterations (def 1000)
C
C     Some parameters for a random number generator.
      Parameter (IM=259200,IA=7141,IC=54773)
      Dimension CC(nort,nort), CL(nort,nort),DMAO(NTT,3), MOUse(*),
     $  IOrd(*), IIR(*), RIJ(NTT,3), QPIX(*), QPJX(*)
      Logical UseLst
      Save MaxTry,Zero,TenM6,TenM8,One,Two,Four
      Data MaxTry/3/, Zero/0.0d0/, TenM6/1.d-6/,
     $  TenM8/1.d-8/, One/1.0d0/, Two/2.0d0/,
     $  Four/4.0d0/, Pt5/0.5d0/
      LInd(I,J) = ((Max0(I,J)*(Max0(I,J)-1)/2)+Min0(I,J))
 1000 Format(' BoyLoc:  No rotation increases integrals for I=',I4,
     $       ' J=',I4,' Theta=',D15.8,' Change=',D15.8)
 1040 Format(' Initial Trace=',D15.8,' Initial TraceA=',D15.8)
 1050 Format(' Boys localization failed after',I5,' tries of',I5,
     $       ' iterations each.  Last change=',D15.8)
 1060 Format(' Final Trace=',D15.8,' Final TraceA=',D15.8)
 1070 Format(' Warning from BoyLoc, TracI=',D15.8,' TracF=',D15.8)
 1080 Format(' Largest derivative:  DDelta(',I3,',',I3,')=',D15.8)
 1090 Format(' Warning from BoyLoc, DDelta(',I3,',',I3,')=',D15.8)
C
C     Loop over tries to localize.
C
      UseLst = MOUse(1).ne.0
      RJRan = dble(NBasis-1)*DSqrt(dfloat(IM))+dble(NBasis)
      JRan = int(RJRan+Pt5)
      JRan = Mod(JRan,IM)
      JRan = Mod(JRan*IA+IC,IM)
      Do 950 ITry = 1, MaxTry
C
C     Calculate <I/O/J> for MOs I and J O=X,Y,Z and store in RIJ.
C
      TracI = Zero
      TracIA = Zero
      Do 290 KK = 1, 3
        Do 290 I = 1,NOrb
          II = I
          If(UseLst) II = MOUse(I)
          Do 280 J = 1, I
            JJ = J
            If(UseLst) JJ = MOUse(J)
            Sum = Zero
            Do 260 K = 1, NBasis
              Do 260 L = 1, NBasis
  260           Sum = Sum + CC(K,II)*CC(L,JJ)*
     $            DMAO(LInd(K,L),KK)
  280       RIJ(LInd(I,J),KK) = Sum
          TracIA = TracIA + RIJ(LInd(I,I),KK)**2
  290     TracI = TracI + RIJ(LInd(I,I),KK)
      If(IPrint.gt.0) Write(IOut,1040) TracI, TracIA
      Call AClear(NBasis*NBasis,CL)
      Do 320 I = 1, NOrb
  320   CL(I,I) = One
      Iter = 0
      Shift = ATan(One)
  360 Change = Zero
      Iter = Iter + 1
      Do 380 I = 1, NOrb
  380   IIR(I) = I
      NNN = NOrb
      Do 400 I = 1, NOrb
        JRan = Mod(JRan*IA+IC,IM)
        III = 1+(NNN*JRan)/IM
        IOrd(I) = IIR(III)
        IIR(III) = IIR(NNN)
  400   NNN = NNN - 1
C
C     FOR EACH PAIR OF ORBITALS A TWO DIMENSIONAL UNITARY TRANSFORMATION
C     IS PERFORMED. THE TRANSFORMATION IS  PSI PRIME(I)=
C       COS(T)*PSI(I)+SIN(T)*PSI(J)  AND    PSI PRIME (J)=
C         -SIN(T)PSI(I)+COS(T)PSI(J).
C     THE BOYS METHOD REQUIRES THAT  T BE SUCH AS TO MAXIMIZE
C      THE SUM OF THE SQUARES OF THE ONE CENTER MOLECULAR ORBITAL
C      DIPOLE MOMENT INTEGRALS.
C
      Do 920 III = 1, NOrb
        I = IOrd(III)
        LI = LInd(I,I)
        JM = 1
        RM = Zero
        TM = Zero
        SM = Zero
        CM = One
        Do 580 J = 1, NOrb
          If(I.eq.J) goto 580
          LJ = LInd(J,J)
          IJ = LInd(I,J)
          T = Zero
          TX = Zero
          Do 480 KK = 1, 3
            T = T + Four*RIJ(IJ,KK)**2 - RIJ(LI,KK)**2
     $        - RIJ(LJ,KK)**2
     $        + Two*RIJ(LI,KK)*RIJ(LJ,KK)
  480       TX = TX + RIJ(IJ,KK)*(RIJ(LJ,KK)-RIJ(LI,KK))
          If(Abs(T).le.TenM10.and.Abs(TX).le.TenM10) goto 580
          TX = Four * TX
          T = ATan2(TX,T) / Four
          Sign = One
C         If(T.gt.Zero) Sign = -One
          If(T.gt.TenM10) Sign = -One
          T = T + Sign*Shift
          ITim = 0
  500     S = Sin(T)
          ITim = ITim + 1
          C = Cos(T)
          RIn = Zero
          Do 520 KK = 1, 3
            QPI = C*C*RIJ(LI,KK)+S*S*RIJ(LJ,KK)+Two*C*S*RIJ(IJ,KK)
            QPJ = C*C*RIJ(LJ,KK)+S*S*RIJ(LI,KK)-Two*C*S*RIJ(IJ,KK)
  520       RIn = RIn + QPI*QPI+QPJ*QPJ - RIJ(LI,KK)**2
     $        - RIJ(LJ,KK)**2
          TTest = Abs(T) - Shift
          If(Abs(T).le.TenM8.or.Abs(TTest).lt.TenM8.or.
     $      RIn.ge.(-TenM8)) goto 560
          If(ITim.le.1) goto 540
            If(IPrint.ge.2) Write(IOut,1000) I, J, T, RIn
            Goto 940
  540     Sign = One
          If(T.gt.Zero) Sign = -One
          T = T + Shift*Sign
          Goto 500
  560     If(RIn.le.RM) goto 580
            RM = RIn
            JM = J
            SM = S
            CM = C
            TM = T
  580     Continue
          T = TM
          RIn = RM
          S = SM
          C = CM
          J = JM
          IJ = LInd(I,J)
          LJ = LInd(J,J)
          Change = Change + T*T
          Do 880 KK = 1, 3
            QPI = C*C*RIJ(LI,KK) + S*S*RIJ(LJ,KK)
     $        + Two*C*S*RIJ(IJ,KK)
            QPJ = C*C*RIJ(LJ,KK) + S*S*RIJ(LI,KK)
     $        - Two*C*S*RIJ(IJ,KK)
            QPIJ = (C*C-S*S)*RIJ(IJ,KK) + C*S*(RIJ(LJ,KK)-RIJ(LI,KK))
            Do 720 K = 1, NOrb
              If(I.eq.K.or.J.eq.K) goto 720
              IK = LInd(I,K)
              JK = LInd(J,K)
              QPIX(K) = C*RIJ(IK,KK) + S*RIJ(JK,KK)
              QPJX(K) = C*RIJ(JK,KK) - S*RIJ(IK,KK)
  720         Continue
            Do 860 K = 1, NOrb
              If(I.eq.K.or.J.eq.K) goto 860
              IK = LInd(I,K)
              JK = LInd(J,K)
              RIJ(IK,KK) = QPIX(K)
              RIJ(JK,KK) = QPJX(K)
  860         Continue
            RIn = RIn + QPI + QPJ - RIJ(LI,KK) - RIJ(LJ,KK)
            RIJ(LI,KK) = QPI
            RIJ(LJ,KK) = QPJ
  880       RIJ(IJ,KK) = QPIJ
          Do 900 K = 1, NOrb
            C1 = C*CL(K,I) + S*CL(K,J)
            C2 = -S*CL(K,I) + C*CL(K,J)
            CL(K,I) = C1
  900       CL(K,J) = C2
  920     Continue
C
C     If convergence has not been reached start another series
C     of two center rotations.
C
      Change = Sqrt(Two*Change/dfloat(NOrb*(NOrb-1)))
      If(Iter.gt.MaxIt) goto 940
        If(Iter.ge.1.and.IPrint.gt.0.and.mod(Iter,10).eq.0)
     1  Write(IOut,1010)Iter,Change,TenM10
 1010 Format(' BoyLoc:  Iteration',I5,' Change=',D12.5,' Limit=',D15.3)
        If(Change.ge.TenM10) goto 360
  940 If(IPrint.gt.0) Write(IOut,1020) Iter
 1020 Format(' Localization complete after',I4,' iterations.')
c     Petr Bour's functional change:
c     old:
c     If(Iter.lt.MaxIt.and.Change.le.TenM6) goto 960
c     new:
      If(Iter.lt.MaxIt.and.Change.le.TenM10) goto 960
      If(IPrint.gt.0) Write(IOut,1030)
 1030 Format(' Localization failed.  Restart with new sequence.')
  950 Continue
      Write(IOut,1050) MaxTry, MaxIt, Change
C
C     Localization has been completed.  Transform back to the AO basis.
C
  960 Do 980 I = 1, NOrb
        Call AClear(NBasis,QPIX)
        Do 970 J = 1, NOrb
          JJ = J
          If(UseLst) JJ = MOUse(J)
          Do 970 K = 1, NBasis
  970       QPIX(K) = QPIX(K) + CC(K,JJ)*CL(J,I)
        Call AMove(NBasis,QPIX,CL(1,I))
  980   Continue
      Do 985 I = 1, NOrb
        II = I
        If(UseLst) II = MOUse(I)
        Call AMove(NBasis,CL(1,I),CC(1,II))
  985   Continue
      TracF = Zero
      TracFA = Zero
      Do 990 KK = 1, 3
        Do 990 I = 1, NOrb
          TracFA = TracFA + RIJ(LInd(I,I),KK)**2
  990     TracF = TracF + RIJ(LInd(I,I),KK)
      If(IPrint.gt.0) Write(IOut,1060) TracF, TracFA
      If(Abs(TracI-TracF).gt.TenM8) Write(IOut,1070) TracI, TracF
      DMax = -One
      Do 2000 I = 2, NOrb
        LI = LInd(I,I)
        LimJ = I - 1
        Do 2000 J = 1, LimJ
          LJ = LInd(J,J)
          IJ = LInd(I,J)
          Deriv = Zero
          Do 2001 KK = 1, 3
 2001       Deriv = Deriv + RIJ(IJ,KK)*(RIJ(LI,KK)-RIJ(LJ,KK))
          If(Abs(Deriv).le.DMax) goto 2000
            DMax = Abs(Deriv)
            IMax = I
            JMax = J
 2000     Continue
      DMax = Two*DMax
      If(IPrint.gt.0) Write(IOut,1080) IMax, JMax, DMax
      If(DMax.le.TenM8) Return
      Write(IOut,1090) IMax, JMax, DMax
      Return
      End
c     ******************************
      SUBROUTINE ACLEAR(N,A)
      Implicit Real*8(A-H,O-Z)
      Implicit integer*4 (i-n)
C
C     ROUTINE TO CLEAR N ELEMENTS IN ARRAY A.
C
      DIMENSION A(*)
      Save ZERO
      DATA ZERO/0.0D0/
      IF(N.LT.1) RETURN
      DO 10 I=1,N
   10     A(I)=ZERO
      RETURN
      END
c     **************************
      Subroutine AMove(N,A,B)
      Implicit Real*8(A-H,O-Z)
      Implicit integer*4 (i-n)
C
C     ROUTINE TO MOVE N WORDS FROM A TO B.
C
      DIMENSION A(*),B(*)
      IF(N.LT.1) RETURN
      DO 10 I=1,N
   10     B(I)=A(I)
      RETURN
      END
