      subroutine cigh(no,nhci,n,ist)
c
c     makes CI Hamiltonian, writes it to A.SCR or AT.SCR
c     n .. number of Slater determinants
c     nhci .. number of selected spin states (singlets or triplets)
c     nsg ... number of spin groups of determinants
c     ist=1 writes H into A.SCR
c     ist=3 writes H into AT.SCR
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhci0=140000,nort=700,nh110=2*nort,nhcir=100000,
     1nh0=100,tol=1.0d-10,nii00=8,nii33=1+2*nii00)
      integer*4 nncig
      common/icicom/nncig(nh110),nnci(nhci0,nii33),
     1icie(nhcir),icid(nhcir),icis(nhcir),
     2isis(nhci0),isie(nhci0)
      common/rcicom/cic(nhcir,nh0)
      integer*4 is(nh110),js(nh110)
      dimension h(nhci0),ind(nhci0),
     1h1(nh0,nh0),h2(nh0),h3(nh0)
      logical londisk
c     character*1 ok
c
      write(3,*)'starting cigh, nhci= ',nhci,' n = ',n
      write(6,*)'starting cigh, nhci= ',nhci,' n = ',n
      if(n.gt.nhci0)call report('n>nhci0 in cigh')
      if(nhci.gt.nhcir)call report('nhci>nhcir in cigh')
      ns=2*no
c
      if(ist.eq.1)inquire(file='A.SCR',exist=londisk)
      if(ist.eq.3)inquire(file='AT.SCR',exist=londisk)
      if(londisk)then
       if(ist.eq.1)write(6,*)'A.SCR found on disk'
       if(ist.eq.3)write(6,*)'AT.SCR found on disk'
       return
      endif
c
c     Hamiltonian in spin-adapted functions 1..nhci
      if(ist.eq.1)open(20,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='AT.SCR',form='unformatted')
      write(20)nhci
      write(6,*)'making Hamiltonian in spin-adapted basis'
c
c     number of non-zero elements:
      inz=0
c
c     number of all elements (calculated):
      int=0
      ip0=0
      ii=0
c
c     Loop over ii
c     ii,jj .. spin adapted basis function index
c     id,jd .. determinant index
101   ii=ii+1
      if(ii.gt.nhci)goto 999
      istart=icis(ii)
      nhdimi=icid(ii)
c
c     spin states iistart...iiend consist of determinands istart..(iend)
c     find iiend, iistart
      do 5 iiend=ii,nhci
5     if(icis(iiend).ne.istart)goto 6
      iiend=nhci+1
6     iiend=iiend-1
      do 52 iistart=ii,1,-1
52    if(icis(iistart).ne.istart)goto 62
      iistart=0
62    iistart=iistart+1
c
      ip=ii*100/nhci
      if(ip.gt.ip0+3)then
       ip0=ip
       write(6,*)ip,'%'
      endif
      jj=0
c
c     number of non-zero elements in row ii:
      jt=0
c
c     Loop over jj, record only jj<=ii
102   jj=jj+1
      if(jj.gt.ii)goto 888
      jstart=icis(jj)
      nhdimj=icid(jj)
c
c     spin states jj...jjend consist of determinands jstart..(jend)
c     find jjend and process all states jj..jjend:
c
      do 51 jjend=jj,nhci
51    if(icis(jjend).ne.jstart)goto 61
      jjend=nhci+1
61    jjend=jjend-1
c
c     Form the small Hamiltonian in determinants
      do 1 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 1 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
      call dhsd(hjj,is,js,ns)
1     h1(id,jd)=hjj
c
c     transform into big - only for ii
c     first index
      do 7 jd=1,nhdimj
      s=0.0d0
      do 8 id=1,nhdimi
8     s=s+cic(ii,id)*h1(id,jd)
7     h2(jd)=s
c
c     second index, for one ii and all jj within jj..jjend
      do 9 j1=jj,jjend
      s=0.0d0
      do 10 jd=1,nhdimj
10    s=s+cic(j1,jd)*h2(jd)
9     h3(j1-jj+1)=s
c
c     store it in h and ind
      do 11 j1=jj,jjend
      if(j1.gt.ii)goto 11
      hij=h3(j1-jj+1)
      int=int+1
      if(j1.eq.ii)then
       inz=inz+1
       jt=jt+1
       ind(jt)=j1
       h(jt)=hij*0.5d0
      else
       if(abs(hij).gt.tol)then
        inz=inz+1
        jt=jt+1
        ind(jt)=j1
        h(jt)=hij
       endif
      endif
11    continue
c
      jj=jjend
      goto 102
888   write(20) jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c
c     write(6,*)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c     read(5,'(a)')ok

      goto 101
999   write(6,6009)dble(inz)/real(int)*100.0d0,inz
6009  format(f10.4,'% of non-zero elements (',i10,')')
      close(20)
      return
      end
c     ================================================================
      subroutine dhsd(hsd,is,js,ns)
c     <is|H|js>, between two Slater dets
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nh110=2*nort,noo0=30,noo1=(noo0*(noo0+1))/2,
     1noo5=(noo1*(noo1+1))/2)
      integer*4 is(nh110),js(nh110)
      dimension k(2),isomo(2*nort),isos(2*nort),j(2),
     1ist(2*nort)
      integer*4 slateri(nh110),slaterj(nh110),it
      logical lconfig
      common/hsdcom/noa,lconfig,hkin(nort,nort),hpot(nort,nort),
     1bkin(nort,nort),bpot(nort,nort),aj(nort,nort),ak(nort,nort)
      common/mp2II/Aabcd(noo5)
c     character*1 ok
c
      hsd=0.0d0
      idif=0
c
c     determine how many orbitals are different and made
c     Slater determinant for each configuration
      is1=0
      js1=0
      do 1 i=1,ns
      if(is(i).ne.0)then
       is1=is1+1
       slateri(is1)=i
      endif
      if(js(i).ne.0)then
       js1=js1+1
       slaterj(js1)=i
      endif
      if(is(i).ne.js(i))then
       idif=idif+1
       if(idif.gt.4)return
      endif
1     continue
c
      if(js1.ne.is1)call report('is1<>js1')
c
c     determine sign of Hamiltonian element from Slater determinants
      kd=0
      sign=1.0d0
      ie=0
6     ie=ie+1
      kk=slateri(ie)
      je=0
4     je=je+1
      if(kk.eq.slaterj(je))then
c      put same orbital in j on the same place
       if(je.ne.ie)then
        sign=-sign
        it=slaterj(ie)
        slaterj(ie)=slaterj(je)
        slaterj(je)=it
       endif
       if(ie.lt.is1)goto 6
       goto 61
      else
       if(je.lt.js1)goto 4
      endif
c     this orbital k is not in j, put it in k
      kd=kd+1
      k(kd)=kk
      if(ie.lt.is1)goto 6
c
61    jd=0
      do 5 ie=1,is1
      if(slateri(ie).ne.slaterj(ie))then
       jd=jd+1
       j(jd)=slaterj(ie)
      endif
5     continue
c
c     write(6,6001)(is(i),i=1,ns)
c     write(6,6001)(js(i),i=1,ns)
c6001  format(26(i2,i1))
c     write(6,6002)(slateri(i),i=1,is1)
c     write(6,6002)(slaterj(i),i=1,js1)
c     write(6,6002)(k(i),i=1,kd)
c     write(6,6002)(j(i),i=1,jd)
c6002  format(26i3)
c     read(5,'(a)')ok
c
      if(jd.ne.kd)call report('jd<>kd')
c
      goto(10,20)jd
c
c     same determinants (jd=0)
c     put occupied orbitals into isomo
      imo=0
      do 2 i=1,ns
      if(is(i).ne.0)then
       imo=imo+1
       isomo(imo)=(i+1)/2
       ist(imo)=(i+1)/2
       isos(imo)=is(i)
      endif
2     continue
      nsorb=imo
      call rehf(hsd,noa,en,et,ev,ej,ek,lconfig,hkin,hpot,bkin,
     1bpot,nsorb,isomo,isos,ist,aj,ak)
      return
c
c     mp1 expression,jd=kd=1 (1 spinorbital difference)
c     <k|Hc|j> + (i<>k,j) (jk|ii)-(ji|ki)
10    if(is(k(1)).ne.js(j(1)))call report('change of spin not allowed')
      k1=(k(1)+1)/2
      j1=(j(1)+1)/2
      hsd=hkin(k1,j1)+hpot(k1,j1)
      do 3 i=1,ns
      isp=is(i)
      if(isp.ne.0.and.isp.eq.js(i))then
       io=(i+1)/2
       if(k1.le.j1)then
        i1=k1+j1*(j1-1)/2
       else
        i1=j1+k1*(k1-1)/2
       endif
       i2=io+io*(io-1)/2
       if(i2.le.i1)then
        it=i2+i1*(i1-1)/2
       else
        it=i1+i2*(i2-1)/2
       endif
       hsd=hsd+Aabcd(it)
       if(isp.eq.js(j(1)))then
        if(k1.le.io)then
         i1=k1+io*(io-1)/2
        else
         i1=io+k1*(k1-1)/2
        endif
        if(j1.le.io)then
         i2=j1+io*(io-1)/2
        else
         i2=io+j1*(j1-1)/2
        endif
        if(i2.le.i1)then
         it=i2+i1*(i1-1)/2
        else
         it=i1+i2*(i2-1)/2
        endif
        hsd=hsd-Aabcd(it)
       endif
      endif
3     continue
c
      hsd=hsd*sign
      return
c
c     single integral,jd=kd=2, 2 spinrobital differences
c     (k1j1|k2j2)-(k1j2|k2j1)
20    k1=(k(1)+1)/2
      k2=(k(2)+1)/2
      j1=(j(1)+1)/2
      j2=(j(2)+1)/2
      if(is(k(1)).eq.js(j(1)).and.is(k(2)).eq.js(j(2)))then
       if(k1.le.j1)then
        i1=k1+j1*(j1-1)/2
       else
        i1=j1+k1*(k1-1)/2
       endif
       if(k2.le.j2)then
        i2=k2+j2*(j2-1)/2
       else
        i2=j2+k2*(k2-1)/2
       endif
       if(i2.le.i1)then
        it=i2+i1*(i1-1)/2
       else
        it=i1+i2*(i2-1)/2
       endif
       hsd=hsd+Aabcd(it)
      endif
      if(is(k(1)).eq.js(j(2)).and.is(k(2)).eq.js(j(1)))then
       if(k1.le.j2)then
        i1=k1+j2*(j2-1)/2
       else
        i1=j2+k1*(k1-1)/2
       endif
       if(j1.le.k2)then
        i2=j1+k2*(k2-1)/2
       else
        i2=k2+j1*(j1-1)/2
       endif
       if(i2.le.i1)then
        it=i2+i1*(i1-1)/2
       else
        it=i1+i2*(i2-1)/2
       endif
       hsd=hsd-Aabcd(it)
      endif
      hsd=hsd*sign
      return
      end
