      subroutine cighd(no,nhci,n,ist)
c
c     analogous to cigh, but works with batches of integrals (KJ|LM)
c
c     makes CI Hamiltonian, writes it to A.SCR(singlets) or AT.SCR(triplets)
c     n .. number of Slater determinants
c     nhci .. number of selected spin states (singlets or triplets)
c     nsg ... number of spin groups of determinants
c     ist=1 ... write it to A.SCR
c     ist=3 ... write it to AT.SCR
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhci0=140000,nort=700,nh110=2*nort,nhcir=100000,
     1nh0=100,tol=1.0d-10,nii00=8,nii33=1+2*nii00)
      integer*4 nncig
      common/icicom/nncig(nh110),nnci(nhci0,nii33),
     1icie(nhcir),icid(nhcir),icis(nhcir),
     2isis(nhci0),isie(nhci0)
      common/rcicom/cic(nhcir,nh0)
      integer*4 is(nh110),js(nh110)
      dimension h(nhci0),ind(nhci0),
     1h1(nh0,nh0),h2(nh0),h3(nh0)
      logical londisk
c     character*1 ok
c
c     ***************** DEBUG
      open(99,file='DEBUG.SCR')
      write(3,*)'starting cighd, nhci= ',nhci,' n = ',n
      write(6,*)'starting cighd, nhci= ',nhci,' n = ',n
      if(n.gt.nhci0)call report('n>nhci0 in cigh')
      if(nhci.gt.nhcir)call report('nhci>nhcir in cigh')
      ns=2*no
c
      write(6,*)'cighd: making Hamiltonian in spin-adapted basis'
      if(ist.eq.1)inquire(file='A.SCR',exist=londisk)
      if(ist.eq.3)inquire(file='AT.SCR',exist=londisk)
      if(ist.eq.1)open(20,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='AT.SCR',form='unformatted')
      ifo=0
      if(londisk)then
       if(ist.eq.1)write(6,*)'A.SCR found on disk'
       if(ist.eq.3)write(6,*)'AT.SCR found on disk'
       read(20,err=222,end=222)nfo
       if(nfo.ne.nhci)call report('wrong dimension')
       ifo=ifo+1
120    read(20,err=222,end=222)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
       ifo=ifo+1
       goto 120
222    write(6,*)ifo,' lines found'
       ifo=ifo-1
       if(ifo.lt.0)ifo=0
       rewind 20
       do 223 ioo=1,ifo
223    read(20)
      endif
c
c     Hamiltonian in spin-adapted functions 1..nhci
      if(ifo.eq.0)then
       write(20)nhci
       ifo=ifo+1
      endif
c
c     number of non-zero elements:
      inz=0
c
c     number of all elements (calculated):
      int=0
      ip0=ifo*100/nhci
      ip=0
      write(6,*)ip0,'%'
      ii=ifo-1
      itotal0=mclock()
      iload=0
      ical=0
c
c     Loop over ii
c     ii,jj .. spin adapted basis function index
c     id,jd .. determinant index
101   ii=ii+1
      if(ii.gt.nhci)goto 999
c
      open(56,file='cighd.progress')
      write(56,*)ii,' line of ',nhci
      write(56,6888)ip,iload,ical,mclock()-itotal0
      close(56)
c
      istart=icis(ii)
      nhdimi=icid(ii)
c
c     spin states iistart...iiend consist of determinands istart..(iend)
c     find iiend, iistart
      do 5 iiend=ii,nhci
5     if(icis(iiend).ne.istart)goto 6
      iiend=nhci+1
6     iiend=iiend-1
      do 52 iistart=ii,1,-1
52    if(icis(iistart).ne.istart)goto 62
      iistart=0
62    iistart=iistart+1
c
      ip=ii*100/nhci
      if(ip.gt.ip0+3)then
       ip0=ip
       write(6,6888)ip,iload,ical,mclock()-itotal0
6888   format(i3,'%, times load cal total:',3i10)
      endif
c
c     =========================================================================
c     in the first loop over jj just gather integrals needed for line ii:
c     =========================================================================
      iint=0
      jj=0
1021  jj=jj+1
      if(jj.gt.ii)goto 8881
      jstart=icis(jj)
      nhdimj=icid(jj)
      do 51 jjend=jj,nhci
51    if(icis(jjend).ne.jstart)goto 61
      jjend=nhci+1
61    jjend=jjend-1
      do 11 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 11 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
11    call dhsg(iint,is,js,ns)
      jj=jjend
      goto 1021
8881  continue
c     =========================================================================
c     load the integrals
      il0=mclock()
      if(iint.gt.0)call dhsl(iint,no)
      iload=iload+mclock()-il0
c      do i=1,iint
c       write(6,6008)i,j9(i),k9(i),l9(i),m9(i),a9(i)
c6008   format(i4,4i3,f10.6)
c      enddo
c     read(5,*)oo
c     =========================================================================
c     in the second loop over jj make the elements
c     =========================================================================
      jj=0
c
c     number of non-zero elements in row ii:
      jt=0
c
c     Loop over jj, record only jj<=ii
102   jj=jj+1
      if(jj.gt.ii)goto 888
      jstart=icis(jj)
      nhdimj=icid(jj)
c
c     spin states jj...jjend consist of determinands jstart..(jend)
c     find jjend and process all states jj..jjend:
c
      do 512 jjend=jj,nhci
512   if(icis(jjend).ne.jstart)goto 612
      jjend=nhci+1
612   jjend=jjend-1
c
c     Form the small Hamiltonian in determinants
      do 1 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 1 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
      il0=mclock()
      call dhsdg(hjj,is,js,ns,iint)
      ical=ical+mclock()-il0
1     h1(id,jd)=hjj
c
c     transform into big - only for ii
c     first index
      do 7 jd=1,nhdimj
      s=0.0d0
      do 8 id=1,nhdimi
8     s=s+cic(ii,id)*h1(id,jd)
7     h2(jd)=s
c
c     second index, for one ii and all jj within jj..jjend
      do 9 j1=jj,jjend
      s=0.0d0
      do 10 jd=1,nhdimj
10    s=s+cic(j1,jd)*h2(jd)
9     h3(j1-jj+1)=s
c
c     store it in h and ind
      do 111 j1=jj,jjend
      if(j1.gt.ii)goto 111
      hij=h3(j1-jj+1)
      int=int+1
      if(j1.eq.ii)then
       inz=inz+1
       jt=jt+1
       ind(jt)=j1
       h(jt)=hij*0.5d0
      else
       if(abs(hij).gt.tol)then
        inz=inz+1
        jt=jt+1
        ind(jt)=j1
        h(jt)=hij
       endif
      endif
111   continue
c
      jj=jjend
      goto 102
888   write(20) jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c
c     write(6,*)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c     read(5,'(a)')ok

      goto 101
999   write(6,6009)dble(inz)/(real(int)+0.1)*100.0d0,inz
6009  format(f10.4,'% of non-zero elements (',i10,')')
      close(20)
      close(99)
      return
      end
c     ================================================================
      subroutine dhsdg(hsd,is,js,ns,iint)
c     <is|H|js>, between two Slater dets
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nh110=2*nort)
      integer*4 is(nh110),js(nh110)
      dimension k(2),isomo(2*nort),isos(2*nort),j(2),
     1ist(2*nort)
      integer*4 slateri(nh110),slaterj(nh110)
      logical lconfig
      common/hsdcom/noa,lconfig,hkin(nort,nort),hpot(nort,nort),
     1bkin(nort,nort),bpot(nort,nort),aj(nort,nort),ak(nort,nort)
c     character*1 ok
c
      hsd=0.0d0
      idif=0
c
c     determine how many orbitals are different and made
c     Slater determinant for each configuration
      is1=0
      js1=0
      do 1 i=1,ns
      if(is(i).ne.0)then
       is1=is1+1
       slateri(is1)=i
      endif
      if(js(i).ne.0)then
       js1=js1+1
       slaterj(js1)=i
      endif
      if(is(i).ne.js(i))then
       idif=idif+1
       if(idif.gt.4)return
      endif
1     continue
c
      if(js1.ne.is1)call report('is1<>js1')
c
c     determine sign of Hamiltonian element from Slater determinants
      kd=0
      sign=1.0d0
      ie=0
6     ie=ie+1
      kk=slateri(ie)
      je=0
4     je=je+1
      if(kk.eq.slaterj(je))then
c      put same orbital in j on the same place
       if(je.ne.ie)then
        sign=-sign
        it=slaterj(ie)
        slaterj(ie)=slaterj(je)
        slaterj(je)=it
       endif
       if(ie.lt.is1)goto 6
       goto 61
      else
       if(je.lt.js1)goto 4
      endif
c     this orbital k is not in j, put it in k
      kd=kd+1
      k(kd)=kk
      if(ie.lt.is1)goto 6
c
61    jd=0
      do 5 ie=1,is1
      if(slateri(ie).ne.slaterj(ie))then
       jd=jd+1
       j(jd)=slaterj(ie)
      endif
5     continue
      if(jd.ne.kd)call report('jd<>kd')
c
      goto(10,20)jd
c
c     same determinants (jd=0)
c     put occupied orbitals into isomo
      imo=0
      do 2 i=1,ns
      if(is(i).ne.0)then
       imo=imo+1
       isomo(imo)=(i+1)/2
       ist(imo)=(i+1)/2
       isos(imo)=is(i)
      endif
2     continue
      nsorb=imo
      call rehf(hsd,noa,en,et,ev,ej,ek,lconfig,hkin,hpot,bkin,
     1bpot,nsorb,isomo,isos,ist,aj,ak)
      return
c
c     mp1 expression,jd=kd=1 (1 spinorbital difference)
c     <k|Hc|j> + (i<>k,j) (jk|ii)-(ji|ki)
10    if(is(k(1)).ne.js(j(1)))then
       call report('change of spin not allowed dhsdg')
       write(6,6001)(is(i),i=1,ns)
       write(6,6001)(js(i),i=1,ns)
6001   format(26(i2,i1))
       write(6,6002)(slateri(i),i=1,is1)
       write(6,6002)(slaterj(i),i=1,js1)
       write(6,6002)(k(i),i=1,kd)
       write(6,6002)(j(i),i=1,jd)
6002   format(26i3)
      endif
c
      k1=(k(1)+1)/2
      j1=(j(1)+1)/2
      hsd=hkin(k1,j1)+hpot(k1,j1)
      do 3 i=1,ns
      isp=is(i)
      if(isp.ne.0.and.isp.eq.js(i))then
       io=(i+1)/2
c      find the integrals in the common batch
       hsd=hsd+Aabcdcb(k1,j1,io,io,iint)
       if(isp.eq.js(j(1)))hsd=hsd-Aabcdcb(k1,io,j1,io,iint)
      endif
3     continue
c
      hsd=hsd*sign
      return
c
c     single integral,jd=kd=2, 2 spinrobital differences
c     (k1j1|k2j2)-(k1j2|k2j1)
20    k1=(k(1)+1)/2
      k2=(k(2)+1)/2
      j1=(j(1)+1)/2
      j2=(j(2)+1)/2
      if(is(k(1)).eq.js(j(1)).and.is(k(2)).eq.js(j(2)))then
       hsd=hsd+Aabcdcb(k1,j1,k2,j2,iint)
      endif
      if(is(k(1)).eq.js(j(2)).and.is(k(2)).eq.js(j(1)))then
       hsd=hsd-Aabcdcb(k1,j2,j1,k2,iint)
      endif
      hsd=hsd*sign
      return
      end
c     ================================================================
      subroutine dhsg(iint,is,js,ns)
c     <is|H|js>, between two Slater dets, just gather int indices
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nh110=2*nort)
      integer*4 is(nh110),js(nh110)
      dimension k(2),j(2)
      integer*4 slateri(nh110),slaterj(nh110)
c
      idif=0
c
c     determine how many orbitals are different and made
c     Slater determinant for each configuration
      is1=0
      js1=0
      do 1 i=1,ns
      if(is(i).ne.0)then
       is1=is1+1
       slateri(is1)=i
      endif
      if(js(i).ne.0)then
       js1=js1+1
       slaterj(js1)=i
      endif
      if(is(i).ne.js(i))then
       idif=idif+1
       if(idif.gt.4)return
      endif
1     continue
c
c     check that # of electrons is same
      if(js1.ne.is1)call report('is1<>js1')
c
c     determine sign of Hamiltonian element from Slater determinants
      kd=0
      sign=1.0d0
      ie=0
6     ie=ie+1
      kk=slateri(ie)
      je=0
4     je=je+1
      if(kk.eq.slaterj(je))then
c      put same orbital in j on the same place
       if(je.ne.ie)then
        sign=-sign
        it=slaterj(ie)
        slaterj(ie)=slaterj(je)
        slaterj(je)=it
       endif
       if(ie.lt.is1)goto 6
       goto 61
      else
       if(je.lt.js1)goto 4
      endif
c     this orbital k is not in j, put it in k
      kd=kd+1
      k(kd)=kk
      if(ie.lt.is1)goto 6
c
61    jd=0
      do 5 ie=1,is1
      if(slateri(ie).ne.slaterj(ie))then
       jd=jd+1
       j(jd)=slaterj(ie)
      endif
5     continue
      if(jd.ne.kd)call report('jd<>kd')
c
      goto(10,20)jd
c
c     same determinants (jd=0), from aj,ak, int not needed
      return
c
c     mp1 expression,jd=kd=1 (1 spinorbital difference)
c     <k|Hc|j> + (i<>k,j) (jk|ii)-(ji|ki)
10    if(is(k(1)).ne.js(j(1)))then
       write(6,6001)(is(i),i=1,ns)
       write(6,6001)(js(i),i=1,ns)
6001   format(26(i2,i1))
       write(6,6002)(slateri(i),i=1,is1)
       write(6,6002)(slaterj(i),i=1,js1)
       write(6,6002)(k(i),i=1,kd)
       write(6,6002)(j(i),i=1,jd)
6002   format(26i3)
       call report('change of spin dhsg')
      endif
      k1=(k(1)+1)/2
      j1=(j(1)+1)/2
      do 3 i=1,ns
      isp=is(i)
      if(isp.ne.0.and.isp.eq.js(i))then
       io=(i+1)/2
       call addi(k1,j1,io,io,iint)
       if(isp.eq.js(j(1)))call addi(k1,io,j1,io,iint)
      endif
3     continue
      return
c
c     single integral,jd=kd=2, 2 spinrobital differences
c     (k1j1|k2j2)-(k1j2|k2j1)
20    k1=(k(1)+1)/2
      k2=(k(2)+1)/2
      j1=(j(1)+1)/2
      j2=(j(2)+1)/2
      if(is(k(1)).eq.js(j(1)).and.is(k(2)).eq.js(j(2)))
     1call addi(k1,j1,k2,j2,iint)
      if(is(k(1)).eq.js(j(2)).and.is(k(2)).eq.js(j(1)))
     1call addi(k1,j2,k2,j1,iint)
      return
      end
c     =======================================
      subroutine addi(j1,j2,j3,j4,iint)
c     add (ab|cd) in the list
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
c
c     take (j1 j2 | j3 j4)
c     and make same as (ia ib | ic id), ia<=ib, ic<=id, (ia,ib)<=(ic,id)
      ia=j1
      ib=j2
      ic=j3
      id=j4
      if(ib.lt.ia)call swi(ia,ib)
      i1=ia+ib*(ib-1)/2
      if(id.lt.ic)call swi(ic,id)
      i2=ic+id*(id-1)/2
      if(i2.lt.i1)then
       call swi(ia,ic)
       call swi(ib,id)
      endif
c
c     define (jkl) index for easier identification:
      jkl=ia+ib*(ib-1)/2+(ic-1)*(id*(id-1)+ic)/2
c
c     find, if already in the list:
      do 1 i=iint,1,-1
1     if(jkl.eq.i88(i).and.id.eq.m9(i))return
c
c     not foudn in the list, so add it there:
      iint=iint+1
      if(iint.gt.nhcir)call report('iint > nhcir in addi')
      j9(iint)=ia
      k9(iint)=ib
      l9(iint)=ic
      m9(iint)=id
      i88(iint)=jkl
      return
      end
c     =======================================================
      function Aabcdcb(i,j,k,l,iint)
c     find integral (ij|kl) in common batch
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000,nort=700)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      common/jklmapp/nds(nort),nde(nort)
c
      if(i.lt.j)then
       ia=i
       ib=j
      else
       ia=j
       ib=i
      endif
      i1=ia+ib*(ib-1)/2
      if(k.lt.l)then
       ic=k
       id=l
      else
       ic=l
       id=k
      endif
      i2=ic+id*(id-1)/2
      if(i2.lt.i1)then
       call swi(ia,ic)
       call swi(ib,id)
      endif
      jkl=ia+ib*(ib-1)/2+(ic-1)*(id*(id-1)+ic)/2
      if(nds(id).eq.0)goto 2
      do 1 m=nds(id),nde(id)
      if(jkl.eq.i88(m))then
       Aabcdcb=a9(m)
       return
      endif
1     continue
2     do iw=1,iint
       write(6,6000)iw,j9(iw),k9(iw),l9(iw),m9(iw),i88(iw),
     1 nds(l9(iw)),nde(l9(iw))
6000   format(i10,4i6,i20/2i5)
      enddo
      write(6,6004)i,j,k,l,iint
      write(6,6005)ia,ib,ic,id,jkl
6004  format('(',4i5,')',/,' iint = ',i20)
6005  format('(',4i5,')',/,' jkl  = ',i20)
      call report('integral not found in Aabcd')
      end
