      subroutine cighd1(no,nhci,n,ist)
c
c     analogous to cigh, but works with batches of integrals (KJ|LM)
c     analogous to cighd, but makes MOs from AOs
c
c     makes CI Hamiltonian, writes it to A.SCR(singlets) or AT.SCR(triplets)
c     n .. number of Slater determinants
c     nhci .. number of selected spin states (singlets or triplets)
c     nsg ... number of spin groups of determinants
c     ist=1 ... write it to A.SCR
c     ist=3 ... write it to AT.SCR
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhci0=140000,nort=700,nh110=2*nort,nhcir=100000,
     1nh0=100,tol=1.0d-10,nii00=8,nii33=1+2*nii00)
      integer*4 nncig
      common/icicom/nncig(nh110),nnci(nhci0,nii33),
     1icie(nhcir),icid(nhcir),icis(nhcir),
     2isis(nhci0),isie(nhci0)
      common/rcicom/cic(nhcir,nh0)
      integer*4 is(nh110),js(nh110)
      dimension h(nhci0),ind(nhci0),
     1h1(nh0,nh0),h2(nh0),h3(nh0)
      logical londisk
c     character*1 ok
c
c     ***************** DEBUG
      open(99,file='DEBUG.SCR')
      write(3,*)'starting cighd1, nhci= ',nhci,' n = ',n
      write(6,*)'starting cighd1, nhci= ',nhci,' n = ',n
      if(n.gt.nhci0)call report('n>nhci0 in cigh')
      if(nhci.gt.nhcir)call report('nhci>nhcir in cigh')
      ns=2*no
c
      write(6,*)'cighd1: making Hamiltonian in spin-adapted basis'
      if(ist.eq.1)inquire(file='A.SCR',exist=londisk)
      if(ist.eq.3)inquire(file='AT.SCR',exist=londisk)
      if(ist.eq.1)open(20,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='AT.SCR',form='unformatted')
      ifo=0
      if(londisk)then
       if(ist.eq.1)write(6,*)'A.SCR found on disk'
       if(ist.eq.3)write(6,*)'AT.SCR found on disk'
       read(20,err=222,end=222)nfo
       if(nfo.ne.nhci)call report('wrong dimension')
       ifo=ifo+1
120    read(20,err=222,end=222)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
       ifo=ifo+1
       goto 120
222    write(6,*)ifo,' lines found'
       rewind 20
       do 223 ioo=1,ifo
223    read(20)
      endif
c
c     Hamiltonian in spin-adapted functions 1..nhci
      if(ifo.eq.0)then
       write(20)nhci
       ifo=ifo+1
      endif
c
c     number of non-zero elements:
      inz=0
c
c     number of all elements (calculated):
      int=0
      ip0=ifo*100/nhci
      ip=0
      write(6,*)ip0,'%'
      ii=ifo-1
      itotal0=mclock()
      iload=0
      ical=0
      nint=0
c
c     Loop over ii
c     ii,jj .. spin adapted basis function index
c     id,jd .. determinant index
101   ii=ii+1
      if(ii.gt.nhci)goto 999
c
      open(56,file='cighd1.progress')
      write(56,*)ii,' line of ',nhci
      write(56,6888)ip,iload,ical,mclock()-itotal0
      close(56)
c
      istart=icis(ii)
      nhdimi=icid(ii)
c
c     spin states iistart...iiend consist of determinands istart..(iend)
c     find iiend, iistart
      do 5 iiend=ii,nhci
5     if(icis(iiend).ne.istart)goto 6
      iiend=nhci+1
6     iiend=iiend-1
      do 52 iistart=ii,1,-1
52    if(icis(iistart).ne.istart)goto 62
      iistart=0
62    iistart=iistart+1
c
      ip=ii*100/nhci
      if(ip.gt.ip0+3)then
       ip0=ip
       write(6,6888)ip,iload,ical,mclock()-itotal0
6888   format(i3,'%, times load cal total:',3i10)
      endif
c
c     =========================================================================
c     in the first loop over jj just gather integrals needed for line ii:
c     =========================================================================
c
c     integrals 1..nint remain from the last line,
c     initialize the jklm0 common 000000
      call iniz(nint)
      nintp=nint
c
      jj=0
1021  jj=jj+1
      if(jj.gt.ii)goto 8881
      jstart=icis(jj)
      nhdimj=icid(jj)
      do 51 jjend=jj,nhci
51    if(icis(jjend).ne.jstart)goto 61
      jjend=nhci+1
61    jjend=jjend-1
      do 11 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 11 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
11    call dhsg1(is,js,ns,nintp)
      jj=jjend
      goto 1021
8881  continue
c     =========================================================================
c     delete unused integrals marked by zeros in jklm0
      call dui(nint,nintp)
c     =========================================================================
c     load the integrals  nint+1 ... nintp
      il0=mclock()
      if(nintp.gt.nint)call dhsl1(nint,no,nintp)
      iload=iload+mclock()-il0
      nint=nintp
c
c     order integrals and define jklmapp common
      call iorder(nint,no)
c     do i=1,nint
c      write(6,6008)i,j9(i),k9(i),l9(i),m9(i),a9(i)
c6008   format(i4,4i3,f10.6)
c     enddo
c     read(5,*)oo
c     =========================================================================
c     in the second loop over jj make the elements
c     =========================================================================
      jj=0
c
c     number of non-zero elements in row ii:
      jt=0
c
c     Loop over jj, record only jj<=ii
102   jj=jj+1
      if(jj.gt.ii)goto 888
      jstart=icis(jj)
      nhdimj=icid(jj)
c
c     spin states jj...jjend consist of determinands jstart..(jend)
c     find jjend and process all states jj..jjend:
c
      do 512 jjend=jj,nhci
512   if(icis(jjend).ne.jstart)goto 612
      jjend=nhci+1
612   jjend=jjend-1
c
c     Form the small Hamiltonian in determinants
      do 1 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 1 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
      il0=mclock()
      call dhsdg(hjj,is,js,ns,nint)
      ical=ical+mclock()-il0
1     h1(id,jd)=hjj
c
c     transform into big - only for ii
c     first index
      do 7 jd=1,nhdimj
      s=0.0d0
      do 8 id=1,nhdimi
8     s=s+cic(ii,id)*h1(id,jd)
7     h2(jd)=s
c
c     second index, for one ii and all jj within jj..jjend
      do 9 j1=jj,jjend
      s=0.0d0
      do 10 jd=1,nhdimj
10    s=s+cic(j1,jd)*h2(jd)
9     h3(j1-jj+1)=s
c
c     store it in h and ind
      do 111 j1=jj,jjend
      if(j1.gt.ii)goto 111
      hij=h3(j1-jj+1)
      int=int+1
      if(j1.eq.ii)then
       inz=inz+1
       jt=jt+1
       ind(jt)=j1
       h(jt)=hij*0.5d0
      else
       if(abs(hij).gt.tol)then
        inz=inz+1
        jt=jt+1
        ind(jt)=j1
        h(jt)=hij
       endif
      endif
111   continue
c
      jj=jjend
      goto 102
888   write(20) jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c
c     write(6,*)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c     read(5,'(a)')ok

      goto 101
999   write(6,6009)dble(inz)/(real(int)+0.1)*100.0d0,inz
6009  format(f10.4,'% of non-zero elements (',i10,')')
      close(20)
      close(99)
      return
      end
c     ================================================================
      subroutine dhsg1(is,js,ns,nintp)
c
c     mark new integrals that need to be calculated or are already done by 1
c     1 .... nint      nintp
c     0 1 0   1  1 1 1 1
c
c     <is|H|js>, between two Slater dets, just gather int indices
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nh110=2*nort)
      integer*4 is(nh110),js(nh110)
      dimension k(2),j(2)
      integer*4 slateri(nh110),slaterj(nh110)
c
      idif=0
c
c     determine how many orbitals are different and made
c     Slater determinant for each configuration
      is1=0
      js1=0
      do 1 i=1,ns
      if(is(i).ne.0)then
       is1=is1+1
       slateri(is1)=i
      endif
      if(js(i).ne.0)then
       js1=js1+1
       slaterj(js1)=i
      endif
      if(is(i).ne.js(i))then
       idif=idif+1
       if(idif.gt.4)return
      endif
1     continue
c
c     check that # of electrons is same
      if(js1.ne.is1)call report('is1<>js1')
c
c     determine sign of Hamiltonian element from Slater determinants
      kd=0
      sign=1.0d0
      ie=0
6     ie=ie+1
      kk=slateri(ie)
      je=0
4     je=je+1
      if(kk.eq.slaterj(je))then
c      put same orbital in j on the same place
       if(je.ne.ie)then
        sign=-sign
        it=slaterj(ie)
        slaterj(ie)=slaterj(je)
        slaterj(je)=it
       endif
       if(ie.lt.is1)goto 6
       goto 61
      else
       if(je.lt.js1)goto 4
      endif
c     this orbital k is not in j, put it in k
      kd=kd+1
      k(kd)=kk
      if(ie.lt.is1)goto 6
c
61    jd=0
      do 5 ie=1,is1
      if(slateri(ie).ne.slaterj(ie))then
       jd=jd+1
       j(jd)=slaterj(ie)
      endif
5     continue
      if(jd.ne.kd)call report('jd<>kd')
c
      goto(10,20)jd
c
c     same determinants (jd=0), from aj,ak, int not needed
      return
c
c     mp1 expression,jd=kd=1 (1 spinorbital difference)
c     <k|Hc|j> + (i<>k,j) (jk|ii)-(ji|ki)
10    if(is(k(1)).ne.js(j(1)))then
       write(6,6001)(is(i),i=1,ns)
       write(6,6001)(js(i),i=1,ns)
6001   format(26(i2,i1))
       write(6,6002)(slateri(i),i=1,is1)
       write(6,6002)(slaterj(i),i=1,js1)
       write(6,6002)(k(i),i=1,kd)
       write(6,6002)(j(i),i=1,jd)
6002   format(26i3)
       call report('change of spin dhsg')
      endif
      k1=(k(1)+1)/2
      j1=(j(1)+1)/2
      do 3 i=1,ns
      isp=is(i)
      if(isp.ne.0.and.isp.eq.js(i))then
       io=(i+1)/2
       call addi1(k1,j1,io,io,nintp)
       if(isp.eq.js(j(1)))call addi1(k1,io,j1,io,nintp)
      endif
3     continue
      return
c
c     single integral,jd=kd=2, 2 spinrobital differences
c     (k1j1|k2j2)-(k1j2|k2j1)
20    k1=(k(1)+1)/2
      k2=(k(2)+1)/2
      j1=(j(1)+1)/2
      j2=(j(2)+1)/2
      if(is(k(1)).eq.js(j(1)).and.is(k(2)).eq.js(j(2)))
     1call addi1(k1,j1,k2,j2,nintp)
      if(is(k(1)).eq.js(j(2)).and.is(k(2)).eq.js(j(1)))
     1call addi1(k1,j2,k2,j1,nintp)
      return
      end
c     =======================================
      subroutine dui(nint,nintp)
c     delete unused integrals, change definition of nint,nintp
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000)
      common/jklm0/i0s(nhcir)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
c
      i=0
1     i=i+1
      if(i.gt.nintp)return
3     if(i0s(i).eq.0)then
       do 2 j=i,nintp-1
       j9(j)=j9(j+1)
       k9(j)=k9(j+1)
       l9(j)=l9(j+1)
       m9(j)=m9(j+1)
       a9(j)=a9(j+1)
       i88(j)=i88(j+1)
2      i0s(j)=i0s(j+1)
       nintp=nintp-1
       nint =nint -1
       if(nintp.gt.0)goto 3
      endif
      goto 1
c
      end
c     =======================================
      subroutine iniz(nint)
c     ini i0s for nint
      implicit integer*4 (i-n)
      parameter (nhcir=100000)
      common/jklm0/i0s(nhcir)
      do 1 i=1,nint
1     i0s(i)=0
      return
      end
c     =======================================
      subroutine addi1(j1,j2,j3,j4,nintp)
c     add (ab|cd) in the list
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      common/jklm0/i0s(nhcir)
c
c     take (j1 j2 | j3 j4)
c     and make same as (ia ib | ic id), ia<=ib, ic<=id, (ia,ib)<=(ic,id)
      ia=j1
      ib=j2
      ic=j3
      id=j4
      if(ib.lt.ia)call swi(ia,ib)
      i1=ia+ib*(ib-1)/2
      if(id.lt.ic)call swi(ic,id)
      i2=ic+id*(id-1)/2
      if(i2.lt.i1)then
       call swi(ia,ic)
       call swi(ib,id)
      endif
c
c     define (jkl) index for easier identification:
      jkl=ia+ib*(ib-1)/2+(ic-1)*(id*(id-1)+ic)/2
c
c     mark new integrals that need to be calculated or are already done by 1
c     1 .... nint      nintp
c     0 1 0   1  1 1 1 1
c
c     find, if already in the list:
      do 1 i=1,nintp
      if(jkl.eq.i88(i).and.id.eq.m9(i))then
       i0s(i)=1
       return
      endif
1     continue
c
c     not foudn in the list, so add it there:
      nintp=nintp+1
      if(nintp.gt.nhcir)call report('nintp > nhcir in addi1')
      j9(nintp) =ia
      k9(nintp) =ib
      l9(nintp) =ic
      m9(nintp) =id
      i88(nintp)=jkl
      i0s(nintp)=1
      return
      end
c     =======================================================
      subroutine dhsl1(nint,nmo,nintp)
c
c     load nint+1...nintp integrals in common jklm into a9 from BBCD.SCR
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      dimension bmm(100)
c
      ks=1
      je=nmo
      ifound=0
c
      open(53,file='BBCD.SCR',form='unformatted',status='old')
      do 57 IDB=ks,je
c
c     read from 100 word blocks:
      read(53)ntest
      i1=1
60001 i2=min(i1+99,ntest)
      read(53)(bmm(ibb-i1+1),ibb=i1,i2)
c
c     look if current batch contains integrals from the list
      do 1 i8=nint+1,nintp
      if(m9(i8).eq.IDB)then
       i888=i88(i8)
       if(i888.le.i2.and.i888.ge.i1)then
        a9(i8)=bmm(i888-i1+1)
c       write(6,*)IDB,i8,i888,a9(i8)
        ifound=ifound+1
        if(ifound.eq.nintp-nint)goto 571
       endif
      endif
1     continue
c
      if(i2.lt.ntest)then
       i1=i2+1
       goto 60001
      endif
c
57    continue
c
571   close(53)
      if(ifound.ne.nintp-nint)then
       write(6,*)ifound,nintp-nint
       do 2 i8=nint,nintp
2      write(6,6000)i8,j9(i8),k9(i8),l9(i8),m9(i8)
6000   format(i13,3x,4i3)
       call report('Some integrals were not found in dhsl1')
      endif
c
      return
      end
c     ============================================
      subroutine iorder(iint,nmo)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000,nort=700)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      common/jklmapp/nds(nort),nde(nort)
c
c     preorder integrals with respect to last index
      call qisort1(iint)
c
c     mark position where starts and ends each d-index
      do 576 IDB=1,nmo
      do 571 nstart=1,iint
571   if(m9(nstart).eq.IDB)goto 572
      nstart=0
      nend=0
      goto 575
572   do 573 nend=iint,nstart,-1
573   if(m9(nend).eq.IDB)goto 575
575   nds(IDB)=nstart
576   nde(IDB)=nend
c
      return
      end
c     =====================================================
      subroutine qisort1(n)
c     orders integrals in common jklm with respect to m9 index=arr
      integer*4 nhcir,M,nstack
      parameter (nhcir=100000,M=10,NSTACK=nhcir)
      real*8 a9,at(nhcir)
      integer*4 n,j9,k9,l9,i88,i,ir,j,temp,
     1jstack,k,l,istack(NSTACK),it(nhcir),brr(nhcir),arr,a,b
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),arr(nhcir),
     1i88(nhcir),a9(nhcir)
c
      do i=1,n
       brr(i)=i
      enddo
c
c     QUICKSORT::::::::::::::::::::::::::::::::::
c     Sorts an array arr(1:n) into ascending order while
c     making rearangement of the array brr(1:n)
c     M ... when buble sort is switched on
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
c      insertion sort for small Ms:
       do j=l+1,ir
        a=arr(j)
        b=brr(j)
        do i=j-1,l,-1
         if(arr(i).le.a)goto 2
         arr(i+1)=arr(i)
         brr(i+1)=brr(i)
        enddo
        i=l-1
2       arr(i+1)=a
        brr(i+1)=b
       enddo
       if(jstack.eq.0)goto 9999
c      pop stack and begind new round of partitioning
       ir=istack(jstack)
       l=istack(jstack-1)
       jstack=jstack-2
      else
c      choose median of left, center and right elements as partitioning
c      element a. Also rearrange so that a(l)<=a(l+1)<=a(ir)
       k=(l+ir)/2
       temp=arr(k)
       arr(k)=arr(l+1)
       arr(l+1)=temp
       temp=brr(k)
       brr(k)=brr(l+1)
       brr(l+1)=temp
       if(arr(l).gt.arr(ir))then
        temp=arr(l)
        arr(l)=arr(ir)
        arr(ir)=temp
        temp=brr(l)
        brr(l)=brr(ir)
        brr(ir)=temp
       endif
       if(arr(l+1).gt.arr(ir))then
        temp=arr(l+1)
        arr(l+1)=arr(ir)
        arr(ir)=temp
        temp=brr(l+1)
        brr(l+1)=brr(ir)
        brr(ir)=temp
       endif
       if(arr(l).gt.arr(l+1))then
        temp=arr(l)
        arr(l)=arr(l+1)
        arr(l+1)=temp
        temp=brr(l)
        brr(l)=brr(l+1)
        brr(l+1)=temp
       endif
c      initialize pointers for partitioning
       i=l+1
       j=ir
c      partitioning element
       a=arr(l+1)
       b=brr(l+1)
c      beginninf of innermost loop
3      continue
c      scan up to find element >a
       i=i+1
       if(arr(i).lt.a)goto 3
4      continue
c      scan down to find element <a
       j=j-1
       if(arr(j).gt.a)goto 4
c      pointers crossed; exit whe partitioning complete
       if(j.lt.i)goto 5
c      exchange elements of both arrays
       temp=arr(i)
       arr(i)=arr(j)
       arr(j)=temp
       temp=brr(i)
       brr(i)=brr(j)
       brr(j)=temp
       goto 3
c      end of innermost loop
c      insert partitioning elements in both arrays
5      arr(l+1)=arr(j)
       arr(j)=a
       brr(l+1)=brr(j)
       brr(j)=b
       jstack=jstack+2
c      push pointers to larger subarray on stack,
c      process smaller subarray immediately
       if(jstack.gt.nstack)write(6,*) 'nstack too small'
       if(ir-i+1.ge.j-l)then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
       else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
       endif
      endif
      goto 1
c     QUICKSORT::::::END::::::::::::::::::::
9999  do 100 i=1,n
100   it(i)=j9(brr(i))
      do 101 i=1,n
      j9(i)=it(i)
101   it(i)=k9(brr(i))
      do 102 i=1,n
      k9(i)=it(i)
102   it(i)=l9(brr(i))
      do 103 i=1,n
      l9(i)=it(i)
103   it(i)=i88(brr(i))
      do 104 i=1,n
      i88(i)=it(i)
104   at(i)=a9(brr(i))
      do 105 i=1,n
105   a9(i)=at(i)
      return
      end
c     =======================================================
