      subroutine cighs(no,nhci,n,ist)
c
c     analogous to cigh, but works with batches of integrals (KJ|LM)
c     analogous to cighd, but expansds some integrals into mo basis
c
c     makes CI Hamiltonian, writes it to A.SCR or AT.SCR
c     n .. number of Slater determinants
c     nhci .. number of selected spin states (singlets or triplets)
c     nsg ... number of spin groups of determinants
c     ist=1 ... write H into A.SCR
c     ist=3 ... write H into AT.SCR
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhci0=140000,nort=700,nh110=2*nort,nhcir=100000,
     1nh0=100,tol=1.0d-10,nii00=8,nii33=1+2*nii00)
      integer*4 nncig
      common/icicom/nncig(nh110),nnci(nhci0,nii33),
     1icie(nhcir),icid(nhcir),icis(nhcir),
     2isis(nhci0),isie(nhci0)
      common/rcicom/cic(nhcir,nh0)
      integer*4 is(nh110),js(nh110)
      dimension h(nhci0),ind(nhci0),
     1h1(nh0,nh0),h2(nh0),h3(nh0)
      logical londisk
c     character*1 ok
c
      open(99,file='debug.SCR')
      write(3,*)'starting cighs, nhci= ',nhci,' n = ',n
      write(6,*)'starting cighs, nhci= ',nhci,' n = ',n
      if(n.gt.nhci0)call report('n>nhci0 in cigh')
      if(nhci.gt.nhcir)call report('nhci>nhcir in cigh')
      ns=2*no
      nmo=no
c
      if(ist.eq.1)inquire(file= 'A.SCR',exist=londisk)
      if(ist.eq.3)inquire(file='AT.SCR',exist=londisk)
      if(londisk)then
       if(ist.eq.1)write(6,*)'A.SCR found on disk'
       if(ist.eq.3)write(6,*)'AT.SCR found on disk'
       return
      endif
c
c     Hamiltonian in spin-adapted functions 1..nhci
      if(ist.eq.1)open(20,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='AT.SCR',form='unformatted')
      write(20)nhci
      write(6,*)'making Hamiltonian in spin-adapted basis'
c
c     number of non-zero elements:
      inz=0
c
c     number of all elements (calculated):
      int=0
      ip0=0
      ii=0
c
c     Loop over ii
c     ii,jj .. spin adapted basis function index
c     id,jd .. determinant index
101   ii=ii+1
      if(ii.gt.nhci)goto 999
      istart=icis(ii)
      nhdimi=icid(ii)
c
c     spin states iistart...iiend consist of determinands istart..(iend)
c     find iiend, iistart
      do 5 iiend=ii,nhci
5     if(icis(iiend).ne.istart)goto 6
      iiend=nhci+1
6     iiend=iiend-1
      do 52 iistart=ii,1,-1
52    if(icis(iistart).ne.istart)goto 62
      iistart=0
62    iistart=iistart+1
c
      ip=ii*100/nhci
      if(ip.gt.ip0+3)then
       ip0=ip
       write(6,*)ip,'%'
      endif
c
c     =========================================================================
c     in the first loop over jj just gather integrals needed for line ii:
c     =========================================================================
      iint=0
      jj=0
1021  jj=jj+1
      if(jj.gt.ii)goto 8881
      jstart=icis(jj)
      nhdimj=icid(jj)
      do 51 jjend=jj,nhci
51    if(icis(jjend).ne.jstart)goto 61
      jjend=nhci+1
61    jjend=jjend-1
      do 11 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 11 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
11    call dhsg(iint,is,js,ns)
      jj=jjend
      goto 1021
8881  continue
c     =========================================================================
c     load the integrals
      if(iint.gt.0)call dhss(iint,nmo)
c     =========================================================================
c     in the second loop over jj make the elements
c     =========================================================================
      jj=0
c
c     number of non-zero elements in row ii:
      jt=0
c
c     Loop over jj, record only jj<=ii
102   jj=jj+1
      if(jj.gt.ii)goto 888
      jstart=icis(jj)
      nhdimj=icid(jj)
c
c     spin states jj...jjend consist of determinands jstart..(jend)
c     find jjend and process all states jj..jjend:
c
      do 512 jjend=jj,nhci
512   if(icis(jjend).ne.jstart)goto 612
      jjend=nhci+1
612   jjend=jjend-1
c
c     Form the small Hamiltonian in determinants
      do 1 id=1,nhdimi
      call tcin(nnci,nncig,is,nh110,id+istart-1,ns)
      do 1 jd=1,nhdimj
      call tcin(nnci,nncig,js,nh110,jd+jstart-1,ns)
      call dhsdg(hjj,is,js,ns,iint)
1     h1(id,jd)=hjj
c
c     transform into big - only for ii
c     first index
      do 7 jd=1,nhdimj
      s=0.0d0
      do 8 id=1,nhdimi
8     s=s+cic(ii,id)*h1(id,jd)
7     h2(jd)=s
c
c     second index, for one ii and all jj within jj..jjend
      do 9 j1=jj,jjend
      s=0.0d0
      do 10 jd=1,nhdimj
10    s=s+cic(j1,jd)*h2(jd)
9     h3(j1-jj+1)=s
c
c     store it in h and ind
      do 111 j1=jj,jjend
      if(j1.gt.ii)goto 111
      hij=h3(j1-jj+1)
      int=int+1
      if(j1.eq.ii)then
       inz=inz+1
       jt=jt+1
       ind(jt)=j1
       h(jt)=hij*0.5d0
      else
       if(abs(hij).gt.tol)then
        inz=inz+1
        jt=jt+1
        ind(jt)=j1
        h(jt)=hij
       endif
      endif
111   continue
c
      jj=jjend
      goto 102
888   write(20) jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c
c     write(6,*)jt,(h(j1),j1=1,jt),(ind(j1),j1=1,jt)
c     read(5,'(a)')ok

      goto 101
999   write(6,6009)dble(inz)/real(int)*100.0d0,inz
6009  format(f10.4,'% of non-zero elements (',i10,')')
      close(20)
      close(99)
      return
      end
