      subroutine cigt(nhci,nv,nat)
c
c     transforms transitional integrals into CI BASIS
c     nv .. number of found excited electronic states
c     nhci .. number of selected spin states (singlets or triplets), CI basis
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000,nel=15,tol=1.0d-10,nat0=190)
      common/dd1/o1(nhcir),o(nhcir),cci(nhcir),d(nhcir)
      common/dd2/ox(nhcir),oy(nhcir),oz(nhcir),ax(nhcir)
      common/dd3/ay(nhcir),az(nhcir),
     2vx(nhcir),vy(nhcir),vz(nhcir),ind1(nhcir),ind(nhcir)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      character*8 fn(nel),fnc(nel)
      data fn/' APX.SCR',' APY.SCR',' APZ.SCR',
     1' AQ1.SCR',' AQ2.SCR',' AQ3.SCR',' AQ4.SCR',' AQ5.SCR',' AQ6.SCR',
     1' ALX.SCR',' ALY.SCR',' ALZ.SCR',
     1' AVX.SCR',' AVY.SCR',' AVZ.SCR'/
      data fnc/'CAPX.SCR','CAPY.SCR','CAPZ.SCR',
     1'CAQ1.SCR','CAQ2.SCR','CAQ3.SCR','CAQ4.SCR','CAQ5.SCR','CAQ6.SCR',
     1'CALX.SCR','CALY.SCR','CALZ.SCR',
     1'CAVX.SCR','CAVY.SCR','CAVZ.SCR'/
      logical londisk
c     character*1 ok
c
      write(3,*)'starting cigt, nhci= ',nhci,' nv = ',nv
      write(6,*)'starting cigt, nhci= ',nhci,' nv = ',nv
      write(6,*)'transforming integrals to CI states'
c
c     Loop over all types of moments:
      do 10000 io=1,nel
      inquire(file=fnc(io),exist=londisk)
      if(londisk)then
       write(6,*)fnc(io),' found on disk'
      else
       write(6,*)'making ',fnc(io)
       open(22,file='EV.SCR',form='unformatted')
       open(23,file='TEM.SCR',form='unformatted')
c      <CIi|u|CIj>=ciIcjJ<I|u|J>, <I|u|J> is in file 20
c
c      transform first index    <CIi|o|JJ>=ciII<II|o|JJ>
       open(20,file=fn(io),form='unformatted')
       do 1 i=1,nv
       read(22)(cci(ii),ii=1,nhci)
       rewind 20
       read(20)nhcif
       if(nhcif.ne.nhci)call report('nhcif<>nhci')
       jt=0
       do 2 jj=1,nhci
       read(20)nj,(o(j1),j1=1,nj),(ind(j1),j1=1,nj)
       sijj=0.0d0
c      if(io.eq.3)then
c       write(6,*)o(1),ind(1)
c       read(5,*)iooo
c      endif
       do 22 j1=1,nj
22     sijj=sijj+cci(ind(j1))*o(j1)
       if(abs(sijj).gt.tol)then
        jt=jt+1
        ind1(jt)=jj
        o1(jt)=sijj
       endif
2      continue
1      write(23)jt,(o1(j1),j1=1,jt),(ind1(j1),j1=1,jt)
       close(20)
c
c      transform second index    <CIi|o|CIj>=cjJJ<CIi|o|JJ>
       open(21,file=fnc(io),form='unformatted')
       rewind 22
       do 3 j=1,nv
       read(22)(cci(jj),jj=1,nhci)
       rewind 23
       do 4 i=1,nv
       read(23)jt,(o1(j1),j1=1,jt),(ind1(j1),j1=1,jt)
       sji=0.0d0
       do 41 j1=1,jt
41     sji=sji+cci(ind1(j1))*o1(j1)
4      o(i)=sji
3      write(21)(o(i),i=1,nv)
       close(21)
       close(23)
       close(22)
c
      endif
10000 continue
c
      write(6,*)'Retrieving CD spectrum'
      open(23,file='ECI.SCR',form='unformatted')
      read(23)nv
      do i=1,nv
       read(23)d(i)
      enddo
      do i=1,nv
       ind(i)=i
      enddo
      read(23,err=8999)(ind(i),i=1,nv)
8999  close(23)
c
      do i=1,3
       open(43+i,file=fnc(i),form='unformatted')
       open(43+9+i,file=fnc(9+i),form='unformatted')
       open(43+12+i,file=fnc(12+i),form='unformatted')
      enddo
c
      open(76,file='UVCDCI.TAB')
      write(76,3636)
3636  format('UVCD CI',/,'trans de(nm)  d  r  r',/,80(1h-))
      do i=1,nv
       read(43+ 1)(ox(j),j=1,nv)
       read(43+ 2)(oy(j),j=1,nv)
       read(43+ 3)(oz(j),j=1,nv)
       read(43+10)(ax(j),j=1,nv)
       read(43+11)(ay(j),j=1,nv)
       read(43+12)(az(j),j=1,nv)
       read(43+13)(vx(j),j=1,nv)
       read(43+14)(vy(j),j=1,nv)
       read(43+15)(vz(j),j=1,nv)
       ux=-ox(i)
       uy=-oy(i)
       uz=-oz(i)
       do ia=1,nat
        ux=ux+xv(1,ia)*z(ia)
        uy=uy+xv(2,ia)*z(ia)
        uz=uz+xv(3,ia)*z(ia)
       enddo
       write(3,3999)i,ux,uy,uz,sqrt(ux**2+uy**2+uz**2)
3999   format('state ',i6,' dipole ',3f12.5,'|u|=',f12.5)
       if(i.gt.1)then
        ds=ox(1)*ox(1)+oy(1)*oy(1)+oz(1)*oz(1)
        rs=ox(1)*ax(1)+oy(1)*ay(1)+oz(1)*az(1)
        de=d(i)-d(1)
        denm=0.0d0
        if(de.gt.1.0d-7)denm=1.0d7/(de*219470.0d0)
        write(76,3699)i,denm,ds,rs,rs
3699    format(i6,4g15.6)
c
c       debug:
        if(i.lt.5)then
        write(3,*)'u,uv and m, 1->',i,':'
        write(3,3700)ox(1),oy(1),oz(1)
        write(3,3700)vx(1),vy(1),vz(1)
        write(3,3700)ax(1),ay(1),az(1)
3700    format(3f12.6)
        write(3,*)'u,uv and m, 2->',i,':'
        write(3,3700)ox(2),oy(2),oz(2)
        write(3,3700)vx(2),vy(2),vz(2)
        write(3,3700)ax(2),ay(2),az(2)
        write(3,*)'u,uv and m, 3->',i,':'
        write(3,3700)ox(3),oy(3),oz(3)
        write(3,3700)vx(3),vy(3),vz(3)
        write(3,3700)ax(3),ay(3),az(3)
        write(3,*)'u,uv and m, 4->',i,':'
        write(3,3700)ox(4),oy(4),oz(4)
        write(3,3700)vx(4),vy(4),vz(4)
        write(3,3700)ax(4),ay(4),az(4)
        endif
c
       endif
      enddo
      write(76,3688)
3688  format(80(1h-))
      close(76)

      do i=1,3
       close(43+i)
       close(43+9+i)
       close(43+12+i)
      enddo
c
      return
      end
