      subroutine csm(ri,rj,nat0,sm,nao,noa,alpha,ty,nop,ish)
c     calculates S-matrix between AO orbitals on one geometry (r0)
c     and other AO orbitals on another geometry (r)
      implicit none
      integer*4 nat0,u0,i,j,nao,nort,noa,io,ia,ip,nor,icha,n1
      parameter (u0=28,nort=700,nor=80)
      integer*4 npi,npii,nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),
     1nzj(u0),ja,jo,jp,nop(nat0),npj,npjj,ioj,ipp,jpp,ioo,joo,ii,
     1jj,ish(nat0,nor)
      real*8 ri(nat0,3),rj(nat0,3),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     1tol,pi,clau,spt,bohr,debye,spi,sm(nao,nao),sv(u0,nort),
     1xi,yi,zi,ai,alpha(nat0,nor),cci(u0),ccj(u0),oi,
     3b6(u0,u0),aai(u0,u0),aaj(u0,u0),xj,yj,zj,xij,yij,zij,
     4x2ij,y2ij,z2ij,r2ij,aj,aij,tt,t,ec,ef,con,
     5aiii,ajjj,aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      common/const/pi,clau,spt,bohr,debye
      character*1 ty(nat0,nor)
      logical ld5,lf7,lsprint,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4),ld5),(lopt(8),lf7)

      call inipoly
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      tol=100.0d0
      spi=sqrt(pi*pi*pi)

      do 10 i=1,nao
      do 10 j=1,u0
10    sv(j,i)=0.0d0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=ri(ia,1)
      yi=ri(ia,2)
      zi=ri(ia,3)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=rj(ja,1)
      yj=rj(ja,2)
      zj=rj(ja,3)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=1.0d0/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=0.0d0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      do 71 ioo=1,npi
c     overlap
71    b6(ioo,joo)=
     1oi(0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)*
     2oi(0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)*
     3oi(0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)*con*cci(ioo)
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 33  jj=1,nao
33     sm(ii+io,jj)=sv(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
9      sv(ii,jj)=0.0d0
      endif
3     continue
2     continue
c
      if(lsprint)call wmtr(sm,nao,nao,'Overlap matrix, AO',0)
c
      return
      end
