      subroutine dapt(ioe)
c
c     atomic polar and atomic axial tensors
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=18,ndm=4,nfiles=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c     ndm    maximum degree of degeneracy
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension dmo(nel,nort),dmt(nort),
     6ak(nort,nort),aj(nort,nort),apt(nat0,3,3),aat(nat0,3,3),
     7vel(nat0,3,3),aatlab(nat0,3,3),
     8grade(3),gradn(3),dipe(3),dipn(3)
      logical ldo,lopt,lscr,lcomb,lpro,lall
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(38),lcomb),(lopt(39),lpro),
     1(lopt(44),lall)
      dimension jdeg(ndm),buff(nort,nort),temi(nort),temj(nort)
      character*7 fm(nfiles)
      data fm/'PMO.SCR','QMO.SCR','LMO.SCR','VMO.SCR'/
      dimension id(nfiles)
      data id/3,6,3,3/
c
      ic7=0
      Ithree=3
      etol=0.00001D0
      write(3,4001)nmo,nao
4001  format(' Dipolar derivatives (APT, AAT); NMO = ',I3,' NAO = ',I3)
      if(nao.gt.nort)call report('Too many orbitals for dapt')
c
c     read-in the coulomb and exchange terms
      if(ioe.eq.0)call inibe4
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       inquire(file='AKJK.SCR',exist=lscr)
       if(.not.lscr)call report('AKJK.SCR not found')
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     <I|o|J>=cIi*cJj<i|o|j> 1-15 in MO.SCR
c     MO.SCR should have been allready created in dqmpol3
c         r         rr                 rxgrad/2  grad      (R-used only here)
c     k=  1  2  3   4  5  6  7  8  9   10 11 12  13 14 15  16 17 18
c         x  y  z   xx xy xz yy yz zz  x  y  z   x  y  z   x  y  z
c
      inquire(file='PMO.SCR',exist=lscr)
      if(.not.lscr)call report('PMO.SCR not found')
      open(37,file='MOX.SCR',form='unformatted',status='unknown')
      open(38,file='MOY.SCR',form='unformatted',status='unknown')
      open(39,file='MOZ.SCR',form='unformatted',status='unknown')
c
c     Loop over atoms:
      do 1212 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      rewind 37
      rewind 38
      rewind 39
      do ix=1,3
c
c     calculate ao integrals (i|grad_lat_ixH|j), put them in buff
      call overlagg(lat,ix,buff)
c
c     transform into MO basis and write into MOXi.SCR:
c
      ctol=1.0d-5
      do imo=1,ndo
       do i=1,nao
        temi(i)=cij(imo,i)
       enddo
       jstart=imo
       if(lall)jstart=1
       do jmo=jstart,nmo
        do i=1,nao
         temj(i)=cij(jmo,i)
        enddo
        sum=z0
        do i=1,nao
         cimoi=temi(i)
         cimoj=temj(i)
         sum=sum+cimoi*cimoj*buff(i,i)
         if(abs(cimoi).gt.ctol)then
          st=z0
          do j=1,i-1
           st=st+temj(j)*buff(j,i)
          enddo
          sum=sum+st*cimoi
         endif
         if(abs(cimoj).gt.ctol)then
          st=z0
          do j=1,i-1
           st=st+temi(j)*buff(j,i)
          enddo
          sum=sum+st*cimoj
         endif
        enddo
        dmt(jmo)=sum
       enddo
       write(37+ix-1)(dmt(jmo),jmo=jstart,nmo)
      enddo
      enddo
c
      do 11 i=1,3
      do 11 j=1,3
      apt(lat,i,j)=z0
      vel(lat,i,j)=z0
11    aat(lat,i,j)=z0
c
      rewind 37
      rewind 38
      rewind 39
c
      call vz(dipe,z0,ithree)
      call vz(grade,z0,ithree)
c
c     sum over doubly-occupied orbitals:
      do 5 k=1,ndo
      wk=e(k)
c     read(36)((dmo(kk,j),kk=1,15),j=1,nmo)


c
      kk=0
      do ifil=1,4
       open(36,file=fm(ifil),form='unformatted')
       do ix=1,id(ifil)
        kk=kk+1
        do kc=1,nmo
         if(kc.eq.k)then
          read(36)(dmo(kk,j),j=1,nmo)
         else
          read(36)
         endif
        enddo
       enddo
       close(36)
      enddo


      jstart=k
      if(lall)jstart=1
      read(37)(dmo(16,j),j=jstart,nmo)
      read(38)(dmo(17,j),j=jstart,nmo)
      read(39)(dmo(18,j),j=jstart,nmo)
      do ix=1,3
       grade(ix)=grade(ix)+two*dmo(ix+15,k)
       dipe(ix)=dipe(ix)-two*dmo(ix,k)
      enddo
c
c     sum over excited states = virtual orbitals, all orbitals for lall opt
      jstart=ndo+1
      if(lall)jstart=1
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
      wj=e(j)
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies
      ejk0=wj-wk
c
c     check for degeneracy
      ndeg=0
      do 2 jj=jstart,nmo
      if(abs(wj-e(jj)).lt.0.001d0)then
       ndeg=ndeg+1
       jdeg(ndeg)=jj
      endif
2     continue
c
      if(ndeg.gt.2.and.ic7.eq.0)then
       ic7=1
       write(3,*)'higher degeneracy may not be implemented properly'
      endif
      if(ndeg.gt.ndm)call report('the degeneracy is higher than ndm')
c
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg)
       do ideg=1,ndeg
        ckj=ckj+aj(k,jdeg(ideg))*afac
        ekj=ekj+ak(k,jdeg(ideg))*aex*afac
       enddo
      endif
c
      wnj=ejk0-ckj+two*ekj
c
      if(wnj.lt.etol)goto 6
c
c     wnj - electroni excitation energy difference
c     ejk0 - MO energy difference
c
      ei=one/wnj
      e2i=ei+ei
      e4i=e2i+e2i
      do 10 ix=1,3
      ixj=ix+1
      if(ixj.eq.4)ixj=1
      ixk=ixj+1
      if(ixk.eq.4)ixk=1
      adnj  =dmo(ix   ,j)*e4i
      avnj  =dmo(12+ix,j)*e4i*ei
      alocal=dmo(9+ix,j)-
     1 half*(xv(ixj,lat)*dmo(12+ixk,j)-xv(ixk,lat)*dmo(12+ixj,j))
      ama=alocal*e2i*ei
      do 10 jx=1,3
      grjn=dmo(15+jx,j)
      apt(lat,jx,ix)=apt(lat,jx,ix)+adnj*grjn
      vel(lat,jx,ix)=vel(lat,jx,ix)+avnj*grjn
10    aat(lat,jx,ix)=aat(lat,jx,ix)+ama *grjn
c     first two indices - nucleus, last index - field
6     continue
c
5     continue
c
      call vz(dipn,z0,ithree)
      call vz(gradn,z0,ithree)
      do ia=1,noa
       r=sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2)
       do ix=1,3
        dipn(ix)=dipn(ix)+z(ia)*xv(ix,ia)
        if(ia.ne.lat)then
         gradn(ix)=gradn(ix)-z(lat)*z(ia)*(xv(ix,lat)-xv(ix,ia))/(r*r*r)
        endif
       enddo
      enddo
      write(3,*)' Static dipole'
      write(3,3009)(dipe(ix),ix=1,3),(dipn(ix),ix=1,3),
     1dipe(1)+dipn(1),dipe(2)+dipn(2),dipe(3)+dipn(3)
3009  format(' Electronic: ',3F15.8,/,
     1       ' Nuclear   : ',3F15.8,/,
     2       '             ',45(1H-),/,
     3       ' Total     : ',3F15.8,/)
      write(3,*)' Gradient'
      write(3,3009)(grade(ix),ix=1,3),(gradn(ix),ix=1,3),
     1grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
c
      do 24 i=1,3
      vel(lat,i,i)=vel(lat,i,i)+z(lat)
24    apt(lat,i,i)=apt(lat,i,i)+z(lat)
c
      write(3,*)
      write(3,*)'Atomic polar tensor - R'
      write(3,4006)((apt(lat,j,i),i=1,3),j=1,3)
4006  format(/,'                        ',14x,'FX',14x,'FY',14x,'FZ',/,
     1         '           Rx           ',3F16.8,/,
     1         '           Ry           ',3F16.8,/,
     2         '           Rz           ',3F16.8,/,
     3         '                        ',16(1H-),/)
      write(3,*)'Atomic polar tensor - V'
      write(3,4006)((vel(lat,j,i),i=1,3),j=1,3)
      write(3,*)'Local atomic axial tensor'
      write(3,4006)((aat(lat,j,i),i=1,3),j=1,3)
      write(3,4007)
4007  format(80(1h*))
c
1212  continue
c
      close(37)
      close(38)
      close(39)
c
      n=3*noa
      open(15,file='RAW.TEN')
      call vcdd1(aat,apt,xv,noa,aatlab)
      call rules(xv,dipn,dipe,apt,aatlab,nat0,noa)
      call writeten(nat0,apt,aatlab,noa)
      write(6,*)' File RAW.TEN written.. '
      write(3,*)' File RAW.TEN written.. '
      if(lpro)then
       write(3,*)'projection of zero-frequency modes ON'
       do ix=1,3
c
c      project partially three rotations:
        call project3(apt,n,xv,ix)
        write(3,*)ix,' projected from P'
        do lat=1,noa
         write(3,4006)((apt(lat,i,j),i=1,3),j=1,3)
        enddo
       enddo
c      project 3 translations:
       call projectp(apt,n)
       call projectp(aat,n)
       call projectp(vel,n)
      else
       write(3,*)'projection of zero-frequency modes OFF'
      endif
      if(lcomb)then
       write(3,*)' APT read from APT.TEN'
       open(33,file='APT.TEN',status='old')
       read(33,*) NATF
       if(NATF.NE.NOA)call report(' Number of atoms differs')
       DO L=1,NOA
        DO J=1,3
         read(33,*)(apt(L,J,I),I=1,3)
        endDO
       endDO
       close(33)
      endif
      write(3,*)' Distributed origin gauge ...'
      if(lopt(297))then
       write(3,*)' Projection of space coordinates from local AAT:'
       call project6(aat,n,xv)
      endif
      call vcdd1(aat,apt,xv,noa,aatlab)
      OPEN(15,FILE='FILE.TEN')
      call writeten(nat0,apt,aatlab,noa)
      call rules(xv,dipn,dipe,apt,aatlab,nat0,noa)
      WRITE(6,*)' FILE.TEN written ...'
      WRITE(3,*)' FILE.TEN written ...'
c
      return
      end
c
      SUBROUTINE WRITETEN(N0,P,A,NAT)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(N0,3,3),A(N0,3,3)
      WRITE(15,1500) NAT,3*NAT-6,0
1500  FORMAT(3I5)
      DO 10 L=1,NAT
      DO 10 J=1,3
10    WRITE(15,1501) (P(L,J,I),I=1,3),L
1501  FORMAT(3F14.8,I5)
      DO 220 L=1,NAT
      DO 220 J=1,3
220   WRITE(15,1501) (A(L,J,I),I=1,3),L
      Z0=0.0d0
      DO 230 L=1,NAT
      DO 230 J=1,3
230   WRITE(15,1501) (Z0,I=1,3),L
      DO 100 L=1,NAT
      DO 100 J=1,3
100   WRITE(15,1501) (P(L,J,I),I=1,3),L
      CLOSE(15)
      RETURN
      END
C
      SUBROUTINE VCDD1(VCD,P,C,NAT,VCDLAB)
c     VCD - atomic axial tensor, local
c     VCDLAB - atomic axial tensor, in the common (laboratory) origin
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      INTEGER*4 A,B,G,D
      PARAMETER (nat0=190)
      DIMENSION VCD(nat0,3,3),P(nat0,3,3),C(3,NAT),VCDLAB(nat0,3,3)
      DO L=1,NAT
       DO A=1,3
        DO B=1,3
         VCDLAB(L,A,B)=VCD(L,A,B)
        ENDDO
       ENDDO
      ENDDO
      DO 90 B =1,3
      DO 90 G=1,3
      DO 90 D=1,3
      SKEW=0.25D0*EPS(B,G,D)
      IF (DABS(SKEW).GT.1.0D-10)THEN
       DO 80 A=1,3
       DO 80 L=1,NAT
80     VCDLAB(L,A,B)=VCDLAB(L,A,B)+SKEW*C(G,L) * P(L,A,D)
      ENDIF
90    CONTINUE
      RETURN
      END
c
      subroutine rules(R,dn,de,P,A,N0,nat)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(N0,3,3),A(N0,3,3),R(3,NAT),dn(3),de(3),rule(3,3),
     1d(3)
      i9=9
      z0=0.0d0
c
      d(1)=de(1)+dn(1)
      d(2)=de(2)+dn(2)
      d(3)=de(3)+dn(3)
c
      call vz(rule,z0,i9)
      do 1 i=1,3
      do 1 j=1,3
      do 1 k=1,3
1     rule(i,j)=rule(i,j)+eps(i,j,k)*d(k)
      call wrr(rule,'S1, Rotation of dipole moment ')
c
      call vz(rule,z0,i9)
      do 2 i=1,3
      do 2 j=1,3
      do 2 l=1,nat
2     rule(i,j)=rule(i,j)+P(l,i,j)
      call wrr(rule,' Translation of APTs (should be zero)')
c
      call vz(rule,z0,i9)
      do 3 i=1,3
      do 3 j=1,3
      do 3 l=1,nat
      do 3 k=1,3
      do 3 n=1,3
3     rule(i,j)=rule(i,j)+eps(j,k,n)*R(k,l)*P(l,n,i)
      call wrr(rule,' S2, Rotation of APTs, should be S1')
c
      call vz(rule,z0,i9)
      do 4 i=1,3
      do 4 j=1,3
      do 4 l=1,nat
4     rule(i,j)=rule(i,j)+A(l,i,j)
      call wrr(rule,'S3, Translation of AATs, should be S2')
c
      call vz(rule,z0,i9)
      do 5 i=1,3
      do 5 j=1,3
      do 5 l=1,nat
      do 5 k=1,3
      do 5 n=1,3
5     rule(i,j)=rule(i,j)+eps(j,k,n)*R(k,l)*A(l,n,i)
      call wrr(rule,'S4, Rotation of AATs, should be Chi_P')
c
      return
      end
c
      subroutine wrr(a,s)
      real*8 a(3,3)
      character*(*) s
      write(3,'(a)')s
      write(3,3)a
3     format(3(3F15.7,/),/)
      return
      end

