      subroutine dcoupl(ioe)
c
c     nuclear shielding coupling constants
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nr0=1000)
      integer*4 u0
      parameter (u0=28)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*3 sn,sm
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/iopts/iopt(300)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      common/atoms/qz(nat0),zsum,xv(3,nat0)
      dimension ak(nort,nort),aj(nort,nort),
     1rx(nr0),ry(nr0),rz(nr0),vv(nr0),db(nr0)
c
      common/bigstack/akdso((nat0*(nat0+1))/2),
     1buff(nort,nort),oo(nort,nort),btem(nort,nort),
     2oon(nort,nort,3),oom(nort,nort,3),jdeg(4),
     3ttn(nort,nort,6),ttm(nort,nort,6),temi(nort),temj(nort),
     4pjdso(3*nat0,3*nat0),totalc(nat0,nat0)
      logical ldo,lscf,lopt,lgiao,l1e,l2e,lsppl,lex,lcall,
     1lall
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(21),lscf),(lopt(32),lgiao),
     1(lopt(58),lsppl),(iopt(1),ncnmr),(iopt(2),inormo),
     1(lopt(67),lcall),(lopt(44),lall)
      common/snell/aa1(u0,u0),aad(u0,u0),aaf(u0,u0),
     1aag(u0,u0),aah(u0,u0),aai(u0,u0)
      common/sicon/sie,simu0,simun,sime,sib0,sih,sieps0,sieau,
     1simub,ge,amin(3),amax(3)
c
      sm='XXX'
      sn='YYY'
      bdel=one/dble(ncnmr)
      write(3,4401)nmo,nao,bdel
      write(6,4401)nmo,nao,bdel
4401  format(' Nuclear coupling constants; NMO = ',I3,' NAO = ',I3,/,
     1' Numerical grid step ',F6.3,' Bohr')
      if(lall)then
       write(6,*)'All Js'
       write(3,*)'All Js'
      else
       write(6,*)'Virtual Js'
       write(3,*)'Virtual Js'
      endif
c
      call initfd(aa1,aad,aaf,aag,aah,aai)
c
      etol=0.0001d0
      ione=1
c
c     SI constants:
c     negative charge of an electron, Coulombs:
      sie=1.60217733d-19
c     vaccum permeability, Henry/metr:
      simu0=four*Pi*1.0d-7
c     nuclear magneton, Joule/Tesla or Ampere.meter^2
      simun=5.0507866d-27
c     mass of electron, kilogramms
      sime=9.1093897d-31
c     Bohr radius, meters
      sib0=5.29177d-11
c     ordinary Planck's constant, Joule.second
      sih=6.6260755d-34
c     vaccum permitivity, coulomb^2/Jm
      sieps0=8.854187817d-12
c     atomic unit of energy, Joule
      sieau=sie**2/four/Pi/ sieps0/sib0
c     Bohr magneton, J/T
      simub=9.2740154d-24
c
c     dimensionless gyromagnetic ratio for electron
      ge=2.0023d0
c
c     DSO:
      const2=(sie*simu0*simun)**2/(24.0d0*Pi**2*sime)/sib0**4/sih
c
c     FC:
      const4=(two*ge*simu0*simub*simun/three)**2/(sib0**6*sieau)/sih
c
c     PSO:
      const6=(sie*simu0*simun/two/Pi/sime)**2/three
     1*(sih/two/Pi)**2/(sib0**6*sieau)/sih
c
c     SD:
      const8=(ge*simub*simun*simu0/four/Pi)**2/three
     1/(sib0**6*sieau)/sih
c
c     set cage
      t1=2.5d0/0.529d0
      t2=1.8d0/0.529d0
      arl=t1*t1
      do 7 i=1,3
      if(abs(qz(1)).lt.two)then
       t=t2
      else
       t=t1
      endif
      amin(i)=xv(i,1)-t
      amax(i)=xv(i,1)+t
      do 7 l=2,noa
      if(abs(qz(l)).lt.two)then
       t=t2
      else
       t=t1
      endif
      if(xv(i,l)-t.lt.amin(i))amin(i)=xv(i,l)-t
7     if(xv(i,l)+t.gt.amax(i))amax(i)=xv(i,l)+t
      inquire(file='DIAM.SCR',exist=lex)
      if(lex)then
       write(3,*)'DIAM.SCR exist, DSO read in'
       write(6,*)'DIAM.SCR exist, DSO read in'
       open(36,file='DIAM.SCR',form='unformatted')
       read(36)akdso,pjdso
       close(36)
       goto 54321
      endif
c
c     tolerance for zero distance
      call inibe4
      if(.not.lopt(297))goto 12345
c
c     diamagnetic coupling, semianalytical calculation
c
      ii=0
      do 1001 in=1,noa
      do 1001 im=in+1,noa
      ii=ii+1
      write(6,*)in,' - ',im
c     place <a|rN.RM rN^-3 rM^-3|b> into buffer
c     and transform into MOs, put into oo
      call overla55(in,im,buff)
      call taomo(buff,oo,cij,nort,nort,ndo,nao,temi,temj,1.0d-8)
      akdso(ii)=z0
      do 1001 k=1,ndo
1001  akdso(ii)=akdso(ii)+two*oo(k,k)
c
      goto 54322
c
12345 continue
c
c     diamagnetic couplings/numerical integration
c
      do 6 ii=1,(noa*(noa+1))/2
6     akdso(ii)=z0
      do 1002 in=1,noa
      do 1002 ix1=1,3
      i1=3*(in-1)+ix1
      do 1002 im=1,noa
      do 1002 ix2=1,3
      i2=3*(im-1)+ix2
1002  pjdso(i1,i2)=z0
      write(6,*)' numerical integration started'
      ib=0
      ip0=0
      anro=z0
      x=amin(1)
4001  adiv=one
      dmin=abs(x-xv(1,1))
      do 41 i=2,noa
41    if(abs(x-xv(1,i)).lt.dmin)dmin=abs(x-xv(1,i))
      if(dmin.lt.0.50d0)adiv=two
      if(dmin.lt.0.25d0)adiv=four
      delx=bdel/adiv
      ip=int(100.0d0*(x-amin(1))/(amax(1)-amin(1)))
      if(ip.gt.ip0)then
       write(6,*)ip,'% ',x
       open(22,file='num.progres')
       write(22,*)ip,'%'
       close(22)
      endif
      ip0=ip
      x=x+delx
      xc=x-delx/two
      y=amin(2)
4002  adiv=one
      dmin=abs(y-xv(2,1))
      do 42 i=2,noa
42    if(abs(y-xv(2,i)).lt.dmin)dmin=abs(y-xv(2,i))
      if(dmin.lt.0.50d0)adiv=two
      if(dmin.lt.0.25d0)adiv=four
      dely=bdel/adiv
      y=y+dely
      yc=y-dely/two
      z=amin(3)
      delxy=dely*delx
4003  adiv=one
      dmin=abs(z-xv(3,1))
      do 43 i=2,noa
43    if(abs(z-xv(3,i)).lt.dmin)dmin=abs(z-xv(3,i))
      if(dmin.lt.0.50d0)adiv=two
      if(dmin.lt.0.25d0)adiv=four
      delz=bdel/adiv
      z=z+delz
      zc=z-delz*half
      ic=0
      do 45 i=1,noa
      rr=(xc-xv(1,i))**2+(yc-xv(2,i))**2+(zc-xv(3,i))**2
45    if(rr.lt.arl)ic=1+ic
      if(ic.eq.0)goto 45454
      ib=ib+1
      rx(ib)=xc
      ry(ib)=yc
      rz(ib)=zc
      vv(ib)=delz*delxy
      if(ib.eq.nr0)call emptybuf(ib,rx,ry,rz,db,ione,ndo,vv,anro,
     1 noa,xv,akdso,pjdso,z0)
45454 if(z.lt.amax(3))goto 4003
      if(y.lt.amax(2))goto 4002
      if(x.lt.amax(1))goto 4001
c
      call emptybuf(ib,rx,ry,rz,db,ione,ndo,vv,anro,
     1 noa,xv,akdso,pjdso,z0)
c
      write(3,3030)anro
      write(6,3030)anro
3030  format(' Integration sum: ',F10.4)
c
54322 write(3,*)'DIAM.SCR written'
      write(6,*)'DIAM.SCR written'
      open(36,file='DIAM.SCR',form='unformatted')
      write(36)akdso,pjdso
      close(36)
c
54321 continue
c
c     read in coulomb and exchange integrals
      if(ioe.eq.2.or.ioe.eq.3)then
       aex=one
       if(ioe.eq.3)aex=z0
       open(23,file='AKJK.SCR',form='unformatted',status='old')
       read(23)((ak(i,j),i=1,nmo),j=1,nmo),((aj(i,j),i=1,nmo),j=1,nmo)
       close(23)
       write(6,*)'Coulomb and exchange terms read from scratch.'
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
      INQUIRE(file='MOLL.SCR',exist=l1e)
      INQUIRE(file='MO22.SCR',exist=l2e)
      open(46,file='MOLL.SCR',form='unformatted')
      open(47,file='MO22.SCR',form='unformatted')
      if(l1e.and.l2e)then
       write(3,*)'MOLL.SCR and MO22.SCR read from disk'
       write(6,*)'MOLL.SCR and MO22.SCR read from disk'
       goto 6363
      endif
      write(6,*)' Transforming integrals, writing MOLL.SCR and MO22.SCR'
      write(3,*)' Transforming integrals, writing MOLL.SCR and MO22.SCR'
      do 101 lat=1,noa
      write(6,*)' Atom ',lat
c
c     prepare integrals <MO|3(r-R)(r-R)/(r-R)^5-1/(r-R)^3|MO>
      do 106 i=1,3
      do 106 j=i,3
      call overla22(lat,i,j,buff)
      call taomo(buff,oo,cij,nort,nort,nmo,nao,temi,temj,1.0d-8)
106   write(47)((oo(io,jo),io=1,nmo),jo=1,nmo)
c
c     prepare integrals <MO|(r-R)xgrad/(r-R)^3|MO>
c
      I0=0
      call overlaps(lat,I0)
      do 101 ix=1,3
      open(43,file='F2.SCR',form='unformatted')
      do 202 i=1,nao
      do 206 i1=1,ix-1
206   read(43)
      read(43)(buff(i,j),j=1,nao)
      do 207 i1=ix+1,3
207   read(43)
202   continue
      close(43)
c
c     transform into MO basis and write into oo
      write(3,*)lat,ix
      call taomo2(buff,oo,cij,nort,nort,nmo,nao,btem)
101   write(46)((oo(i,j),i=1,nmo),j=1,nmo)
c
6363  continue
c
      ii=0
c
c     first atom
      do 1 n=1,noa
      rewind(46)
      do 102 jj=1,n
      do 102 ix=1,3
102   read(46)((oon(i,j,ix),i=1,nmo),j=1,nmo)
      rewind(47)
      do 104 jj=1,n
      do 104 ix=1,6
104   read(47)((ttn(i,j,ix),i=1,nmo),j=1,nmo)
c
c     second atom
      do 1 m=n+1,noa
      ii=ii+1
      write(6,*)' pair',n,m
      do 105 ix=1,3
105   read(46)((oom(i,j,ix),i=1,nmo),j=1,nmo)
      do 103 ix=1,6
103   read(47)((ttm(i,j,ix),i=1,nmo),j=1,nmo)
c
      afc=z0
      apdc=z0
      asd=z0
      afcsd=z0
c
c     sum over occupied orbitals
      do 55 k=1,ndo
      ek=e(k)
      call forbaa(fkn,n,k)
      call forbaa(fkm,m,k)
c
c     sum over virtual orbitals
      if(lall)then
       jstart=1
      else
       jstart=ndo+1
      endif
      do 66 j=jstart,nmo
      if(j.eq.k)goto 66
      ej=e(j)
      call forbaa(fjn,n,j)
      call forbaa(fjm,m,j)
c
      ndeg=0
      do 22 jj=jstart,nmo
      if(abs(ej-e(jj)).lt.etol.and.jj.ne.k)then
       ndeg=ndeg+1
       if(ndeg.gt.4)then
        write(6,*)'Ndeg > 4 (?)'
        write(3,*)'Ndeg > 4 (?)'
        ndeg=4
       endif
       jdeg(ndeg)=jj
      endif
22    continue
c
      sums=z0
      sumt=z0
      if(ioe.eq.2.or.ioe.eq.3)then
       do 23 i2=1,ndeg
       jj=jdeg(i2)
       sumt=sumt-aj(k,jj)
23     sums=sums-aj(k,jj)+(ak(k,jj)+ak(k,jj))*aex
       sums=sums/dble(ndeg)
       sumt=sumt/dble(ndeg)
      endif
c
c     singlet and triplet states:
      ejks=ej-ek+sums
      ejkt=ej-ek+sumt
c     if(n.eq.1.and.m.eq.2)write(3,8777)k,j,ejks,ejkt,ej-ek,ej,ek
8777  format(2I3,5F8.4)
c
      if(abs(ejks).gt.etol)then
c
c      for paramagnetic is +, because of sqrt(-1)**2 from l-operator
       apdc=apdc+( oon(k,j,1)*oom(j,k,1)+oon(k,j,2)*oom(j,k,2)
     2            +oon(k,j,3)*oom(j,k,3)                      )/ejks
      endif
c
      if(abs(ejkt).gt.etol)then
c
c      Fermi:
       afc=afc-fkn*fjn*fkm*fjm/ejkt
c      tensor components  1  2  3  4  5  6
c                        xx xy xz yy yz zz
c      NxxMxx+NxyMxy+NxzMxz+NyxMyx+NyyMyy+NyzMyz+NzxMzx+NzyMzy+NzzMzz=
c      NxxMxx+NyyMyy+NzzMzz+2(NxyMxy+NxzMxz+NzyMzy=11+44+66+2*(22+33+55)
       aco4=-four/three*Pi
       tnxx=ttn(k,j,1)+aco4*fkn*fjn
       tmxx=ttm(j,k,1)+aco4*fjm*fkm
       tnyy=ttn(k,j,4)+aco4*fkn*fjn
       tmyy=ttm(j,k,4)+aco4*fjm*fkm
       tnzz=ttn(k,j,6)+aco4*fkn*fjn
       tmzz=ttm(j,k,6)+aco4*fjm*fkm
c
c      spin-dipolar:
       asd=asd-(     tnxx*tmxx+tnyy*tmyy+tnzz*tmzz+
     1          two*(ttn(k,j,2)*ttm(j,k,2)+ttn(k,j,3)*ttm(j,k,3)+
     1               ttn(k,j,5)*ttm(j,k,5)))/ejkt
       xxn= ttn(k,j,4)+ttn(k,j,6)
       yyn= ttn(k,j,1)+ttn(k,j,6)
       zzn= ttn(k,j,1)+ttn(k,j,4)
       xyn=-ttn(k,j,2)
       xzn=-ttn(k,j,3)
       yzn=-ttn(k,j,5)
       xxm= ttm(k,j,4)+ttm(k,j,6)
       yym= ttm(k,j,1)+ttm(k,j,6)
       zzm= ttm(k,j,1)+ttm(k,j,4)
       xym=-ttm(k,j,2)
       xzm=-ttm(k,j,3)
       yzm=-ttm(k,j,5)
       afcsd=afcsd-(xxn*xxm+yyn*yym+zzn*zzm+
     1         two*(xyn*xym+xzn*xzm+yzn*yzm))/ejkt
      endif
c
66    continue
c     j
c
55    continue
c     k
c
c     convert atomic units to SI and to Hz
      akdso(ii)=akdso(ii)*const2
      afc      =afc      *const4
      apdc     =apdc     *const6
      asd      =asd      *const8
      afcsd    =afcsd    *const8
c
c     adjust the g-factors and multiply by the spin factor
      call gyrf(gm,int(qz(m)),sm)
      call gyrf(gn,int(qz(n)),sn)
      pp=gn*gm
      call spin(spn,int(qz(n)),sn)
      call spin(spm,int(qz(m)),sm)
      pp=pp/spn/spm
      akdso(ii)=akdso(ii)*pp
      afc      =afc      *pp
      apdc     =apdc     *pp
      asd      =asd      *pp
      afcsd    =afcsd    *pp
c
      totalc(n,m)=akdso(ii)+afcsd+apdc
      totalc(m,n)=akdso(ii)+afcsd+apdc
      write(3,3000)sn,n,sm,m,n,m,afc,asd,afcsd,apdc,
     1 akdso(ii),totalc(n,m)
      write(6,3000)sn,n,sm,m,n,m,afc,asd,afcsd,apdc,
     1 akdso(ii),totalc(n,m)
3000  format(
     1' Atom pair  ',A3,' ',I5,' - ',A3,' ',I5,' /',I3,'@',I3,'/',/,
     2' ------------------------------',/,
     4' Fermi contact term           :',f11.4,/,
     6' Spin dipolar                 :',f11.4,'   FC + SD: ',f11.4,/,
     5' Paramagnetic spin orbit      :',f11.4,/,
     3' Diamagnetic spin orbit       :',f11.4,/,
     7' ------------------------------',/,
     8' Total coupling               :',f11.4,' [Hz]',/,/)
1     continue
c
      close(46)
      close(47)
      if(lsppl)call sppl
c
c     brief notation
      ii=0
      do n=1,nat-1
       write(6,3099)n
       write(3,3099)n
3099   format(i4,'. ATOM:')
       write(3,*)'ATOM ',n
       write(3,30991)(m,m=n+1,nat)
       write(3,30992)(totalc(n,m),m=n+1,nat)
       write(6,30991)(m,m=n+1,nat)
       write(6,30992)(totalc(n,m),m=n+1,nat)
30991  format(11i7)
30992  format(11f7.2)
       write(3,*)
       write(6,*)
      enddo
c
      return
      end
c
c     ============================================================
      subroutine gyrf(gn,izn,sn)
c     g-number = gyrf
c     u-magn. moment
c     un-nuclear magneton
c     l-spin
c     gamma - gyromagnetic ratio
c     hc - crossed Planck's constant
c
c     u = gamma . l = g . un . l / hc
c
      integer*4 izn
      real*8 gn,an
      character*3 sn
      an=0.0d0
      if(izn.eq.1)then
       an=2.792847d0
       sn=' 1H'
      endif
      if(izn.eq.6)then
       an=0.7024118d0
       sn='13C'
      endif
      if(izn.eq.7)then
       an=0.4037610d0
       sn='14N'
      endif
      if(izn.eq.8)then
       an=-1.89379d0
       sn='17O'
      endif
      if(izn.eq.9)then
       an=2.628868d0
       sn='19F'
      endif
      if(abs(an).lt.0.0001d0)then
       sn='XXX'
       an=2.7928474d0
       write(3,*)'Unknown atom kind, values for 1H used'
      endif
      gn=an
      return
      end
c
      subroutine spin(spn,izn,sn)
      integer*4 izn
      real*8 spn,an
      character*3 sn
      an=0.5d0
      sn='XXX'
      if(izn.eq.1)then
       sn=' 1H'
      endif
      if(izn.eq.6)then
       an=0.5
       sn='13C'
      endif
      if(izn.eq.7)then
       an=1.0
       sn='14N'
      endif
      if(izn.eq.8)then
       an=2.5
       sn='17O'
      endif
      if(izn.eq.9)then
       an=0.5
       sn='19F'
      endif
      if(sn.eq.'XXX')write(3,*)'Unknown atom kind, values for 1H used'
      spn=an
      return
      end
c     ==========================================================
      subroutine emptybuf(ib,rx,ry,rz,db,ione,ndo,vv,anro,
     1 noa,xv,akdso,pjdso,z0)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nr0=1000,nat0=190)
      dimension rx(nr0),ry(nr0),rz(nr0),db(nr0),vv(nr0),xv(3,noa),
     1akdso(nat0*(nat0+1)/2),pjdso(3*nat0,3*nat0)
c
      nb=ib
      close=0.01d0
      call rosnake(nb,rx,ry,rz,db,ione,ndo)
      do 901 ib=1,nb
      qc=vv(ib)*db(ib)
      anro=anro+qc
901   db(ib)=qc
      ii=0
      do 11 n=1,noa
      xn=xv(1,n)
      yn=xv(2,n)
      zn=xv(3,n)
      do 11 m=n+1,noa
      ii=ii+1
      xm=xv(1,m)
      ym=xv(2,m)
      zm=xv(3,m)
      del=z0
      do 902 ib=1,nb
      xxn=rx(ib)-xn
      yyn=ry(ib)-yn
      zzn=rz(ib)-zn
      rn2=xxn*xxn+yyn*yyn+zzn*zzn
      if(rn2.lt.close)goto 902
      xxm=rx(ib)-xm
      yym=ry(ib)-ym
      zzm=rz(ib)-zm
      rm2=xxm*xxm+yym*yym+zzm*zzm
      if(rm2.lt.close)goto 902
      rnm=xxn*xxm+yyn*yym+zzn*zzm
      del=del+db(ib)*rnm/(rn2*sqrt(rn2*rm2)*rm2)
902   continue
      akdso(ii)=akdso(ii)+del
11    continue
      do 1003 n=1,noa
      xn=xv(1,n)
      yn=xv(2,n)
      zn=xv(3,n)
      do 1003 m=1,noa
      xm=xv(1,m)
      ym=xv(2,m)
      zm=xv(3,m)
      delxx=z0
      delxy=z0
      delxz=z0
      delyx=z0
      delyy=z0
      delyz=z0
      delzx=z0
      delzy=z0
      delzz=z0
      do 903 ib=1,nb
      xxn=rx(ib)-xn
      yyn=ry(ib)-yn
      zzn=rz(ib)-zn
      rn2=xxn*xxn+yyn*yyn+zzn*zzn
      if(rn2.lt.close)goto 903
      xxm=rx(ib)-xm
      yym=ry(ib)-ym
      zzm=rz(ib)-zm
      rm2=xxm*xxm+yym*yym+zzm*zzm
      if(rm2.lt.close)goto 903
      t=db(ib)/(rn2*sqrt(rn2*rm2)*rm2)
      delxx=delxx+xxn*xxm*t
      delxy=delxy+xxn*yym*t
      delxz=delxz+xxn*zzm*t
      delyx=delyx+yyn*xxm*t
      delyy=delyy+yyn*yym*t
      delyz=delyz+yyn*zzm*t
      delzx=delzx+zzn*xxm*t
      delzy=delzy+zzn*yym*t
      delzz=delzz+zzn*zzm*t
903   continue
      pjdso(3*(n-1)+1,3*(m-1)+1)=pjdso(3*(n-1)+1,3*(m-1)+1)+delxx
      pjdso(3*(n-1)+1,3*(m-1)+2)=pjdso(3*(n-1)+1,3*(m-1)+2)+delxy
      pjdso(3*(n-1)+1,3*(m-1)+3)=pjdso(3*(n-1)+1,3*(m-1)+3)+delxz
      pjdso(3*(n-1)+2,3*(m-1)+1)=pjdso(3*(n-1)+2,3*(m-1)+1)+delyx
      pjdso(3*(n-1)+2,3*(m-1)+2)=pjdso(3*(n-1)+2,3*(m-1)+2)+delyy
      pjdso(3*(n-1)+2,3*(m-1)+3)=pjdso(3*(n-1)+2,3*(m-1)+3)+delyz
      pjdso(3*(n-1)+3,3*(m-1)+1)=pjdso(3*(n-1)+3,3*(m-1)+1)+delzx
      pjdso(3*(n-1)+3,3*(m-1)+2)=pjdso(3*(n-1)+3,3*(m-1)+2)+delzy
1003  pjdso(3*(n-1)+3,3*(m-1)+3)=pjdso(3*(n-1)+3,3*(m-1)+3)+delzz
      ib=0
      return
      end
c     ==================================================
