      subroutine densitymat
c     calculates density matrix
      implicit none
      integer*4 nat0,nor,nort
      parameter (nat0=190,nor=80,nort=700)
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     1nop,ish
      real*8 escf,cc,alpha,rcp,cij,bij,e,be
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      integer*4 i,j,k
      real*8 d(nort,nort),s(nort,nort),t(nort,nort),tr,sum

c     calculate density matrix
      do 1 i=1,nao
      do 1 j=1,nao
      d(i,j)=0.0d0
      sum=0.0d0
      do 2 k=1,ndo
2     sum=sum+cij(k,i)*cij(k,j)
      sum=sum+sum
      do 3 k=1,nsa
3     sum=sum+cij(k,i)*cij(k,j)
      do 4 k=1,nsb
4     sum=sum+bij(k,i)*bij(k,j)
1     d(i,j)=sum

      call wmtr(d,nort,nao,'Density Matrix:',1)

c     load overlap matrix
      open(33,file='SAO.SCR',form='unformatted')
      do 5 i=1,nao
      read(33)(s(j,i),j=1,i)
      do 5 j=1,i-1
5     s(i,j)=s(j,i)
      close(33)


c     multiply elements and check the trace
      tr=0.0d0
      do 6 i=1,nao
      do 6 j=1,nao
      t(i,j)=s(i,j)*d(i,j)
6     tr=tr+t(i,j)

      call wmtr(t,nort,nao,'Density x Overlap ijji:',1)

      open(33,file='PTD.SCR',form='unformatted')
      write(33)((t(i,j),i=1,nao),j=1,nao)
      close(33)

      write(6,6002)
6002  format(' D x S in PTD.SCR')

      write(6,6001)tr
6001  format(' Tr D.S = ',f10.2)

c     transform experimental ("GIAO") angular momenta:
      open(33,file='W.SCR',form='unformatted')
      open(34,file='U.SCR',form='unformatted')
      do 53 i=1,nao
      read(33)(s(i,j),j=1,nao)
      write(34)(s(i,j)*t(i,j),j=1,nao)
      read(33)(s(i,j),j=1,nao)
      write(34)(s(i,j)*t(i,j),j=1,nao)
      read(33)(s(i,j),j=1,nao)
53    write(34)(s(i,j)*t(i,j),j=1,nao)
      close(34)
      close(33)

      open(33,file='T.SCR',form='unformatted')
      open(34,file='C.SCR',form='unformatted')
      do 54 i=1,nao
      read(33)(s(i,j),j=1,nao)
      write(34)(s(i,j)*t(i,j),j=1,nao)
      read(33)(s(i,j),j=1,nao)
      write(34)(s(i,j)*t(i,j),j=1,nao)
      read(33)(s(i,j),j=1,nao)
54    write(34)(s(i,j)*t(i,j),j=1,nao)
      close(34)
      close(33)

      return
      end
