      subroutine diagodd(n,ist)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (nh0=1200)
      dimension h(nh0,nh0),z(nh0,nh0),e(nh0),d(nh0),
     1ar(nh0),iar(nh0),ind(nh0)
c
      do i=1,n
       ind(i)=i
       do j=1,n
        h(i,j)=0.0d0
       enddo
      enddo
c
      if(ist.eq.1)open(20,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='AT.SCR',form='unformatted')
      read(20)nd
      if(nd.ne.n)write(6,*)nd,n
      if(nd.ne.n)call report('nd<>n')
      if(nd.gt.nh0)call report('nd>nh0')
      do 5 i=1,n
      read(20)ni,(ar(ii),ii=1,ni),(iar(ii),ii=1,ni)
      do 5 jj=1,ni
      j=iar(jj)
      h(j,i)=ar(jj)
      if(j.eq.i)h(j,i)=2.0d0*h(j,i)
5     h(i,j)=h(j,i)
      close(20)
c
c     do i=1,n
c      write(3,*)i
c      write(3,3999)(h(i,j),j=1,i)
c3999   format(6f13.5)
c     enddo
c
      at=mclock()
      IEIG=2
      call TRED12(N,h,Z,D,IEIG,IERR,nh0,E)
      write(6,*)'Direct diagonalization time=',mclock()-at
      if(ist.eq.1)open(23,file='ECI.SCR',form='unformatted')
      if(ist.eq.3)open(23,file='ECIT.SCR',form='unformatted')
      write(23)n
      do i=1,n
       write(23)d(i)
      enddo
      write(23)(ind(i),i=1,n)
      close(23)
      if(ist.eq.1)open(23,file='EV.SCR',form='unformatted')
      if(ist.eq.3)open(23,file='EVT.SCR',form='unformatted')
      do i=1,n
       write(23)(z(j,i),j=1,n)
      enddo
      close(23)
      return
      end
c     ================================
      subroutine diagodsk(n,nv,ist)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (nhcir=100000)
      dimension d(nhcir),x(nhcir),y(nhcir),z(nhcir),ind(nhcir)
c
      at=mclock()
      call diagos(n,d,x,y,z,ind,nv,ist)
      write(6,*)'Disk diagonalization time=',mclock()-at
      if(ist.eq.1)open(23,file='ECI.SCR',form='unformatted')
      if(ist.eq.3)open(23,file='ECIT.SCR',form='unformatted')
      write(23)nv
      do 1 i=1,nv
1     write(23)d(i)
      write(23)(ind(i),i=1,nv)
      close(23)
      return
      end
c     ===========================================
      SUBROUTINE diagos(n,D,x,y,z,ind,nv,ist)
c
c     sparse matrix diagonalization,
c     A is on disk in A.SCR/AT.SCR, EV will be in EV.SCR, ECI.SCR
c
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (nhcir=100000)
      parameter (itmax=500,tol=1.0d-10)
      DIMENSION D(nhcir),x(nhcir),y(nhcir),z(nhcir),
     1ar(nhcir),iar(nhcir),ind(nhcir)
      common/iopts/iopt(300)
      equivalence (nev,iopt(19))
c
      if(nev.ne.0)nv=nev
      write(6,*)'Finding',nv,' vectors of ',n
c
c     form initial eigenvectors
      if(ist.eq.1)open(20,file='EV.SCR',form='unformatted')
      if(ist.eq.3)open(20,file='EVT.SCR',form='unformatted')
      do 2 i=1,n
2     x(i)=0.0d0
      do 1 i=1,nv
      d(i)=1.0d7
      x(i)=1.0d0
      write(20)(x(j),j=1,n)
1     x(i)=0.0d0
c
      ic=0
c
c     get new eigenvectors and eigenvalues
999   ic=ic+1
      if(ic.gt.itmax)goto 777
      rewind 20
c
      grad=0.0d0
      grad2=0.0d0
      do 3 i=1,nv
c
c     read old eigenvector Xi:
      read(20)(x(j),j=1,n)
c
c     make Yi=A.Xi
      if(ist.eq.1)open(27,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(27,file='AT.SCR',form='unformatted')
      read(27)nd
      if(nd.ne.n)call report('nd<>n')
      do 7 j=1,n
7     y(j)=0.0d0
      do 8 ii=1,n
      read(27)ni,(ar(jj),jj=1,ni),(iar(jj),jj=1,ni)
      do 8 js=1,ni
      jj=iar(js)
      y(jj)=y(jj)+ar(js)*x(ii)
8     y(ii)=y(ii)+ar(js)*x(jj)
      close(27)
c
c     get new eigenvalue li=Xi.Yi
      al=0.0d0
      do 5 j=1,n
5     al=al+x(j)*y(j)
c
      do 52 j=1,n
52    grad2=grad2+abs(y(j)-al*x(j))
c
      grad=grad+abs(al-d(i))
      d(i)=al
c
c     ortonormalize to previous eigenvextors Xip,ip=1..i-1, write to Zi
      rewind 20
      do 18 j=1,n
18    z(j)=y(j)
      do 10 j=1,i-1
      read(20)(x(ii),ii=1,n)
      sp=0.0d0
      do 11 ii=1,n
11    sp=sp+y(ii)*x(ii)
      do 10 ii=1,n
10    z(ii)=z(ii)-sp*x(ii)
      an=0.0d0
      do 12 ii=1,n
12    an=an+z(ii)**2
      an=1.0d0/sqrt(an)
      do 13 ii=1,n
13    z(ii)=z(ii)*an
c
c     write new Xi in place of the old one:
3     write(20)(z(ii),ii=1,n)
c
      write(6,700)grad,ic
      write(6,*)'grad2',grad2
      write(6,*)'al',al
      if(grad.gt.tol*dble(n))goto 999
777   close(20)
      write(6,700)grad,ic
700   format('gradient:',f20.15,' iteration ',i3)
c
c     order eigedmaxnvalues, bubble sort
      do 142 i=1,nv
142   ind(i)=i
      do 14 i=1,nv
      imax=i
      dmax=d(i)
      do 15 j=i+1,nv
      if(d(j).gt.dmax)then
       dmax=d(j)
       imax=j
      endif
15    continue
      if(imax.ne.i)then
       it=ind(i)
       ind(i)=ind(imax)
       ind(imax)=it
       et=d(i)
       d(i)=dmax
       d(imax)=et
      endif
14    continue
c
      return
      end
c     ================================
      subroutine diagomit(n,nv,ist)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (nhcir=100000)
      dimension d(nhcir)
      common/iopts/iopt(300)
      equivalence (nev,iopt(19)),(mmit,iopt(20))
c
      if(mmit.lt.2)mmit=10
      at=mclock()
      NE=nv
      if(nev.gt.0)NE=nev
      ELMAX=1.0d10
      J1=1
      write(6,*)'Mitin diagonalization'
      call mitin5(mmit,NE,ELMAX,D,IERR,MV,J1,n,ist)
      write(6,*)'Mitin diagonalization time=',mclock()-at
      return
      end
