      subroutine dnmr(ioe)
c
c     nuclear shielding tensor
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=42,
     1ndegmax=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension dmo(nel,nort),chip(3,3),chit(3,3),
     6 chidgiao(3,3),temd(nort),chidlorg(3,3),tem3(3,nort,nort),
     1 ct(3,nort),chip2(3,3),am(3),
     7 cor(3,3),jdeg(ndegmax),chid1(3,3),chid2(3,3)
      logical ldo,lscf,lopt,lgiao,lall,lssup,lrgr,lmoscr,lorg,
     1lex,lsprint
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(21),lscf),(lopt(32),lgiao),
     1(lopt(44),lall),(lopt(46),lssup),(lopt(79),lrgr),
     1(lopt(80),lorg),(lopt(1),lsprint)
      common/d1007/tem(nort*nort),temmo(nort*nort),btem(nort*nort),
     1ee3(3,nort),rr3(3,nort),cc3(3,nort),or3(3,nort),cijtem(nort**2)
      character*7 fm(3)
      data fm/'PMO.SCR','LMO.SCR','VMO.SCR'/
      dimension kkfm(3),id(3)
      data kkfm/18,12,30/
      data id/3,3,3/
      character*6 aof(5)
      data aof/'F1.SCR','F2.SCR','F3.SCR','F4.SCR','F5.SCR'/
      character*8 mof(5)
      data mof/'F1MO.SCR','F2MO.SCR','F3MO.SCR','F4MO.SCR','F5MO.SCR'/
      dimension jxf(5)
      data jxf/3,3,9,9,9/
      dimension kkf(5)
      data kkf/15,0,3,21,33/
      dimension uloc(nort,nort)
c
      I0=0
      etol=0.00001d0
      ppm=one/(clau*clau)*1.0d6
      write(3,4001)nmo,nao
4001  format(' Nuclear shielding tensor; NMO = ',I3,' NAO = ',I3)
      if(nao.gt.nort)call report('Too many orbitals for dqmpol2')
      call inibe4
      iu=0
      if(ldo)iu=iu+1
      if(lgiao)iu=iu+1
      if(lorg)iu=iu+1
      if(iu.gt.1)call report('Only one of {giao,ldo,lorg} allowed')
      if(ldo)then
       call w36(' Distributed origin gauge')
      else
       if(lgiao)then
        call w36(' Giao - diamagnetic part only')
       else
        if(lorg)then
         call w36(' LORG')
         call lookl(uloc)
c
c        checking orthogonality
         tol=1.0d-5
         do i=1,nmo
         do j=1,nmo
         sum=0.0d0
         do ii=1,nmo
         sum=sum+uloc(ii,i)*uloc(ii,j)
         enddo
         if(i.eq.j.and.abs(sum-1.0d0).gt.tol)call report('Norm error 1')
         if(i.ne.j.and.abs(sum).gt.tol)      call report('Norm error 2')
         enddo
         enddo
         do i=1,nmo
         do j=1,nmo
         sum=0.0d0
         do ii=1,nmo
         sum=sum+uloc(i,ii)*uloc(j,ii)
         enddo
         if(i.eq.j.and.abs(sum-1.0d0).gt.tol)call report('Norm error 3')
         if(i.ne.j.and.abs(sum).gt.tol)      call report('Norm error 4')
         enddo
         enddo
         do i=1,ndo
         do j=1,ndo
         sum=0.0d0
         do ii=1,ndo
         sum=sum+uloc(ii,i)*uloc(ii,j)
         enddo
         if(i.eq.j.and.abs(sum-1.0d0).gt.tol)call report('Norm error 5')
         if(i.ne.j.and.abs(sum).gt.tol)      call report('Norm error 6')
         enddo
         enddo
         do i=ndo+1,nmo
         do j=ndo+1,nmo
         sum=0.0d0
         do ii=ndo+1,nmo
         sum=sum+uloc(i,ii)*uloc(j,ii)
         enddo
         if(i.eq.j.and.abs(sum-1.0d0).gt.tol)call report('Norm error 7')
         if(i.ne.j.and.abs(sum).gt.tol)      call report('Norm error 8')
         enddo
         enddo
         write(6,*)'Uloc orthogonality check passed'
        else
         call w36(' Common origin gauge')
        endif
       endif
      endif
c
      if(lrgr)then
       call overgr(1)
       inquire(file='RGRMO.SCR',exist=lmoscr)
       if(.not.lmoscr)call makemos3(nao,cij,nmo)
       call w36('RGR gradient')
      endif
c
      if(lall)then
       call w36('all js')
       jstart=1
      else
       call w36('virtual js')
       jstart=ndo+1
      endif
      if(lssup)call report('lssup not implemented for NMR')
c
      if(lorg)then
c      if lorg, transform r into LMO
c      Rx Ry Rz,  <k|r|k> = U(k,K)U(k,K')<K|r|K'>
       call w36('getting local origins')
       open(36,file=fm(1),form='unformatted')
       do ix=1,3
        do 21 k=1,nmo
21      read(36)(tem((k-1)*nmo+j),j=1,nmo)
        do 22 k=1,nmo
        do 22 ks=1,ndo
        sum=0.0d0
        do 23 kk=1,nmo
23      sum=sum+uloc(ks,kk)*tem((kk-1)*nmo+k)
22      btem((k-1)*nmo+ks)=sum
        dip=0.0d0
        do 24 ks=1,ndo
        sum=0.0d0
        do 25 k=1,nmo
25      sum=sum+uloc(ks,k)*btem((k-1)*nmo+ks)
        or3(ix,ks)=sum
24      dip=dip+sum
        write(3,3400)ix,-dip-dip
3400    format('Dipole ',i1,' :',f15.6)
       enddo
       close(36)
       write(3,*)'local origins'
       sx=0.0d0
       sy=0.0d0
       sz=0.0d0
       do k=1,ndo
        write(3,6057)k,(or3(ix,k),ix=1,3)
6057    format(i5,3f10.4)
        sx=sx+or3(1,k)
        sy=sy+or3(2,k)
        sz=sz+or3(3,k)
       enddo
       write(6,6058)sx,sy,sz
6058   format('sum  ',3f10.4)
      endif
c
c     get <K|C|K'> = sum(k, occupied) u^K'_k <k|R|k> u^K_k
      inquire(file='CKK.SCR',exist=lex)
      if(lorg.and..not.lex)then
       open(37,file='CKK.SCR',form='unformatted')
       do 29 k=1,ndo
       do 27 ix=1,3
       do 27 kp=1,ndo
       sum=0.0d0
       do 28 ks=1,ndo
28     sum=sum+uloc(ks,k)*or3(ix,ks)*uloc(ks,kp)
27     cc3(ix,kp)=sum
       do 29 ix=1,3
29     write(37)(cc3(ix,j),j=1,ndo)
       close(37)
      endif
c
c     get <K|E|K'> = sum(K, occupied) C_KK' (eJ-eK')^-1 x <K'|grad/2|J>
      inquire(file='EKK.SCR',exist=lex)
      if(lorg.and..not.lex)then
c
c      read in gradient, keep all in tem3
       open(36,file=fm(3),form='unformatted')
       do 30 ix=1,id(3)
       do 30 k=1,nmo
30     read(36)(tem3(ix,k,j),j=1,nmo)
       close(36)
c
c      read C and contract, form vector product,record for each K
       open(36,file='CKK.SCR',form='unformatted')
       open(37,file='EKK.SCR',form='unformatted')
       do 31 k=1,ndo
       do 34 ix=1,3
34     read(36)(ct(ix,kp),kp=1,ndo)
       do kp=1,ndo
       if(k.eq.1)write(6,*)'c',ct(1,kp),ct(2,kp),ct(3,kp)
       enddo
       do 32 j=1,nmo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 33 kp=1,ndo
       if(kp.eq.j)goto 33
       de=e(j)-e(kp)
       if(abs(de).lt.etol)goto 33
       sumx=sumx+(ct(2,kp)*tem3(3,kp,j)-ct(3,kp)*tem3(2,kp,j))/de*half
       sumy=sumy+(ct(3,kp)*tem3(1,kp,j)-ct(1,kp)*tem3(3,kp,j))/de*half
       sumz=sumz+(ct(1,kp)*tem3(2,kp,j)-ct(2,kp)*tem3(1,kp,j))/de*half
33     continue
       ee3(1,j)=sumx
       ee3(2,j)=sumy
32     ee3(3,j)=sumz
       do 31 ix=1,3
31     write(37)(ee3(ix,j),j=1,nmo)
       close(36)
       close(37)
      endif
c
c     and <K|R|K'> = sum(K, occupied) C_KK' x <K'|r|J>
      inquire(file='RKK.SCR',exist=lex)
      if(lorg.and..not.lex)then
c
c      read in dipoles, keep all in tem3
       open(36,file=fm(1),form='unformatted')
       do 35 ix=1,id(1)
       do 35 k=1,nmo
35     read(36)(tem3(ix,k,j),j=1,nmo)
       close(36)
c
c      read C and contract, form vector product,record for each K
       open(36,file='CKK.SCR',form='unformatted')
       open(37,file='RKK.SCR',form='unformatted')
       do 36 k=1,ndo
       do 38 ix=1,3
38     read(36)(ct(ix,kp),kp=1,ndo)
       do 44 l=1,ndo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 20 kp=1,ndo
       sumx=sumx+ct(2,kp)*tem3(3,kp,l)-ct(3,kp)*tem3(2,kp,l)
       sumy=sumy+ct(3,kp)*tem3(1,kp,l)-ct(1,kp)*tem3(3,kp,l)
20     sumz=sumz+ct(1,kp)*tem3(2,kp,l)-ct(2,kp)*tem3(1,kp,l)
       rr3(1,l)=sumx
       rr3(2,l)=sumy
44     rr3(3,l)=sumz
       do 36 ix=1,3
36     write(37)(rr3(ix,l),l=1,ndo)
       close(36)
       close(37)
      endif
c
c     construct MO overlaps:<I|o|J>=cIi*cJj<i|o|j> symbolicaly((r-Rb) divided):
c       F2           F3                                   F1
c       (r-Rb)xgrad  (r-Rb) r                    l        (r-Rb)   r  r  r
c     k=1  2  3      4  5  6  7  8  9  10 11 12  13 14 15 16 17 18 19 20 21
c       x  y  z      xx xy xz yx yy yz zx zy zz  x  y  z  x  y  z  x  y  z
c
c     F4                                  F5
c     r (r-Rb)xr                 grad     giao correction to diamagn
c     22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42
c     xx xy xz yx yy yz zx zy zz  x  y  z xx xy xz yx yy yz zx zy zz
c
c     for each atom:
      inquire(file='NMR.RES',exist=lex)
      if(lex)then
       open(34,file='NMR.RES')
       read(34,*)latstart
       close(34)
       write(6,*)' Restarted from atom ',latstart
      else
       latstart=1
      endif
      do 1212 lat=latstart,noa
      iz=int(z(lat))
      write(3,*)' Atom ',lat,', charge ',iz
      write(6,*)' Atom ',lat,', charge ',iz
      ax=xv(1,lat)
      ay=xv(2,lat)
      az=xv(3,lat)
c
      do 11 i=1,3
      do 11 j=1,3
      chid1(i,j)=z0
      chid2(i,j)=z0
      chidlorg(i,j)=z0
      chidgiao(i,j)=z0
      chip2(i,j)=z0
11    chip(i,j)=z0
c
      if(ioe.ne.0.and.lat.eq.1)then
       write(3,3334)
3334  format(
     1'  j  k         ejk =         ej -         ek -      Jjk + 2 x ',
     2'       Kjk',/,80(1H-))
      endif
      if((ioe.eq.2.or.ioe.eq.3).and.lat.eq.1)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nmo),j=1,nmo),((aj(i,j),i=1,nmo),j=1,nmo)
       close(23)
       write(6,*)'Coulomb and exchange terms read from scratch.'
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     call overlaps(lat,I0)
      call overnmr(lat,I0)
c
c     transform to MOs
      write(6,*)'transforming to MOs'
c
      if(ldo.or.lorg)then
       kstart=1
      else
       kstart=2
      endif
      if(lgiao)then
       kend=5
      else
       kend=3
      endif
c
      do i=1,nmo
       do j=1,nao
        cijtem(j+(i-1)*nmo)=cij(i,j)
       enddo
      enddo
      do k=kstart,kend
       open(43,file=aof(k),form='unformatted')
       open(49,file=mof(k),form='unformatted')
       do 39 ic=1,jxf(k)
       rewind 43
       do 41 i=1,nao
       do 40 ii=1,ic-1
40     read(43)
       read(43)(tem(j+(i-1)*nao),j=1,nao)
       do 41 ii=ic+1,jxf(k)
41     read(43)
       call taomo21(tem,temmo,cijtem,nort,nort,nmo,nao,btem)
       do 39 i=1,nmo
39     write(49)(temmo(j+(i-1)*nmo),j=1,nmo)
       close(43)
       close(49)
      enddo
c
c     sum over occupied orbitals
      if(lorg)then
       open(67,file='EKK.SCR',form='unformatted')
       open(68,file='RKK.SCR',form='unformatted')
       open(69,file='CKK.SCR',form='unformatted')
      endif
      do 5 k=1,ndo
c
      if(lorg)then
       do 42 ix=1,3
       read(69)(cc3(ix,j),j=1,ndo)
       read(68)(rr3(ix,j),j=1,ndo)
42     read(67)(ee3(ix,j),j=1,nmo)
      endif
c
c     read F1,F2,F3,F4,F5
      do ic=kstart,kend
       open(49,file=mof(ic),form='unformatted')
       kk=kkf(ic)
       do ix=1,jxf(ic)
        kk=kk+1
        do kc=1,nmo
         if(kc.eq.k)then
          read(49)(dmo(kk,j),j=1,nmo)
         else
          read(49)
         endif
        enddo
       enddo
       close(49)
      enddo
c
c     read Rx Ry Rz, Lx Ly Lz ( (1/2) r x grad ) and gradx grady gradz:
      do ic=1,3
       kk=kkfm(ic)
       open(86,file=fm(ic),form='unformatted')
       do ix=1,id(ic)
        kk=kk+1
        do kc=1,nmo
         if(kc.eq.k)then
          read(86)(dmo(kk,j),j=1,nmo)
         else
          read(86)
         endif
        enddo
       enddo
       close(86)
      enddo
c
c     if RGR replace the gradient
      if(lrgr)then
       kk=12
       open(36,file='RGRMO.SCR',form='unformatted')
       do ix=1,3
        kk=kk+1
        do kc=1,nmo
         if(kc.eq.k)then
          read(36)(temd(j),j=1,nmo)
          do j=1,nmo
           if(lat.eq.1)write(3,3434)k,ix,j,temd(j),dmo(kk,j)
3434       format('<',i3,'|',i1,'|',i3,'>: ',2f10.5)
           dmo(kk,j)=temd(j)
          enddo
         else
          read(36)
         endif
        enddo
       enddo
       close(36)
      endif
c
c     sum over excited states = virtual orbitals
c
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies, Kjk neglected
      ejk=e(j)-e(k)
c
      if(ioe.eq.2.or.ioe.eq.3)then
c
c      check for degeneracy
       ndeg=1
       jdeg(1)=1
       do 2 jj=jstart,nmo
       if(jj.ne.j.and.jj.ne.k)then
        if(abs(e(j)-e(jj)).lt.0.001d0)then
         ndeg=ndeg+1
         if(ndeg.gt.ndegmax)call report('degeneracy too high')
         jdeg(ndeg)=jj
        endif
       endif
2      continue
       ckj=z0
       ekj=z0
       do ju=1,ndeg
        jj=jdeg(ju)
        ckj=ckj+aj(k,jj)
        ekj=ekj+ak(k,jj)
       enddo
       ckj=ckj/dble(ndeg)
       ekj=ekj/dble(ndeg)
       ejk=ejk-ckj+two*ekj
       if(lat.eq.1)write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333   format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1 ' + 2 x ',F10.6)
      endif
c
      if(abs(ejk).lt.etol)goto 6
      ejki=one/ejk
      w4=ejki*four
c
      am(1)=dmo(13,j)
      am(2)=dmo(14,j)
      am(3)=dmo(15,j)
c
      if(ldo)then
c
c      r -> r-A    <r x grad/2> -> <(r-A) x grad/2>
       gx=dmo(31,j)
       gy=dmo(32,j)
       gz=dmo(33,j)
       am(1)=am(1)-half*(ay*gz-az*gy)
       am(2)=am(2)-half*(az*gx-ax*gz)
       am(3)=am(3)-half*(ax*gy-ay*gx)
      endif
c
c     <K|m|J><J|rNxgr|K>
c     chip -first index -magnetic field(el moment)
      do 10 ix=1,3
      do 10 jx=1,3
10    chip(ix,jx)=chip(ix,jx)-am(ix)*dmo(jx,j)*w4
c
      if(lorg)then
       do 17 ix=1,3
       do 17 jx=1,3
17     chip2(ix,jx)=chip2(ix,jx)+4.0d0*ee3(ix,j)*dmo(jx,j)
       if(k.eq.1.and.j.eq.12)
     1 write(6,*)k,j,ee3(1,j),dmo(1,j),chip2(1,1)*ppm
      endif
c
      if(lgiao)then
       oxx=dmo(22,j)
       oxy=dmo(23,j)
       oxz=dmo(24,j)
       oyx=dmo(25,j)
       oyy=dmo(26,j)
       oyz=dmo(27,j)
       ozx=dmo(28,j)
       ozy=dmo(29,j)
       ozz=dmo(30,j)
       gx =dmo(31,j)
       gy =dmo(32,j)
       gz =dmo(33,j)
c      chip    grad  rO
c      xx   ->  y    zx  - z   yx
c      xy   ->  z    xx  - x   zx  etc
       cor(1,1)=gy*ozx-gz*oyx
       cor(1,2)=gz*oxx-gx*ozx
       cor(1,3)=gx*oyx-gy*oxx
       cor(2,1)=gy*ozy-gz*oyy
       cor(2,2)=gz*oxy-gx*ozy
       cor(2,3)=gx*oyy-gy*oxy
       cor(3,1)=gy*ozz-gz*oyz
       cor(3,2)=gz*oxz-gx*ozz
       cor(3,3)=gx*oyz-gy*oxz
c      <K|m|J><J|rNxgr|K>+<K|grad|J> x <J|r rNxgr|K>+
       do 12 ix=1,3
       do 12 jx=1,3
12     chip(ix,jx)=chip(ix,jx)-half*cor(jx,ix)*w4
c      half above because of (1/2)rxgrad
      endif
c
c
6     continue
c     (virtual orbitals)
c
c
c     normal diamagnetic shielding:
c     should be multiplied by 2 for occupied orbital,
c     but the H(1,1) terms involves a half
c     <K|[r.(r-rL) E - r (r-rL)]/|r-rL|^3|K>
      iin=3
      do 13 i3=1,3
      do 13 j3=1,3
      iin=iin+1
13    chid1(i3,j3)=chid1(i3,j3)+dmo(iin,k)
c
      if(lgiao)then
c      correction to diamagnetic part comming from the
c      paramagnetic giao hamiltonian derivative:
       iin=33
       do 15 i3=1,3
       do 15 j3=1,3
       iin=iin+1
15     chidgiao(i3,j3)=chidgiao(i3,j3)+dmo(iin,k)
      endif
c
      if(ldo)then
c
c      <(r-rL) r> -> <(r-rL) r> - <r-rL> A
       gx=dmo(16,k)
       gy=dmo(17,k)
       gz=dmo(18,k)
       chid1(1,1)=chid1(1,1)-ay*gy-az*gz
       chid1(1,2)=chid1(1,2)+ay*gx
       chid1(1,3)=chid1(1,3)+az*gx
       chid1(2,1)=chid1(2,1)+ax*gy
       chid1(2,2)=chid1(2,2)-ax*gx-az*gz
       chid1(2,3)=chid1(2,3)+az*gy
       chid1(3,1)=chid1(3,1)+ax*gz
       chid1(3,2)=chid1(3,2)+ay*gz
       chid1(3,3)=chid1(3,3)-ay*gy-ax*gx
      endif

      if(lorg)then
       do 43 l=1,ndo
       gx=dmo(16,l)
       gy=dmo(17,l)
       gz=dmo(18,l)
       rkx=cc3(1,l)
       rky=cc3(2,l)
       rkz=cc3(3,l)
c
c      -2 RKL<L||r-rL|^-3 (r-rL)xgrad|K>
       if(.not.lall)then
        do 18 jx=1,3
        do 18 ix=1,3
18      chidlorg(jx,ix)=chidlorg(jx,ix)+two*rr3(ix,l)*dmo(jx,l)
       endif
c
c      <K|[CKL.(r-rL) E - CKL (r-rL)]/|r-rL|^3|K>
       chid2(1,1)=chid2(1,1)-rky*gy-rkz*gz
       chid2(1,2)=chid2(1,2)+rky*gx
       chid2(1,3)=chid2(1,3)+rkz*gx
       chid2(2,1)=chid2(2,1)+rkx*gy
       chid2(2,2)=chid2(2,2)-rkx*gx-rkz*gz
       chid2(2,3)=chid2(2,3)+rkz*gy
       chid2(3,1)=chid2(3,1)+rkx*gz
       chid2(3,2)=chid2(3,2)+rky*gz
43     chid2(3,3)=chid2(3,3)-rky*gy-rkx*gx
      endif
c
5     continue
c     (occupied orbitals)
      close(67)
      close(68)
      close(69)
c
      do 37 i=1,3
      do 37 j=1,3
      chid1(i,j)=chid1(i,j)*ppm
      chid2(i,j)=chid2(i,j)*ppm
      chidgiao(i,j)=chidgiao(i,j)*ppm
      chidlorg(i,j)=chidlorg(i,j)*ppm
      chip2(i,j)=chip2(i,j)*ppm
37    chip(i,j)=chip(i,j)*ppm
c
      if(lorg.and.lsprint)then
       call stout('Shielding tensor, para 1 :',chip,iz)
       call stout('Shielding tensor, para 2 :',chip2,iz)
       call stout('Shielding tensor, dia 1 :',chid1,iz)
       call stout('Shielding tensor, dia 2 :',chid2,iz)
       call stout('Shielding tensor, dia 3 :',chidlorg,iz)
      endif
c
      do 19 i=1,3
      do 19 j=1,3
      chip(i,j)=chip(i,j)+chip2(i,j)
      chid1(i,j)=chid1(i,j)+chid2(i,j)+chidlorg(i,j)
19    chit(i,j)=chid1(i,j)+chip(i,j)
c
      if(lsprint)then
       call stout('Shielding tensor, diamagnetic :',chid1,iz)
       call stout('Shielding tensor, paramagnetic:',chip,iz)
      endif
c
      call stout('Shielding tensor, total       :',chit,iz)
c
      if(lgiao)then
       do 16 i=1,3
       do 16 j=1,3
16     chid1(i,j)=chid1(i,j)+chidgiao(i,j)
       call stout('Effective giao diamagnetic',chid1,iz)
      endif
c
c     if(lorg)call stout('LORG double occupied part:',chidlorg,iz)
c
1212  continue
c     (new atom lat)
c
      return
      end
c
      subroutine stout(ss,chi,iz)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*(*) ss
      real*8 chi(3,3),sp,ai,z(3,3),e(3),d(3),
     1chis(3,3)
c
      write(6,*)ss
      write(3,*)ss
      sp=(chi(1,1)+chi(2,2)+chi(3,3))/3.0d0
      do 2 i=1,3
      do 2 j=1,i
      chis(i,j)=(chi(i,j)+chi(j,i))*0.50d0
2     chis(j,i)=chis(i,j)
      call TRED12(3,chis,Z,D,2,IERR,3,e)
      im=1
      if(d(2).gt.d(1))im=2
      if(d(3).gt.d(im))im=3
      ai=d(im)
      do 1 i=1,3
1     if(i.ne.im)ai=ai-0.5d0*d(i)
c
c     first index magnetic field;second nuclear moment
      write(3,4006)((chi(j,i),i=1,3),j=1,3),sp,d,ai
      write(6,4006)((chi(j,i),i=1,3),j=1,3),sp,d,ai
4006  format(/,'                         ',14x,'Mx',14x,'My',14x,'Mz',/,
     1         '    Chi             Bx   ',3F16.8,/,
     2         '  [ppm]             By   ',3F16.8,/,
     3         '                    Bz   ',3F16.8,/,
     4         '                         ',16(1H-),/,
     5         '    (Tr Chi)/3           ',F16.8,/,
     6         '    eigenvalues          ',3F16.8,/,
     7         '    anisotropy           ',F16.8,/,/)
c
      open(70,file='NMR')
7     read(70,*,end=999,err=999)
      goto 7
999   write(70,700)iz,sp,ai
700   format(i6,2f12.4)
      close(70)
c
      return
      end

      subroutine doCRE
c     LORG matrices
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension tem3(3,nort,nort),ct(3,nort)
      logical ldo,lscf,lopt,lgiao,lall,lssup,lrgr,lorg,
     1lex,lsprint
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(21),lscf),(lopt(32),lgiao),
     1(lopt(44),lall),(lopt(46),lssup),(lopt(79),lrgr),
     1(lopt(80),lorg),(lopt(1),lsprint)
      common/d1007/tem(nort*nort),temmo(nort*nort),btem(nort*nort),
     1ee3(3,nort),rr3(3,nort),cc3(3,nort),or3(3,nort),cijtem(nort**2)
      character*7 fm(3)
      data fm/'PMO.SCR','LMO.SCR','VMO.SCR'/
      dimension kkfm(3),id(3)
      data kkfm/18,12,30/
      data id/3,3,3/
      character*6 aof(5)
      data aof/'F1.SCR','F2.SCR','F3.SCR','F4.SCR','F5.SCR'/
      character*8 mof(5)
      data mof/'F1MO.SCR','F2MO.SCR','F3MO.SCR','F4MO.SCR','F5MO.SCR'/
      dimension jxf(5)
      data jxf/3,3,9,9,9/
      dimension kkf(5)
      data kkf/15,0,3,21,33/
      dimension uloc(nort,nort)
c
      I0=0
      etol=0.00001d0
      ppm=one/(clau*clau)*1.0d6
      if(nao.gt.nort)call report('Too many orbitals for dqmpol2')
      call lookl(uloc)
c     if lorg, transform r into LMO
c     Rx Ry Rz,  <k|r|k> = U(k,K)U(k,K')<K|r|K'>
      call w36('getting local origins')
      open(36,file=fm(1),form='unformatted')
      do 1 ix=1,3
      do 21 k=1,nmo
21    read(36)(tem((k-1)*nmo+j),j=1,nmo)
      do 22 k=1,nmo
      do 22 ks=1,nmo
      sum=0.0d0
      do 23 kk=1,nmo
23    sum=sum+uloc(ks,kk)*tem((kk-1)*nmo+k)
22    btem((k-1)*nmo+ks)=sum
      dip=0.0d0
      do 24 ks=1,nmo
      sum=0.0d0
      do 25 k=1,nmo
25    sum=sum+uloc(ks,k)*btem((k-1)*nmo+ks)
      or3(ix,ks)=sum
24    dip=dip+sum
1     write(3,3400)ix,-dip-dip
3400  format('Dipole ',i1,' :',f15.6)
      close(36)

      write(3,*)'local origins'
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do 2 k=1,nmo
      write(3,6057)k,(or3(ix,k),ix=1,3)
6057  format(i5,3f10.4)
      sx=sx+or3(1,k)
      sy=sy+or3(2,k)
2     sz=sz+or3(3,k)
      write(6,6058)sx,sy,sz
6058  format('sum  ',3f10.4)
c
c     get <K|C|K'> = sum(k, occupied) u^K'_k <k|R|k> u^K_k
      inquire(file='CKK.SCR',exist=lex)
      if(lex)then
       call w36('CKK.SCR found, unchanged')
      else
       open(37,file='CKK.SCR',form='unformatted')
       do 29 k=1,nmo
       do 27 ix=1,3
       do 27 kp=1,nmo
       sum=0.0d0
       do 28 ks=1,nmo
28     sum=sum+uloc(ks,k)*or3(ix,ks)*uloc(ks,kp)
27     cc3(ix,kp)=sum
       do 29 ix=1,3
29     write(37)(cc3(ix,j),j=1,nmo)
       close(37)
       call w36('CKK.SCR done')
      endif
c
c     get <K|E|K'> = sum(K, occupied) C_KK' (eJ-eK')^-1 x <K'|grad/2|J>
      inquire(file='EKK.SCR',exist=lex)
      if(lex)then
       call w36('EKK.SCR found, unchanged')
      else
c      read in gradient, keep all in tem3
       open(36,file=fm(3),form='unformatted')
       do 30 ix=1,id(3)
       do 30 k=1,nmo
30     read(36)(tem3(ix,k,j),j=1,nmo)
       close(36)
c
c      read C and contract, form vector product,record for each K
       open(36,file='CKK.SCR',form='unformatted')
       open(37,file='EKK.SCR',form='unformatted')
       do 31 k=1,nmo
       do 34 ix=1,3
34     read(36)(ct(ix,kp),kp=1,nmo)
       do kp=1,nmo
       if(k.eq.1)write(6,*)'c',ct(1,kp),ct(2,kp),ct(3,kp)
       enddo
       do 32 j=1,nmo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 33 kp=1,nmo
       if(kp.eq.j)goto 33
       de=e(j)-e(kp)
       if(abs(de).lt.etol)goto 33
       sumx=sumx+(ct(2,kp)*tem3(3,kp,j)-ct(3,kp)*tem3(2,kp,j))/de*half
       sumy=sumy+(ct(3,kp)*tem3(1,kp,j)-ct(1,kp)*tem3(3,kp,j))/de*half
       sumz=sumz+(ct(1,kp)*tem3(2,kp,j)-ct(2,kp)*tem3(1,kp,j))/de*half
33     continue
       ee3(1,j)=sumx
       ee3(2,j)=sumy
32     ee3(3,j)=sumz
       do 31 ix=1,3
31     write(37)(ee3(ix,j),j=1,nmo)
       close(36)
       close(37)
       call w36('EKK.SCR done')
      endif
c
c     and <K|R|K'> = sum(K, occupied) C_KK' x <K'|r|J>
      inquire(file='RKK.SCR',exist=lex)
      if(lex)then
       call w36('RKK.SCR found, unchanged')
      else
c
c      read in dipoles, keep all in tem3
       open(36,file=fm(1),form='unformatted')
       do 35 ix=1,id(1)
       do 35 k=1,nmo
35     read(36)(tem3(ix,k,j),j=1,nmo)
       close(36)
c
c      read C and contract, form vector product,record for each K
       open(36,file='CKK.SCR',form='unformatted')
       open(37,file='RKK.SCR',form='unformatted')
       do 36 k=1,nmo
       do 38 ix=1,3
38     read(36)(ct(ix,kp),kp=1,nmo)
       do 44 l=1,nmo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 20 kp=1,nmo
       sumx=sumx+ct(2,kp)*tem3(3,kp,l)-ct(3,kp)*tem3(2,kp,l)
       sumy=sumy+ct(3,kp)*tem3(1,kp,l)-ct(1,kp)*tem3(3,kp,l)
20     sumz=sumz+ct(1,kp)*tem3(2,kp,l)-ct(2,kp)*tem3(1,kp,l)
       rr3(1,l)=sumx
       rr3(2,l)=sumy
44     rr3(3,l)=sumz
       do 36 ix=1,3
36     write(37)(rr3(ix,l),l=1,nmo)
       close(36)
       close(37)
       call w36('RKK.SCR done')
      endif
      return
      end
