      subroutine dnmrao(ioe)
c
c     nuclear shielding tensor Atomic Orbital Local Origin (AOLO)
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=42,ndegmax=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/const/pi,clau,spt,bohr,debye
      dimension  chip1(3,3),chip2(3,3),chip3(3,3),
     1chid1(3,3),chid2(3,3),chid31(3,3),chid32(3,3),chit(3,3),
     1jdeg(ndegmax),chid5(3,3)
      common/d1001/dip(3,nort,nort)
      common/d1002/grad(3,nort,nort),dmo(nel,nort)
      common/d1003/tem(nort*nort),temmo(nort*nort),btem(nort*nort),
     1cijtem(nort*nort)
      common/d1004/ciji(nort,nort),ipiv(nort)
      common/d1005/escr(nort,2*nort),ef(9,nort)
      logical ldo,lscf,lopt,lgiao,lall,lssup,lrgr,lorg,
     1lex,lsprint
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(21),lscf),(lopt(32),lgiao),
     1(lopt(44),lall),(lopt(46),lssup),(lopt(79),lrgr),
     1(lopt(80),lorg),(lopt(1),lsprint)
      dimension ee3(3,nort),rr3(3,nort),cc3(3,nort),or3(3,nort),
     1rt(3)
      character*7 fm(3)
      data fm/'PMO.SCR','LMO.SCR','VMO.SCR'/
      dimension id(3)
      data id/3,3,3/
      character*6 aof(5)
      data aof/'F1.SCR','F2.SCR','F3.SCR','F4.SCR','F5.SCR'/
      character*8 mof(5)
      data mof/'F1MO.SCR','F2MO.SCR','F3MO.SCR','F4MO.SCR','F5MO.SCR'/
      dimension jxf(5)
      data jxf/3,3,9,9,9/
      dimension kkf(5)
      data kkf/15,0,3,21,33/
c
      I0=0
      etol=0.00001d0
      ppm=one/(clau*clau)*1.0d6
      write(3,4001)nmo,nao
4001  format(' Nuclear shielding tensor AOG; NMO = ',I3,' NAO = ',I3)
      call inibe4
      if(lall)then
       write(3,*)'all js'
       write(6,*)'all js'
       jstart=1
      else
       write(3,*)'virtual js'
       write(6,*)'virtual js'
       jstart=ndo+1
      endif
c
      if(nao.ne.nmo)call report('NMO must be equal to NAO')
      inquire(file='CIJI.SCR',exist=lex)
      if(lex)then
       call w36('CIJI.SCR read')
       open(20,file='CIJI.SCR',form='unformatted')
       read(20)((ciji(i,j),i=1,nmo),j=1,nmo)
       close(20)
      else
       call w36('inverting MO coeff')
       tol=1.0d-5
c
c      Gauss-Jacob's elimination - probably unstable for bigger matrices:
c      call inv(nort,cij,ciji,nmo,tol,escr,ierr)
c      if(ierr.eq.1)call report('matrix could not be inverted')
c      goto 677
c
       do i=1,nmo
        do j=1,nmo
         ciji(i,j)=cij(i,j)
        enddo
       enddo
c
c      Linpack routine, Lapack should be better:
c      call dgedi(ciji,nort,nmo,ipiv,determinant,grad,1)
c      goto 677
c
c      lapack routine, use grad as a work space
       lwork=3*nort*nort
       call dgetrf(nmo,nmo,ciji,nort,ipiv,info)
       if(info.eq.0)then
        call w36('pivoting OK')
       else
        write(3,*)info
        call report('pivoting failed')
       endif
c
c      use grad as a work space
       lwork=3*nort*nort
       call dgetri(nmo,ciji,nort,ipiv,grad,lwork,info)
c
       if(info.eq.0)call w36('successful inversion')
       if(info.lt.0)then
        write(3,*)info
        call report('invalid argument')
       endif
       if(info.gt.0)then
        write(3,*)info
          write(6,*)cij(1,1),ciji(1,1)
          write(6,*)cij(2,1),ciji(2,1)
          write(6,*)cij(2,2),ciji(2,2)
          write(6,*)cij(1,2),ciji(1,2)
        call report('singular matrix')
       endif
c
c      cij(ii,j)*ciji(i,ii)=delta(i,j)
c      cij(j,ii)*ciji(ii,i)=delta(i,j)
c
       do i=1,nmo
        do j=1,nmo
         sum=0.0d0
         sum2=0.0d0
         do ii=1,nmo
          sum=sum+cij(i,ii)*ciji(ii,j)
          sum2=sum2+cij(ii,i)*ciji(j,ii)
         enddo
         ic=0
         if(abs(sum ).gt.tol.and.i.ne.j)ic=1
         if(abs(sum2).gt.tol.and.i.ne.j)ic=2
         if(abs(sum -1.0d0).gt.tol.and.i.eq.j)ic=3
         if(abs(sum2-1.0d0).gt.tol.and.i.eq.j)ic=4
         if(ic.ne.0)then
          write(6,*)'ic = ',ic
          write(6,*)i,j,sum,sum2
          write(6,*)i,j,sum
          write(6,*)cij(1,1),ciji(1,1)
          write(6,*)cij(2,1),ciji(2,1)
          write(6,*)cij(2,2),ciji(2,2)
          write(6,*)cij(1,2),ciji(1,2)
          call report('Inversion error')
         endif
        enddo
       enddo
c
       write(6,*)'Inversion OK'
c
       open(20,file='CIJI.SCR',form='unformatted')
       write(20)((ciji(i,j),i=1,nao),j=1,nmo)
       close(20)
       call w36('CIJI.SCR written')
c
      endif
c
      inquire(file='CKKAO.SCR',exist=lex)
      if(.not.lex)then
c      CKL=c(K,l)c^-1(L,l) Rl
c      C is not symmetric !!!! K=1..ndo,L=1..NMO
       call w36('getting local origins')
c
       open(33,file='P.SCR',form='unformatted',status='old')
       do 1 i=1,nao
       do 1 ix=1,3
1      read(33)(or3(ix,i),j=1,i)
       close(33)
       call w36('P.SCR read')
c
       open(37,file='CKKAO.SCR',form='unformatted')
       do 29 k=1,ndo
       do 27 ix=1,3
       do 27 l=1,nmo
       sum=0.0d0
       do 28 ks=1,nao
28     sum=sum+cij(k,ks)*or3(ix,ks)*ciji(ks,l)
27     cc3(ix,l)=sum
29     write(37)((cc3(ix,l),ix=1,3),l=1,nmo)
       close(37)
      endif
c
c     read in gradient and dipoles
      open(36,file=fm(3),form='unformatted')
      do 30 ix=1,id(3)
      do 30 k=1,nmo
30    read(36)(grad(ix,k,j),j=1,nmo)
      close(36)
c
      open(36,file=fm(1),form='unformatted')
      do 35 ix=1,id(1)
      do 35 k=1,nmo
35    read(36)(dip(ix,k,j),j=1,nmo)
      close(36)
c
c     <K|E|J> = sum(L<>J) C_KL (eJ-eL)^-1 x <L|grad|J> / 2
c
      inquire(file='EKKAO.SCR',exist=lex)
      if(.not.lex)then
       open(36,file='CKKAO.SCR',form='unformatted')
       open(37,file='EKKAO.SCR',form='unformatted')
       do 31 k=1,ndo
       read(36)((cc3(ix,l),ix=1,3),l=1,nmo)
       do 32 j=jstart,nmo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 33 l=1,nmo
       de=e(j)-e(l)
       if(abs(de).gt.etol)then
        sumx=sumx+(cc3(2,l)*grad(3,l,j)-cc3(3,l)*grad(2,l,j))/de*half
        sumy=sumy+(cc3(3,l)*grad(1,l,j)-cc3(1,l)*grad(3,l,j))/de*half
        sumz=sumz+(cc3(1,l)*grad(2,l,j)-cc3(2,l)*grad(1,l,j))/de*half
       endif
33     continue
       ee3(1,j)=sumx
       ee3(2,j)=sumy
32     ee3(3,j)=sumz
31     write(37)((ee3(ix,j),ix=1,3),j=jstart,nmo)
       close(36)
       close(37)
      endif
c
c     <K|R|J> = sum(L,all) C_KL x <L|r|J> / 2
c
      inquire(file='RKKAO.SCR',exist=lex)
      if(.not.lex.and..not.lall)then
       open(36,file='CKKAO.SCR',form='unformatted')
       open(37,file='RKKAO.SCR',form='unformatted')
       do 36 k=1,ndo
       read(36)((cc3(ix,l),ix=1,3),l=1,nmo)
       do 44 j=1,ndo
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 20 l=1,nmo
       if(j.ne.l)then
        sumx=sumx+cc3(2,l)*dip(3,l,j)-cc3(3,l)*dip(2,l,j)
        sumy=sumy+cc3(3,l)*dip(1,l,j)-cc3(1,l)*dip(3,l,j)
        sumz=sumz+cc3(1,l)*dip(2,l,j)-cc3(2,l)*dip(1,l,j)
       endif
20     continue
       rr3(1,j)=sumx*half
       rr3(2,j)=sumy*half
44     rr3(3,j)=sumz*half
36     write(37)((rr3(ix,j),ix=1,3),j=1,ndo)
       close(36)
       close(37)
      endif
c
c     construct MO overlaps:<I|o|J>=cIi*cJj<i|o|j> symbolicaly((r-Rb) divided):
c       F2           F3                                   F1
c       (r-Rb)xgrad  (r-Rb) r                    l        (r-Rb)   r  r  r
c     k=1  2  3      4  5  6  7  8  9  10 11 12  13 14 15 16 17 18 19 20 21
c       x  y  z      xx xy xz yx yy yz zx zy zz  x  y  z  x  y  z  x  y  z
c
c     F4                                  F5
c     r (r-Rb)xr                 grad     giao correction to diamagn
c     22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42
c     xx xy xz yx yy yz zx zy zz  x  y  z xx xy xz yx yy yz zx zy zz
c
c     for each atom:
      inquire(file='NMR.RES',exist=lex)
      if(lex)then
       open(34,file='NMR.RES')
       read(34,*)latstart
       close(34)
       write(6,*)' Restarted from atom ',latstart
      else
       latstart=1
      endif
      do 1212 lat=latstart,noa
      iz=nint(z(lat))
      write(3,*)' Atom ',lat,', charge ',iz
      write(6,*)' Atom ',lat,', charge ',iz
c
      do 11 i=1,3
      do 11 j=1,3
      chid1(i,j)=z0
      chid2(i,j)=z0
      chid31(i,j)=z0
      chid32(i,j)=z0
      chid5(i,j)=z0
      chip1(i,j)=z0
      chip2(i,j)=z0
11    chip3(i,j)=z0
c
      if(ioe.ne.0.and.lat.eq.1)then
       write(3,3334)
3334  format(
     1'  j  k         ejk =         ej -         ek -      Jjk + 2 x ',
     2'       Kjk',/,80(1H-))
      endif
      if((ioe.eq.2.or.ioe.eq.3).and.lat.eq.1)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nmo),j=1,nmo),((aj(i,j),i=1,nmo),j=1,nmo)
       close(23)
       write(6,*)'Coulomb and exchange terms read from scratch.'
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
      call overnmr(lat,I0)
c
      write(6,*)'transforming to MOs'
c
      do i=1,nmo
       do j=1,nao
        cijtem(j+(i-1)*nmo)=cij(i,j)
       enddo
      enddo
      do 47 k=1,3
      open(43,file=aof(k),form='unformatted')
      open(49,file=mof(k),form='unformatted')
      do 39 ic=1,jxf(k)
      rewind 43
      do 41 i=1,nao
      do 40 ii=1,ic-1
40    read(43)
      read(43)(tem(j+(i-1)*nao),j=1,nao)
      do 41 ii=ic+1,jxf(k)
41    read(43)
      call taomo21(tem,temmo,cijtem,nort,nort,nmo,nao,btem)
      do 39 i=1,nmo
39    write(49)(temmo(j+(i-1)*nmo),j=1,nmo)
      close(43)
47    close(49)
c
      open(67,file='EKKAO.SCR',form='unformatted')
      if(.not.lall)open(68,file='RKKAO.SCR',form='unformatted')
      open(69,file='CKKAO.SCR',form='unformatted')
c
c     sum over occupied orbitals
      do 5 k=1,ndo
c
      read(69)             ((cc3(ix,l),ix=1,3),l=1,nmo)
      read(67)             ((ee3(ix,j),ix=1,3),j=jstart,nmo)
      if(.not.lall)read(68)((rr3(ix,j),ix=1,3),j=1,ndo)
c
c     (EF)JK=sum(all L) CKL <J||r-rL|^-3 (r-rL)xgrad|L> / 2
c
      open(38,file=mof(2),form='unformatted')
      do 45 jx=1,3
      do 48 l=1,nmo
48    read(38)(temmo(j+(l-1)*nmo),j=1,nmo)
      do 45 ix=1,3
      ind=ix+3*(jx-1)
      do 45 j=1,nmo
      sum=0.0d0
      do 50 l=1,nmo
50    sum=sum+cc3(ix,l)*temmo(j+(l-1)*nmo)
45    ef(ind,j)=sum*half
      close(38)
c
c     read F1,F2,F3
      do 52 ic=1,3
      open(49,file=mof(ic),form='unformatted')
      kk=kkf(ic)
      do 53 ix=1,jxf(ic)
      kk=kk+1
      do 53 kc=1,nmo
      if(kc.eq.k)then
       read(49)(dmo(kk,j),j=1,nmo)
      else
       read(49)
      endif
53    continue
52    close(49)
c
c     read  (1/2) r x grad
      kk=12
      open(86,file='LMO.SCR',form='unformatted')
      do 54 ix=1,3
      kk=kk+1
      do 55 kc=1,nmo
      if(kc.eq.k)then
       read(86)(dmo(kk,j),j=1,nmo)
      else
       read(86)
      endif
55    continue
54    continue
      close(86)
c
c     sum over excited states = virtual orbitals
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies, Kjk neglected
      ejk=e(j)-e(k)
c
      if(ioe.eq.2.or.ioe.eq.3)then
c
c      check for degeneracy
       ndeg=1
       jdeg(1)=1
       do 2 jj=jstart,nmo
       if(jj.ne.j.and.jj.ne.k)then
        if(abs(e(j)-e(jj)).lt.0.001d0)then
         ndeg=ndeg+1
         if(ndeg.gt.ndegmax)call report('degeneracy too high')
         jdeg(ndeg)=jj
        endif
       endif
2      continue
       ckj=z0
       ekj=z0
       do ju=1,ndeg
        jj=jdeg(ju)
        ckj=ckj+aj(k,jj)
        ekj=ekj+ak(k,jj)
       enddo
       ckj=ckj/dble(ndeg)
       ekj=ekj/dble(ndeg)
       ejk=ejk-ckj+two*ekj
       if(lat.eq.1)write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333   format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1 ' + 2 x ',F10.6)
      endif
c
      if(abs(ejk).lt.etol)goto 6
      ejki=one/ejk
      w4=ejki*four
      do 10 ix=1,3
      do 10 jx=1,3
c
c     4 sum(occ K, virt J) ejk-1 <K|m|J> <J||r-rL|^-1(r-rL)xgrad|K>
c     (normal paramagnetic, first index magnetic field
c
      chip1(ix,jx)=chip1(ix,jx)-w4*dmo(ix+12,j)*dmo(jx,j)
c
c     -2 sum(occ K, virt J) EJK <J||r-rL|^-1(r-rL)xgrad|K>
c
10    chip2(ix,jx)=chip2(ix,jx)+2.0d0*ee3(ix,j)*dmo(jx,j)
c
      gx=grad(1,k,j)
      gy=grad(2,k,j)
      gz=grad(3,k,j)
      efxx=ef(1,j)
      efyx=ef(2,j)
      efzx=ef(3,j)
      efxy=ef(4,j)
      efyy=ef(5,j)
      efzy=ef(6,j)
      efxz=ef(7,j)
      efyz=ef(8,j)
      efzz=ef(9,j)
c
c
c     -2 sum (occ K, virt J) (E)JK x <K|grad|J> (F)JK ejk-1
c
      chip3(1,1)=chip3(1,1)+2.0d0*(gz*efyx-gy*efzx)*ejki
      chip3(2,1)=chip3(2,1)+2.0d0*(gx*efzx-gz*efxx)*ejki
      chip3(3,1)=chip3(3,1)+2.0d0*(gy*efxx-gx*efyx)*ejki
      chip3(1,2)=chip3(1,2)+2.0d0*(gz*efyy-gy*efzy)*ejki
      chip3(2,2)=chip3(2,2)+2.0d0*(gx*efzy-gz*efxy)*ejki
      chip3(3,2)=chip3(3,2)+2.0d0*(gy*efxy-gx*efyy)*ejki
      chip3(1,3)=chip3(1,3)+2.0d0*(gz*efyz-gy*efzz)*ejki
      chip3(2,3)=chip3(2,3)+2.0d0*(gx*efzz-gz*efxz)*ejki
      chip3(3,3)=chip3(3,3)+2.0d0*(gy*efxz-gx*efyz)*ejki
c
6     continue
c     (virtual orbitals J )
c
      iin=3
      do 13 i3=1,3
      do 13 j3=1,3
      iin=iin+1
c
c     sum (occ K) <K||r-rL|^3[r.(r-rL) E - r (r-rL)]|K>
c     (normal diamagnetic shielding)
c
13    chid1(i3,j3)=chid1(i3,j3)+dmo(iin,k)
c
      do 43 l=1,nmo
      gx=dmo(16,l)
      gy=dmo(17,l)
      gz=dmo(18,l)
      rkx=cc3(1,l)
      rky=cc3(2,l)
      rkz=cc3(3,l)
c
c     - sum(occ K, all L)  <K||r-rL|^-3[CKL.(r-rL) E - (r-rL) CKL]|K>
c
      chid2(1,1)=chid2(1,1)-rky*gy-rkz*gz
      chid2(1,2)=chid2(1,2)+rky*gx
      chid2(1,3)=chid2(1,3)+rkz*gx
      chid2(2,1)=chid2(2,1)+rkx*gy
      chid2(2,2)=chid2(2,2)-rkx*gx-rkz*gz
      chid2(2,3)=chid2(2,3)+rkz*gy
      chid2(3,1)=chid2(3,1)+rkx*gz
      chid2(3,2)=chid2(3,2)+rky*gz
43    chid2(3,3)=chid2(3,3)-rky*gy-rkx*gx
c
      if(.not.lall)then
       do 51 j=1,ndo
       do 51 ix=1,3
       do 51 jx=1,3
c
c      -2 sum(occ L) RKL <L||r-rL|^-3 (r-rL)xgrad|K>
c
51     chid31(jx,ix)=chid31(jx,ix)+two*rr3(ix,j)*dmo(jx,j)
c
       do 18 j=1,ndo
       if(j.ne.k)then
        gx=dip(1,k,j)
        gy=dip(2,k,j)
        gz=dip(3,k,j)
        efxx=ef(1,j)
        efyx=ef(2,j)
        efzx=ef(3,j)
        efxy=ef(4,j)
        efyy=ef(5,j)
        efzy=ef(6,j)
        efxz=ef(7,j)
        efyz=ef(8,j)
        efzz=ef(9,j)
c
c       -2 sum(occ K, occ L) (E)LK x <K|r|L> (F)LK
c
        chid32(1,1)=chid32(1,1)+2.0d0*(gz*efyx-gy*efzx)
        chid32(2,1)=chid32(2,1)+2.0d0*(gx*efzx-gz*efxx)
        chid32(3,1)=chid32(3,1)+2.0d0*(gy*efxx-gx*efyx)
        chid32(1,2)=chid32(1,2)+2.0d0*(gz*efyy-gy*efzy)
        chid32(2,2)=chid32(2,2)+2.0d0*(gx*efzy-gz*efxy)
        chid32(3,2)=chid32(3,2)+2.0d0*(gy*efxy-gx*efyy)
        chid32(1,3)=chid32(1,3)+2.0d0*(gz*efyz-gy*efzz)
        chid32(2,3)=chid32(2,3)+2.0d0*(gx*efzz-gz*efxz)
        chid32(3,3)=chid32(3,3)+2.0d0*(gy*efxz-gx*efyz)
       endif
18     continue
c
      endif
c
      do 62 j=1,nmo
      gx=dip(1,j,j)-dip(1,k,k)
      gy=dip(2,j,j)-dip(2,k,k)
      gz=dip(3,j,j)-dip(3,k,k)
      rt(1)=cc3(2,j)*gz-cc3(3,j)*gy
      rt(2)=cc3(3,j)*gx-cc3(1,j)*gz
      rt(3)=cc3(1,j)*gy-cc3(2,j)*gx
      do 62 jx=1,3
      do 62 ix=1,3
62    chid5(jx,ix)=chid5(jx,ix)+rt(jx)*dmo(ix,j)
c
5     continue
c     (occupied orbitals K )
      close(67)
      if(.not.lall)close(68)
      close(69)
c
      do 37 i=1,3
      do 37 j=1,3
      chid1(i,j)=chid1(i,j)*ppm
      chid2(i,j)=chid2(i,j)*ppm
      chid31(i,j)=chid31(i,j)*ppm
      chid32(i,j)=chid32(i,j)*ppm
      chid5(i,j)=chid5(i,j)*ppm
      chip1(i,j)=chip1(i,j)*ppm
      chip2(i,j)=chip2(i,j)*ppm
37    chip3(i,j)=chip3(i,j)*ppm
c
      if(lsprint)then
       call stout('Shielding tensor, para 1 :',chip1,iz)
       call stout('Shielding tensor, para 2 :',chip2,iz)
       call stout('Shielding tensor, para 3 :',chip3,iz)
       call stout('Shielding tensor, dia 1  :',chid1,iz)
       call stout('Shielding tensor, dia 2  :',chid2,iz)
       if(.not.lall)then
        call stout('Shielding tensor, dia 31 :',chid31,iz)
        call stout('Shielding tensor, dia 32 :',chid32,iz)
       endif
       call stout('Shielding tensor, dia 5  :',chid5,iz)
      endif
c
      do 19 i=1,3
      do 19 j=1,3
      chip1(i,j)=chip1(i,j)+chip2(i,j)+chip3(i,j)
      chid1(i,j)=chid1(i,j)+chid2(i,j)+chid31(i,j)+chid32(i,j)
     1+chid5(i,j)
19    chit(i,j)=chid1(i,j)+chip1(i,j)
c
      if(lsprint)then
       call stout('Shielding tensor, diamagnetic :',chid1,iz)
       call stout('Shielding tensor, paramagnetic:',chip1,iz)
      endif
c
      call stout('Shielding tensor, total       :',chit,iz)
c
1212  continue
c     (new atom lat)
c
      return
      end
c
