      subroutine dnmrao3(ioe)
c
c     nuclear shielding tensor Atomic Orbital Local Origin (AOLO)
c     rkl = <k|r|l> /<k|l> (AO)
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=42,ndegmax=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/const/pi,clau,spt,bohr,debye
      dimension  chip1(3,3),chip2(3,3),
     1chid1(3,3),chid2(3,3),chid3(3,3),chit(3,3),
     1jdeg(ndegmax),rt(3),chid5(3,3),chid6(3,3)
      common/d1001/dip(3,nort,nort)
      common/d1002/grad(3,nort,nort),dmo(nel,nort)
      common/d1003/tem(nort*nort),temmo(nort*nort),btem(nort*nort),
     1cijtem(nort*nort)
      common/d1004/ciji(nort,nort),ipiv(nort)
      logical ldo,lscf,lopt,lgiao,lall,lssup,lrgr,lorg,
     1lex,lsprint
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(21),lscf),(lopt(32),lgiao),
     1(lopt(44),lall),(lopt(46),lssup),(lopt(79),lrgr),
     1(lopt(80),lorg),(lopt(1),lsprint)
      common/d1006/or3(3,nort,nort),cijk(nort),
     1cc3(3,nort,nort),cc3tem(3,nort,nort)
      common/d1017/ee3(3,nort,nort),rr3(3)
      common/d1018/ojl(3,nort,nort),gl(3,nort,nort)
      character*7 fm(3)
      data fm/'PMO.SCR','LMO.SCR','VMO.SCR'/
      dimension id(3)
      data id/3,3,3/
      character*6 aof(5)
      data aof/'F1.SCR','F2.SCR','F3.SCR','F4.SCR','F5.SCR'/
      character*8 mof(5)
      data mof/'F1MO.SCR','F2MO.SCR','F3MO.SCR','F4MO.SCR','F5MO.SCR'/
      dimension jxf(5)
      data jxf/3,3,9,9,9/
      dimension kkf(5)
      data kkf/15,0,3,21,33/
c
      I0=0
      etol=0.00001d0
      ppm=one/(clau*clau)*1.0d6
      write(3,4001)nmo,nao
4001  format(' Nuclear shielding tensor AOG3; NMO = ',I3,' NAO = ',I3)
      call inibe4
      if(lall)then
       call w36('all js')
       jstart=1
      else
       call w36('virtual js')
       jstart=ndo+1
      endif
c
      if(nao.ne.nmo)call report('NMO must be equal to NAO')
c
      inquire(file='CIJI.SCR',exist=lex)
      if(lex)then
       call w36('CIJI.SCR read')
       open(20,file='CIJI.SCR',form='unformatted')
       read(20)((ciji(i,j),i=1,nmo),j=1,nmo)
       close(20)
      else
       call w36('inverting MO coeff')
       tol=1.0d-5
c
       do i=1,nmo
        do j=1,nmo
         ciji(i,j)=cij(i,j)
        enddo
       enddo
c
c      lapack routine, use grad as a work space
       lwork=3*nort*nort
       call dgetrf(nmo,nmo,ciji,nort,ipiv,info)
       if(info.eq.0)then
        call w36('pivoting OK')
       else
        write(3,*)info
        call report('pivoting failed')
       endif
c
c      use grad as a work space
       lwork=3*nort*nort
       call dgetri(nmo,ciji,nort,ipiv,grad,lwork,info)
c
       if(info.eq.0)call w36('successful inversion')
       if(info.lt.0)then
        write(3,*)info
        call report('invalid argument')
       endif
       if(info.gt.0)then
        write(3,*)info
        write(6,*)cij(1,1),ciji(1,1)
        write(6,*)cij(2,1),ciji(2,1)
        write(6,*)cij(2,2),ciji(2,2)
        write(6,*)cij(1,2),ciji(1,2)
        call report('singular matrix')
       endif
c
       do i=1,nmo
        do j=1,nmo
         sum=0.0d0
         sum2=0.0d0
         do ii=1,nmo
          sum=sum+cij(i,ii)*ciji(ii,j)
          sum2=sum2+cij(ii,i)*ciji(j,ii)
         enddo
         ic=0
         if(abs(sum ).gt.tol.and.i.ne.j)ic=1
         if(abs(sum2).gt.tol.and.i.ne.j)ic=2
         if(abs(sum -1.0d0).gt.tol.and.i.eq.j)ic=3
         if(abs(sum2-1.0d0).gt.tol.and.i.eq.j)ic=4
         if(ic.ne.0)then
          write(6,*)'ic = ',ic
          write(6,*)i,j,sum,sum2
          write(6,*)i,j,sum
          write(6,*)cij(1,1),ciji(1,1)
          write(6,*)cij(2,1),ciji(2,1)
          write(6,*)cij(2,2),ciji(2,2)
          write(6,*)cij(1,2),ciji(1,2)
          call report('Inversion error')
         endif
        enddo
       enddo
c
       call w36('Inversion OK')
c
       open(20,file='CIJI.SCR',form='unformatted')
       write(20)((ciji(i,j),i=1,nao),j=1,nmo)
       close(20)
       call w36('CIJI.SCR written')
c
      endif
c
c     get AO origins:
      call overla67(or3)
c
c     read in gradient (MO)
      open(36,file=fm(3),form='unformatted')
      do 30 ix=1,id(3)
      do 30 k=1,nmo
30    read(36)(grad(ix,k,j),j=1,nmo)
      close(36)
c
c     read in dipoles (MO)
      open(36,file=fm(1),form='unformatted')
      do 35 ix=1,id(1)
      do 35 k=1,nmo
35    read(36)(dip(ix,k,j),j=1,nmo)
      close(36)
c
c     store cij in a fast array:
      do i=1,nmo
       do j=1,nao
        cijtem(j+(i-1)*nmo)=cij(i,j)
       enddo
      enddo
c
c     construct MO overlaps:<I|o|J>=cIi*cJj<i|o|j> symbolicaly((r-Rb) divided):
c       F2           F3                                   F1
c       (r-Rb)xgrad  (r-Rb) r                    l        (r-Rb)   r  r  r
c     k=1  2  3      4  5  6  7  8  9  10 11 12  13 14 15 16 17 18 19 20 21
c       x  y  z      xx xy xz yx yy yz zx zy zz  x  y  z  x  y  z  x  y  z
c
c     F4                                  F5
c     r (r-Rb)xr                 grad     giao correction to diamagn
c     22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42
c     xx xy xz yx yy yz zx zy zz  x  y  z xx xy xz yx yy yz zx zy zz
c
c     for each atom:
      inquire(file='NMR.RES',exist=lex)
      if(lex)then
       open(34,file='NMR.RES')
       read(34,*)latstart
       close(34)
       write(6,*)' Restarted from atom ',latstart
      else
       latstart=1
      endif
      do 1212 lat=latstart,noa
      iz=nint(z(lat))
      write(3,*)' Atom ',lat,', charge ',iz
      write(6,*)' Atom ',lat,', charge ',iz
c
      do 11 i=1,3
      do 11 j=1,3
      chid1(i,j)=z0
      chid2(i,j)=z0
      chid3(i,j)=z0
      chid5(i,j)=z0
      chid6(i,j)=z0
      chip1(i,j)=z0
11    chip2(i,j)=z0
c
      if(ioe.ne.0.and.lat.eq.1)then
       write(3,3334)
3334  format(
     1'  j  k         ejk =         ej -         ek -      Jjk + 2 x ',
     2'       Kjk',/,80(1H-))
      endif
      if((ioe.eq.2.or.ioe.eq.3).and.lat.eq.1)then
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nmo),j=1,nmo),((aj(i,j),i=1,nmo),j=1,nmo)
       close(23)
       call w36('Coulomb and exchange terms read from scratch.')
      endif
c
      call overnmr(lat,I0)
c
      write(6,*)'transforming to MOs'
c
      do 47 k=1,3
      open(43,file=aof(k),form='unformatted')
      open(49,file=mof(k),form='unformatted')
      do 39 ic=1,jxf(k)
      rewind 43
      do 41 i=1,nao
      do 40 ii=1,ic-1
40    read(43)
      read(43)(tem(j+(i-1)*nao),j=1,nao)
      do 41 ii=ic+1,jxf(k)
41    read(43)
      call taomo21(tem,temmo,cijtem,nort,nort,nmo,nao,btem)
      do 39 i=1,nmo
39    write(49)(temmo(j+(i-1)*nmo),j=1,nmo)
      close(43)
47    close(49)
c
c     read F1  and keep
      open(49,file=mof(1),form='unformatted')
      do 58 ix=1,3
      do 58 kc=1,nmo
58    read(49)(gl(ix,kc,l),l=1,nmo)
      close(49)
c
c     read F2  and keep
      open(49,file=mof(2),form='unformatted')
      do 56 ix=1,3
      do 56 kc=1,nmo
56    read(49)(ojl(ix,kc,l),l=1,nmo)
      close(49)
c
c     sum over occupied orbitals
      do 5 k=1,ndo
c
      do 9 kk=1,nao
9     cijk(kk)=cij(k,kk)
c
c     make RK,K'L=UKlUKk rkl/Skl U-1kK' U-1lL
      do 8 KP=1,nmo
      do 8 ll=1,nao
      do 8 ix=1,3
      sum=0.0d0
      do 81 kk=1,nao
81    sum=sum+cijk(kk)*or3(ix,kk,ll)*ciji(kk,KP)
8     cc3tem(ix,KP,ll)=sum
c
      do 12 KP=1,nmo
      do 12 L=1,nmo
      do 12 ix=1,3
      sum=0.0d0
      do 121 ll=1,nao
121   sum=sum+cijk(ll)*cc3tem(ix,KP,ll)*ciji(ll,L)
12    cc3(ix,KP,L)=sum
c
c     <J|E|L> = sum(KP<>J) RK,KPL (eJ-eKP)^-1 x <KP|grad|J> / 2
c
      do 31 j=jstart,nmo
      do 31 l=1,nmo
      sumx=0.0d0
      sumy=0.0d0
      sumz=0.0d0
      do 32 kp=1,nmo
      de=two*(e(j)-e(kp))
      if(abs(de).gt.etol)then
       gx=grad(1,kp,j)
       gy=grad(2,kp,j)
       gz=grad(3,kp,j)
       sumx=sumx+(cc3(2,kp,l)*gz-cc3(3,kp,l)*gy)/de
       sumy=sumy+(cc3(3,kp,l)*gx-cc3(1,kp,l)*gz)/de
       sumz=sumz+(cc3(1,kp,l)*gy-cc3(2,kp,l)*gx)/de
      endif
32    continue
      ee3(1,j,l)=sumx
      ee3(2,j,l)=sumy
31    ee3(3,j,l)=sumz
c
c     read F1,F2,F3
      do 52 ic=1,3
      open(49,file=mof(ic),form='unformatted')
      kk=kkf(ic)
      do 53 ix=1,jxf(ic)
      kk=kk+1
      do 53 kc=1,nmo
      if(kc.eq.k)then
       read(49)(dmo(kk,j),j=1,nmo)
      else
       read(49)
      endif
53    continue
52    close(49)
c
c     read  (1/2) r x grad
      kk=12
      open(86,file='LMO.SCR',form='unformatted')
      do 54 ix=1,3
      kk=kk+1
      do 55 kc=1,nmo
      if(kc.eq.k)then
       read(86)(dmo(kk,j),j=1,nmo)
      else
       read(86)
      endif
55    continue
54    continue
      close(86)
c
c     sum over excited states = virtual orbitals
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies, Kjk neglected
      ejk=e(j)-e(k)
c
      if(ioe.eq.2.or.ioe.eq.3)then
       ndeg=1
       jdeg(1)=1
       do 2 jj=jstart,nmo
       if(jj.ne.j.and.jj.ne.k)then
        if(abs(e(j)-e(jj)).lt.0.001d0)then
         ndeg=ndeg+1
         if(ndeg.gt.ndegmax)call report('degeneracy too high')
         jdeg(ndeg)=jj
        endif
       endif
2      continue
       ckj=z0
       ekj=z0
       do ju=1,ndeg
        jj=jdeg(ju)
        ckj=ckj+aj(k,jj)
        ekj=ekj+ak(k,jj)
       enddo
       ckj=ckj/dble(ndeg)
       ekj=ekj/dble(ndeg)
       ejk=ejk-ckj+two*ekj
       if(lat.eq.1)write(3,3333)j,k,ejk,e(j),e(k),ckj,ekj
3333   format(2I3,': ',F10.6,' = ',F10.6,' - ',F10.6,' - ',F10.6,
     1 ' + 2 x ',F10.6)
      endif
c
      if(abs(ejk).lt.etol)goto 6
      ejki=one/ejk
      w4=ejki*four
c
c     4 sum(occ K, virt J) ejk-1 <K|m|J> <J||r-rL|^-1(r-rL)xgrad|K>
c     (normal paramagnetic, first index magnetic field
c
      do 10 ix=1,3
      do 10 jx=1,3
10    chip1(ix,jx)=chip1(ix,jx)-w4*dmo(ix+12,j)*dmo(jx,j)
c
c     -4 sum(occ K, virt J or J<>K) EK,JL <J||r-rL|^-1(r-rL)xgrad|L>
c
      do 14 l=1,nmo
      do 14 ix=1,3
      do 14 jx=1,3
14    chip2(ix,jx)=chip2(ix,jx)-4.0d0*ee3(ix,j,l)*ojl(jx,j,l)
c
6     continue
c     (virtual orbitals J )
c
      iin=3
      do 13 i3=1,3
      do 13 j3=1,3
      iin=iin+1
c
c     sum (occ K) <K||r-rL|^3[r.(r-rL) E - r (r-rL)]|K>
c     (normal diamagnetic shielding)
c
13    chid1(i3,j3)=chid1(i3,j3)+dmo(iin,k)
c
      do 43 l=1,nmo
      do 43 kp=1,nmo
      gx=gl(1,l,kp)
      gy=gl(2,l,kp)
      gz=gl(3,l,kp)
      rkx=cc3(1,l,kp)
      rky=cc3(2,l,kp)
      rkz=cc3(3,l,kp)
c
c     - sum(occ K, all L, all KP)
c              <KP||r-rL|^-3[RK,KPL.(r-rL) E - (r-rL) RK,KPL]|L>
c
      chid2(1,1)=chid2(1,1)-rky*gy-rkz*gz
      chid2(1,2)=chid2(1,2)+rky*gx
      chid2(1,3)=chid2(1,3)+rkz*gx
      chid2(2,1)=chid2(2,1)+rkx*gy
      chid2(2,2)=chid2(2,2)-rkx*gx-rkz*gz
      chid2(2,3)=chid2(2,3)+rkz*gy
      chid2(3,1)=chid2(3,1)+rkx*gz
      chid2(3,2)=chid2(3,2)+rky*gz
43    chid2(3,3)=chid2(3,3)-rky*gy-rkx*gx
c
      if(.not.lall)then
c
       do 51 j=1,ndo
       do 51 l=1,nmo
c
c      make rr3:
       sumx=0.0d0
       sumy=0.0d0
       sumz=0.0d0
       do 36 kp=1,nmo
       if(kp.ne.j)then
        gx=dip(1,kp,j)*half
        gy=dip(2,kp,j)*half
        gz=dip(3,kp,j)*half
        rx=cc3(1,kp,l)
        ry=cc3(2,kp,l)
        rz=cc3(3,kp,l)
        rt(1)=ry*gz-rz*gy
        rt(2)=rz*gx-rx*gz
        rt(3)=rx*gy-ry*gx
        sumx=sumx+rt(1)
        sumy=sumy+rt(2)
        sumz=sumz+rt(3)
       endif
36     continue
       rr3(1)=sumx
       rr3(2)=sumy
       rr3(3)=sumz
c
       do 51 ix=1,3
       do 51 jx=1,3
c
c      -2 sum(all L) RRK,JL <J||r-rL|^-3 (r-rL)xgrad|L>
c
51     chid3(jx,ix)=chid3(jx,ix)-four*rr3(ix)*ojl(jx,j,l)
c
      else
c
c      sum(K,occ;K',L)RK,K'L x rK'K/2 oKL
c
       do 61 kp=1,nmo
       if(kp.ne.k)then
        gx=dip(1,k,kp)*half
        gy=dip(2,k,kp)*half
        gz=dip(3,k,kp)*half
        do 62 l=1,nmo
        rx=cc3(1,kp,l)
        ry=cc3(2,kp,l)
        rz=cc3(3,kp,l)
        rt(1)=ry*gz-rz*gy
        rt(2)=rz*gx-rx*gz
        rt(3)=rx*gy-ry*gx
        do 62 jx=1,3
        do 62 ix=1,3
62      chid6(ix,jx)=chid6(ix,jx)-four*rt(ix)*ojl(jx,k,l)
       endif
61     continue
c
      endif
c
c     -4sum(occK,Jall,Lall)RK,JL x rJJ/2 oJL
c
      do 59 j=1,nmo
      gx=dip(1,j,j)*half
      gy=dip(2,j,j)*half
      gz=dip(3,j,j)*half
      do 59 l=1,nmo
      rx=cc3(1,j,l)
      ry=cc3(2,j,l)
      rz=cc3(3,j,l)
      rt(1)=ry*gz-rz*gy
      rt(2)=rz*gx-rx*gz
      rt(3)=rx*gy-ry*gx
      do 59 jx=1,3
      do 59 ix=1,3
59    chid5(ix,jx)=chid5(ix,jx)-four*rt(ix)*ojl(jx,j,l)
c
5     continue
c     (occupied orbitals K )
c
      close(67)
      if(.not.lall)close(68)
      close(69)
c
      do 37 i=1,3
      do 37 j=1,3
      chid1(i,j)=chid1(i,j)*ppm
      chid2(i,j)=chid2(i,j)*ppm
      chid3(i,j)=chid3(i,j)*ppm
      chid5(i,j)=chid5(i,j)*ppm
      chid6(i,j)=chid6(i,j)*ppm
      chip1(i,j)=chip1(i,j)*ppm
37    chip2(i,j)=chip2(i,j)*ppm
c
      if(lsprint)then
       call stout('Shielding tensor, para 1 :',chip1,iz)
       call stout('Shielding tensor, para 2 :',chip2,iz)
       call stout('Shielding tensor, dia 1  :',chid1,iz)
       call stout('Shielding tensor, dia 2  :',chid2,iz)
       if(.not.lall)call stout('Shielding tensor, dia 3  :',chid3,iz)
       call stout('Shielding tensor, dia 5  :',chid5,iz)
       if(lall)call stout('Shielding tensor, dia 6  :',chid6,iz)
      endif
c
      do 19 i=1,3
      do 19 j=1,3
      chip1(i,j)=chip1(i,j)+chip2(i,j)
      chid1(i,j)=chid1(i,j)+chid2(i,j)+chid3(i,j)+
     1chid5(i,j)+chid6(i,j)
19    chit(i,j)=chid1(i,j)+chip1(i,j)
c
      if(lsprint)then
       call stout('Shielding tensor, diamagnetic :',chid1,iz)
       call stout('Shielding tensor, paramagnetic:',chip1,iz)
      endif
c
      call stout('Shielding tensor, total       :',chit,iz)
c
1212  continue
c     (new atom lat)
c
      return
      end
c
