      SUBROUTINE DORAMAN(NS,N,ALPHA,G,A)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0)
      DIMENSION ALPHA(NS,3,3),G(NS,3,3),A(NS,3,3,3),
     1ALPHAL(3,3),AL(3,3,3),GL(3,3)
      REAL*8 IDX,IDY
      COMMON//E(N30),N7
      CM=219470.0
      CLIGHT=137.037
c     static limit of G is calculated
c     BOHR=0.529177
C     FREQUENCY (a.u) OF THE EXCITING LASER LIGHT (488 nm)
c     ALEXC=2.0*PI*CLIGHT
C     WAVELENGTH (a.u) OF THE EXCITING LASER LIGHT (488 nm)
      UNITS=1500.0/7.0
C     UNITS TO BE SAME AS POLAVARAPU'S RESULTS
      TOL=1.0D-6
      TOLOM=0.05
c
      OPEN(4,FILE='ROA.TAB')
      WRITE(3,3004)
      WRITE(4,3004)
3004  FORMAT(
     1'MODE   FREQ    IDX    IDY    RAMAN     ROA-Z',
     2'     ROA-X   ROA-180  DEP   raw180',/,
     3'       cm-1                                 ',
     4'    (CID*10000)         %  au.10^3')
      write(3,3002)
      write(4,3002)
3002  FORMAT(80(1H-))
c
      DO 1 IQ=1,N
      ECM=CM*E(IQ)
      IF(ABS(ECM).LT.TOLOM)GOTO 1
      DO 2 I=1,3
      DO 2 J=1,3
      ALPHAL(I,J)=ALPHA(IQ,I,J)
      GL(I,J)=G(IQ,I,J)
      DO 2 K=1,3
2     AL(I,J,K)=A(IQ,I,J,K)
      A2=0.0
      BA=0.0
      S901=0.0
      SAG1=0.0
      SAG0=0.0
      SA1=0.0
      SAL0=0.0
      SAL1=0.0
      DO 3 I=1,3
      AII=ALPHAL(I,I)
      DO 3 J=1,3
      AIJ=ALPHAL(I,J)
      AJJ=ALPHAL(J,J)
      GJJ=GL(J,J)
      GIJ=GL(I,J)
      SAL0=SAL0+AII*AJJ
      SAL1=SAL1+AIJ*AIJ
      SAG0=SAG0+AII*GJJ
      SAG1=SAG1+AIJ*GIJ
      DO 3 K=1,3
      DO 3 KD=1,3
3     SA1=SA1+(1.0D0/3.0D0)*EPS(I,K,KD)*AIJ*AL(K,KD,J)
      S901=0.5*(14.0*SAL1+2.0*SAL0)*UNITS
      BA=0.5*(3.0*SAL1-SAL0)
      A2=SAL0*(1.0/9.0)
      DX=0.0
      D180=0.0
      DZ=0.0
      IDY=(3.0*SAL1-SAL0)*UNITS
      IDX=(4.0*SAL1+2.0*SAL0)*UNITS
      IF(A2.LT.TOL.AND.BA.LT.TOL)GOTO 4
c
      DX  =2.0*(7.0*SAG1+SAG0+SA1)/(7.0*SAL1+SAL0)/CLIGHT*10000.0
c
c     circular intensity difference for ICP backscattering:
      D180=8.0*(3.0*SAG1-SAG0+SA1)/(7.0*SAL1+SAL0)/CLIGHT*10000.0
c
c     circular intensity difference for I right angle scattering:
      DZ  =2.0*(3.0*SAG1-SAG0-SA1)/(3.0*SAL1-SAL0)/CLIGHT*10000.0
c
      D180RAW=8.0*(3.0*SAG1-SAG0+SA1)*1000.0D0
      I1=INT(3.0*BA/(45.0*A2+4.0*BA)*100.0D0)
      WRITE(4,3000)IQ,ECM,IDX,IDY,S901,DZ,DX,D180,I1,D180RAW
4     WRITE(3,3000)IQ,ECM,IDX,IDY,S901,DZ,DX,D180,I1,D180RAW
3000  FORMAT(I3,f8.2,2f7.0,f9.2,3f10.2,I5,f9.1)
1     CONTINUE
      WRITE(3,3002)
      WRITE(4,3002)
      CLOSE(4)
      RETURN
      END
