      subroutine dox31
c
c     calculate all the four-center integrals (op||rs) (AO)
c     and write then on disk or something like that
c     make storage ~ N or constant
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*1 ok,ty
      character*2 at
      parameter (nat0=190,nor=80,nort=700,
     1mmax=21,npb0=10000,npbe=500)
      integer*4 u0
      parameter (u0=28)
c
c     npb0-dimension of the primitive buffer=max.degree of contraction^4
c     maximum angular momentum is f if npb0=10^4
c
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/iopts/iopt(300)
      equivalence (iopt(22),ncut)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/cmpn51/i51,ifn51
      dimension
     1nxi(u0),nyi(u0),nzi(u0),cci(u0),aai(u0,u0),
     1nxi_1(u0),nyi_1(u0),nzi_1(u0),aai_1(u0,u0),
     1nxi_2(u0),nyi_2(u0),nzi_2(u0),aai_2(u0,u0),
     1nxi_3(u0),nyi_3(u0),nzi_3(u0),aai_3(u0,u0),
     1nxi_4(u0),nyi_4(u0),nzi_4(u0),aai_4(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical ld5,lf7,lopt,tight,nosym,lspecial,lond,
     1lsx,lsy,lsz,loose,lci,lmp2,lmcon
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4),ld5),(lopt(8),lf7),(lopt(35),tight),
     1(lopt(34),nosym),(lopt(37),loose),
     1(lopt(61),lmp2),(lopt(59),lci),
     1(lopt(75),lmcon)
c
      dimension eep(mmax),o4d(npbe)
c
c     primitive quartet buffer
      dimension pqxq(npb0),pqyq(npb0),pqzq(npb0),hspq(npb0),
     1hsqq(npb0),eepq(npb0,mmax),aaq(npb0),bbq(npb0),u_q(npb0),
     2ccq(npb0),ddq(npb0),ccc1(u0,u0),ccc2(u0,u0),ccc3(u0,u0),
     3ccc4(u0,u0),tem(npb0),bbb(npb0),idb(npb0),
     4ii4b(npb0),ii1b(npb0),ii2b(npb0),ii3b(npb0)
c
c     integral buffers
      parameter (nbuff=400)
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
c
c     shell list
      dimension is_a(nort),is_fp(nort),is_lp(nort),is_fo(nort),
     1s_x(nort)
c
      logical lnknj
      parameter (nkkjj0=nort*(nort+1))
      common/kkjj/ckkjj(nkkjj0),enknj(nort),lnknj
c
      call vz(ak,z0,nort*nort)
      call vz(aj,z0,nort*nort)
      call vz(eep,z0,mmax)
      atol=1.0d-15
      xtol=1.0d-6
      if(tight)then
       tol=26.0D0
      else
       tol=23.0D0
       if(loose)tol=11.0D0
      endif
      if(ncut.gt.0)tol=dble(ncut)*log(10.0d0)
      fpl=exp(-tol)
      pi3=pi*pi*pi
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      call inibe4
c
c     for each shell, find its atom, first and last primitive
c     and first and last orbital and alpha_min
c     ioo/npi cartesian
c     io/npii spherical (orbitals (AOs)
      is=0
      io=0
      ioo=0
      lspecial=.false.
      islast=0
      do ia=1,noa
       do ip=1,nop(ia)
        call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1  aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
        if(npi.ne.npii)lspecial=.true.
c
        if(ish(ia,ip)+islast.ne.is)then
         is=is+1
         if(is.gt.nort)call report('too many shells')
         if(is.ne.ish(ia,ip)+islast)then
          do i=1,is-1
           write(6,3001)i,is_a(i),is_fp(i),is_lp(i),is_fo(i),
     1     s_x(i)
          enddo
          write(6,*)is,ia,ip,ish(ia,ip)
          call report('unable to determine shells')
         endif
         is_a(is)=ia
         is_fp(is)=ip
         is_fo(is)=io+1
        endif
c
        is_lp(is)=ip
        if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
        ioo=ioo+npi
        s_x(is)=alpha(ia,ip)
       enddo
       islast=ish(ia,nop(ia))+islast
      enddo
      if(lspecial)then
       write(3,*)'special'
       write(6,*)'5d 7f',ld5,lf7
      else
       write(3,*)'6d, 10f'
       write(6,*)'6d, 10f'
      endif
c
c     control listings
c     ==========================================================
      write(3,*)is,' shells:'
      write(6,*)is,' shells:'
      write(3,*)'shell atom primitives  first orbital  alphamin'
      do i=1,is
       write(3,3001)i,is_a(i),is_fp(i),is_lp(i),is_fo(i),
     1              s_x(i)
3001   format(3i5,' -',i5,i6,f20.10)
      enddo
      write(6,67000)kmin,kmax,jmin,jmax
67000 format('kmin = ',i4,' kmax = ',i4,' jmin = ',i4,' jmax = ',i4)
c     ==========================================================
      t0=dble(mclock())
c
      if(lmp2.or.lci)then
       inquire(file='MPN45.SCR',exist=lond)
       if(lond)then
        write(6,6002)
        write(3,6002)
6002    format('MPN45.SCR found, 2-el AO ints skipped')
        goto 5555
       endif
       open(45,file='MPN45.SCR',form='unformatted')
       open(46,file='MPN46.SCR',form='unformatted')
       open(47,file='MPN47.SCR',form='unformatted')
       open(48,file='MPN48.SCR',form='unformatted')
       open(49,file='MPN49.SCR',form='unformatted')
       open(50,file='MPN50.SCR',form='unformatted')
       open(51,file='MPN51.SCR',form='unformatted')
       ifn51=0
       i51=0
       anit=0.0d0
       niiii=0
       niiij=0
       niijj=0
       nijkk=0
       nijij=0
       nikjk=0
       nijkl=0
      endif
c     ==============================================================
c     first loop over shells
      do 101 i1=1,is
      write(6,6500)i1,is,dble(mclock())-t0
6500  format(i3,' shell of ',i4,' time:',f20.0)
      ia1=is_a(i1)
      am1=s_x(i1)
      x1=xv(1,ia1)
      y1=xv(2,ia1)
      z1=xv(3,ia1)
      call nppp(ty(ia1,is_fp(i1)),n11,n21,cci,
     1nxi_1,nyi_1,nzi_1,
     1aai_1,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia1,is_fp(i1))
c
c     number of gaussians:
      n01=is_lp(i1)-is_fp(i1)+1
      iao1=is_fo(i1)
c     second loop over shells
      do 201 i2=1,i1
      ia2=is_a(i2)
      am2=s_x(i2)
      x2=xv(1,ia2)
      y2=xv(2,ia2)
      z2=xv(3,ia2)
      x12=x2-x1
      y12=y2-y1
      z12=z2-z1
      r12=x12*x12+y12*y12+z12*z12
      t12=am1*am2/(am1+am2)*r12
c
      if(t12.lt.tol)THEN
c
c     third loop over shells
      call nppp(ty(ia2,is_fp(i2)),n12,n22,cci,
     1nxi_2,nyi_2,nzi_2,
     1aai_2,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia2,is_fp(i2))
c
c     number of gaussians:
      n02=is_lp(i2)-is_fp(i2)+1
      iao2=is_fo(i2)
      do 301 i3=1,i1
      ia3=is_a(i3)
      am3=s_x(i3)
      x3=xv(1,ia3)
      y3=xv(2,ia3)
      z3=xv(3,ia3)
c     fourth loop over shells
      if(i3.eq.i1)then
       iend=i2
      else
       iend=i3
      endif
      call nppp(ty(ia3,is_fp(i3)),n13,n23,cci,
     1nxi_3,nyi_3,nzi_3,
     1aai_3,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia3,is_fp(i3))
      x23=x3-x2
      y23=y3-y2
      z23=z3-z2
c
c     number of gaussians:
      n03=is_lp(i3)-is_fp(i3)+1
      n2223=n22*n23
      iao3=is_fo(i3)
      do 401 i4=1,iend
      ia4=is_a(i4)
      am4=s_x(i4)
      x4=xv(1,ia4)
      y4=xv(2,ia4)
      z4=xv(3,ia4)
      x34=x4-x3
      y34=y4-y3
      z34=z4-z3
      r34=x34*x34+y34*y34+z34*z34
      t34=am3*am4/(am3+am4)*r34
c
      if(t34.lt.tol)THEN
c
      call nppp(ty(ia4,is_fp(i4)),n14,n24,cci,
     1nxi_4,nyi_4,nzi_4,
     1aai_4,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia4,is_fp(i4))
c
c     number of gaussians:
      n04=is_lp(i4)-is_fp(i4)+1
      n222324=n2223*n24
      n2324=n23*n24
      iao4=is_fo(i4)
      lsx=abs(x12).lt.xtol.and.abs(x34).lt.xtol.and.abs(x23).lt.xtol
      lsy=abs(y12).lt.xtol.and.abs(y34).lt.xtol.and.abs(y23).lt.xtol
      lsz=abs(z12).lt.xtol.and.abs(z34).lt.xtol.and.abs(z23).lt.xtol
c
c     precalculate [0][m] and common exponent for involved gaussians
      npg=n01*n02*n03*n04
      if(npg.gt.npb0)call report('npg>npb0 in dox31')
      call vz(u_q,0.0d0,npg)
c
c     loops over gaussians--------------------------------:
      npgb=0
      do 1011 i1g=is_fp(i1),is_lp(i1)
      call nppp(ty(ia1,i1g),npi,npii1,cci,
     1nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia1,i1g)
      alpha1=alpha(ia1,i1g)
      ii1=i1g-is_fp(i1)+1
      do 51 ii=1,npi
51    ccc1(ii1,ii)=cci(ii)
      aa=alpha1+alpha1
      m1=mifu(ty(ia1,i1g))
      do 1012 i2g=is_fp(i2),is_lp(i2)
      call nppp(ty(ia2,i2g),npi,npii2,cci,
     1nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia2,i2g)
      alpha2=alpha(ia2,i2g)
      a12=alpha1*alpha2/(alpha1+alpha2)*r12
      if(a12.lt.tol)then
       m2=mifu(ty(ia2,i2g))
       m12=m1+m2
       bb=alpha2+alpha2
       abi=1.0d0/(alpha1+alpha2)
       u1=sqrt(pi3*abi*abi*abi)*exp(-a12)
       px=(alpha1*x1+alpha2*x2)*abi
       py=(alpha1*y1+alpha2*y2)*abi
       pz=(alpha1*z1+alpha2*z2)*abi
       hsp=0.5d0*abi
       ii2=i2g-is_fp(i2)+1
       do 52 ii=1,npi
52     ccc2(ii2,ii)=cci(ii)
       do 1013 i3g=is_fp(i3),is_lp(i3)
       call nppp(ty(ia3,i3g),npi,npii3,cci,
     1 nxi,nyi,nzi,
     1 aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia3,i3g)
       alpha3=alpha(ia3,i3g)
       m3=mifu(ty(ia3,i3g))
       ii3=i3g-is_fp(i3)+1
       do 53 ii=1,npi
53     ccc3(ii3,ii)=cci(ii)
       gg=alpha3+alpha3
       do 1014 i4g=is_fp(i4),is_lp(i4)
       call nppp(ty(ia4,i4g),npi,npii4,cci,
     1 nxi,nyi,nzi,
     1 aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia4,i4g)
       alpha4=alpha(ia4,i4g)
       a34=alpha3*alpha4/(alpha3+alpha4)*r34
       if(a34.lt.tol)then
        ii4=i4g-is_fp(i4)+1
        do 54 ii=1,npi
54      ccc4(ii4,ii)=cci(ii)
        m4=mifu(ty(ia4,i4g))
        m34=m3+m4
        dd=alpha4+alpha4
        cdi=1.0d0/(alpha3+alpha4)
        u2=sqrt(pi3*cdi*cdi*cdi)*exp(-a34)
        uu=u1*u2
        qx=(alpha3*x3+alpha4*x4)*cdi
        qy=(alpha3*y3+alpha4*y4)*cdi
        qz=(alpha3*z3+alpha4*z4)*cdi
        hsq=0.5d0*cdi
c       write(6,6701)i1,i2,i3,i4
c       write(6,6701)i1g,i2g,i3g,i4g
6701    format(4i4)
c       write(6,6700)m12,m34,qx,qy,qz,px,py,pz,hsp,hsq,tol
6700    format(2i4,5f10.5,/,8x,5f10.5)
c
c       activate [0][m] integrals (in eep) and pqx,pqy,pqz,
        call iactivate(m12,m34,qx,qy,qz,px,py,pz,eep,
     1                 pqx,pqy,pqz,hsp,hsq,tol)
        npgb=npgb+1
        ii1b(npgb)=ii1
        ii2b(npgb)=ii2
        ii3b(npgb)=ii3
        ii4b(npgb)=ii4
        pqxq(npgb)=pqx
        pqyq(npgb)=pqy
        pqzq(npgb)=pqz
        hspq(npgb)=hsp
        hsqq(npgb)=hsq
        aaq(npgb)=aa
        bbq(npgb)=bb
        ccq(npgb)=gg
        ddq(npgb)=dd
        u_q(npgb)=uu
        do 55 ii=1,m12+m34+1
55      eepq(npgb,ii)=eep(ii)
       endif
1014   continue
1013   continue
      endif
1012  continue
1011  continue
c     end of loop of involved gaussians-------------------
c
c     loops over cartesian components:====================
      call vz(bbb,0.0d0,n11*n12*n13*n14)
      do 2011 ip1c=1,n11
      nx1=nxi_1(ip1c)
      ny1=nyi_1(ip1c)
      nz1=nzi_1(ip1c)
      m1=nx1+ny1+nz1
      do 2011 ip2c=1,n12
      nx2=nxi_2(ip2c)
      ny2=nyi_2(ip2c)
      nz2=nzi_2(ip2c)
      m2=nx2+ny2+nz2
      do 2011 ip3c=1,n13
      nx3=nxi_3(ip3c)
      ny3=nyi_3(ip3c)
      nz3=nzi_3(ip3c)
      m3=nx3+ny3+nz3
      do 2011 ip4c=1,n14
      nx4=nxi_4(ip4c)
      ny4=nyi_4(ip4c)
      nz4=nzi_4(ip4c)
      m4=nx4+ny4+nz4
      mmx=m1+m2+m3+m4
c
c     consider symmetry
      if(nosym)goto 666
      if(lsx)then
       mx=nx1+nx2+nx3+nx4
       mx2=mx/2
       if(mx2+mx2.ne.mx)goto 2011
      endif
      if(lsy)then
       my=ny1+ny2+ny3+ny4
       my2=my/2
       if(my2+my2.ne.my)goto 2011
      endif
      if(lsz)then
       mz=nz1+nz2+nz3+nz4
       mz2=mz/2
       if(mz2+mz2.ne.mz)goto 2011
      endif
666   continue
c
      ind=ip4c+(ip3c-1)*n14+(ip2c-1)*n14*n13+(ip1c-1)*n14*n13*n12
      b=0.0d0
c
c     evaluate all primitive integrals 1..npgb for current momenta
c     in npbe batches
      nst=1
333   nnd=min(nst+npbe-1,npgb)
      call oce5(nx1,ny1,nz1,nx2,ny2,nz2,nx3,ny3,nz3,nx4,ny4,nz4,
     1x12,y12,z12,x34,y34,z34,pqxq,pqyq,pqzq,hspq,hsqq,
     2aaq,bbq,ccq,ddq,mmx,eepq,atol,nst,nnd,o4d)
c
c     contract them into cartesian AO
      do 3999 ii=nst,nnd
3999  b=b+ccc1(ii1b(ii),ip1c)*ccc2(ii2b(ii),ip2c)*
     1    ccc3(ii3b(ii),ip3c)*ccc4(ii4b(ii),ip4c)*o4d(ii-nst+1)*u_q(ii)
c
      if(nnd.lt.npgb)then
       nst=nnd+1
       goto 333
      endif
c
      bbb(ind)=b
2011  continue
c
c     if sherical functions, cartesian->spherical trafo is needed!
      if(lspecial)then
c
c      fourth index bb->tem
       do 5001 i1x=1,n11
       iu1=(i1x-1)*n14*n13*n12
       iu2=(i1x-1)*n24*n13*n12
       do 5001 i2x=1,n12
       ju1=(i2x-1)*n14*n13+iu1
       ju2=(i2x-1)*n24*n13+iu2
       do 5001 i3x=1,n13
       do 5001 i4s=1,n24
       noo=i4s+(i3x-1)*n24+ju2
       tem(noo)=0.0d0
       do 5001 i4x=1,n14
       ind=i4x+(i3x-1)*n14+ju1
5001   tem(noo)=tem(noo)+aai_4(i4s,i4x)*bbb(ind)
c
c      third index tem->bb
       do 5002 i1x=1,n11
       do 5002 i2x=1,n12
       do 5002 i3s=1,n23
       do 5002 i4s=1,n24
       noo=i4s+(i3s-1)*n24+(i2x-1)*n24*n23+(i1x-1)*n24*n23*n12
       bbb(noo)=0.0d0
       do 5002 i3x=1,n13
       ind=i4s+(i3x-1)*n24+(i2x-1)*n24*n13+(i1x-1)*n24*n13*n12
5002   bbb(noo)=bbb(noo)+aai_3(i3s,i3x)*tem(ind)
c
c      second index bb->tem
       do 5003 i1x=1,n11
       do 5003 i2s=1,n22
       do 5003 i3s=1,n22
       do 5003 i4s=1,n24
       noo=i4s+(i3s-1)*n24+(i2s-1)*n24*n23+(i1x-1)*n24*n23*n22
       tem(noo)=0.0d0
       do 5003 i2x=1,n12
       ind=i4s+(i3s-1)*n24+(i2x-1)*n24*n23+(i1x-1)*n24*n23*n12
5003   tem(noo)=tem(noo)+aai_2(i2s,i2x)*bbb(ind)
c
c      first index tem->bb
       do 5004 i1s=1,n21
       do 5004 i2s=1,n22
       do 5004 i3s=1,n23
       do 5004 i4s=1,n24
       noo=i4s+(i3s-1)*n24+(i2s-1)*n24*n23+(i1s-1)*n24*n23*n22
       bbb(noo)=0.0d0
       do 5004 i1x=1,n11
       ind=i4s+(i3s-1)*n24+(i2s-1)*n24*n23+(i1x-1)*n24*n23*n22
5004   bbb(noo)=bbb(noo)+aai_1(i1s,i1x)*tem(ind)
      endif
c
c     look, if orbital intervals overlap:
c     if no complication, sort integrals and write all on disk
      if(i1.ne.i2.and.i1.ne.i3.and.i1.ne.i4.and.i2.ne.i3.and.
     1   i2.ne.i4.and.i3.ne.i4)then
       igi=-n222324
       do 1029 ii1=1,n21
       igi=igi+n222324
       io1=ii1+iao1-1
       igj=igi-n2324
       do 1029 ii2=1,n22
       igj=igj+n2324
       io2=ii2+iao2-1
       igk=igj-n24
       do 1029 ii3=1,n23
       igk=igk+n24
       io3=ii3+iao3-1
       do 1029 ii4=1,n24
       b=bbb(ii4+igk)
       if(abs(b).gt.fpl)then
c
        if(lnknj)then
c        contract with limited number of (JJ|KK),(JK|JK) integrals:
         call cnknj(b,io1,io2,io3,ii4+iao4-1)
        else
         if(lmp2.or.lci)then
c         write to buffer
          call adb(b,io1,io2,io3,ii4+iao4-1)
         else
          if(lmcon) then
           call adb2(b,io1,io2,io3,ii4+iao4-1)
          else
           call contra3(b,io1,io2,io3,ii4+iao4-1)
          endif
         endif
        endif
        anit=anit+1.0d0
c
       endif
1029   continue
      else
c
c      set id for each and
c      before writing, investigate if previously defined
       do 1031 ii1=1,n21
       io1=ii1+iao1-1
       do 1031 ii2=1,n22
       io2=ii2+iao2-1
       if(io1.le.io2)then
        i12=io1+(io2-1)*io2/2
       else
        i12=io2+(io1-1)*io1/2
       endif
       do 1031 ii3=1,n23
       io3=ii3+iao3-1
       do 1031 ii4=1,n24
       io4=ii4+iao4-1
       if(io3.le.io4)then
        i34=io3+(io4-1)*io4/2
       else
        i34=io4+(io3-1)*io3/2
       endif
       if(i34.le.i12)then
        i1234=i34+(i12-1)*i12/2
       else
        i1234=i12+(i34-1)*i34/2
       endif
       noo=ii4+(ii3-1)*n24+(ii2-1)*n24*n23+(ii1-1)*n24*n23*n22
       idb(noo)=i1234
       b=bbb(noo)
       if(abs(b).gt.fpl)then
        do 1032 iprev=1,noo-1
1032    if(i1234.eq.idb(iprev))goto 1031
c
        if(lnknj)then
c        contract with limited number of (JJ|KK),(JK|JK) integrals:
         call cnknj(b,io1,io2,io3,ii4+iao4-1)
        else
         if(lmp2.or.lci)then
          call adb(b,io1,io2,io3,io4)
         else
          if(lmcon) then
           call adb2(b,io1,io2,io3,ii4+iao4-1)
          else
           call contra3(b,io1,io2,io3,io4)
          endif
         endif
        endif
        anit=anit+1.0d0
c
       endif
1031   continue
      endif
c
      ENDIF
c
401   continue
301   continue
c
      ENDIF
c
201   continue
101   continue
      write(6,67000)kmin,kmax,jmin,jmax
c     loops over shells
c     ==============================================================
      if(.not.lnknj)then
       if(lmp2.or.lci)then
        call cmp2i(0)
        do i=45,51
         close(i)
        enddo
       else
        if(lmcon)then
         call cmpp(0)
        else
         call contrxx(0)
        endif
       endif
      endif
c
      r=dble(nao)
      rr=(r +1.0d0)*r *0.5d0
      r4=(rr+1.0d0)*rr*0.5d0
      ti=dble(mclock())-t0
      write(3,3002)anit,anit/r4*100.0d0,ti-t0
      write(6,3002)anit,anit/r4*100.0d0,ti-t0
3002  format(f20.0,' non-zero AO 2-e integrals (',f9.4,'%)',/,
     1'time ',f10.0)
c
5555  nstart=max(iopt(8),1)
      nend=iopt(9)
      if(nend.eq.0)nend=nmo
      if((lmp2.or.lci).and..not.lnknj)then
       if(lci)then
        write(6,*)'1',nmo
        call trafosp(1,nmo,fpl)
        write(6,*)'2',nmo
        call fillajk(1,nmo)
        write(6,*)'3',nmo
       else
        call trafosp(nstart,nend,fpl)
        call fillajk(nstart,nend)
       endif
      endif
      return
      end
c     ====================================
      subroutine adb(b,i,j,k,l)
c
c     just write the integrals in buffer
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400)
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
c
         if(i.eq.j)then
c         II
          if(k.eq.i)then
c          III
           if(l.eq.i)then
c           IIII
            goto 1
           else
c           IIIJ
            ii=i
            jj=l
            goto 2
           endif
          else
c          IIJ
           if(l.eq.i)then
c           IIJI
            ii=i
            jj=k
            goto 2
           else
            if(l.eq.k)then
c            IIJJ
             goto 3
            else
c            IIJK
             ii=i
             jj=k
             kk=l
             goto 5
            endif
           endif
          endif
         else
c         IJ
          if(k.eq.i)then
c          IJI
           if(l.eq.i)then
c           IJII
            ii=i
            jj=j
            goto 2
           else
            if(l.eq.j)then
c            IJIJ
             goto 4
            else
c            IJIK
             ii=i
             jj=j
             kk=l
             goto 6
            endif
           endif
          else
           if(k.eq.j)then
c           IJJ
            if(l.eq.i)then
c            IJJI
             goto 4
            else
             if(l.eq.j)then
c             IJJJ
              ii=j
              jj=i
              goto 2
             else
c             IJJK
              ii=j
              jj=i
              kk=l
              goto 6
             endif
            endif
           else
c           IJK
            if(l.eq.i)then
c            IJKI
             ii=i
             jj=j
             kk=k
             goto 6
            else
             if(l.eq.j)then
c             IJKJ
              ii=j
              jj=i
              kk=k
              goto 6
             else
              if(l.eq.k)then
c              IJKK
               ii=k
               jj=i
               kk=j
               goto 5
              else
c              IJKL
               goto 7
              endif
             endif
            endif
           endif
          endif
         endif
c
c     iiii
1     niiii=niiii+1
      aiiii(niiii)=b
      iiiii(niiii)=i
      if(niiii.eq.nbuff)then
       call cmp2i(1)
       niiii=0
      endif
      return
c
c     iiij
2     niiij=niiij+1
      aiiij(niiij)=b
      iiiij(niiij)=ii
      jiiij(niiij)=jj
      if(niiij.eq.nbuff)then
       call cmp2i(2)
       niiij=0
      endif
      return
c
c     iijj
3     niijj=niijj+1
      aiijj(niijj)=b
      iiijj(niijj)=i
      jiijj(niijj)=k
      if(niijj.eq.nbuff)then
       call cmp2i(3)
       niijj=0
      endif
      return
c
c     ijij
4     nijij=nijij+1
      aijij(nijij)=b
      iijij(nijij)=i
      jijij(nijij)=j
      if(nijij.eq.nbuff)then
       call cmp2i(4)
       nijij=0
      endif
      return
c
c     iijk ijkk
5     nijkk=nijkk+1
      aijkk(nijkk)=b
      iijkk(nijkk)=kk
      jijkk(nijkk)=jj
      kijkk(nijkk)=ii
      if(nijkk.eq.nbuff)then
       call cmp2i(5)
       nijkk=0
      endif
      return
c
c     ijik-ikjk
6     nikjk=nikjk+1
      aikjk(nikjk)=b
      iikjk(nikjk)=kk
      jikjk(nikjk)=jj
      kikjk(nikjk)=ii
      if(nikjk.eq.nbuff)then
       call cmp2i(6)
       nikjk=0
      endif
      return
c
c     ijkl
7     nijkl=nijkl+1
      aijkl(nijkl)=b
      iijkl(nijkl)=i
      jijkl(nijkl)=j
      kijkl(nijkl)=k
      lijkl(nijkl)=l
      if(nijkl.eq.nbuff)then
       call cmp2i(7)
       nijkl=0
      endif
      return
      end
c     ==========================
      subroutine adb2(b,i,j,k,l)
c
c     write the integrals in buffers, if full call cmpp
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nbuffmax=100)
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
c
      call report('not implemented yet')
         if(i.eq.j)then
c         II
          if(k.eq.i)then
c          III
           if(l.eq.i)then
c           IIII
            goto 1
           else
c           IIIJ
            ii=i
            jj=l
            goto 2
           endif
          else
c          IIJ
           if(l.eq.i)then
c           IIJI
            ii=i
            jj=k
            goto 2
           else
            if(l.eq.k)then
c            IIJJ
             goto 3
            else
c            IIJK
             ii=i
             jj=k
             kk=l
             goto 5
            endif
           endif
          endif
         else
c         IJ
          if(k.eq.i)then
c          IJI
           if(l.eq.i)then
c           IJII
            ii=i
            jj=j
            goto 2
           else
            if(l.eq.j)then
c            IJIJ
             goto 4
            else
c            IJIK
             ii=i
             jj=j
             kk=l
             goto 6
            endif
           endif
          else
           if(k.eq.j)then
c           IJJ
            if(l.eq.i)then
c            IJJI
             goto 4
            else
             if(l.eq.j)then
c             IJJJ
              ii=j
              jj=i
              goto 2
             else
c             IJJK
              ii=j
              jj=i
              kk=l
              goto 6
             endif
            endif
           else
c           IJK
            if(l.eq.i)then
c            IJKI
             ii=i
             jj=j
             kk=k
             goto 6
            else
             if(l.eq.j)then
c             IJKJ
              ii=j
              jj=i
              kk=k
              goto 6
             else
              if(l.eq.k)then
c              IJKK
               ii=k
               jj=i
               kk=j
               goto 5
              else
c              IJKL
               goto 7
              endif
             endif
            endif
           endif
          endif
         endif
c
c     iiii
1     niiii=niiii+1
      aiiii(niiii)=b
      iiiii(niiii)=i
      if(niiii.eq.nbuffmax)then
       call cmpp(1)
       niiii=0
      endif
      return
c
c     iiij
2     niiij=niiij+1
      aiiij(niiij)=b
      iiiij(niiij)=ii
      jiiij(niiij)=jj
      if(niiij.eq.nbuffmax)then
       call cmpp(2)
       niiij=0
      endif
      return
c
c     iijj
3     niijj=niijj+1
      aiijj(niijj)=b
      iiijj(niijj)=i
      jiijj(niijj)=k
      if(niijj.eq.nbuffmax)then
       call cmpp(3)
       niijj=0
      endif
      return
c
c     ijij
4     nijij=nijij+1
      aijij(nijij)=b
      iijij(nijij)=i
      jijij(nijij)=j
      if(nijij.eq.nbuffmax)then
       call cmpp(4)
       nijij=0
      endif
      return
c
c     iijk ijkk
5     nijkk=nijkk+1
      aijkk(nijkk)=b
      iijkk(nijkk)=kk
      jijkk(nijkk)=jj
      kijkk(nijkk)=ii
      if(nijkk.eq.nbuffmax)then
       call cmpp(5)
       nijkk=0
      endif
      return
c
c     ijik-ikjk
6     nikjk=nikjk+1
      aikjk(nikjk)=b
      iikjk(nikjk)=kk
      jikjk(nikjk)=jj
      kikjk(nikjk)=ii
      if(nikjk.eq.nbuffmax)then
       call cmpp(6)
       nikjk=0
      endif
      return
c
c     ijkl
7     nijkl=nijkl+1
      aijkl(nijkl)=b
      iijkl(nijkl)=i
      jijkl(nijkl)=j
      kijkl(nijkl)=k
      lijkl(nijkl)=l
      if(nijkl.eq.nbuffmax)then
       call cmpp(7)
       nijkl=0
      endif
      return
      end
c     =================================================================
      subroutine cmpp(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with the MO coeff
c     quasi N**5 procedure
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      call report('not implemented yet')
c     probably contra33 will be modified here
c
      end
