      subroutine dqmpol3k(ioe)
c
c     molecule - vacuum interaction energy - conducting wall
c     boundary condition
c
      implicit none
      integer*4 nat0,nor,nort,ioe,nzz,nmo,i,j,nat,nao,nxmax,nymax,nzmax,
     1noe,ichm,mtp,ndo,nsa,nsb,noa,nori,nop,ish,kmin,kmax,jmin,jmax,
     1icha,n1,nx,ny,nz,idk,nxstart(3),nystart(3),nzstart(3),nleb,
     1nxend(3),nyend(3),nzend(3),i3,nmax0,iopt,y6,iu,nklim,ilebed
      parameter (nat0=190,nor=80,nort=700,nmax0=200,y6=6)
      integer*4 u0
      parameter (u0=28)
c
c     nat0   maximum number of atoms
c     nor    maximum number of primitives on one atom
c     nort   maximum number of orbitals
c     nmax0  maximum dimension for the integration buffer
c
      real*8 aex,one,aa1,aaf,ox,oy,oz,aj,ak,alx,aly,alz,escf,aag,aah,
     1aaii,
     1cc,alpha,rcp,c,bij,e,be,aad,pi,clau,dekcal(y6),deau(y6),deold,
     2spt,bohr,debye,z0,two,three,four,five,six,half,qua,a8,a10,px,py,
     3pz,de,akx,aky,akz,cox,coy,coz,sox,soy,soz,kxmax,kymax,kzmax,
     3sum(y6),rklim,eklim,pr,akr,rkm,rkp,dv,sumv,deklim,srr1,srr2,
     4vkx,vky,vkz,dkx,dky,dkz,ktol,krmax2,de0,planex(y6,nmax0,nmax0),
     5planexm(y6,nmax0,nmax0),planexmm(y6,nmax0,nmax0),
     5f0,axx,ayy,azz,ceau,prt,tmax,tau,
     6akmax,T,ropt,deorb
      common/cazsums/de(y6)
      common/dedel/deorb(nort)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),c(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/aa100/aa1(u0,u0),aad(u0,u0),aaf(u0,u0),
     1aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      logical lopt,lconfig,lkprn,ltt,lcaz,lkcaz,lkorb,lcazfac,lcazcub,
     1lklim,ldamp
      common/opts/lopt(300),icha,n1
      common/iopts/iopt(300)
      common/ropts/ropt(300)
      equivalence (lopt(65),lconfig),(lopt(84),lcaz),(lopt(85),lkcaz),
     1            (lopt(86),lkprn),(lopt(87),lkorb),(lopt(90),lcazfac),
     1            (lopt(91),lcazcub),(lopt(95),lklim),(lopt(96),ldamp),
     1            (iopt(25),nxmax),(iopt(26),nymax ),(iopt(27),nzmax),
     1            (iopt(28),idk),(iopt(29),nklim),(iopt(30),ilebed),
     1            (ropt(3),ox ),(ropt(4),oy ),(ropt(5),oz ),
     1            (ropt(6),alx),(ropt(7),aly),(ropt(8),alz),
     1            (ropt(9),ktol),(ropt(10),akmax),
     1            (ropt(11),kxmax),(ropt(12),kymax ),(ropt(12),kzmax),
     1            (ropt(14),px  ),(ropt(15),py  ),(ropt(16),pz),
     1            (ropt(18),rklim),(ropt(19),eklim),(ropt(20),pr),
     1            (ropt(21),deklim)
      common/kelvin/T,ltt
      integer*4 l0
      parameter (l0=6000)
      real*8 X,Y,Z,W
      common/llcommon/X(l0),Y(l0),Z(l0),W(l0)

      if(lkcaz)then
       ok='k'
      else
       ok='n'
      endif

      do 1 i=1,nmo
1     deorb(i)=0.0d0
c
      aex=one
      call inipoly
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      if(ioe.eq.3)aex=z0
      if(ioe.gt.0)then
       nzz=nmo
       if(lconfig)nzz=2*nmo
       open(23,file='AKJK.SCR',form='unformatted',status='old')
       read(23)((ak(i,j),i=1,nzz),j=1,nzz),((aj(i,j),i=1,nzz),j=1,nzz)
       close(23)
       write(6,*)'K_JK, J_JK read from scratch'
      endif
c
c     constant that firstly transforms calculated energy
c     into SI units (J), then to kcal/mol and back to hartree
      ceau=1.6021892d-19**2*1.0545886d-34**4/8.8541878181d-12/
     19.109534d-31**2/4.359d-18**2/0.529177d-10**5*
     26.022045d23/1000.0d0/4.184d0/627.5d0
c
      if(lkprn)open(9,file='k.prn')
      write(6,6007)ndo,nsa,nsb,nmo
6007  format(/,i4,' doubly ',i4,' alpha ',i4,' beta ',i4,' MOs')

      call vz(de,0.0d0,y6)
      if(ok.eq.'n'.or.ok.eq.'N')then
       write(6,6003)ox,oy,oz,alx,aly,alz,nxmax+1,nymax+1,nzmax+1,
     1 (nxmax+1)*(nymax+1)*(nzmax+1)-1
6003   format(/,
     1 ' Vacuum interaction energy calculation',/,/,
     1 ' N-type input',/,/,
     1 ' cage origin (',f6.2,2h, ,f6.2,2h, ,f6.2,3h) A,/,
     2 ' cage         ',f6.2,2h x,f6.2,2h x,f6.2,2h A,/,
     1 '              ',i4,2h x,i4,2h x,i4,' - 1 =',i12,' photon modes')
       ox=ox/bohr
       oy=oy/bohr
       oz=oz/bohr
       alx=alx/bohr
       aly=aly/bohr
       alz=alz/bohr
       px=pi/alx
       py=pi/aly
       pz=pi/alz

       do 2 nx=0,nxmax
       write(6,*)nx
       akx=dble(nx)*px
       cox=cos(akx*ox)
       sox=sin(akx*ox)
       do 2 ny=0,nymax
       aky=dble(ny)*py
       coy=cos(aky*oy)
       soy=sin(aky*oy)
       do 2 nz=0,nzmax
       akz=dble(nz)*pz
       coz=cos(akz*oz)
       soz=sin(akz*oz)
2      if(nx.gt.0.or.ny.gt.0.or.nz.gt.0)
     1 call addkpo(akx,aky,akz,cox,coy,coz,sox,soy,soz,de,ndo,e,
     2 nmo,nao,ioe,aex,c)

       call vm(de,8.0d0/alx/aly/alz,y6)

c      basis functions  sqrt(8/L) cos(kxx)sin(kyy)sin(kzz) etc.

      else

       nxmax=int(kxmax/px)
       nymax=int(kymax/py)
       nzmax=int(kzmax/pz)
       write(3,6001)kxmax,kymax,kzmax,px,py,pz,
     1 nxmax,nymax,nzmax,nxmax*nymax*nzmax
       write(6,6001)kxmax,kymax,kzmax,px,py,pz,
     1 nxmax,nymax,nzmax,nxmax*nymax*nzmax
6001   format(/,
     1 ' Vacuum interaction energy calculation',/,/,
     1 ' K-type input',/,/,
     1 ' kxmax kymax kzmax ',f6.3,2h  ,f6.3,2h  ,f6.3,' bohr^-1',/,
     2 ' dkx dky dkz       ',f6.3,2h  ,f6.3,2h  ,f6.3,' bohr^-1',/,
     1 ' photons           ',i4,2h x,i4,2h x,i4,1h=,i12)
       if(ltt)write(6,6009)T
6009   format(' T = ',f10.2,' Kelvins')
       if(nklim.gt.0)write(6,654)nklim
       if(nklim.gt.0)write(3,654)nklim
654    format(' Maximal virtual orbital included: ',i4)
       if(nklim.gt.nmo)call report('nklim > nmo!')
       if(eklim.gt.0.0d0)write(6,655)eklim
       if(eklim.gt.0.0d0)write(3,655)eklim
655    format(' Maximal virtual energy included: ',f12.2,' hartree')
       if(ldamp)then
        write(6,656)deklim
        write(3,656)deklim
656     format(' Damping width',f12.2,' hartree')
       endif
c      ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
       if(idk.eq.-3)then
        write(6,*)'constant spacing-plot XY'
        open(45,file='XY.PRN')
        akz=pz/2.0d0
        aky=-py
        do ny=1,nymax
        write(6,*)ny
        aky=aky+py
        akx=-px
        do nx=1,nxmax
         akx=akx+px
         call vz(de,0.0d0,y6)
         call addkpi(akx,aky,akz,de,ndo,e,nmo,nao,ioe,aex,c,
     1   bij,be,nsa,nsb)
         write(45,4545)akx,aky,de(1)
4545     format(6e13.5)
        enddo
        enddo
       endif
c      YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY
       if(idk.eq.-2)then
        write(6,*)'constant spacing-plot RXZ'
        open(45,file='RXZ.PRN')
        aky=py/2.0d0
        akz=-pz
        do nz=1,nzmax
        write(6,*)nz
        akz=akz+pz
        akx=dble(nxmax)*px
        do nx=1,nxmax
         akx=akx-px
         call vz(de,0.0d0,y6)
         call addkpi(akx,aky,akz,de,ndo,e,nmo,nao,ioe,aex,c,
     1   bij,be,nsa,nsb)
         write(45,4545)-akx,akz,de(1)
        enddo
        enddo
       endif
c      XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
       if(idk.eq.-1)then
        write(6,*)'constant spacing-plot YZ'
        open(45,file='YZ.PRN')
        akx=px/2.0d0
        akz=-pz
        do nz=1,nzmax
        write(6,*)nz
        akz=akz+pz
        aky=-py
        do ny=1,nymax
         aky=aky+py
         call vz(de,0.0d0,y6)
         call addkpi(akx,aky,akz,de,ndo,e,nmo,nao,ioe,aex,c,
     1   bij,be,nsa,nsb)
         write(45,4545)aky,akz,de(1)
        enddo
        enddo
       endif

       if(idk.lt.0)then
        close(45)
        call report('plot only option')
       endif
c      0000000000000000000000000000000000000000000000000000000000000000
       if(idk.eq.0)then
        if(lcazcub)then
         if(nymax.gt.nmax0.or.nzmax.gt.nmax0)call report('nmax0 over')
         open(56,file='CAZ.CUB')
         write(56,5656)
5656     format(' contributions of individual photon modes',/,
     1          ' SCF Total Density')
         write(56,5657)1,px/2.0d0,py/2.0d0,pz/2.0d0
5657     format(i5,4f12.6)
         write(56,5657)nxmax,px,0.0,0.0
         write(56,5657)nymax,0.0,py,0.0
         write(56,5657)nzmax,0.0,0.0,pz
         write(56,5657)1,1.0,0.0,0.0,0.0
        endif

        write(6,*)'constant spacing'
        akx=-px/2.0d0
        do 3001 nx=1,nxmax
        write(6,*)nx
        akx=akx+px
        aky=-py/2.0d0
        do 3 ny=1,nymax
        aky=aky+py
        akz=-pz/2.0d0
        do 3 nz=1,nzmax
        akz=akz+pz
        if(lcazcub)deold=de(1)
        call addkpi(akx,aky,akz,de,ndo,e,nmo,nao,ioe,aex,c,
     1  bij,be,nsa,nsb)
3       if(lcazcub)planex(1,ny,nz)=de(1)-deold
        if(lcazcub)then
         do 3002 ny=1,nymax
3002     write(56,5658)(planex(1,ny,nz),nz=1,nzmax)
5658     format(6e13.5)
        endif
3001    continue
        call vm(de,px*py*pz/pi**3,y6)
        if(lkorb)then
         do i=1,ndo
          deorb(i)=deorb(i)**px*py*pz/pi**3
         enddo
        endif
        if(lcazcub)close(56)
       endif
c      1111111111111111111111111111111111111111111111111111111111111
       if(idk.eq.1)then
c       one octant only - variable spacing  dk=k*dk0
        write(6,*)'variable spacing'
        nx=0
31      nx=nx+1
        if(nx.eq.1)then
         dkx=2.0d0*px*px
         akx=px*px
        else
         dkx=akx*px
         akx=akx+dkx
        endif
        vkx=(dkx+akx*px)/2.0d0
        write(6,*)nx,akx
        ny=0
32      ny=ny+1
        if(ny.eq.1)then
         dky=2.0d0*py*py
         aky=py*py
        else
         dky=aky*py
         aky=aky+dky
        endif
        vky=(dky+aky*py)/2.0d0
        nz=0
33      nz=nz+1
        if(nz.eq.1)then
         dkz=2.0d0*pz*pz
         akz=pz*pz
        else
         dkz=akz*pz
         akz=akz+dkz
        endif
        vkz=(dkz+akz*pz)/2.0d0
        call vz(sum(iu),0.0d0,y6)
        call addkpi(akx,aky,akz,sum,ndo,e,nmo,nao,ioe,aex,c,
     1  bij,be,nsa,nsb)
        if(lkprn)write(9,9000)dsqrt(akx**2+aky**2+akz**2),sum(1)
9000    format(2f10.6)
        do iu=1,y6
         de(iu)=de(iu)+sum(iu)*vkx*vky*vkz
        enddo
        if(akz.lt.kzmax)goto 33
        if(aky.lt.kymax)goto 32
        if(akx.lt.kxmax)goto 31
        call vm(de,1.0d0/pi**3,y6)
       endif
c      2222222222222222222222222222222222222222222222222222222222222
       if(idk.eq.2)then
        write(6,*)'constant spacing k->k**2 '
        px=dsqrt(kxmax)/dble(nxmax)
        py=dsqrt(kymax)/dble(nymax)
        pz=dsqrt(kzmax)/dble(nzmax)
        akx=-px/2.0d0
        do 36 nx=1,nxmax
        write(6,*)nx
        akx=akx+px
        aky=-py/2.0d0
        do 36 ny=1,nymax
        aky=aky+py
        akz=-pz/2.0d0
        do 36 nz=1,nzmax
        akz=akz+pz
        call vz(sum(iu),0.0d0,y6)
        call addkpi(akx**2,aky**2,akz**2,sum,ndo,e,nmo,nao,ioe,aex,c,
     1  bij,be,nsa,nsb)
        if(lkprn)write(9,9000)akx**2+aky**2+akz**2,sum(1)*akx*aky*akz
        do iu=1,y6
         de(iu)=de(iu)+sum(iu)*8.0d0*akx*aky*akz
        enddo
36      continue
        call vm(de,px*py*pz/pi**3,y6)
        if(lkorb)call vm(deorb,px*py*pz/pi**3,ndo)
       endif
c      3333333333333333333333333333333333333333333333333333333333333
       if(idk.eq.3)then
        write(6,6004)ktol
6004    format('constant spacing k->k**2, find kmax, del e < ',f9.5,
     1  ' hartree')
        nxstart(1)=1
        nystart(1)=1
        nzstart(1)=1
        nxend(1)=nxmax
        nyend(1)=nymax
        nzend(1)=nzmax
        nxstart(2)=1
        nystart(2)=1
        nzstart(2)=1
        nxend(2)=0
        nyend(2)=0
        nzend(2)=0
        nxstart(3)=1
        nystart(3)=1
        nzstart(3)=1
        nxend(3)=0
        nyend(3)=0
        nzend(3)=0
        px=dsqrt(kxmax)/dble(nxmax)
        py=dsqrt(kymax)/dble(nymax)
        pz=dsqrt(kzmax)/dble(nzmax)
        de0=de(1)
444     do 34 i3=1,3
        do 34 nx=nxstart(i3),nxend(i3)
        write(6,*)i3,nx
        akx=(dble(nx)-0.5d0)*px
        do 34 ny=nystart(i3),nyend(i3)
        aky=(dble(ny)-0.5d0)*py
        do 34 nz=nzstart(i3),nzend(i3)
        akz=(dble(nz)-0.5d0)*pz
        call vz(sum,0.0d0,y6)
        call addkpi(akx**2,aky**2,akz**2,sum,ndo,e,nmo,nao,ioe,aex,c,
     1  bij,be,nsa,nsb)
        do iu=1,y6
         de(iu)=de(iu)+sum(iu)*8.0d0*akx*aky*akz*px*py*pz/pi**3
        enddo
34      continue
        deau(1)=de(1)*ceau
        write(6,6005)de0,deau(1),deau(1)-de0
6005    format(' old E = ',f9.6,', new E =',f9.6,', del = ',f9.6)
        if(abs(deau(1)-de0).gt.ktol)then
         write(6,*)' not converged'
         de0=deau(1)
         nx=nxmax
         ny=nymax
         nz=nzmax
         nxmax=max(nxmax+1,nxmax*5/4)
         nymax=max(nymax+1,nymax*5/4)
         nzmax=max(nzmax+1,nzmax*5/4)
         nxstart(1)=nx+1
         nxend(1)=nxmax
         nystart(1)=1
         nyend(1)=nymax
         nzstart(1)=1
         nzend(1)=nzmax
         nxstart(2)=1
         nxend(2)=nx
         nystart(2)=ny+1
         nyend(2)=nymax
         nzstart(2)=1
         nzend(2)=nzmax
         nxstart(3)=1
         nxend(3)=nx
         nystart(3)=1
         nyend(3)=ny
         nzstart(3)=nz+1
         nzend(3)=nzmax
         goto 444
        else
         krmax2=((dble(nxmax)-0.5d0)*px)**4
     1         +((dble(nymax)-0.5d0)*py)**4
     2         +((dble(nzmax)-0.5d0)*pz)**4
         write(6,6006)dsqrt(krmax2)
6006     format(' converged, kmax = ',f9.5)
        endif
       endif
c      4444444444444444444444444444444444444444444444444444444444444
       if(idk.eq.4)then
        call w36('constant spacing k->k**2, with smoothing')
        if(lklim)then
         write(6,6098)rklim
         write(3,6098)rklim
6098     format(' |k| < ',f10.2)
        endif
        px=dsqrt(kxmax)/dble(nxmax)
        py=dsqrt(kymax)/dble(nymax)
        pz=dsqrt(kzmax)/dble(nzmax)
        if(nmax0.lt.nymax)call report('nymax overflow')
        if(nmax0.lt.nzmax)call report('nzmax overflow')
c
c       initialize plane to avoid compiler warnings
        do 3521 ny=1,nymax
        do 3521 nz=1,nzmax
        do 3521 iu=1,y6
        planexm(iu,ny,nz)=0.0d0
3521    planexmm(iu,ny,nz)=0.0d0
c
c       pre-calculate k-ints into buffer
        if(lcazfac)then
         call report('Not implemented yet')
c        if you want to implement it, you must consider
c        that only primitive can be factorized - into X.Y.Z product,
c        not the atomic orbitals
         akx=-px/2.0d0
         do nx=1,nxmax
          akx=akx+px
          call prfib(1,akx,nx)
         enddo
         aky=-py/2.0d0
         do ny=1,nymax
          aky=aky+py
          call prfib(2,aky,ny)
         enddo
         akz=-pz/2.0d0
         do nz=1,nzmax
          akz=akz+pz
          call prfib(3,akz,nz)
         enddo
         write(6,*)'k-ints precalculated into AO X Y Z buffers'
        endif

        akx=-px/2.0d0
        do 35 nx=1,nxmax
        akx=akx+px
        open(88,file='progress')
        write(88,*)nx
        close(88)
        write(6,886)nx,akx**2
886     format(i4,f15.5)
c
c       K = k ** 2   !!!!!
c
c       remember plane yz at X
        aky=-py/2.0d0
        do 351 ny=1,nymax
        aky=aky+py
        akz=-pz/2.0d0
        do 351 nz=1,nzmax
        akz=akz+pz
        call vz(sum,0.0d0,y6)
        if(.not.lklim.or.dsqrt(akx**4+aky**4+akz**4).le.rklim)
     1  call addkpi(akx**2,aky**2,akz**2,
     2  sum,ndo,e,nmo,nao,ioe,aex,c,bij,be,nsa,nsb)
        do 351 iu=1,y6
351     planex(iu,ny,nz)=sum(iu)*akx*aky*akz

        if(lkprn.and.nx.eq.1)then
         aky=-py/2.0d0
         do ny=1,nymax
          aky=aky+py
          akz=-pz/2.0d0
          do nz=1,nzmax
           akz=akz+pz
           write(9,9009)aky**2,akz**2,planex(1,ny,nz)
 9009      format(3f15.9)
          enddo
         enddo
        endif
c
c       integrate plane X-1
        if(nx.gt.1)then
         do 352 ny=1,nymax
         do 352 nz=1,nzmax
         do 352 iu=1,y6
         f0=planexm(iu,ny,nz)
         if(nx.gt.2)then
          axx=planexmm(iu,ny,nz)+planex(iu,ny,nz)-2.0d0*f0
         else
          axx=0.0d0
         endif
         if(ny.gt.1.and.ny.lt.nymax)then
          ayy=planexm(iu,ny-1,nz)+planexm(iu,ny+1,nz)-2.0d0*f0
         else
          ayy=0.0d0
         endif
         if(nz.gt.1.and.nz.lt.nzmax)then
          azz=planexm(iu,ny,nz-1)+planexm(iu,ny,nz+1)-2.0d0*f0
         else
          azz=0.0d0
         endif
352      de(iu)=de(iu)+f0+(axx+ayy+azz)/24.0d0
        endif
c
c       shift planes in X-direction back
        do 35 ny=1,nymax
        do 35 nz=1,nzmax
        do 35 iu=1,y6
        planexmm(iu,ny,nz)=planexm(iu,ny,nz)
35      planexm(iu,ny,nz)=planex(iu,ny,nz)
c
c       integrate plane Xmax
        do 354 ny=1,nymax
        do 354 nz=1,nzmax
        do 354 iu=1,y6
        f0=planexm(iu,ny,nz)
        axx=0.0d0
        if(ny.gt.1.and.ny.lt.nymax)then
         ayy=planexm(iu,ny-1,nz)+planexm(iu,ny+1,nz)-2.0d0*f0
        else
         ayy=0.0d0
        endif
        if(nz.gt.1.and.nz.lt.nzmax)then
         azz=planexm(iu,ny,nz-1)+planexm(iu,ny,nz+1)-2.0d0*f0
        else
         azz=0.0d0
        endif
354     de(iu)=de(iu)+f0+(axx+ayy+azz)/24.0d0
        

        call vm(de,8.0d0*px*py*pz/pi**3,y6)
        if(lkorb)call vm(deorb,8.0d0*px*py*pz/pi**3,ndo)
       endif
c      4444444444444444444444444444444444444444444444444444444444444
c      555555555555555555555555555555555555555555555555555555555555
       if(idk.eq.5)then
        call w36('constant spacing with smoothing')
        if(lklim)then
         write(6,6098)rklim
         write(3,6098)rklim
        endif
        px=kxmax/dble(nxmax)
        py=kymax/dble(nymax)
        pz=kzmax/dble(nzmax)
        if(nmax0.lt.nymax)call report('nymax overflow')
        if(nmax0.lt.nzmax)call report('nzmax overflow')
c
c       initialize plane to avoid compiler warnings
        do 3523 ny=1,nymax
        do 3523 nz=1,nzmax
        do 3523 iu=1,y6
        planexm(iu,ny,nz)=0.0d0
3523    planexmm(iu,ny,nz)=0.0d0

        akx=-px/2.0d0
        do 353 nx=1,nxmax
        akx=akx+px
        open(88,file='progress')
        write(88,*)nx
        close(88)
        write(6,886)nx,akx
c
c       remember plane yz at X
        aky=-py/2.0d0
        do 3513 ny=1,nymax
        aky=aky+py
        akz=-pz/2.0d0
        do 3513 nz=1,nzmax
        akz=akz+pz
        call vz(sum,0.0d0,y6)
        if(.not.lklim.or.dsqrt(akx**2+aky**2+akz**2).le.rklim)
     1  call addkpi(akx,aky,akz,
     2  sum,ndo,e,nmo,nao,ioe,aex,c,bij,be,nsa,nsb)
        do 3513 iu=1,y6
3513    planex(iu,ny,nz)=sum(iu)
c
c       integrate plane X-1
        if(nx.gt.1)then
         do 3524 ny=1,nymax
         do 3524 nz=1,nzmax
         do 3524 iu=1,y6
         f0=planexm(iu,ny,nz)
         if(nx.gt.2)then
          axx=planexmm(iu,ny,nz)+planex(iu,ny,nz)-2.0d0*f0
         else
          axx=0.0d0
         endif
         if(ny.gt.1.and.ny.lt.nymax)then
          ayy=planexm(iu,ny-1,nz)+planexm(iu,ny+1,nz)-2.0d0*f0
         else
          ayy=0.0d0
         endif
         if(nz.gt.1.and.nz.lt.nzmax)then
          azz=planexm(iu,ny,nz-1)+planexm(iu,ny,nz+1)-2.0d0*f0
         else
          azz=0.0d0
         endif
3524     de(iu)=de(iu)+f0+(axx+ayy+azz)/24.0d0
        endif
c
c       shift planes in X-direction back
        do 353 ny=1,nymax
        do 353 nz=1,nzmax
        do 353 iu=1,y6
        planexmm(iu,ny,nz)=planexm(iu,ny,nz)
353     planexm(iu,ny,nz)=planex(iu,ny,nz)
c
c       integrate last plane (Xmax)
        do 3543 ny=1,nymax
        do 3543 nz=1,nzmax
        do 3543 iu=1,y6
        f0=planexm(iu,ny,nz)
        axx=0.0d0
        if(ny.gt.1.and.ny.lt.nymax)then
         ayy=planexm(iu,ny-1,nz)+planexm(iu,ny+1,nz)-2.0d0*f0
        else
         ayy=0.0d0
        endif
        if(nz.gt.1.and.nz.lt.nzmax)then
         azz=planexm(iu,ny,nz-1)+planexm(iu,ny,nz+1)-2.0d0*f0
        else
         azz=0.0d0
        endif
3543    de(iu)=de(iu)+f0+(axx+ayy+azz)/24.0d0
        call vm(de,px*py*pz/pi**3,y6)
        if(lkorb)call vm(deorb,px*py*pz/pi**3,ndo)
       endif
c      555555555555555555555555555555555555555555555555555555555555
c      666666666666666666666666666666666666666666666666666666666666
       if(idk.eq.6)then
        open(77,file='akr.prn')
        call w36('Spherical grid')
        if(lklim)then
         write(6,6098)rklim
         write(3,6098)rklim
        else
         call report('klimit is not defined')
        endif
        call ll(ilebed,nleb,1)
        if(pr.eq.0.0d0)call report('pr=0!')
        nxmax=int(rklim/pr)
        write(6,900)nxmax,nleb,nleb*nxmax
        write(3,900)nxmax,nleb,nleb*nxmax
900     format(i4,' x ',i4,' = ',i10,' grid points')
        akr=-pr/2.0d0
        sumv=0.0d0
        do 35361 nx=1,nxmax
        akr=akr+pr
        open(88,file='progress')
        write(88,*)nx
        close(88)
        write(6,*)nx,akr
        rkm=akr-pr/2.0d0
        rkp=akr+pr/2.0d0
        dv=(1.0d0/8.0d0)*(4.0d0/3.0d0)*pi*(rkp**3-rkm**3)
        srr1=0.0d0
        srr2=0.0d0
        do 3536 ny=1,nleb
        akx=akr*X(ny)
        aky=akr*Y(ny)
        akz=akr*Z(ny)
        call vz(sum,0.0d0,y6)
        call addkpi(akx,aky,akz,
     1  sum,ndo,e,nmo,nao,ioe,aex,c,bij,be,nsa,nsb)
        sumv=sumv+W(ny)*dv
        srr1=srr1+sum(1)*dv*W(ny)
        srr2=srr2+sum(4)*dv*W(ny)
        do 3536 iu=1,y6
3536    de(iu)=de(iu)+sum(iu)*dv*W(ny)
35361   write(77,770)akr,srr1,srr2
770     format(3f20.10)
        call vm(de,1.0d0/pi**3,y6)
        write(6,*)sumv
        write(6,*)0.125d0*4.0d0/3.0d0*pi*rkp**3
        close(77)
       endif
c      666666666666666666666666666666666666666666666666666666666666
c      777777777777777777777777777777777777777777777777777777777777
       if(idk.eq.7)then
        open(77,file='akr.prn')
        call w36('Spherical grid, r**2')
        if(lklim)then
         write(6,6098)rklim
         write(3,6098)rklim
        else
         call report('klimit is not defined')
        endif
        call ll(ilebed,nleb,1)
        if(pr.eq.0.0d0)call report('pr=0!')
        nxmax=int(rklim/pr)
        write(6,900)nxmax,nleb,nleb*nxmax
        write(3,900)nxmax,nleb,nleb*nxmax
c
c       t^2=k
c
        tmax=dsqrt(rklim)
        prt=tmax/dble(nxmax)
        tau=-prt/2.0d0
        sumv=0.0d0
        do 35367 nx=1,nxmax
        tau=tau+prt
        akr=tau**2
        open(88,file='progress')
        write(88,*)nx
        write(6,*)nx,akr
        close(88)
        rkm=(tau-prt/2.0d0)**2
        rkp=(tau+prt/2.0d0)**2
        dv=(1.0d0/8.0d0)*(4.0d0/3.0d0)*pi*(rkp**3-rkm**3)
        srr1=0.0d0
        srr2=0.0d0
        do 35362 ny=1,nleb
        akx=akr*X(ny)
        aky=akr*Y(ny)
        akz=akr*Z(ny)
        call vz(sum,0.0d0,y6)
        call addkpi(akx,aky,akz,
     1  sum,ndo,e,nmo,nao,ioe,aex,c,bij,be,nsa,nsb)
        sumv=sumv+W(ny)*dv
        srr1=srr1+sum(1)*dv*W(ny)
        srr2=srr2+sum(4)*dv*W(ny)
        do 35362 iu=1,y6
35362   de(iu)=de(iu)+sum(iu)*dv*W(ny)
35367   write(77,770)akr,srr1,srr2
        call vm(de,1.0d0/pi**3,y6)
        write(6,*)sumv
        write(6,*)0.125d0*4.0d0/3.0d0*pi*rkp**3
        close(77)
       endif
c      777777777777777777777777777777777777777777777777777777777777
      endif


      if(lkprn)close(9)

c     should be multiplied by 8 bacause of the K-wavefunction  norm
c     but we took it 8-times (ccc+ssc+scs etc) in order to eliminate
c     the origin dependence

      de(5)=de(1)+de(3)
c
      do iu=1,y6
       deau(iu)=de(iu)*ceau
      enddo

      if(lkorb)then
       open(55,file='DEORB.PRN')
       do i=1,ndo
        write(55,5555)i,deorb(i)*ceau
5555    format(i4,f15.7)
       enddo
       do i=1,nsa
        write(55,5555)i,deorb(i)*ceau
       enddo
       do i=1,nsb
         write(55,5555)i,deorb(i)*ceau
       enddo
       close(55)
      endif

c     kcal/mol:
      do iu=1,y6
       dekcal(iu)=deau(iu)*627.5d0
      enddo

      write(6,6304)T
      write(3,6304)T
6304  format(' T = ',f10.2,' K')
      write(6,6303)
6303  format(
     1'  para        exper       temp        depen       para+temp')
      write(6,6002)(dekcal(iu),iu=1,5),(deau(iu),iu=1,5)
      write(3,6002)(dekcal(iu),iu=1,5),(deau(iu),iu=1,5)
6002  format(f12.7,' ',4f12.7,' kcal/mol',/,
     1       f12.7,' ',4f12.7,' hartree')
c
      write(6,*)' Leaving dqmpol3k ...'
      return
      end
c     ==========================================================
      subroutine addkpi(kx,ky,kz,de,ndo,e,nmo,nao,ioe,aex,c,
     1bij,be,nsa,nsb)
c     addk optimized for integral
      implicit none
      integer*4 nort,y6,iu
      parameter (nort=700,y6=6)
      real*8 kx,ky,kz,de(y6),e(*),be(*),
     1aex,sk,hck,pi,clau,spt,bohr,debye,bij(nort,nort),
     2c(nort,nort),sum(y6),k0x,k0y,k0z
      integer*4 ndo,nmo,nao,ioe,nsa,nsb
      common/const/pi,clau,spt,bohr,debye
      logical lopt,lcazfac
      integer icha,n1
      common/opts/lopt(300),icha,n1
      equivalence (lopt(90),lcazfac)
c
c     calculate <aAO|cos(kx x)sin(ky(y-yo)sin(kz z) grad_x|bAO>
c               <aAO|cos(kx x)cos(ky(y-yo)cos(kz z) grad_x|bAO>
c               <aAO|sin(kx x)cos(ky(y-yo)sin(kz z) grad_y|bAO>
c               <aAO|sin(kx x)sin(ky(y-yo)cos(kz z) grad_z|bAO> atd. elements
c
      if(lcazfac)then
c      call overfac(nx,ny,nz,nao)
       call report('lcazfac not implemented')
      else
       call overlap6kpi(kx,ky,kz)
      endif

c     transform closed shell or alpha orbitals
      call elementsi(nmo,nao,c)

      sk=dsqrt(kx**2+ky**2+kz**2)
      hck=clau*sk
      k0x=kx/sk
      k0y=ky/sk
      k0z=kz/sk

c     sum over double occupied orbitals
      call adds(aex,hck,sum,ndo,nmo,e,ioe,k0x,k0y,k0z)
c
c     factor of 2 for singlet closed shell transition is included in
c     dqmpol3k final energy expression
      do 1 iu=1,y6
1     de(iu)=de(iu)+sum(iu)

c     sum over singly occupied orbitals
c     alpha
      call adds(aex,hck,sum,nsa,nmo,e,ioe,k0x,k0y,k0z)
c
c     factor of 2 for singlet closed shell transition is included in
c     dqmpol3k final energy expression, so half must be taken for
c     single transitions
      do 2 iu=1,y6
2     de(iu)=de(iu)+sum(iu)/2.0d0

c     beta
      if(nsb.gt.0)call elementsi(nmo,nao,bij)
      call adds(aex,hck,sum,nsb,nmo,be,ioe,k0x,k0y,k0z)
c
c     factor of 2 for singlet closed shell transition is included in
c     dqmpol3k final energy expression, so half must be taken for
c     single transitions
      do 3 iu=1,y6
3     de(iu)=de(iu)+sum(iu)/2.0d0

      return
      end
c     ============================================================
      subroutine overlap6kpi(akx,aky,akz)
c
c     <a(AO)| X |b(ao)>
c     X= cccx,ccsx,cscx,sccx,sssx,sscx,scsx,cssx,
c        cccy,ccsy,cscy,sccy,sssy,sscy,scsy,cssy,
c        cccz,ccsz,cscz,sccz,sssz,sscz,scsz,cssz
c
c        cccx=cos(kx.x)cos(ky.y)cos(kz.z) grad x
c        cscz=cos(kx.x)sin(ky.y)cos(kz.z) grad z atd
c
c     Note, that this is not a symmetric matrix with
c     respect to orbital exchange !!
c
c     the "true" d-orbitals are included here
      implicit none
      character*2 at
      character*1 ok,ty
      integer*4 nat0,nor,nort
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      real*8 X24,akx,aky,akz,kk,q,zsum,xv,
     1escf,cc,alpha,rcp,cij,bij,e,be,pi,clau,spt,
     2bohr,debye,z0,one,two,three,four,five,six,half,qua,a8,a10,
     3cci(u0),ccj(u0),aai(u0,u0),aaj(u0,u0),
     3b6x1(u0,u0),b6x2(u0,u0),b6x3(u0,u0),b6x4(u0,u0),
     3b6x5(u0,u0),b6x6(u0,u0),b6x7(u0,u0),b6x8(u0,u0),
     3b6y1(u0,u0),b6y2(u0,u0),b6y3(u0,u0),b6y4(u0,u0),
     3b6y5(u0,u0),b6y6(u0,u0),b6y7(u0,u0),b6y8(u0,u0),
     3b6z1(u0,u0),b6z2(u0,u0),b6z3(u0,u0),b6z4(u0,u0),
     3b6z5(u0,u0),b6z6(u0,u0),b6z7(u0,u0),b6z8(u0,u0),
     2svx1(u0,nort),svy1(u0,nort),svz1(u0,nort),
     2svx2(u0,nort),svy2(u0,nort),svz2(u0,nort),
     2svx3(u0,nort),svy3(u0,nort),svz3(u0,nort),
     2svx4(u0,nort),svy4(u0,nort),svz4(u0,nort),
     2svx5(u0,nort),svy5(u0,nort),svz5(u0,nort),
     2svx6(u0,nort),svy6(u0,nort),svz6(u0,nort),
     2svx7(u0,nort),svy7(u0,nort),svz7(u0,nort),
     2svx8(u0,nort),svy8(u0,nort),svz8(u0,nort),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),tol,spi,xi,yi,zi,ai,xj,yj,zj,
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5xij,yij,zij,x2ij,y2ij,z2ij,r2ij,aj,aij,tt,t,ec,ef,con,coe,
     6cx0,cy0,cz0,cx1,cy1,cz1,aiii,ajjj,rkx,fkx,skx,ckx,sky,cky,
     7skz,ckz,rky,rkz,fky,fkz,Px,Py,Pz,anjx,anjy,anjz,sx1,
     8sy1,sz1,sx0,sy0,sz0,told,cxm,cym,czm,sxm,sym,szm,
     9cxp,cyp,czp,sxp,syp,szp,twoaj
      common/xkykzko/X24(24,nort*nort)
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,
     1noa,nori,nop,ish,nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),
     2io,ia,i,j,jo,ja,ioj,ioo,joo,ip,jp,ii,jj,icha,n1,iorb,ipp,jpp,
     3npi,npii,npj,npjj,njx,njy,njz,nix,niy,niz,iorbnao,j3
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/aa100/aa1,aad,aaf,aag,aah,aaii
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,noe,ichm,mtp,ndo,
     4nsa,nsb,noa,nori,nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4),ld5),(lopt(8),lf7)
c
c     call inipoly
c     call initfd(aa1,aad,aaf)
c                  - initialized already at the beginning of dqmpol3k
c
      tol=13.0d0
      told=1.0d-10
      kk=akx*akx+aky*aky+akz*akz
      spi=sqrt(pi*pi*pi)

      do 10 i=1,nao
      do 10 j=1,u0
      svx1(j,i)=z0
      svy1(j,i)=z0
      svz1(j,i)=z0
      svx2(j,i)=z0
      svy2(j,i)=z0
      svz2(j,i)=z0
      svx3(j,i)=z0
      svy3(j,i)=z0
      svz3(j,i)=z0
      svx4(j,i)=z0
      svy4(j,i)=z0
      svz4(j,i)=z0
      svx5(j,i)=z0
      svy5(j,i)=z0
      svz5(j,i)=z0
      svx6(j,i)=z0
      svy6(j,i)=z0
      svz6(j,i)=z0
      svx7(j,i)=z0
      svy7(j,i)=z0
      svz7(j,i)=z0
      svx8(j,i)=z0
      svy8(j,i)=z0
10    svz8(j,i)=z0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      twoaj=aj+aj
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=(ai*aj*r2ij+kk/4.0d0)*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)*t*t*t
      else
       goto 777
      endif
      Px=(ai*xi+aj*xj)*tt
      Py=(ai*yi+aj*yj)*tt
      Pz=(ai*zi+aj*zj)*tt
      skx=sin(Px*akx)
      ckx=cos(Px*akx)
      sky=sin(Py*aky)
      cky=cos(Py*aky)
      skz=sin(Pz*akz)
      ckz=cos(Pz*akz)
      rkx=dsqrt(Px**2+(akx*tt/two)**2)
      rky=dsqrt(Py**2+(aky*tt/two)**2)
      rkz=dsqrt(Pz**2+(akz*tt/two)**2)
      if(rkx.gt.told)then
       fkx=asin(akx*tt/two/rkx)
       if(Px.lt.0.0d0)fkx=pi-fkx
      else
       fkx=0.0d0
      endif
      if(rky.gt.told)then
       fky=asin(aky*tt/two/rky)
       if(Py.lt.0.0d0)fky=pi-fky
      else
       fky=0.0d0
      endif
      if(rkz.gt.told)then
       fkz=asin(akz*tt/two/rkz)
       if(Pz.lt.0.0d0)fkz=pi-fkz
      else
       fkz=0.0d0
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      anjx=dble(njx)
      anjy=dble(njy)
      anjz=dble(njz)
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)
c
c     <pj | cos/sin(k*(r-o))      | pi> for x,y,z:
      call oikc(nix,njx,skx,ckx,rkx,fkx,t,xi,xj,cx0,sx0)
      call oikc(niy,njy,sky,cky,rky,fky,t,yi,yj,cy0,sy0)
      call oikc(niz,njz,skz,ckz,rkz,fkz,t,zi,zj,cz0,sz0)
c     <pj | cos/sin(k*(r-o)) grad | pi> for x,y,z:
c     grad (x-xj)^nj e(-aj(x-xj)^2) =nj(x-xj)^(nj-1)e(-aj(x-xj)^2)
c                                    -2aj(x-xj)^(nj+1)e(-aj(x-xj)^2) =
      call oikc(nix,njx+1,skx,ckx,rkx,fkx,t,xi,xj,cxp,sxp)
      call oikc(niy,njy+1,sky,cky,rky,fky,t,yi,yj,cyp,syp)
      call oikc(niz,njz+1,skz,ckz,rkz,fkz,t,zi,zj,czp,szp)
      cx1=-twoaj*cxp
      sx1=-twoaj*sxp
      cy1=-twoaj*cyp
      sy1=-twoaj*syp
      cz1=-twoaj*czp
      sz1=-twoaj*szp
      if(njx.gt.0)then
       call oikc(nix,njx-1,skx,ckx,rkx,fkx,t,xi,xj,cxm,sxm)
       cx1=anjx*cxm+cx1
       sx1=anjx*sxm+sx1
      endif
      if(njy.gt.0)then
       call oikc(niy,njy-1,sky,cky,rky,fky,t,yi,yj,cym,sym)
       cy1=anjy*cym+cy1
       sy1=anjy*sym+sy1
      endif
      if(njz.gt.0)then
       call oikc(niz,njz-1,skz,ckz,rkz,fkz,t,zi,zj,czm,szm)
       cz1=anjz*czm+cz1
       sz1=anjz*szm+sz1
      endif
      sx1=sx1*coe
      sy1=sy1*coe
      sz1=sz1*coe
      cx1=cx1*coe
      cy1=cy1*coe
      cz1=cz1*coe
c
c     Order of elements:
c     cccx->cssx->scsx->sscx->sssx->sccx->cscx->ccsx->
c     cccy->cssy->scsy->sscy->sssy->sccy->cscy->ccsy->
c     cccz->cssz->scsz->sscz->sssz->sccz->cscz->ccsz
c
      b6x1(ioo,joo)=cx1*cy0*cz0
      b6x2(ioo,joo)=cx1*sy0*sz0
      b6x3(ioo,joo)=sx1*cy0*sz0
      b6x4(ioo,joo)=sx1*sy0*cz0
      b6x5(ioo,joo)=sx1*sy0*sz0
      b6x6(ioo,joo)=sx1*cy0*cz0
      b6x7(ioo,joo)=cx1*sy0*cz0
      b6x8(ioo,joo)=cx1*cy0*sz0
      b6y1(ioo,joo)=cx0*cy1*cz0
      b6y2(ioo,joo)=cx0*sy1*sz0
      b6y3(ioo,joo)=sx0*cy1*sz0
      b6y4(ioo,joo)=sx0*sy1*cz0
      b6y5(ioo,joo)=sx0*sy1*sz0
      b6y6(ioo,joo)=sx0*cy1*cz0
      b6y7(ioo,joo)=cx0*sy1*cz0
      b6y8(ioo,joo)=cx0*cy1*sz0
      b6z1(ioo,joo)=cx0*cy0*cz1
      b6z2(ioo,joo)=cx0*sy0*sz1
      b6z3(ioo,joo)=sx0*cy0*sz1
      b6z4(ioo,joo)=sx0*sy0*cz1
      b6z5(ioo,joo)=sx0*sy0*sz1
      b6z6(ioo,joo)=sx0*cy0*cz1
      b6z7(ioo,joo)=cx0*sy0*cz1
71    b6z8(ioo,joo)=cx0*cy0*sz1
c
c     transform primitives into atomic arbitals
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       svx1(ioo,ioj)=svx1(ioo,ioj)+ajjj*b6x1(ipp,jpp)
       svx2(ioo,ioj)=svx2(ioo,ioj)+ajjj*b6x2(ipp,jpp)
       svx3(ioo,ioj)=svx3(ioo,ioj)+ajjj*b6x3(ipp,jpp)
       svx4(ioo,ioj)=svx4(ioo,ioj)+ajjj*b6x4(ipp,jpp)
       svx5(ioo,ioj)=svx5(ioo,ioj)+ajjj*b6x5(ipp,jpp)
       svx6(ioo,ioj)=svx6(ioo,ioj)+ajjj*b6x6(ipp,jpp)
       svx7(ioo,ioj)=svx7(ioo,ioj)+ajjj*b6x7(ipp,jpp)
       svx8(ioo,ioj)=svx8(ioo,ioj)+ajjj*b6x8(ipp,jpp)
       svy1(ioo,ioj)=svy1(ioo,ioj)+ajjj*b6y1(ipp,jpp)
       svy2(ioo,ioj)=svy2(ioo,ioj)+ajjj*b6y2(ipp,jpp)
       svy3(ioo,ioj)=svy3(ioo,ioj)+ajjj*b6y3(ipp,jpp)
       svy4(ioo,ioj)=svy4(ioo,ioj)+ajjj*b6y4(ipp,jpp)
       svy5(ioo,ioj)=svy5(ioo,ioj)+ajjj*b6y5(ipp,jpp)
       svy6(ioo,ioj)=svy6(ioo,ioj)+ajjj*b6y6(ipp,jpp)
       svy7(ioo,ioj)=svy7(ioo,ioj)+ajjj*b6y7(ipp,jpp)
       svy8(ioo,ioj)=svy8(ioo,ioj)+ajjj*b6y8(ipp,jpp)
       svz1(ioo,ioj)=svz1(ioo,ioj)+ajjj*b6z1(ipp,jpp)
       svz2(ioo,ioj)=svz2(ioo,ioj)+ajjj*b6z2(ipp,jpp)
       svz3(ioo,ioj)=svz3(ioo,ioj)+ajjj*b6z3(ipp,jpp)
       svz4(ioo,ioj)=svz4(ioo,ioj)+ajjj*b6z4(ipp,jpp)
       svz5(ioo,ioj)=svz5(ioo,ioj)+ajjj*b6z5(ipp,jpp)
       svz6(ioo,ioj)=svz6(ioo,ioj)+ajjj*b6z6(ipp,jpp)
       svz7(ioo,ioj)=svz7(ioo,ioj)+ajjj*b6z7(ipp,jpp)
74     svz8(ioo,ioj)=svz8(ioo,ioj)+ajjj*b6z8(ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       svx1(ioo,ioj)=svx1(ioo,ioj)+b6x1(ioo,joo)
       svx2(ioo,ioj)=svx2(ioo,ioj)+b6x2(ioo,joo)
       svx3(ioo,ioj)=svx3(ioo,ioj)+b6x3(ioo,joo)
       svx4(ioo,ioj)=svx4(ioo,ioj)+b6x4(ioo,joo)
       svx5(ioo,ioj)=svx5(ioo,ioj)+b6x5(ioo,joo)
       svx6(ioo,ioj)=svx6(ioo,ioj)+b6x6(ioo,joo)
       svx7(ioo,ioj)=svx7(ioo,ioj)+b6x7(ioo,joo)
       svx8(ioo,ioj)=svx8(ioo,ioj)+b6x8(ioo,joo)
       svy1(ioo,ioj)=svy1(ioo,ioj)+b6y1(ioo,joo)
       svy2(ioo,ioj)=svy2(ioo,ioj)+b6y2(ioo,joo)
       svy3(ioo,ioj)=svy3(ioo,ioj)+b6y3(ioo,joo)
       svy4(ioo,ioj)=svy4(ioo,ioj)+b6y4(ioo,joo)
       svy5(ioo,ioj)=svy5(ioo,ioj)+b6y5(ioo,joo)
       svy6(ioo,ioj)=svy6(ioo,ioj)+b6y6(ioo,joo)
       svy7(ioo,ioj)=svy7(ioo,ioj)+b6y7(ioo,joo)
       svy8(ioo,ioj)=svy8(ioo,ioj)+b6y8(ioo,joo)
       svz1(ioo,ioj)=svz1(ioo,ioj)+b6z1(ioo,joo)
       svz2(ioo,ioj)=svz2(ioo,ioj)+b6z2(ioo,joo)
       svz3(ioo,ioj)=svz3(ioo,ioj)+b6z3(ioo,joo)
       svz4(ioo,ioj)=svz4(ioo,ioj)+b6z4(ioo,joo)
       svz5(ioo,ioj)=svz5(ioo,ioj)+b6z5(ioo,joo)
       svz6(ioo,ioj)=svz6(ioo,ioj)+b6z6(ioo,joo)
       svz7(ioo,ioj)=svz7(ioo,ioj)+b6z7(ioo,joo)
7      svz8(ioo,ioj)=svz8(ioo,ioj)+b6z8(ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
       iorbnao=(iorb-1)*nao
       do 33 jj=1,nao
       j3=iorbnao+jj
       X24( 1,j3)=svx1(ii,jj)
       X24( 2,j3)=svx2(ii,jj)
       X24( 3,j3)=svx3(ii,jj)
       X24( 4,j3)=svx4(ii,jj)
       X24( 5,j3)=svx5(ii,jj)
       X24( 6,j3)=svx6(ii,jj)
       X24( 7,j3)=svx7(ii,jj)
       X24( 8,j3)=svx8(ii,jj)
       X24( 9,j3)=svy1(ii,jj)
       X24(10,j3)=svy2(ii,jj)
       X24(11,j3)=svy3(ii,jj)
       X24(12,j3)=svy4(ii,jj)
       X24(13,j3)=svy5(ii,jj)
       X24(14,j3)=svy6(ii,jj)
       X24(15,j3)=svy7(ii,jj)
       X24(16,j3)=svy8(ii,jj)
       X24(17,j3)=svz1(ii,jj)
       X24(18,j3)=svz2(ii,jj)
       X24(19,j3)=svz3(ii,jj)
       X24(20,j3)=svz4(ii,jj)
       X24(21,j3)=svz5(ii,jj)
       X24(22,j3)=svz6(ii,jj)
       X24(23,j3)=svz7(ii,jj)
33     X24(24,j3)=svz8(ii,jj)

       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       svx1(ii,jj)=z0
       svx2(ii,jj)=z0
       svx3(ii,jj)=z0
       svx4(ii,jj)=z0
       svx5(ii,jj)=z0
       svx6(ii,jj)=z0
       svx7(ii,jj)=z0
       svx8(ii,jj)=z0
       svy1(ii,jj)=z0
       svy2(ii,jj)=z0
       svy3(ii,jj)=z0
       svy4(ii,jj)=z0
       svy5(ii,jj)=z0
       svy6(ii,jj)=z0
       svy7(ii,jj)=z0
       svy8(ii,jj)=z0
       svz1(ii,jj)=z0
       svz2(ii,jj)=z0
       svz3(ii,jj)=z0
       svz4(ii,jj)=z0
       svz5(ii,jj)=z0
       svz6(ii,jj)=z0
       svz7(ii,jj)=z0
9      svz8(ii,jj)=z0
c
      endif
3     continue
2     continue

      return
      end
c     ==========================================================
      subroutine oikc(ni,nj,sk,ck,R ,fi,t,xi,xj,oikr,oiki)
c
c     calculates real and imaginary parts of the integral
c
c       infinity
c          /
c         |     i*k*x      ni      nj -ai*(x-xi)^2 -aj*(x-xj)^2
c      i= |    e     (x-xi)  (x-xj)  e            e            dx
c         |
c        /
c     -infinity
c
c
c   i = oik *exp(-ai*aj*xij**2/(ai+aj)-k**2/4/(ai+aj))*sqrt(pi/(ai+aj))
c    prefactors added in overlap6k
c
c    xij=(xj-xi); ai>0; aj>0
c
c    t=1/sqrt(ai+aj)
c
      implicit none
      real*8 t,xi,xj,oikr,oiki,z0,one,two,three,ei,
     1four,five,six,half,qua,a8,a10,pp,R,
     2fi,sumi,sumr,pii,pj,pm,zr,zfi,ck,sk
      integer*4 ni,nj,nd,l,ll,k,n
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      parameter (nd=24)
      common/poly/pp(nd,nd)
      real*8 eis(nd),zrs(nd),zis(nd),ts(nd),xjs(nd)
c
c     prepare some strings for faster computation
      do 5 k=0,nj
5     xjs(k+1)=pp(nj+1,k+1)*(-xj)**(nj-k)
      zfi=-fi
      do 1 l=0,ni+nj
      zfi=zfi+fi
      zR=R**l
      ts(l+1)=t**l
      zrs(l+1)=zR*cos(zfi)
      zis(l+1)=zR*sin(zfi)
1     eis(l+1)=ei(l)
c
      sumi=z0
      sumr=z0
      do 2 l=0,ni
      pii=pp(ni+1,l+1)
      do 3 ll=1,ni-l
3     pii=-pii*xi
      do 2 k=0,nj
      pj=pii*xjs(k+1)
      do 2 n=0,l+k
      pm=pj*pp(l+k+1,n+1)*ts(n+1)
      sumi=sumi+pm*zis(l+k-n+1)*eis(n+1)
2     sumr=sumr+pm*zrs(l+k-n+1)*eis(n+1)
      oikr=(ck*sumr-sk*sumi)
      oiki=(sk*sumr+ck*sumi)
      return
      end
c
c       infinity
c          /              2
c         |          N  -y
c      I= |         y  e     dy
c         |
c        /
c     -infinity
c
c       I=sqrt(pi)*ei(N)
c
c       sqrt(pi) added in overlap6k
c     ==========================================================
      subroutine adds(aex,hck,sum,ndo,nmo,e,ioe,k0x,k0y,k0z)
      implicit none
      integer*4 y6,nklim,iopt,lastmo
      parameter (y6=6)
      real*8 sum(y6),e(*),k0x,k0y,k0z,ek,eklim,ropt,elim,
     1ejk,kT,aj,ak,hck,aex,hck2,T,de1,deorb,kx2n,ky2n,kz2n,
     1cccx,cssx,scsx,sscx,sssx,sccx,cscx,ccsx,
     2cccy,cssy,scsy,sscy,sssy,sccy,cscy,ccsy,
     3cccz,cssz,scsz,sscz,sssz,sccz,cscz,ccsz,tf,br,deklim
      integer*4 nmok,j,nj,ndo,nmo,ioe,kmin,kmax,jmin,jmax,nort,k
      parameter (nort=700)
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      logical ltt
      common/kelvin/T,ltt
      common/dedel/deorb(nort)
      common/ymo/
     1cccx(nort*nort),cssx(nort*nort),scsx(nort*nort),sscx(nort*nort),
     1sssx(nort*nort),sccx(nort*nort),cscx(nort*nort),ccsx(nort*nort),
     2cccy(nort*nort),cssy(nort*nort),scsy(nort*nort),sscy(nort*nort),
     3sssy(nort*nort),sccy(nort*nort),cscy(nort*nort),ccsy(nort*nort),
     4cccz(nort*nort),cssz(nort*nort),scsz(nort*nort),sscz(nort*nort),
     5sssz(nort*nort),sccz(nort*nort),cscz(nort*nort),ccsz(nort*nort)
      common/ropts/ropt(300)
      equivalence (ropt(19),eklim),(ropt(21),deklim)
      common/iopts/iopt(300)
      equivalence (iopt(29),nklim)
      logical lopt,ldamp
      integer icha,n1
      common/opts/lopt(300),icha,n1
      equivalence (lopt(96),ldamp)
c
c     Boltzmann quantum in atomic units
      kT=T*3.166775d-6
      call vz(sum,0.0d0,y6)
      hck2=hck*hck
      kx2n=1.0d0-k0x**2
      ky2n=1.0d0-k0y**2
      kz2n=1.0d0-k0z**2
      tf=exp(hck/kT)-1.0d0
      lastmo=nmo
      if(nklim.gt.0)lastmo=nklim
      elim=1.0d30
      if(eklim.gt.0.0d0.and..not.ldamp)elim=eklim
      if(ldamp.and.(eklim.eq.0.or.deklim.eq.0))call report(
     1'Damping variables are not defined.')

      do 6 k=1,ndo
      ek=e(k)
      nmok=nmo*(k-1)
      de1=sum(1)
      do 61 j=ndo+1,lastmo
      nj=nmok+j
      if(e(j).lt.elim)then
       ejk=e(j)-ek
       if(ioe.eq.2)ejk=ejk-aj(k,j)+2.0d0*ak(k,j)*aex
       br=
     1 (kx2n*(cccx(nj)**2+ccsx(nj)**2+cscx(nj)**2+sccx(nj)**2
     2       +sssx(nj)**2+sscx(nj)**2+scsx(nj)**2+cssx(nj)**2)
     1 +ky2n*(cccy(nj)**2+ccsy(nj)**2+cscy(nj)**2+sccy(nj)**2
     2       +sssy(nj)**2+sscy(nj)**2+scsy(nj)**2+cssy(nj)**2)
     1 +kz2n*(cccz(nj)**2+ccsz(nj)**2+cscz(nj)**2+sccz(nj)**2
     2       +sssz(nj)**2+sscz(nj)**2+scsz(nj)**2+cssz(nj)**2)
     1 -2.0d0*k0x*k0y*
     2 (cssx(nj)*scsy(nj)+cscx(nj)*sccy(nj)
     3 -ccsx(nj)*sssy(nj)-cccx(nj)*sscy(nj)
     2 -sssx(nj)*ccsy(nj)-sscx(nj)*cccy(nj)
     4 +scsx(nj)*cssy(nj)+sccx(nj)*cscy(nj))
     1 -2.0d0*k0x*k0z*
     2 (cssx(nj)*sscz(nj)-cscx(nj)*sssz(nj)
     3 +ccsx(nj)*sccz(nj)-cccx(nj)*scsz(nj)
     2 -sssx(nj)*cscz(nj)+sscx(nj)*cssz(nj)
     4 -scsx(nj)*cccz(nj)+sccx(nj)*ccsz(nj))
     1 -2.0d0*k0y*k0z*
     2 (scsy(nj)*sscz(nj)-sccy(nj)*sssz(nj)
     3 -sssy(nj)*sccz(nj)+sscy(nj)*scsz(nj)
     2 +ccsy(nj)*cscz(nj)-cccy(nj)*cssz(nj)
     4 -cssy(nj)*cccz(nj)+cscy(nj)*ccsz(nj)) )
       if(ldamp.and.e(j).gt.eklim)br=br*exp(-((e(j)-eklim)/deklim)**2)
c
c      "paramagnetic" part
       sum(1)=sum(1)-1.0d0/(hck*(hck+ejk))*br
c
c      zero T total - only for backwards compatibility
       sum(2)=sum(2)-1.0d0/(ejk*(hck+ejk))*br
c
c      non-zero temperature contribution
       sum(3)=sum(3)-2.0d0*ejk/(hck*(ejk**2-hck2)*tf)*br
c
c      more molecular-dependent part of paramagnetic
       sum(4)=sum(4)+ejk/(hck2*(ejk+hck))*br
      endif
61    continue
6     deorb(k)=deorb(k)+sum(1)-de1
      return
      end
c     ==========================================================
      subroutine elementsi(nmo,nao,c)
      implicit none
      integer*4 nort
      parameter (nort=700)
      real*8 c(nort,nort),X(nort*nort),X24,
     1cccx,cssx,scsx,sscx,sssx,sccx,cscx,ccsx,
     2cccy,cssy,scsy,sscy,sssy,sccy,cscy,ccsy,
     3cccz,cssz,scsz,sscz,sssz,sccz,cscz,ccsz
      integer*4 nmo,nao,i8,i
      common/xkykzko/X24(24,nort*nort)
      common/ymo/
     1cccx(nort*nort),cssx(nort*nort),scsx(nort*nort),sscx(nort*nort),
     1sssx(nort*nort),sccx(nort*nort),cscx(nort*nort),ccsx(nort*nort),
     2cccy(nort*nort),cssy(nort*nort),scsy(nort*nort),sscy(nort*nort),
     3sssy(nort*nort),sccy(nort*nort),cscy(nort*nort),ccsy(nort*nort),
     4cccz(nort*nort),cssz(nort*nort),scsz(nort*nort),sscz(nort*nort),
     5sssz(nort*nort),sccz(nort*nort),cscz(nort*nort),ccsz(nort*nort)
c
c     transform into MO basis:
c     cccx->cssx->scsx->sscx->sssx->sccx->cscx->ccsx->
c     cccy->cssy->scsy->sscy->sssy->sccy->cscy->ccsy->
c     cccz->cssz->scsz->sscz->sssz->sccz->cscz->ccsz
      do 1 i8=1,24
      do 2 i=1,nmo*nao
2     X(i)=X24(i8,i)
      call trkk(X,nmo,nao,c)
      if(i8.eq. 1)call wrtu(X,cccx,nmo**2)
      if(i8.eq. 2)call wrtu(X,cssx,nmo**2)
      if(i8.eq. 3)call wrtu(X,scsx,nmo**2)
      if(i8.eq. 4)call wrtu(X,sscx,nmo**2)
      if(i8.eq. 5)call wrtu(X,sssx,nmo**2)
      if(i8.eq. 6)call wrtu(X,sccx,nmo**2)
      if(i8.eq. 7)call wrtu(X,cscx,nmo**2)
      if(i8.eq. 8)call wrtu(X,ccsx,nmo**2)
      if(i8.eq. 9)call wrtu(X,cccy,nmo**2)
      if(i8.eq.10)call wrtu(X,cssy,nmo**2)
      if(i8.eq.11)call wrtu(X,scsy,nmo**2)
      if(i8.eq.12)call wrtu(X,sscy,nmo**2)
      if(i8.eq.13)call wrtu(X,sssy,nmo**2)
      if(i8.eq.14)call wrtu(X,sccy,nmo**2)
      if(i8.eq.15)call wrtu(X,cscy,nmo**2)
      if(i8.eq.16)call wrtu(X,ccsy,nmo**2)
      if(i8.eq.17)call wrtu(X,cccz,nmo**2)
      if(i8.eq.18)call wrtu(X,cssz,nmo**2)
      if(i8.eq.19)call wrtu(X,scsz,nmo**2)
      if(i8.eq.20)call wrtu(X,sscz,nmo**2)
      if(i8.eq.21)call wrtu(X,sssz,nmo**2)
      if(i8.eq.22)call wrtu(X,sccz,nmo**2)
      if(i8.eq.23)call wrtu(X,cscz,nmo**2)
1     if(i8.eq.24)call wrtu(X,ccsz,nmo**2)
      return
      end
c     ==========================================================
      subroutine wrtu(x,c,n)
      implicit none
      integer*4 n,i
      real*8 x(*),c(*)
      do 1 i=1,n
1     c(i)=x(i)
      return
      end
c     ==========================================================
      subroutine trkk(X,nmo,nao,c)
c     transformation AO->MO, X may be assymetric
      implicit none
      integer*4 nort
      parameter (nort=700)
      real*8 X(*),sum,c(nort,nort),buff(nort*nort)
      integer*4 nmo,nao,i,j,ii,jnao
c
c     first index ab -> ib
      do 1 j=1,nao
      jnao=(j-1)*nao
      do 1 i=1,nmo
      sum=0.0d0
      do 11 ii=1,nao
11    sum=sum+c(i,ii)*X(ii+jnao)
1     buff(j+(i-1)*nao)=sum
c
c     second index ib -> ij
      do 2 j=1,nmo
      jnao=(j-1)*nao
      do 2 i=1,nmo
      sum=0.0d0
      do 22 ii=1,nao
22    sum=sum+c(i,ii)*buff(ii+jnao)
2     X(j+(i-1)*nmo)=sum

      return
      end

c     ==========================================================
      subroutine addkpo(kx,ky,kz,cox,coy,coz,sox,soy,soz,de,ndo,e,
     1nmo,nao,ioe,aex,c)
      implicit none
      integer*4 nort,y6
      parameter (nort=700,y6=6)
      real*8 kx,ky,kz,cox,coy,coz,Xk1,Yk1,Zk1,de(y6),
     1e(*),ek,ejk,aj,ak,
     1aex,sk,hck,pi,clau,spt,bohr,debye,sox,soy,soz,
     2k0x,k0y,k0z,c(nort,nort),rr,sum
      integer*4 k,ndo,nmo,nao,ioe,j,nmok,kmin,kmax,jmin,jmax,nj
      common/const/pi,clau,spt,bohr,debye
      common/xkykzk1/Xk1(nort*nort),Yk1(nort*nort),Zk1(nort*nort)
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      logical lopt,lpara
      integer*4 icha,n1
      common/opts/lopt(300),icha,n1
      equivalence (lopt(89),lpara)
c
c     calculate the AO cssx scsy and sscz elements
      call elementso(kx,ky,kz,cox,coy,coz,sox,soy,soz,nmo,nao,c)


      sk=dsqrt(kx**2+ky**2+kz**2)
      hck=clau*sk
      k0x=kx/sk
      k0y=ky/sk
      k0z=kz/sk

c     sum over occupied orbitals

      sum=0.0d0
      do 6 k=1,ndo
      ek=e(k)
      nmok=nmo*(k-1)
      do 6 j=ndo+1,nmo
      nj=nmok+j
      ejk=e(j)-ek
      if(ioe.eq.2)ejk=ejk-aj(k,j)+2.0d0*ak(k,j)*aex
      if(lpara)then
       rr=-1.0d0/hck*(hck+ejk)
      else
       rr= 1.0d0/ejk*(hck+ejk)
      endif
c     Yx^2+Yy^2+Yz^2-(1/k^2)(kxYx+kyYy+kzYz)^2
6     sum=sum+( Xk1(nj)**2 +Yk1(nj)**2 +Zk1(nj)**2
     1-        (k0x*Xk1(nj)+k0y*Yk1(nj)+k0z*Zk1(nj))**2)*rr

      de(1)=de(1)+sum
c     factor of sqrt(2) for transitional integrals beteen singlet states is
c     included already in dqmpol3k in final sum

      return
      end
c     ===========================================================
      subroutine elementso(kx,ky,kz,cox,coy,coz,sox,soy,soz,nmo,nao,c)
      implicit none
      integer*4 nort
      parameter (nort=700)
      real*8 Xk1,Yk1,Zk1,cox,coy,coz,sox,soy,soz,kx,ky,kz,
     1c(nort,nort),X(nort*nort)
      integer*4 nmo,nao,i
      common/xkykzk1/Xk1(nort*nort),Yk1(nort*nort),Zk1(nort*nort)
c
c     calculate the AO cssx scsy sscz  elements
      call overlap6kpo(kx,ky,kz,cox,coy,coz,sox,soy,soz)
c
c     transform into MO basis
      do 2 i=1,nmo*nao
2     X(i)=Xk1(i)
      call trkk(X,nmo,nao,c)
      do 3 i=1,nmo*nao
3     Xk1(i)=X(i)
      do 4 i=1,nmo*nao
4     X(i)=Yk1(i)
      call trkk(X,nmo,nao,c)
      do 5 i=1,nmo*nao
5     Yk1(i)=X(i)
      do 6 i=1,nmo*nao
6     X(i)=Zk1(i)
      call trkk(X,nmo,nao,c)
      do 1 i=1,nmo*nao
1     Zk1(i)=X(i)

      return
      end
c     ============================================================
      subroutine overlap6kpo(akx,aky,akz,cox,coy,coz,sox,soy,soz)
c
c     <a(AO)| cos(kx.(x-xo))sin(ky(y-yo))sin(kz(z-zo)) grad x |b(ao)>
c     <a(AO)| sin(kx.(x-xo))cos(ky(y-yo))sin(kz(z-zo)) grad y |b(ao)>
c     <a(AO)| sin(kx.(x-xo))sin(ky(y-yo))cos(kz(z-zo)) grad z |b(ao)>
c
c     the "true" d-orbitals are included here
      implicit none
      character*2 at
      character*1 ok,ty
      integer*4 nat0,nor,nort
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      real*8 Xk1,Yk1,Zk1,akx,aky,akz,cox,coy,coz,
     1sox,soy,soz,kk,q,zsum,xv,
     1escf,cc,alpha,rcp,cij,bij,e,be,pi,clau,spt,
     2bohr,debye,z0,one,two,three,four,five,six,half,qua,a8,a10,
     3cci(u0),ccj(u0),b6x(u0,u0),aai(u0,u0),aaj(u0,u0),
     2b6y(u0,u0),b6z(u0,u0),svx(u0,nort),svy(u0,nort),
     3svz(u0,nort),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),tol,spi,xi,yi,zi,ai,xj,yj,zj,
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5xij,yij,zij,x2ij,y2ij,z2ij,r2ij,aj,aij,tt,t,ec,ef,con,coe,
     6cx0,cy0,cz0,cx1,cy1,cz1,aiii,ajjj,rkx,fkx,skx,ckx,sky,cky,
     7skz,ckz,rky,rkz,fky,fkz,Px,Py,Pz,anjx,anjy,anjz,sx1,
     8sy1,sz1,sx0,sy0,sz0,ste,cte,told
      common/xkykzk1/Xk1(nort*nort),Yk1(nort*nort),Zk1(nort*nort)
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,
     1noa,nori,nop,ish,nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),
     2io,ia,i,j,jo,ja,ioj,ioo,joo,ip,jp,ii,jj,icha,n1,iorb,ipp,jpp,
     3npi,npii,npj,npjj,njx,njy,njz,nix,niy,niz
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/aa100/aa1,aad,aaf,aag,aah,aaii
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,noe,ichm,mtp,ndo,
     4nsa,nsb,noa,nori,nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4),ld5),(lopt(8),lf7)
c
c     call inipoly
c     call initfd(aa1,aad,aaf)
c                  - initialized already at the beginning of dqmpol3k
c
      tol=100.0d0
      told=1.0d-10
      kk=akx*akx+aky*aky+akz*akz
      spi=sqrt(pi*pi*pi)
      do 10 i=1,nao
      do 10 j=1,u0
      svx(j,i)=z0
      svy(j,i)=z0
10    svz(j,i)=z0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=(ai*aj*r2ij+kk/4.0d0)*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)*t*t*t
      else
       goto 777
      endif
      Px=(ai*xi+aj*xj)*tt
      Py=(ai*yi+aj*yj)*tt
      Pz=(ai*zi+aj*zj)*tt
      skx=sin(Px*akx)
      ckx=cos(Px*akx)
      sky=sin(Py*aky)
      cky=cos(Py*aky)
      skz=sin(Pz*akz)
      ckz=cos(Pz*akz)
      rkx=dsqrt(Px**2+(akx*tt/two)**2)
      rky=dsqrt(Py**2+(aky*tt/two)**2)
      rkz=dsqrt(Pz**2+(akz*tt/two)**2)
      if(rkx.gt.told)then
       fkx=asin(akx*tt/two/rkx)
      else
       fkx=0.0d0
      endif
      if(rky.gt.told)then
       fky=asin(aky*tt/two/rky)
      else
       fky=0.0d0
      endif
      if(rkz.gt.told)then
       fkz=asin(akz*tt/two/rkz)
      else
       fkz=0.0d0
      endif
      if(Px.lt.0.0d0)fkx=pi-fkx
      if(Py.lt.0.0d0)fky=pi-fky
      if(Pz.lt.0.0d0)fkz=pi-fkz
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      anjx=dble(njx)
      anjy=dble(njy)
      anjz=dble(njz)
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)

c
c     <pj | cos/sin(k*(r-o))      | pi> for x,y,z:
      call okkc(nix,njx  ,skx,ckx,rkx,fkx,t,xi,xj,cox,sox,cx0,sx0)
      call okkc(niy,njy  ,sky,cky,rky,fky,t,yi,yj,coy,soy,cy0,sy0)
      call okkc(niz,njz  ,skz,ckz,rkz,fkz,t,zi,zj,coz,soz,cz0,sz0)
c     <pj | cos/sin(k*(r-o)) grad | pi> for x,y,z:
      call okkc(nix,njx+1,skx,ckx,rkx,fkx,t,xi,xj,cox,sox,cte,ste)
      cx1=-2.0d0*aj*cte
      sx1=-2.0d0*aj*ste
      call okkc(niy,njy+1,sky,cky,rky,fky,t,yi,yj,coy,soy,cte,ste)
      cy1=-2.0d0*aj*cte
      sy1=-2.0d0*aj*ste
      call okkc(niz,njz+1,skz,ckz,rkz,fkz,t,zi,zj,coz,soz,cte,ste)
      cz1=-2.0d0*aj*cte
      sz1=-2.0d0*aj*ste
      if(njx.gt.0)then
       call okkc(nix,njx-1,skx,ckx,rkx,fkx,t,xi,xj,cox,sox,cte,ste)
       cx1=cx1+anjx*cte
       sx1=sx1+anjx*ste
      endif
      if(njy.gt.0)then
       call okkc(niy,njy-1,sky,cky,rky,fky,t,yi,yj,coy,soy,cte,ste)
       cy1=cy1+anjy*cte
       sy1=sy1+anjy*ste
      endif
      if(njz.gt.0)then
       call okkc(niz,njz-1,skz,ckz,rkz,fkz,t,zi,zj,coz,soz,cte,ste)
       cz1=cz1+anjz*cte
       sz1=sz1+anjz*ste
      endif
c
      b6x(ioo,joo)=cx1*sy0*sz0*coe
      b6y(ioo,joo)=sx0*cy1*sz0*coe
71    b6z(ioo,joo)=sx0*sy0*cz1*coe
c
c     transform primitives into atomic arbitals
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       svx(ioo,ioj)=svx(ioo,ioj)+ajjj*b6x(ipp,jpp)
       svy(ioo,ioj)=svy(ioo,ioj)+ajjj*b6y(ipp,jpp)
74     svz(ioo,ioj)=svz(ioo,ioj)+ajjj*b6z(ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       svx(ioo,ioj)=svx(ioo,ioj)+b6x(ioo,joo)
       svy(ioo,ioj)=svy(ioo,ioj)+b6y(ioo,joo)
7      svz(ioo,ioj)=svz(ioo,ioj)+b6z(ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
       do 33 jj=1,nao
       Xk1(jj+(iorb-1)*nao)=svx(ii,jj)
       Yk1(jj+(iorb-1)*nao)=svy(ii,jj)
33     Zk1(jj+(iorb-1)*nao)=svz(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       svx(ii,jj)=z0
       svy(ii,jj)=z0
9      svz(ii,jj)=z0
c
      endif
3     continue
2     continue
      return
      end
c     ============================================================
      subroutine okkc(ni,nj,sk,ck,rk,fk,t,xi,xj,co,so,cte,ste)
c
c     infinity
c         /
c         |                       ni      nj -ai*(x-xi)^2 -aj*(x-xj)^2
c         |cos/sin(k.(x-o)) (x-xi)  (x-xj)  e            e            dx
c         |
c        /
c    -infinity
c
c     except pre-factors, see subroutine below
c
c     P=(ai*xi+aj*xj)/(ai+aj)
c     sk=sin(P*k)) ck=cos(P*k)
c     rk=dsqrt(P**2+(k/2/(ai+aj)**2)
c     fk=asin(k/2/(ai+aj)/rk)
c
      implicit none
      real*8 t,xi,xj,co,so,ireal,iimag,ste,cte,sk,ck,rk,fk
      integer*4 ni,nj
      call oikc(ni,nj,sk,ck,rk,fk,t,xi,xj,ireal,iimag)
      cte=co*ireal+so*iimag
      ste=co*iimag-so*ireal
      return
      end
c     ============================================================
      subroutine prfib(ix,ak,ik)
c
c       /       |cos(k_i xi)        |       \
c      <a_xi(AO)|sin(k_i xi)        |b_xi(AO)>
c       \       |cos(k_i xi) grad_i |       /
c        \      |sin(k_i xi) grad_i |      /

c
c     Note, that this is not a symmetric matrix with
c     respect to orbital exchange !!
c
c     the "true" d-orbitals are included here
      implicit none
      character*2 at
      character*1 ok,ty
      integer*4 nat0,nor,nort,ix,ik
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      real*8 ak,kk,q,zsum,xv,
     1escf,cc,alpha,rcp,cij,bij,e,be,pi,clau,spt,
     2bohr,debye,z0,one,two,three,four,five,six,half,qua,a8,a10,
     3cci(u0),ccj(u0),aai(u0,u0),aaj(u0,u0),rri,rrj,
     3b61(u0,u0),b62(u0,u0),b63(u0,u0),b64(u0,u0),
     2sv1(u0,nort),sv2(u0,nort),sv3(u0,nort),sv4(u0,nort),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),tol,spi,xi,yi,zi,ai,xj,yj,zj,
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5r2ij,aj,aij,tt,t,ec,ef,con,coe,
     6c0,c1,aiii,ajjj,rk,fk,sk,ck,
     7P,anj,s1,
     8s0,told,cm,sm,
     9cp,sp,twoaj

      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,nj,ni,
     1noa,nori,nop,ish,nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),
     2io,ia,i,j,jo,ja,ioj,ioo,joo,ip,jp,ii,jj,icha,n1,iorb,ipp,jpp,
     3npi,npii,npj,npjj,iorbnao,j3
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/aa100/aa1,aad,aaf,aag,aah,aaii
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,noe,ichm,mtp,ndo,
     4nsa,nsb,noa,nori,nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      integer*4 ncb0,nmax0
      parameter (nmax0=200,ncb0=1)
c     parameter (nmax0=200,ncb0=nort**2*nmax0)
      real*8 b_cx,b_cxg,b_sx,b_sxg,b_cy,b_cyg,b_sy,b_syg,
     1b_cz,b_czg,b_sz,b_szg
      common/kcbx/b_cx(ncb0),b_cxg(ncb0),b_sx(ncb0),b_sxg(ncb0)
      common/kcby/b_cy(ncb0),b_cyg(ncb0),b_sy(ncb0),b_syg(ncb0)
      common/kcbz/b_cz(ncb0),b_czg(ncb0),b_sz(ncb0),b_szg(ncb0)
c
c     call inipoly
c     call initfd(aa1,aad,aaf)
c                  - initialized already at the beginning of dqmpol3k
c
      if(ik.gt.nmax0)call report('ik>nmax0 in prfib')
      if(ix.ne.1.and.ix.ne.2.and.ix.ne.3)then
       write(6,*)ix
       call report('value of ix not allowed')
      endif

      tol=13.0d0
      told=1.0d-10
      kk=ak*ak
      spi=sqrt(pi)

c     order    cos    cos grad    sin    sin grad
      do 10 i=1,nao
      do 10 j=1,u0
      sv1(j,i)=z0
      sv2(j,i)=z0
      sv3(j,i)=z0
10    sv4(j,i)=z0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      if(ix.eq.1)r2ij=(xj-xi)**2
      if(ix.eq.2)r2ij=(yj-yi)**2
      if(ix.eq.3)r2ij=(zj-zi)**2
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      twoaj=aj+aj
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=(ai*aj*r2ij+kk/4.0d0)*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)*t
      else
       goto 777
      endif
      if(ix.eq.1)then
       P=(ai*xi+aj*xj)*tt
       rri=xi
       rrj=xj
      endif
      if(ix.eq.2)then
       P=(ai*yi+aj*yj)*tt
       rri=yi
       rrj=yj
      endif
      if(ix.eq.3)then
       P=(ai*zi+aj*zj)*tt
       rri=zi
       rrj=zj
      endif
      sk=sin(P*ak)
      ck=cos(P*ak)
      rk=dsqrt(P**2+(ak*tt/two)**2)
      if(rk.gt.told)then
       fk=asin(ak*tt/two/rk)
       if(P.lt.0.0d0)fk=pi-fk
      else
       fk=0.0d0
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef
      if(ix.eq.1)con=con*ccj(joo)
      if(ix.eq.1)nj=nxj(joo)
      if(ix.eq.2)nj=nyj(joo)
      if(ix.eq.3)nj=nzj(joo)
      anj=dble(nj)
      do 71 ioo=1,npi
      coe=con
      if(ix.eq.1)coe=coe*cci(ioo)
      if(ix.eq.1)ni=nxi(ioo)
      if(ix.eq.2)ni=nyi(ioo)
      if(ix.eq.3)ni=nzi(ioo)
      call oikc(ni,nj,sk,ck,rk,fk,t,rri,rrj,c0,s0)
      call oikc(ni,nj+1,sk,ck,rk,fk,t,rri,rrj,cp,sp)
      c1=-twoaj*cp
      s1=-twoaj*sp
      if(nj.gt.0)then
       call oikc(ni,nj-1,sk,ck,rk,fk,t,rri,rrj,cm,sm)
       c1=anj*cm+c1
       s1=anj*sm+s1
      endif
c

      b61(ioo,joo)=c0*coe
      b62(ioo,joo)=c1*coe
      b63(ioo,joo)=s0*coe
71    b64(ioo,joo)=s1*coe
c
c     transform primitives into atomic arbitals
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       sv1(ioo,ioj)=sv1(ioo,ioj)+ajjj*b61(ipp,jpp)
       sv2(ioo,ioj)=sv2(ioo,ioj)+ajjj*b62(ipp,jpp)
       sv3(ioo,ioj)=sv3(ioo,ioj)+ajjj*b63(ipp,jpp)
74     sv4(ioo,ioj)=sv4(ioo,ioj)+ajjj*b64(ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       sv1(ioo,ioj)=sv1(ioo,ioj)+b61(ioo,joo)
       sv2(ioo,ioj)=sv2(ioo,ioj)+b62(ioo,joo)
       sv3(ioo,ioj)=sv3(ioo,ioj)+b63(ioo,joo)
7      sv4(ioo,ioj)=sv4(ioo,ioj)+b64(ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
       iorbnao=(iorb-1)*nao+(ik-1)*nao**2
       do 33 jj=1,nao
       j3=iorbnao+jj
       if(ix.eq.1)then
        b_cx( j3)=sv1(ii,jj)
        b_cxg(j3)=sv2(ii,jj)
        b_sx( j3)=sv3(ii,jj)
        b_sxg(j3)=sv4(ii,jj)
       endif
       if(ix.eq.2)then
        b_cy( j3)=sv1(ii,jj)
        b_cyg(j3)=sv2(ii,jj)
        b_sy( j3)=sv3(ii,jj)
        b_syg(j3)=sv4(ii,jj)
       endif
       if(ix.eq.3)then
        b_cz( j3)=sv1(ii,jj)
        b_czg(j3)=sv2(ii,jj)
        b_sz( j3)=sv3(ii,jj)
        b_szg(j3)=sv4(ii,jj)
       endif
33     continue

       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       sv1(ii,jj)=z0
       sv2(ii,jj)=z0
       sv3(ii,jj)=z0
9      sv4(ii,jj)=z0
c
      endif
3     continue
2     continue

      return
      end
c     ============================================================
      subroutine overfac(nx,ny,nz,nao)
c
c     <a(AO)| X |b(ao)>
c     X= cccx,ccsx,cscx,sccx,sssx,sscx,scsx,cssx,
c        cccy,ccsy,cscy,sccy,sssy,sscy,scsy,cssy,
c        cccz,ccsz,cscz,sccz,sssz,sscz,scsz,cssz
c
c        cccx=cos(kx.x)cos(ky.y)cos(kz.z) grad x
c        cscz=cos(kx.x)sin(ky.y)cos(kz.z) grad z atd
c
c     Note, that this is not a symmetric matrix with
c     respect to orbital exchange !!
c
c     the "true" d-orbitals are included here
      implicit none
      integer*4 nort,ncb0,i,nao,nx,ny,nz,iorbnao,iorbnaox,
     1iorbnaoy,iorbnaoz,j3,j3x,j3y,j3z,j
c     parameter (nort=700,nmax0=200,ncb0=nort**2*nmax0)
      parameter (nort=700,ncb0=1)
      real*8 X24,cx,cy,cz,sx,sy,sz,sxg,syg,szg,cxg,cyg,czg
      common/xkykzko/X24(24,nort*nort)
      common/kcbx/cx(ncb0),cxg(ncb0),sx(ncb0),sxg(ncb0)
      common/kcby/cy(ncb0),cyg(ncb0),sy(ncb0),syg(ncb0)
      common/kcbz/cz(ncb0),czg(ncb0),sz(ncb0),szg(ncb0)
c
      do 1 i=1,nao
      iorbnao =(i-1)*nao
      iorbnaox=(i-1)*nao+(nx-1)*nao**2
      iorbnaoy=(i-1)*nao+(ny-1)*nao**2
      iorbnaoz=(i-1)*nao+(nz-1)*nao**2
      do 1 j=1,nao
      j3 =iorbnao +j
      j3x=iorbnaox+j
      j3y=iorbnaoy+j
      j3z=iorbnaoz+j
c     cccx->cssx->scsx->sscx->sssx->sccx->cscx->ccsx->
c     write(6,*)i,j,j3x,j3y,j3z,cxg(j3x),cy(j3y),cz(j3z)
      X24( 1,j3)=cxg(j3x)*cy(j3y)*cz(j3z)
      X24( 2,j3)=cxg(j3x)*sy(j3y)*sz(j3z)
      X24( 3,j3)=sxg(j3x)*cy(j3y)*sz(j3z)
      X24( 4,j3)=sxg(j3x)*sy(j3y)*cz(j3z)
      X24( 5,j3)=sxg(j3x)*sy(j3y)*sz(j3z)
      X24( 6,j3)=sxg(j3x)*cy(j3y)*cz(j3z)
      X24( 7,j3)=cxg(j3x)*sy(j3y)*cz(j3z)
      X24( 8,j3)=cxg(j3x)*cy(j3y)*sz(j3z)
c     cccy->cssy->scsy->sscy->sssy->sccy->cscy->ccsy->
      X24( 9,j3)=cx(j3x)*cyg(j3y)*cz(j3z)
      X24(10,j3)=cx(j3x)*syg(j3y)*sz(j3z)
      X24(11,j3)=sx(j3x)*cyg(j3y)*sz(j3z)
      X24(12,j3)=sx(j3x)*syg(j3y)*cz(j3z)
      X24(13,j3)=sx(j3x)*syg(j3y)*sz(j3z)
      X24(14,j3)=sx(j3x)*cyg(j3y)*cz(j3z)
      X24(15,j3)=cx(j3x)*syg(j3y)*cz(j3z)
      X24(16,j3)=cx(j3x)*cyg(j3y)*sz(j3z)
c     cccz->cssz->scsz->sscz->sssz->sccz->cscz->ccsz
      X24(17,j3)=cx(j3x)*cy(j3y)*czg(j3z)
      X24(18,j3)=cx(j3x)*sy(j3y)*szg(j3z)
      X24(19,j3)=sx(j3x)*cy(j3y)*szg(j3z)
      X24(20,j3)=sx(j3x)*sy(j3y)*czg(j3z)
      X24(21,j3)=sx(j3x)*sy(j3y)*szg(j3z)
      X24(22,j3)=sx(j3x)*cy(j3y)*czg(j3z)
      X24(23,j3)=cx(j3x)*sy(j3y)*czg(j3z)
1     X24(24,j3)=cx(j3x)*cy(j3y)*szg(j3z)

      return
      end
c     ================================================================
      subroutine vm(v,c,n)
      real*8 c,v(*)
      integer*4 n,i
      do 1 i=1,n
1     v(i)=v(i)*c
      return
      end
