      subroutine dsm(sdm,nao,noa,alpha,ty,nop,ish)
c     calculates derivatives of the S-matrix and
c     dipoles between AO orbitals
c     with respect to the first index <da/dRa|b>
      implicit none
      integer*4 nat0,u0,i,j,nao,noa,io,ia,ip,nor,icha,n1,n3,
     1ix,iy,iz,ixx,iyy,izz,ji,ik,k,kk,n1e
      parameter (u0=28,nor=80,n1e=7,nat0=190)
c     n1e .. types of overlap: 1 <i(x)|j(0)>
c                              2 <i(x)|x|j(0)>
c                              3 <i(x)|y|j(0)>
c                              4 <i(x)|z|j(0)>
c                              5 <i(x)|lx|j(0)>
c                              6 <i(x)|ly|j(0)>
c                              7 <i(x)|lz|j(0)>
      integer*4 npi,npii,nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),
     1nzj(u0),ja,jo,jp,nop(nat0),npj,npjj,ioj,ipp,jpp,ioo,joo,ii,
     1jj,ish(nat0,nor),nx,ny,nz,mx,my,mz
      real*8 aad(u0,u0),aaf(u0,u0),aa1(u0,u0),half,dx,dy,dz,two,
     1aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     1tol,pi,clau,spt,bohr,debye,spi,sdm(*),anjx,anjy,anjz,
     1bx(n1e,u0,u0),by(n1e,u0,u0),bz(n1e,u0,u0),sxm,sym,szm,
     1xi,yi,zi,ai,alpha(nat0,nor),cci(u0),ccj(u0),oi,
     3aai(u0,u0),aaj(u0,u0),xj,yj,zj,xij,yij,zij,sxp,syp,szp,
     4x2ij,y2ij,z2ij,r2ij,aj,aij,tt,t,ec,ef,con,anix,aniy,aniz,
     5aiii,ajjj,ox,oy,oz,oxx,oyy,ozz,sx,sy,sz,sxx,syy,szz,
     6dxx,dyy,dzz,sxmx,symy,szmz,sxpx,sypy,szpz
      common/const/pi,clau,spt,bohr,debye
      real*8 q,zsum,xv
      common/atoms/q(nat0),zsum,xv(3,nat0)
      character*1 ty(nat0,nor)
      logical ld5,lf7,lsprint,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4),ld5),(lopt(8),lf7)
      real*8,allocatable::svx(:,:,:),svy(:,:,:),svz(:,:,:)

      allocate(svx(n1e,u0,nao),svy(n1e,u0,nao),svz(n1e,u0,nao))
      half=0.50d0
      two=2.0d0
      call inipoly
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      tol=100.0d0
      spi=sqrt(pi*pi*pi)
      n3=3*noa

      do 1 i=1,nao**2*n3*n1e
1     sdm(i)=0.0d0

      do 10 i=1,nao
      do 10 j=1,u0
      do 10 k=1,n1e
      svx(k,j,i)=0.0d0
      svy(k,j,i)=0.0d0
10    svz(k,j,i)=0.0d0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=1.0d0/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=0.0d0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      mx=nxj(joo)
      my=nyj(joo)
      mz=nzj(joo)
      anjx=dble(mx)
      anjy=dble(my)
      anjz=dble(mz)
      do 71 ioo=1,npi
      nx=nxi(ioo)
      ny=nyi(ioo)
      nz=nzi(ioo)
      anix=dble(nx)
      aniy=dble(ny)
      aniz=dble(nz)
      sx=oi(0,nx,mx,ai,aj,xij,t,xi,xj)
      sy=oi(0,ny,my,ai,aj,yij,t,yi,yj)
      sz=oi(0,nz,mz,ai,aj,zij,t,zi,zj)
      sxp=oi(0,nx,mx+1,ai,aj,xij,t,xi,xj)
      syp=oi(0,ny,my+1,ai,aj,yij,t,yi,yj)
      szp=oi(0,nz,mz+1,ai,aj,zij,t,zi,zj)
      ox=oi(1,nx,mx,ai,aj,xij,t,xi,xj)
      oy=oi(1,ny,my,ai,aj,yij,t,yi,yj)
      oz=oi(1,nz,mz,ai,aj,zij,t,zi,zj)
c     primitive derivatives with respect to nucleus i
c     1 -nxi * (nxi-1 nyi nzi || nxj xyj nzj)
c       +2ai * (nxi+1 nyi nzi || nxj xyj nzj)
c     2 -nyi * (nxi nyi-1 nzi || nxj xyj nzj)
c       +2ai * (nxi nyi+1 nzi || nxj xyj nzj)
c     3 -nzi * (nxi nyi nzi-1 || nxj xyj nzj)
c       +2ai * (nxi nyi nzi+1 || nxj xyj nzj)
      sxx =2.0d0*ai*oi(0,nx+1,mx  ,ai,aj,xij,t,xi,xj)
      oxx =2.0d0*ai*oi(1,nx+1,mx  ,ai,aj,xij,t,xi,xj)
      sxpx=2.0d0*ai*oi(0,nx+1,mx+1,ai,aj,xij,t,xi,xj)
      sxm=0.0d0
      sxmx=0.0d0
      if(mx.gt.0)then
       sxm=                      oi(0,nx  ,mx-1,ai,aj,xij,t,xi,xj)
       sxmx=            2.0d0*ai*oi(0,nx+1,mx-1,ai,aj,xij,t,xi,xj)
       if(nx.gt.0)sxmx=sxmx-anix*oi(0,nx-1,mx-1,ai,aj,xij,t,xi,xj)
      endif
      if(nx.gt.0)then
       sxx =sxx -anix*oi(0,nx-1,mx  ,ai,aj,xij,t,xi,xj)
       oxx =oxx -anix*oi(1,nx-1,mx  ,ai,aj,xij,t,xi,xj)
       sxpx=sxpx-anix*oi(0,nx-1,mx+1,ai,aj,xij,t,xi,xj)
      endif
      syy =2.0d0*ai*oi(0,ny+1,my  ,ai,aj,yij,t,yi,yj)
      oyy =2.0d0*ai*oi(1,ny+1,my  ,ai,aj,yij,t,yi,yj)
      sypy=2.0d0*ai*oi(0,ny+1,my+1,ai,aj,yij,t,yi,yj)
      sym=0.0d0
      symy=0.0d0
      if(my.gt.0)then
       sym=                      oi(0,ny  ,my-1,ai,aj,yij,t,yi,yj)
       symy=            2.0d0*ai*oi(0,ny+1,my-1,ai,aj,yij,t,yi,yj)
       if(ny.gt.0)symy=symy-aniy*oi(0,ny-1,my-1,ai,aj,yij,t,yi,yj)
      endif
      if(ny.gt.0)then
       syy =syy -aniy*oi(0,ny-1,my  ,ai,aj,yij,t,yi,yj)
       oyy =oyy -aniy*oi(1,ny-1,my  ,ai,aj,yij,t,yi,yj)
       sypy=sypy-aniy*oi(0,ny-1,my+1,ai,aj,yij,t,yi,yj)
      endif
      szz= 2.0d0*ai*oi(0,nz+1,mz  ,ai,aj,zij,t,zi,zj)
      ozz= 2.0d0*ai*oi(1,nz+1,mz  ,ai,aj,zij,t,zi,zj)
      szpz=2.0d0*ai*oi(0,nz+1,mz+1,ai,aj,zij,t,zi,zj)
      szm=0.0d0
      szmz=0.0d0
      if(mz.gt.0)then
       szm=                      oi(0,nz  ,mz-1,ai,aj,zij,t,zi,zj)
       szmz=            2.0d0*ai*oi(0,nz+1,mz-1,ai,aj,zij,t,zi,zj)
       if(nz.gt.0)szmz=szmz-aniz*oi(0,nz-1,mz-1,ai,aj,zij,t,zi,zj)
      endif
      if(nz.gt.0)then
       szz =szz -aniz*oi(0,nz-1,mz  ,ai,aj,zij,t,zi,zj)
       ozz =ozz -aniz*oi(1,nz-1,mz  ,ai,aj,zij,t,zi,zj)
       szpz=szpz-aniz*oi(0,nz-1,mz+1,ai,aj,zij,t,zi,zj)
      endif
      dx=anjx*sxm-two*aj*sxp
      dy=anjy*sym-two*aj*syp
      dz=anjz*szm-two*aj*szp
      dxx=anjx*sxmx-two*aj*sxpx
      dyy=anjy*symy-two*aj*sypy
      dzz=anjz*szmz-two*aj*szpz
c     overlap derivative
      bx(1,ioo,joo)=sxx*sy *sz
      by(1,ioo,joo)=sx *syy*sz
      bz(1,ioo,joo)=sx *sy *szz
c     electric dipole derivative
c     x-dipole:
      bx(2,ioo,joo)=oxx*sy *sz
      by(2,ioo,joo)=ox *syy*sz
      bz(2,ioo,joo)=ox *sy *szz
c     y-dipole:
      bx(3,ioo,joo)=sxx*oy *sz
      by(3,ioo,joo)=sx *oyy*sz
      bz(3,ioo,joo)=sx *oy *szz
c     z-dipole:
      bx(4,ioo,joo)=sxx*sy *oz
      by(4,ioo,joo)=sx *syy*oz
      bz(4,ioo,joo)=sx *sy *ozz
c     magnetic dipole derivative
c     x-dipole y dz - z dy:
      bx(5,ioo,joo)=half*sxx*(oy *dz  - dy *oz )
      by(5,ioo,joo)=half*sx *(oyy*dz  - dyy*oz )
      bz(5,ioo,joo)=half*sx *(oy *dzz - dy *ozz)
c     y-dipole z dx - z dz:
      bx(6,ioo,joo)=half*sy *(oz *dxx - dz*oxx )
      by(6,ioo,joo)=half*syy*(oz *dx  - dz *ox )
      bz(6,ioo,joo)=half*sy *(ozz*dx  - dzz*ox )
c     z-dipole x dy - y dx:
      bx(7,ioo,joo)=half*sz *(oxx*dy  - dxx*oy )
      by(7,ioo,joo)=half*sz *(ox *dyy - dx *oyy)
      bz(7,ioo,joo)=half*szz*(ox *dy  - dx *oy )

      do 71 k=1,n1e
      bx(k,ioo,joo)=bx(k,ioo,joo)*con*cci(ioo)
      by(k,ioo,joo)=by(k,ioo,joo)*con*cci(ioo)
71    bz(k,ioo,joo)=bz(k,ioo,joo)*con*cci(ioo)
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       do 74 k=1,n1e
       svx(k,ioo,ioj)=svx(k,ioo,ioj)+ajjj*bx(k,ipp,jpp)
       svy(k,ioo,ioj)=svy(k,ioo,ioj)+ajjj*by(k,ipp,jpp)
74     svz(k,ioo,ioj)=svz(k,ioo,ioj)+ajjj*bz(k,ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       do 7 k=1,n1e
       ioj=joo+jo
       svx(k,ioo,ioj)=svx(k,ioo,ioj)+bx(k,ioo,joo)
       svy(k,ioo,ioj)=svy(k,ioo,ioj)+by(k,ioo,joo)
7      svz(k,ioo,ioj)=svz(k,ioo,ioj)+bz(k,ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       ix=1+3*(ia-1)
       iy=2+3*(ia-1)
       iz=3+3*(ia-1)
       do 33 ii=1,npii
       ixx=ix+n3*(ii+io-1)
       iyy=iy+n3*(ii+io-1)
       izz=iz+n3*(ii+io-1)
       do 33  jj=1,nao
       ji=n3*nao*(jj-1)
c      contribution to derivative with respect to Ria <AO=ii+io|AO=jj>
       do 33  kk=1,n1e
       ik=n3*nao*nao*(kk-1)+ji
       sdm(ixx+ik)=sdm(ixx+ik)+svx(kk,ii,jj)
       sdm(iyy+ik)=sdm(iyy+ik)+svy(kk,ii,jj)
33     sdm(izz+ik)=sdm(izz+ik)+svz(kk,ii,jj)
c      sdm(a+3*(ia-1)+n3*(i-1)+n3*nao*(j-1)+n3*nao*nao*(kk-1))
c        a - a-coordinate of ia (derivas)
c        i - AO, differentiated , n3 = 3 x nat
c        j - the other AO
c        kk- 1..4, s and dipoles
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       do 9 kk=1,n1e
       svx(kk,ii,jj)=0.0d0
       svy(kk,ii,jj)=0.0d0
9      svz(kk,ii,jj)=0.0d0
      endif
3     continue
2     continue
c
      return
      end
