      function EE4(T,m)
c
c     The approximate error function
c
c                         1
c                         /
c                        |     2m  -Tu^2
c      E(T) = sqrt(2/pi) |    u   e     du    m=0..12
c                        |
c                       /
c                       0
c
c     common app must be initialized befor use
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nX=2000,mmax=21)
      common/ap4/et(nX),ei(mmax,nX),dt(mmax),dt63(mmax),dt62(mmax),
     1ti(mmax),t5(mmax),dtt,t23,dtt2,dtt3
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
c
      if(m.gt.mmax-1)then
       write(3,*)'m = ',m
       call report('Unknown error function called ee4')
      endif
      am=dble(m)
c
c     if t>t5, use the limit formula
      if(t.gt.t5(m+1))goto 888
c
c     for 0<t<t5 use the cubic interpolation formula
      jm=int(t/dt(m+1))+1
      jmm=jm-1
      jp=jm+1
      jpp=jp+1
      if(jp.gt.nx)goto 888
      if(jmm.lt.1)then
       jmm=1
       jm=2
       jp=3
       jpp=4
      endif
      tm2=dt(m+1)*dble(jmm-1)
      tm2s=tm2*tm2
      tm=tm2+dt(m+1)
      tms=tm*tm
      tp=tm+dt(m+1)
      fp2=ei(m+1,jpp)
      fp=ei(m+1,jp)
      fm=ei(m+1,jm)
      fm2=ei(m+1,jmm)
      d=(fp2+three*(fm-fp)-fm2)*dt63(m+1)
      c=(fp-two*fm+fm2-d*(tp*tp*tp-two*tm*tms+tm2*tm2s))*dt62(m+1)
      b=(fm-fm2-(c+d*tm)*tms+(c+d*tm2)*tm2s)/dt(m+1)
      a=fm2-tm2*(b+tm2*(c+d*tm2))
      EE4=a+t*(b+t*(c+t*d))
      return
888   fac=one
      ai=one
1     fac=ai*fac
      ai=ai+two
      if(ai.lt.two*am)goto 1
      sq=one/sqrt(two*t)
      fac=fac*sq**(2*m+1)
      EE4=fac
      return
      end
c
      subroutine inibe4
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (n5=5,nX=2000,mmax=21)
      common/ap4/et(nX),ei(mmax,nX),dt(mmax),dt63(mmax),dt62(mmax),
     1ti(mmax),t5(mmax),dtt,t23,dtt2,dtt3
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      logical lbe
c
      inquire(file='BE4.SCR',exist=lbe)
      if(lbe)then
       open(23,file='BE4.SCR',FORM='unformatted')
       read(23)nxtr,et,ei,dt,dt63,dt62,ti,t5,dtt,t23,dtt2,dtt3
       close(23)
       if(nxtr.ne.nX)goto 9000
       return
      endif
c
9000  an5=dble(n5)
      spi=sqrt(pi)
c
c     Loop over functions:
      do 6 m=0,mmax-1
      am=dble(m)
c
c     pre-calculate inflection points:
c     calculate ti, when inflection point is for u=1:
      ti(m+1)=(four*am+one+sqrt(two*a8*am+one))*qua
c     last point
      t5(m+1)=an5*an5*ti(m+1)
c
c     amm=(2m-1)!!
      amm=one
      ad=one
30    amm=amm*ad
      ad=ad+two
      if(ad.lt.two*am)goto 30
c
      tmp=one
      do 43 ii=1,m+1
43    tmp=tmp*two
c
c     elementary interval
      dt(m+1)=t5(m+1)/dble(nX)
      dt63(m+1)=one/(six*dt(m+1)*dt(m+1)*dt(m+1))
      dt62(m+1)=one/(two*dt(m+1)*dt(m+1))
c
c     values at the first and last points
      ei(m+1,1)=one/(one+two*am)*sqrt(two/pi)
      ei(m+1,nX)=amm/sqrt(two*(t5(m+1)-dt(m+1)))**(2*m+1)
c
c     values in the middle
      t=z0
      stpi=sqrt(two/pi)
      do 6 i=2,nX-1
      t=t+dt(m+1)
c
      sum=z0
      do 20 l=1,m
      al=dble(l)
c
c     all=(2l-1)!!
      all=one
      ad=one
10    all=all*ad
      ad=ad+two
      if(ad.lt.two*al)goto 10
c
c     tl=2^l ttl=t^(l-1)
      tl=one
      ttl=one
      do 40 ii=1,l
40    tl=tl*two
      do 41 ii=1,l-1
41    ttl=ttl*t
20    sum=sum+ttl*tl / all
      st=sqrt(t)
      tm=one
      do 42 ii=1,m
42    tm=tm*t
6     ei(m+1,i)=amm*(spi*erfcacm(st)-exp(-t)*st*sum)/(tmp*tm*st)*stpi
c     Error function 4 initialized
c
c     initialize exp(-x)
c     elementary interval
      t23=dble(26)
      dtt=t23/dble(nX)
      dtt3=one/(six*dtt*dtt*dtt)
      dtt2=one/(two*dtt*dtt)
      t=-dtt
      do 44 i=1,nX
      t=t+dtt
44    et(i)=exp(-t)
c     exp(-t) initialized
   
      open(23,file='BE4.SCR',FORM='unformatted')
      write(23)nX,et,ei,dt,dt63,dt62,ti,t5,dtt,t23,dtt2,dtt3
      close(23)
      return
      end
