      function erfcacm(q)
c
c     error function from collected algorithms from CACM, alg. # 123
c
c     erfcacm(x)=(2/sqrt(pi))integral(0..x)exp(-t^2)dt
      real*8 erfcacm,q,x, a,u,v,w,y,z,t, n,pi,pic
      pi=dble(4)*atan(real(1))
      pic=2.0D0/sqrt(pi)
      x=q
      z=0.0D0
1     if(dabs(x).gt.1.0D-20)then
       if(0.5D0.lt.abs(x))then
        a=-sign(0.5D0,x)
       else
        a=-x
       endif
       u=pic*exp(-x*x)
       v=u
       t=-v*a
       y=t
       n=1.0D0
2      if(abs(t).ge.1.0D-20)then
        n=n+1.0D0
        w=-2.0D0*(x*v+(n-2.0D0)*u)
        t=t*w*a/(v*n)
        u=v
        v=w
        y=y+t
        goto 2
       endif
       z=z+y
       x=x+a
       goto 1
      endif
      erfcacm=z
      return
      end
