      subroutine fitro1(k,dk,m,al,r)
c     fits the density of an orbital k, ro(k)=dk(i)*x(i)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (igmax=3,nr=100)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      dimension r(3,nr),ath(3,3),al(nr),u(3,3),aii(3),
     1rc(3),bm(nr),dk(nr),am(nr,nr),v(nr),bu(nr,nr),em(nr,2*nr),et(3)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   )
c
      write(3,*)'Fitting orbital ',k
      write(6,*)'Fitting orbital ',k
c
c     calculate the first and second moments
      call muk(k,rx,ry,rz)
      call thk(k,rxx,rxy,rxz,ryy,ryz,rzz)
      ath(1,1)=rxx-rx*rx
      ath(1,2)=rxy-rx*ry
      ath(2,1)=ath(1,2)
      ath(1,3)=rxz-rx*rz
      ath(3,1)=ath(1,3)
      ath(2,2)=ryy-ry*ry
      ath(2,3)=ryz-ry*rz
      ath(3,2)=ath(2,3)
      ath(3,3)=rzz-rz*rz
c
c     diagonalize the second moment
      WRITE(3,5247)rx,ry,rz,((ath(I,J),I=1,3),J=1,3)
5247  FORMAT('  First moment  (a.u.) : ',3F10.4,/,/,
     1       '  Second moment (a.u.) : ',3F10.4,/,
     1     25X,3F10.4,/,25X,3F10.4,/)
      ione=1
      i0=0
      i2=2
      i3=3
      CALL TRED12(i3,ath,U,AII,i2,IERR,3,ET)
      if(lsprint)call wmtr(u,i3,i3,'transformation matrix',ione)
      RC(1)=sqrt(aii(1))
      RC(2)=sqrt(aii(2))
      RC(3)=sqrt(aii(3))
      WRITE(3,3005)(RC(I),I=1,3),(RC(I)*bohr,I=1,3)
3005  FORMAT(/,' Space extension (au): ',3F12.7,/,
     1         '                 ( A): ',3F12.7)
c
c     U(i,j): i-the old system, j-the diagonal system
c
c     define the first gaussian
      m=1
      r(1,m)=rx
      r(2,m)=ry
      r(3,m)=rz
      al(m)=three/(two*(aii(1)+aii(2)+aii(3)))
c
c     define other gaussians
      do 100 ii=2,igmax
      agh=one/dble(ii)
      delx=rc(1)*agh
      alpx=half*agh/aii(1)
      dely=rc(2)*agh
      alpy=half*agh/aii(2)
      delz=rc(3)*agh
      alpz=half*agh/aii(3)
      x=-rc(1)-delx
      do 101 i=1,ii
      x=x+delx+delx
      y=-rc(2)-dely
      do 101 j=1,ii
      y=y+dely+dely
      z=-rc(3)-delz
      do 101 kk=1,ii
      z=z+delz+delz
      m=m+1
      if(m.gt.nr)call report('too many lobes')
      al(m)=(alpx+alpy+alpz)/three
      r(1,m)=u(1,1)*x+u(1,2)*y+u(1,3)*z+rx
      r(2,m)=u(2,1)*x+u(2,2)*y+u(2,3)*z+ry
      r(3,m)=u(3,1)*x+u(3,2)*y+u(3,3)*z+rz
101   continue
100   continue
      if(lsprint)write(3,3001)m,k
3001  format(I5,' gaussian lobes for the orbital ',I4,/,
     1'    m       alpha          Xl          Yl          Zl',
     2/,80(1H-))
      do 102 i=1,m
      if(lsprint)write(3,3006)i,al(i),(r(j,i),j=1,3)
3006  format(I5,4F12.4)
102   continue
c
c     calculate the lobe norms and overlaps
      sp=sqrt(pi*pi*pi)
      do 103 i=1,m
      xi=r(1,i)
      yi=r(2,i)
      zi=r(3,i)
      ai=al(i)
      v(i)=sp/(ai*sqrt(ai))
      do 103 j=1,i
      x=r(1,j)-xi
      y=r(2,j)-yi
      z=r(3,j)-zi
      r2=x*x+y*y+z*z
      aj=al(j)
      aa=one/(ai+aj)
      ef=ai*aj*aa*r2
      if(ef.gt.50.0)then
       am(j,i)=z0
      else
       am(j,i)=sp*aa*sqrt(aa)*exp(-ef)
      endif
103   am(i,j)=am(j,i)
c
c     for the lobes calculate the overlap vector with the density of MOk
      call over7(bm,m,al,r,nr,k)
c
c     form the matrices (Ax=B)
      ndim=m+1
      bm(ndim)=-one
      do 900 i=1,m
      am(ndim,i)=-v(i)
900   am(i,ndim)=-v(i)
      am(ndim,ndim)=z0
      if(lsprint)call wmtr(am,nr,ndim,'am',i0)
      if(lsprint)write(3,*)'bm'
      do 863 i=1,ndim
863   if(lsprint)write(3,3862)i,bm(i)
3862  format(I4,F15.8)
c
c     direct inversion
      atol=0.0000000001
      call inv(nr,am,bu,ndim,atol,em,ierr)
      if(ierr.gt.0)call report('Matrix cannot be inverted')
c
c     make the coefficients
      do 861 i=1,ndim-1
      dk(i)=z0
      do 861 j=1,ndim
861   dk(i)=dk(i)+bu(i,j)*bm(j)
      if(lsprint)write(3,3004)
3004  format('basefunction     coefficient')
      do 862 i=1,m
862   if(lsprint)write(3,3007)i,dk(i)
3007  format(I5,F20.5)
c
c     control norm
      cn=z0
      do 871 i=1,m
871   cn=cn+dk(i)*v(i)
      if(lsprint)write(3,3000)k,cn
3000  format(' Norm of approximate ro for MO ',I3,' = ',F10.6)
      return
      end
c    ============================================================
      subroutine over7(bm,m,al,rl,m0,kphi)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      integer*4 u0
      parameter (u0=28)
      parameter (nat0=190,nor=80,nort=700)
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),bm(m0),rl(3,m0),al(m0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   )
c
      call inipoly
      i0=0
      tol=100.0
      spi=sqrt(pi*pi*pi)
      call vz(bm,z0,m)
c
c     prepare the cartesian/spherical transformations for d and f orbitals
c     see subroutine overlap6 for details
      do 77 i=1,u0
      do 77 j=1,u0
      aa1(i,j)=z0
      aad(i,j)=z0
      aaf(i,j)=z0
77    aa1(i,i)=one
      d1=half
      d5=sqrt(three)*half
      aad(1,1)=-d1
      aad(1,2)=-d1
      aad(1,3)=two*d1
      aad(2,5)=one
      aad(3,6)=one
      aad(4,1)=d5
      aad(4,2)=-d5
      aad(5,4)=one
      f1=half/sqrt(five)
      f2=half*sqrt(three)/sqrt(a10)
      f3=half*sqrt(three)/sqrt(a10)
      f4=sqrt(three)*half
      f5=one
      f6=half/sqrt(two)
      f7=half/sqrt(two)
      aaf(1, 3)= f1 * two * sqrt(five)
      aaf(1, 5)=-f1 * three
      aaf(1, 7)=-f1 * three
      aaf(2, 1)=-f2 * sqrt(five)
      aaf(2, 6)=-f2
      aaf(2, 8)= f2 * four
      aaf(3, 2)=-f3 * sqrt(five)
      aaf(3, 4)=-f3
      aaf(3, 9)= f3 * four
      aaf(4, 5)= f4
      aaf(4, 7)=-f4
      aaf(5,10)= f5
      aaf(6, 1)= f6 * sqrt(five)
      aaf(6, 6)=-f6 * three
      aaf(7, 2)=-f7 * sqrt(five)
      aaf(7, 4)= f7 * three
c
c     triple loop over atoms+centers
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,ld5,lf7,ja,jp)
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
      aij=ai+aj
c
C     lobe k
      do 41 ka=1,m
      ak=al(ka)
      xk=rl(1,ka)
      yk=rl(2,ka)
      zk=rl(3,ka)
      xik=xk-xi
      yik=yk-yi
      zik=zk-zi
      xjk=xk-xj
      yjk=yk-yj
      zjk=zk-zj
      x2jk=xjk*xjk
      y2jk=yjk*yjk
      z2jk=zjk*zjk
      x2ik=xik*xik
      y2ik=yik*yik
      z2ik=zik*zik
      r2ik=x2ik+y2ik+z2ik
      r2jk=x2jk+y2jk+z2jk
      aijk=aij+ak
      tt=one/aijk
      t=sqrt(tt)
      ec=(ai*aj*r2ij+ai*ak*r2ik+aj*ak*r2jk)*tt
      if(ec.gt.tol)goto 41
      ef=spi*exp(-ec)
c
C     Loop over orbitals to which the primitives ip,jp,kp contribute
c
c     1)pure cartesian AOs
      do 71 ioo=1,npi
      co1=ef*cci(ioo)
      do 71 joo=1,npj
      sx=ooi(nxi(ioo),nxj(joo),i0, ai,aj,ak,xi,xj,xk,aijk,t)
      sy=ooi(nyi(ioo),nyj(joo),i0, ai,aj,ak,yi,yj,yk,aijk,t)
      sz=ooi(nzi(ioo),nzj(joo),i0, ai,aj,ak,zi,zj,zk,aijk,t)
71    b6(ioo,joo)=sx*sy*sz*co1*ccj(joo)
c     ijk=ikj=jik=jki=kij=kji
c
c     2)real AOs
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       ioi=ioo+io
       do 74 joo=1,npjj
       ioj=joo+jo
       coe=cij(kphi,ioi)*cij(kphi,ioj)
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)*coe
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     bm(ka)=bm(ka)+b6(ipp,jpp)*ajjj
      else
       do 7 ioo=1,npi
       ioi=ioo+io
       coe=cij(kphi,ioi)
       do 7 joo=1,npj
       ioj=joo+jo
c      if(ka.eq.1.and.kphi.eq.1)then
c       write(6,*)ak,xk,yk,zk
c       write(6,*)ioi,ioj,coe*cij(kphi,ioj),b6(ioo,joo)
c       read(*,'(a)')ok
c      endif
7      bm(ka)=bm(ka)+b6(ioo,joo)*coe*cij(kphi,ioj)
      endif
c
41    continue
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
5     continue
4     continue
      if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
3     continue
2     continue
c
      return
      end
