      subroutine gradc
c
c     detail d cKl/d rux
c
c     gradient according to the Hellmann-Feynman theorem
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      dimension buff(nort,nort),gmo(nort,nort),btem(nort,nort)
      logical lopt,lcall
      common/opts/lopt(300),icha,n1
      equivalence (lopt(67),lcall)
c
      write(3,4001)nmo,nao
4001  format(' Gradient according to the Hellmann-Feynman theorem',/,
     1' NMO = ',I3,' NAO = ',I3)
      if(lcall)then
       write(3,*)'all mos'
      else
       write(3,*)'occ//virt'
      endif
      if(nao.gt.nort)call report('Too many orbitals for gradc')
c
      call inibe4
c
      do 1 lat=1,noa
      do 1 ix=1,3
      write(3,*)' Atom ',lat,' ',ix
      write(6,*)' Atom ',lat,' ',ix
c
c     calculate ao integrals (i|grad_lat_ixH|j), put them in buff
      call overlagg(lat,ix,buff)
c
c     transform into MOs
      call taomo2(buff,gmo,cij,nort,nort,nmo,nao,btem)
c
      do 1 k=1,nmo
      write(3,*)k,' MO'
      do 1 i=1,nao
      sum=0.0d0
      do 2 kp=1,nmo
      if(kp.eq.k)goto 2
      if(.not.lcall)then
       if(k.le.ndo.and.kp.le.ndo)goto 2
       if(k.gt.ndo.and.kp.gt.ndo)goto 2
      endif
      ekkp=e(k)-e(kp)
      if(abs(ekkp).gt.1.0d-6)sum=sum+gmo(k,kp)/ekkp*cij(kp,i)
2     continue
1     write(3,3000)i,sum
3000  format(i4,f15.6)
      call report('gradc finished')
      end
