      subroutine gradhf
c
c     gradient according to the Hellmann-Feynman theorem
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension grade(3,nat0),gradn(3,nat0),buff(nort,nort)
c
      write(3,4001)nmo,nao
4001  format(' Gradient according to the Hellmann-feynmann theorem',/,
     1' NMO = ',I3,' NAO = ',I3)
      if(nao.gt.nort)call report('Too many orbitals for gradhf')
c
      call inibe4
      call vz(grade,z0,3*noa)
      call vz(gradn,z0,3*noa)
c
c     Loop over atoms:
      do 1 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      do 1 ix=1,3
c
c     calculate ao integrals (i|grad_lat_ixH|j), put them in buff
      call overlagg(lat,ix,buff)
      do i=1,nao
      do j=1,nao
c     write(6,*)buff(i,j)
      enddo
      enddo
c
c     transform into MOs and gather controbutions from occupied orbs
      do 1 k=1,ndo
      gkk=z0
      do 2 i=1,nao
      cki=cij(k,i)
      gkk=gkk+cki*cki*buff(i,i)
      sum=z0
      do 3 j=1,i-1
3     sum=sum+cki*cij(k,j)*buff(j,i)
2     gkk=gkk+sum+sum
c
1     grade(ix,lat)=grade(ix,lat)+gkk+gkk
c
c     the nuclear part:
      call vz(gradn,z0,3*noa)
      do 4 lat=1,noa
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      do 4 ia=1,noa
      if(ia.ne.lat)then
       r=sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2)
       fac=z(lat)*z(ia)/(r*r*r)
       do 5 ix=1,3
5      gradn(ix,lat)=gradn(ix,lat)-fac*(xv(ix,lat)-xv(ix,ia))
      endif
4     continue
c
      write(3,*)' Electronic and nuclear gradient:'
      write(6,*)' Electronic and nuclear gradient:'
      do 6 lat=1,noa
      write(6,3000)lat,(grade(i,lat),i=1,3)
      write(6,3000)lat,(gradn(i,lat),i=1,3)
      write(3,3000)lat,(grade(i,lat),i=1,3)
      write(3,3000)lat,(gradn(i,lat),i=1,3)
      write(3,*)
      write(6,*)
3000  format(I4,3F15.7)
      do 6 i=1,3
6     grade(i,lat)=grade(i,lat)+gradn(i,lat)
c
      write(3,*)' Total gradient:'
      write(6,*)' Total gradient:'
      do 9 lat=1,noa
      write(6,3000)lat,(grade(i,lat),i=1,3)
9     write(3,3000)lat,(grade(i,lat),i=1,3)
c
      call projectg(grade,3*noa,xv)
c
      write(3,*)' Total gradient, projected:'
      write(6,*)' Total gradient, projected:'
      do 10 lat=1,noa
      write(6,3000)lat,(grade(i,lat),i=1,3)
10    write(3,3000)lat,(grade(i,lat),i=1,3)
c
c     Add to the file GRAD.SCR:
      open(33,file='GRAD.SCR',form='unformatted')
      i=0
7     read(33,END=8)
      i=i+1
      goto 7
8     write(6,*)i,' gradients found in GRAD.SCR'
      write(3,*)i,' gradients found in GRAD.SCR'
      write(33)((grade(i,j),i=1,3),j=1,noa)
      close(33)
      write(3,*)'Gradient added and file closed'
      write(6,*)'Gradient added and file closed'
      call report('Leaving roa in gradhf')
      end
