      subroutine hell(ioe)
c
c     second energy derivatives according to Hellmann-Feynman theorem
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,ndm=10)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     ndm    maximum degree of degeneracy
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension do(nort,nort),dmoB(3*nat0,nort),dmoXY(6*nat0,nort),
     6ak(nort,nort),aj(nort,nort),fcar(nat0*3,nat0*3),
     8grade(3,nat0),gradn(3,nat0),fdar(nat0*3,nat0*3),
     9ffc(nat0*3,nat0*3),fpar(nat0*3,nat0*3)
      logical lscr,lx
      dimension jdeg(ndm),buff(nort,nort),temi(nort),temj(nort)
c
      ic7=0
      Ithree=3
      etol=0.00001D0
      ctol=1.0d-5
      call vz(fcar,z0,3*nat0*3*nat0)
      call vz(fpar,z0,3*nat0*3*nat0)
      call vz(fdar,z0,3*nat0*3*nat0)
      call vz(ffc,z0,3*nat0*3*nat0)
c
      write(3,4001)nmo,nao
4001  format(' Harmonic Force Field; NMO = ',I3,' NAO = ',I3)
      if(nao.gt.nort)call report('Too many orbitals for hell')
c
c     calculate Fij, i<j, get Fji from symmetry
c
      write(6,*)' The nuclear part ..'
      do 13 ia=1,noa
      qi=z(ia)
      i1=3*(ia-1)+1
      i2=i1+1
      i3=i2+1
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
      do 71 ij=1,noa
      if(ij.ne.ia)then
       xa=xi-xv(1,ij)
       ya=yi-xv(2,ij)
       za=zi-xv(3,ij)
       x2=xa*xa
       y2=ya*ya
       z2=za*za
       rij2=x2+y2+z2
       rij=sqrt(rij2)
       rij5=rij*rij2*rij2
       t=qi*z(ij)/rij5
       fcar(i1,i1)=fcar(i1,i1)+t*(two*x2-y2-z2)
       fcar(i2,i2)=fcar(i2,i2)+t*(two*y2-z2-x2)
       fcar(i3,i3)=fcar(i3,i3)+t*(two*z2-x2-y2)
       fcar(i1,i2)=fcar(i1,i2)+t*three*xa*ya
       fcar(i1,i3)=fcar(i1,i3)+t*three*xa*za
       fcar(i2,i3)=fcar(i2,i3)+t*three*ya*za
      endif
71    continue
      do 13 ja=ia+1,noa
      qj=z(ja)
      j1=3*(ja-1)+1
      j2=j1+1
      j3=j2+1
      xa=xi-xv(1,ja)
      ya=yi-xv(2,ja)
      za=zi-xv(3,ja)
      x2=xa*xa
      y2=ya*ya
      z2=za*za
      rij2=x2+y2+z2
      rij=sqrt(rij2)
      rij5=rij*rij2*rij2
      t=qi*qj/rij5
      fcar(i1,j1)=-t*(two*x2-y2-z2)
      fcar(i2,j2)=-t*(two*y2-z2-x2)
      fcar(i3,j3)=-t*(two*z2-x2-y2)
      fcar(i1,j2)=-t*three*xa*ya
      fcar(i1,j3)=-t*three*xa*za
      fcar(i2,j3)=-t*three*ya*za
      fcar(i2,j1)=fcar(i1,j2)
      fcar(i3,j1)=fcar(i1,j3)
13    fcar(i3,j2)=fcar(i2,j3)
c
c     read-in the coulomb and exchange terms
      if(ioe.eq.0)call inibe4
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       inquire(file='AKJK.SCR',exist=lscr)
       if(.not.lscr)call report('AKJK.SCR not found')
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
      inquire(file='MX.SCR',exist=lx)
      open(37,file='MX.SCR ',form='unformatted')
      open(38,file='MY.SCR ',form='unformatted')
      open(39,file='MZ.SCR ',form='unformatted')
      open(40,file='MOXX.SCR',form='unformatted')
      open(41,file='MOXY.SCR',form='unformatted')
      open(42,file='MOXZ.SCR',form='unformatted')
      open(43,file='MOYY.SCR',form='unformatted')
      open(44,file='MOYZ.SCR',form='unformatted')
      open(45,file='MOZZ.SCR',form='unformatted')
c
      if(.not.lx)THEN
c
c      First loop over atoms - calculate <K|grad|J>(MO), save it to MX,MY,MZ
       write(6,*)'no scratch files found for gradient, recalculate'
       write(3,*)'no scratch files found for gradient, recalculate'
       do 1313 lat=1,noa
       write(6,*)' Atom ',lat
       do 1212 ix=1,3
c
c      calculate ao integrals (i|gradH_^latix|j), put them in buff
       call overlagg(lat,ix,buff)
c
c      transform into MO basis and write into MXi.SCR:
       call taomo(buff,do,cij,nort,nort,nmo,nao,temi,temj,ctol)
       do 1212 imo=1,ndo
1212   write(37+ix-1)(do(imo,jmo),jmo=imo,nmo)
c
       ix=0
       do 1313 iax=1,3
       do 1313 jax=iax,3
       ix=ix+1
c
c      calculate ao integrals (i|grad_iax grad_jax H|j), put them in buff
       call overla22(lat,iax,jax,buff)
c      call overlaff(lat,iax,jax,buff)
c
c      transform buff into MO basis and write into Mij.SCR:
       call taomo(buff,do,cij,nort,nort,nmo,nao,temi,temj,ctol)
       do 1313 imo=1,ndo
1313   write(39+ix)(do(imo,jmo),jmo=imo,nmo)
       write(6,*)'MO transformation finished'
      ELSE
       write(6,*)'Disk MO gradients used'
       write(3,*)'Disk MO gradients used'
      ENDIF
c
      call vz(grade,z0,ithree*nat0)
c
c     sum over doubly-occupied orbitals:
      do 5 k=1,ndo
      wk=e(k)
c
c     read in <K|grad_l_i|J> and <K|grad_L_i grad_L_j|J> for all l,i,j,J
      do 7 irw=1,9
7     rewind irw+36
      do 1515 lat=1,noa
      do 1516 ix=1,3
      iii=3*(lat-1)+ix
      do 1516 kk=1,ndo
      if(kk.ne.k)then
       read(36+ix)
      else
       read(36+ix)(dmoB(iii,j),j=k,nmo)
      endif
1516  continue
c
      do 1515 ix=1,6
      iii=6*(lat-1)+ix
      do 1515 kk=1,ndo
      if(kk.ne.k)then
       read(39+ix)
      else
       read(39+ix)(dmoXY(iii,j),j=k,nmo)
      endif
1515  continue
c
      do 8 ix=1,3
      do 8 lat=1,noa
      iii=3*(lat-1)+ix
8     grade(ix,lat)=grade(ix,lat)+two*dmoB(iii,k)
c
c     diamagnetic part of FF
      ii=0
      do 9 lat=1,noa
      do 9 ix=1,3
      do 9 jx=ix,3
      ii=ii+1
      i1=3*(lat-1)+ix
      j1=3*(lat-1)+jx
9     fdar(i1,j1)=fdar(i1,j1)-two*dmoXY(ii,k)*z(lat)
c
c     sum over excited states = virtual orbitals
      do 6 j=ndo+1,nmo
      wj=e(j)
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies
      ejk0=wj-wk
c
c     check for degeneracy
      ndeg=0
      do 2 jj=ndo+1,nmo
      if(abs(wj-e(jj)).lt.0.001d0)then
       ndeg=ndeg+1
       jdeg(ndeg)=jj
      endif
2     continue
c
      if(ndeg.gt.2.and.ic7.eq.0)then
       ic7=1
       write(3,*)'higher degeneracy may not be implemented properly'
      endif
      if(ndeg.gt.ndm)call report('the degeneracy is higher than ndm')
c
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg)
       do ideg=1,ndeg
        ckj=ckj+aj(k,jdeg(ideg))*afac
        ekj=ekj+ak(k,jdeg(ideg))*aex*afac
       enddo
      endif
c
      wnj=ejk0-ckj+two*ekj
c
      if(wnj.lt.etol)goto 6
c
c     wnj - electroni excitation energy difference
c     ejk0 - MO energy difference
c
      ei=one/wnj
      e2i=ei+ei
      e4i=(e2i+e2i)
c     2(occupied)(=sqrt(2)(exc)^2)*2(definition)
      do 10 ia=1,noa
      do 10 ix=1,3
      i1=3*(ia-1)+ix
      do 10 ja=ia,noa
      js=1
      if(ia.eq.ja)js=ix
      do 10 jx=js,3
      j1=3*(ja-1)+jx
10    fpar(i1,j1)=fpar(i1,j1)-dmoB(i1,j)*dmoB(j1,j)*e4i
6     continue
c
5     continue
      do 12 ix=1,9
12    close(36+ix)
c
c     "Fermi contact" term of FF
      do 11 lat=1,noa
      aco=four/Three*Pi*z(lat)
      do 11 ix=1,3
      i1=3*(lat-1)+ix
      call  froxp(roxp,xv(1,lat),xv(2,lat),xv(3,lat),1,ndo,2,0,1)
11    ffc(i1,i1)=ffc(i1,i1)+roxp*aco
c
      write(3,*)'nuclear FF'
      call wrff(nat0,noa,fcar)
      write(3,*)'diamagnetic'
      call wrff(nat0,noa,fdar)
      write(3,*)'Fermi contact'
      call wrff(nat0,noa,ffc)
      do 1415 i=1,3*noa
      do 1415 j=1,i
1415  fdar(j,i)=fdar(j,i)+ffc(j,i)
      write(3,*)'Pure diamagnetic'
      call wrff(nat0,noa,fdar)
      write(3,*)'Paramagnetic'
      call wrff(nat0,noa,fpar)
c
      do 1414 i=1,3*noa
      do 1414 j=1,i
      fcar(j,i)=fcar(j,i)+fdar(j,i)+fpar(j,i)
1414  fcar(i,j)=fcar(j,i)
c
      write(3,*)'total'
      call wrff(nat0,noa,fcar)
c
      call vz(gradn,z0,ithree*nat0)
      write(3,*)' Gradient'
      do lat=1,noa
      do ia=1,noa
       r=sqrt((xv(1,lat)-xv(1,ia))**2+(xv(2,lat)-xv(2,ia))**2+
     1        (xv(3,lat)-xv(3,ia))**2)
       do ix=1,3
        if(ia.ne.lat)then
         gradn(ix,lat)=gradn(ix,lat)-z(lat)*z(ia)*
     1                (xv(ix,lat)-xv(ix,ia))/(r*r*r)
        endif
       enddo
      enddo
      write(3,3009)lat,(grade(ix,lat),ix=1,3),(gradn(ix,lat),ix=1,3),
     1grade(1,lat)+gradn(1,lat),
     1grade(2,lat)+gradn(2,lat),grade(3,lat)+gradn(3,lat)
3009  format('Atom ',I3,': Electronic: ',3F15.8,/,
     1       '     ',3X,'  Nuclear   : ',3F15.8,/,
     2       '     ',3X,'              ',45(1H-),/,
     3       '     ',3X,'  Total     : ',3F15.8,/)
      enddo
c
      call writeff(nat0,noa,fcar)
      WRITE(6,*)' FILE.FC written ...'
      WRITE(3,*)' FILE.FC written ...'
      return
      end
c

      SUBROUTINE WRITEFF(MX,NA,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FCAR(3*MX,3*MX)
c
      OPEN(15,FILE='FILE.FC')
      N=NA*3
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      DO 130 LN=N1,N
130   WRITE(15,17)LN,(FCAR(LN,J),J=N1,MIN(LN,N3))
      N1=N1+5
      IF(N3.LT.N)GOTO 1
17    FORMAT(I4,5D14.6)
      CLOSE(15)
      RETURN
      END
      SUBROUTINE WRFF(MX,NA,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FCAR(3*MX,3*MX)
      N=NA*3
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      WRITE(3,18)(J,J=N1,N3)
      DO 130 LN=1,N
130   WRITE(3,17)LN,(FCAR(LN,J),J=N1,N3)
      N1=N1+5
      IF(N3.LT.N)GOTO 1
17    FORMAT(I4,5D14.6)
18    FORMAT(4X,5I14)
      RETURN
      END
