      subroutine hfuzzy
c
c     gradient according to the Hellmann-Feynman theorem
c     with fuzzy nuclear charges
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,mmax=21)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension grade(3,nat0),gradn(3,nat0),buff(nort,nort),
     1eep(mmax)
      common/ropts/ropt(300)
      equivalence (ropt(2),rfuz)
      logical lsx,lsy,lsz
c
      tol=23.0d0
      atol=1.0d-10
      write(3,4001)nmo,nao,rfuz
4001  format(' Gradient according to the Hellmann-feynmann theorem',/,
     1' NMO = ',I3,' NAO = ',I3,/,'fuzzy nuclear charges ',f10.3,'au')
      if(nao.gt.nort)call report('Too many orbitals for gradhf')
c
      call inibe4
c
c     the nuclear part:
      al=1.0d0/rfuz**2
      aa=al+al
      hsp=one/aa
      bb=z0
      gg=aa
      hsq=one/gg
      dd=z0
      mmx=1
      lsx=.false.
      lsy=.false.
      lsz=.false.
      call vz(gradn,z0,3*noa)
      do 4 lat=1,noa
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      do 4 ia=1,noa
      xk=xv(1,ia)
      yk=xv(2,ia)
      zk=xv(3,ia)
      A2=z(lat)*z(ia)
      if(ia.ne.lat)then
       do 5 ix=1,3
       n1=0
       n2=0
       n3=0
       if(ix.eq.1)n1=1
       if(ix.eq.2)n2=1
       if(ix.eq.3)n3=1
       call iactivate(1,0,xl,yl,zl,xk,yk,zk,eep,
     1               pqx,pqy,pqz,hsp,hsq,tol)
       ooo=oce2(n1,n2,n3,0,0,0,0,0,0,0,0,0,
     1z0,z0,z0,z0,z0,z0,pqx,pqy,pqz, hsp,hsq,aa,bb,gg,dd,
     2mmx,eep,atol,lsx,lsy,lsz)
5      gradn(ix,lat)=gradn(ix,lat)-A2*2.0d0*al*ooo
      endif
4     continue
      write(6,*)' nuclear gradient:'
      do 64 lat=1,noa
64    write(6,*)(gradn(i,lat),i=1,3)
c
c
c     The electronic part
      call vz(grade,z0,3*noa)
c     Loop over atoms:
      do 1 lat=1,noa
      do 1 ix=1,3
c
c     calculate ao integrals (i|grad_lat_ixH|j), put them in buff
      call overlazz(lat,ix,buff)
c     call overlagg(lat,ix,buff1)
c     do i=1,nao
c     do j=1,nao
c     if(i.eq.1.and.j.eq.3)write(6,*)lat,ix,i,j,buff(i,j),buff1(i,j)
c     if(abs(buff(i,j)-buff1(i,j)).gt.0.01d0)then
c      write(6,*)lat,ix,i,j,buff(i,j),buff1(i,j)
c      write(6,*)'YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY'
c      read(5,*)ipp
c     endif
c     enddo
c     enddo
c
c     transform into MOs and gather controbutions from occupied orbs
      do 1 k=1,ndo
      gkk=z0
      do 2 i=1,nao
      cki=cij(k,i)
      gkk=gkk+cki*cki*buff(i,i)
      sum=z0
      do 3 j=1,i-1
3     sum=sum+cki*cij(k,j)*buff(j,i)
2     gkk=gkk+sum+sum
c
1     grade(ix,lat)=grade(ix,lat)+gkk+gkk
      write(6,*)' electronic gradient:'
      do 65 lat=1,noa
65    write(6,*)(grade(i,lat),i=1,3)
c
      write(3,*)' Electronic and nuclear gradient:'
      do 6 lat=1,noa
      write(3,3000)lat,(grade(i,lat),i=1,3)
      write(3,3000)lat,(gradn(i,lat),i=1,3)
      write(3,*)
3000  format(I4,3F15.7)
      do 6 i=1,3
6     grade(i,lat)=grade(i,lat)+gradn(i,lat)
c
      write(3,*)' Total gradient:'
      write(6,*)' Total gradient:'
      do 9 lat=1,noa
      write(6,3000)lat,(grade(i,lat),i=1,3)
9     write(3,3000)lat,(grade(i,lat),i=1,3)
c
      call projectg(grade,3*noa,xv)
c
      write(3,*)' Total gradient, projected:'
      write(6,*)' Total gradient, projected:'
      do 10 lat=1,noa
      write(6,3000)lat,(grade(i,lat),i=1,3)
10    write(3,3000)lat,(grade(i,lat),i=1,3)
c
c     Add to the file GRAD.SCR:
      open(33,file='GRAD.SCR',form='unformatted')
      i=0
7     read(33,END=8)
      i=i+1
      goto 7
8     write(6,*)i,' gradients found in GRAD.SCR'
      write(3,*)i,' gradients found in GRAD.SCR'
      write(33)((grade(i,j),i=1,3),j=1,noa)
      close(33)
      write(3,*)'Gradient added and file closed'
      write(6,*)'Gradient added and file closed'
      call report('Leaving roa in gradhf')
      end
