      subroutine initfd(aa1,aad,aaf,aag,aah,aai)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      integer*4 u0
      parameter (u0=28)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension aa1(u0,u0),aad(u0,u0),aaf(u0,u0)
      dimension aag(u0,u0),aah(u0,u0),aai(u0,u0)
      logical lopt,lturbo
      common/opts/lopt(300),icha,n1
      equivalence (lopt(68),lturbo)
      real*8,allocatable::Coef2P(:,:),Coef2C(:,:)
c
      do 77 i=1,u0
      do 77 j=1,u0
      aa1(i,j)=z0
      aad(i,j)=z0
      aaf(i,j)=z0
      aag(i,j)=z0
      aah(i,j)=z0
      aai(i,j)=z0
77    aa1(i,i)=one
c
c      Special treatment of the "true" D and F orbitals:
c
c      Ds are calculated in the Cadpac/cartesian order, then transformed
c      into the G94/spherical form
c
c       G94 order          Cadpac order   Turbomole order
c       --------------------------------
c       3z^2-R^2      1      xx             d0  = (-xx-yy+2zz)/sqrt(12)
c       xz            2      yy             d1a = xz
c       yz            3      zz             d1b = yz
c       x^2-y^2       4      xy             d2a = xy
c       xy            5      xz             d2b = (xx-yy)/2
c       -             6      yz
c     cartesian versus spherical Ds:
c       1      2      3      4     5     6
c       xx    yy     zz     xy    xz    yz
c
c 1    -d1   -d1   2*d1      0     0     0
c 2      0     0      0      0     1     0
c 3      0     0      0      0     0     1
c 4     d5   -d5      0      0     0     0
c 5      0     0      0      1     0     0
c
c     |normalized z^2-r^2> = d1*(two*|norm.zz>-|norm.xx>-|norm.yy>)
      d1=half
      st=sqrt(three)
      sf=sqrt(five)
c     |normalized x^2-y^2> = d5*(|norm.xx>-|norm.yy>)
      d5=st*half
      aad(1,1)=-d1
      aad(1,2)=-d1
      aad(1,3)=two*d1
      aad(2,5)=one
      aad(3,6)=one
      if(lturbo)then
       aad(5,1)=d5
       aad(5,2)=-d5
       aad(4,4)=one
      else
       aad(4,1)=d5
       aad(4,2)=-d5
       aad(5,4)=one
      endif
c
C      F-orbitals
c       spherical           cartesian
c       --------------------------------
c        5z^3-3R^2z           1      xxx
c        x(5z^2-R^2)          2      yyy
c        y(5z^2-R^2)          3      zzz
c        xyz                  4      xxy
c        z(x^2-y^2)           5      xxz
c        y(y^2-3x^2)          6      yyx
c        x(x^2-3y^2)          7      yyz
c        -                    8      zzx
c        -                    9      zzy
c        -                   10      xyz
c     cartesian versus spherical Fs:
c    non-normalized functions in the table:
c      1      2      3      4      5      6     7      8      9     10
c     xxx   yyy    zzz    xxy    xxz    yyx   yyz    zzx    zzy    xyz
c1      0     0      2      0     -3      0    -3      0      0      0
c2     -1     0      0      0      0     -1     0      4      0      0
c3      0    -1      0     -1      0      0     0      0      4      0
c4      0     0      0      0      1      0    -1      0      0      0
c5      0     0      0      0      0      0     0      0      0      1
c6      1     0      0      0      0-1391.72064776868     -3     0      0      0      0
c7      0    -1      0      3      0      0     0      0      0      0
c     normalization factors for spherical Fs
      f1=half/sf
      f2=half*st/sqrt(a10)
      f3=half*st/sqrt(a10)
      f4=st*half
      f5=one
      f6=half/sqrt(two)
      f7=half/sqrt(two)
c     expansion into normalized cartesians:
      aaf(1, 3)= f1 * two * sf
      aaf(1, 5)=-f1 * three
      aaf(1, 7)=-f1 * three
      aaf(2, 1)=-f2 * sf
      aaf(2, 6)=-f2
      aaf(2, 8)= f2 * four
      aaf(3, 2)=-f3 * sf
      aaf(3, 4)=-f3
      aaf(3, 9)= f3 * four
      aaf(4, 5)= f4
      aaf(4, 7)=-f4
      aaf(5,10)= f5
      aaf(6, 1)= f6 * sf
      aaf(6, 6)=-f6 * three
      aaf(7, 2)=-f7 * sf
      aaf(7, 4)= f7 * three
c     g,h,i-functions (f for control):
      DO 1 L=1,6
      MCart = ((L+1)*(L+2))/2
      MPure = 2*L+1
      allocate(Coef2P(MCart,MPure),Coef2C(MCart,MPure))
      Call C2PGn1(L,MCart,MPure,Coef2P,Coef2C)
      ia=0
      do 2 m =0,l
      if(m.eq.0)then
       imend=1
      else
       imend=2
      endif
      do 2 im=1,imend
c     im=1 (|lm>+|l-m>/sqrt( 2)
c     im=2 (|lm>-|l-m>/sqrt(-2)
      ia=ia+1
      ix=0
      do 2 Lx=0,L
      do 2 Ly=0,(L-Lx)
      Lz=L-Lx-Ly
      ix=ix+1
      if(L.eq.3)then
c      write(6,6009)LX,LY,LZ,ix,ia,Coef2P(ix,ia),aaf(ia,ix)
c6009   format(3i2,1x,2i3,4f12.6)
      endif
      if(L.eq.4)aag(ia,ix)=Coef2P(ix,ia)
      if(L.eq.5)aah(ia,ix)=Coef2P(ix,ia)
2     if(L.eq.6)aai(ia,ix)=Coef2P(ix,ia)
1     deallocate(Coef2P,Coef2C)

      return
      end
c     ==================================================
      function c2pcff(L,M,Lx,Ly)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
c
c     Generate coefficients for conversion from normalized cartesian
c     gaussians to pure spherical harmonics
c
c     v(L,M) = Sum c2pcff(L,M,Lx,Ly,fac) v(Lx,Ly,Lz)
c          (Lx=0,L;Ly=0,L-Lx)
c
c     L,M  for spherical harmonic
c     Lx,Ly,Lz=L-Lx-Ly for cartesian
c     fac(n) = n!
c
c     H. B. Schlegel  May 1994
c
      Save Zero, Two
      Data Zero/0.D0/, Two/2.D0/
      real*8 fac
C
      Lz = L - Lx - Ly
      Ma = IAbs(M)
      c2pcff = Zero
      If(Ma.gt.L.or.Lz.lt.0) Return
      a = Sqrt(fac(2*Lx)*fac(2*Ly)*fac(2*Lz)*fac(L)/
     $  (fac(2*L)*fac(Lx)*fac(Ly)*fac(Lz)))
      b = Sqrt(fac(L-Ma)/fac(L+Ma))/((2**L)*fac(L))
      ilim = (L-Ma)/2
      j = (L-Ma-Lz)/2
      g = Zero
      If((2*j).eq.(L-Ma-Lz)) then
        do 20 i = 0, ilim
          c = Zero
          If(j.ge.0.and.j.le.i) then
            c = (fac(L)/(fac(i)*fac(L-i)))*
     $        (fac(2*L-2*i)*((-1)**i)/fac(L-Ma-2*i))*
     $        (fac(i)/(fac(j)*fac(i-j)))
            do 10 k = 0, j
              d = Zero
              If((Lx-2*k).ge.0.and.(Lx-2*k).le.Ma) then
                d = (fac(j)/(fac(k)*fac(j-k)))*
     $            (fac(Ma)/(fac(Lx-2*k)*fac(Ma+2*k-Lx)))
                e = Zero
                kmLx2 = k - Lx/2
                If(M.eq.0.and.mod(Lx,2).eq.0) e=(-1)**kmLx2
                kTMaLx = ((2*k+Ma-Lx)/2)
                If(M.gt.0.and.mod(IAbs(Ma-Lx),2).eq.0)
     $            e = Sqrt(Two)*(-1)**kTMaLx
                If(M.lt.0.and.mod(IAbs(Ma-Lx),2).eq.1)
     $            e = Sqrt(Two)*(-1)**kTMaLx
                g = g + c*d*e
                endIf
   10         Continue
            endIf
   20     Continue
        endIf
      c2pcff = a*b*g
      Return
      End
c     ==================================================
      Subroutine C2PGen(LMax,Coef2P,Coef2C)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
c
c  Generate the transformation coefficients to transform between
c  normalized cartesian gaussians to normalized spherical harmonics
c
c  coef2p L(L+1)/2 by (2L+1) blocks of transformation matricies
c         from cartesian to pure.
c  coef2c L(L+1)/2 by (2L+1) blocks of transformation matricies
c         from pure to cartesian.
c         Individual values coef2p and coef2c are calculated by c2pcff.
c  fac    scratch array, length 2 Lmax + 1 (real)
c  Lmax   highest angular momentum to transform
c
c     The block for L starts at 1+ L(L+1)(L+2)(3L-1)/12,
c     and within a block, the cartesian index runs fastest
c
c     Pure functions v(L,M) are in the order:
c
c         v(0,0),v(1,0),v(1,1m),v(1,1p),v(2,0),v(2,1m),v(2,1p), etc
c
c         where v(L,ip) = (v(L,i)+v(L,-i))/Sqrt(2)
c               v(L,im) = (v(L,i)-v(L,-i))/Sqrt(-2)
c
c     Cartesian functions v(Lx,Ly,Lz) are in the Prism order:
c
c         v(0,0,0)
c
c         v(0,0,1),v(0,1,0),v(1,0,0)
c
c         v(0,0,2),v(0,1,1),v(0,2,0),v(1,0,1),v(1,1,0),v(2,0,0)
c
c         v(0,0,3),v(0,1,2),v(0,2,1),v(0,3,0),v(1,0,2),v(1,1,1),
c          v(1,2,0),v(2,0,1),v(2,1,0),v(3,0,0)
c
c         v(0,0,4),v(0,1,3),v(0,2,2),v(0,3,1),v(0,4,0),v(1,0,3),
c          v(1,1,2),v(1,2,1),v(1,3,0),v(2,0,2),v(2,1,1),v(2,2,0),
c          v(3,0,1),v(3,1,0),v(4,0,0)
c
c         etc
c
c     H. B. Schlegel  May 1994
c
      dimension  coef2p(*),coef2c(*)
      Save One
      Data One/1.D0/
c
c     loop over L
c
      Do 20 L = 0, LMax
      MCart = ((L+1)*(L+2))/2
      MPure = 2*L+1
      Call C2PGn1(L,MCart,MPure,Coef2P,Coef2C)
   20 Continue
      Return
      End
c     ==================================================
      Subroutine C2PGn1(L,MCart,MPure,Coef2P,Coef2C)
      Implicit Real*8(A-H,O-Z)
      implicit integer*4 (i-n)
      Dimension Coef2P(MCart,MPure), Coef2C(MCart,MPure)
      real*8 fac
c
c     M=0 case
c
      Call AClear(MCart*MPure,Coef2C)
      lxyz = 0
      do 10 Lx = 0, L
      do 10 Ly = 0, (L-Lx)
      Lz = L-Lx-Ly
      lxyz = lxyz+1
      coef2p(lxyz,1) = c2pcff(L,0,Lx,Ly)
      Do 10 M = 1, L
      coef2p(lxyz,2*M) = c2pcff(L,M,Lx,Ly)
   10 coef2p(lxyz,2*M+1) = c2pcff(L,-M,Lx,Ly)
c
c     compute the overlap and form coef2c
c
      i = 0
      do 230 Lx1 = 0, L
        do 230 Ly1 = 0, (L-Lx1)
          Lz1 = L - Lx1 - Ly1
          i = i + 1
          j = 0
          a1 = Sqrt(fac(Lx1)*fac(Ly1)*fac(Lz1)/
     $      (fac(2*Lx1)*fac(2*Ly1)*fac(2*Lz1)))
          do 220 Lx2 = 0, L
            do 220 Ly2 = 0, (L-Lx2)
              Lz2 = L - Lx2 - Ly2
              j = j + 1
              a2 = Sqrt(fac(Lx2)*fac(Ly2)*fac(Lz2)/
     $          (fac(2*Lx2)*fac(2*Ly2)*fac(2*Lz2)))
              Lx = Lx1 + Lx2
              Ly = Ly1 + Ly2
              Lz = Lz1 + Lz2
              if(mod(Lx,2).eq.0.and.mod(Ly,2).eq.0.and.mod(Lz,2).eq.0)
     $        then
                s = a1*a2*fac(Lx)*fac(Ly)*fac(Lz)/
     $            (fac(Lx/2)*fac(Ly/2)*fac(Lz/2))
                do 210 k = 1, mpure
  210             coef2c(i,k) = coef2c(i,k)+s*coef2p(j,k)
                endIf
  220         Continue
  230     Continue
      Return
      End
      
      function fac(n)
      implicit none
      real*8 fac,f,fi
      integer*4 n,i
      f=1.0d0
      if(n.lt.2)goto 99
      fi=1.0d0
      do 1 i=2,n
      fi=fi+1.0d0
1     f=f*fi
99    fac=f
      return
      end

