      subroutine lookl(u)
c
c     read-in local orbitals
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      logical lex,lopt,levprint
      common/opts/lopt(300),icha,n1
      common/ropts/ropt(300)
      common/iopts/iopt(300)
      common/d1008/cl(nort,nort),s(nort,nort),ss(nort,nort)
      dimension u(nort,nort)
      equivalence (lopt(5),levprint)
      equivalence (iopt(32),ibiter)
      equivalence (ropt(22),btol)
c
      inquire(file='LOMOS.SCR',exist=lex)
      if(.not.lex)call boyso2(1,1,6,btol,ibiter)
      call w36('LOMOS.SCR found')
      open(89,file='LOMOS.SCR',form='unformatted')
      read(89)nbl,nol
      read(89)
      read(89)((cl(j1,i1),i1=1,nbl),j1=1,nol)
      read(89)
      read(89)
      close(89)
c
      write(3,3000)nbl,nol
      write(6,3000)nbl,nol
3000  format(i5,' AOs ',i4,' LOS found in LOMOS.SCR')
      if(nao.ne.nbl)call report('Different number of AOs')
c
      if(levprint)then
       do 3 i=1,nol
       write(3,*)' orbital ',i
3      write(3,3001)(cl(i,j),j=1,nbl)
3001   format(8f10.5)
      endif
c
      inquire(file='UKKP.SCR',exist=lex)
      if(lex)then
       open(89,file='UKKP.SCR', form='unformatted')
       read(89)nmo,nol
       read(89)((u(j,i),i=1,nmo),j=1,nol)
       close(89)
       return
      endif
c
      open(33,file='SAO.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(s(i,j),j=1,i)
      do 2 j=1,i-1
2     s(j,i)=s(i,j)
1     continue
      close(33)
c
c     1) ssKi = <i|j><j|k>
      do 8 k=1,nmo
      do 8 i=1,nao
      sum=0.0d0
      do 9 j=1,nao
9     sum=sum+s(i,j)*cij(k,j)
8     ss(k,i)=sum
c
c     1) UkK = <K|i><i|j><j|k> k...localize, K .. canonical
      do 10 k=1,nmo
      do 10 kp=1,nol
      sum=0.0d0
      do 11 j=1,nao
11    sum=sum+ss(k,j)*cl(kp,j)
10    u(kp,k)=sum
c
c     orthogonalize
      if(levprint)then
       write(3,*)'Raw U coefficients:'
       do k=1,nol
        write(3,*)k
        write(3,3001)(u(k,i),i=1,nmo)
       enddo
      endif

      do 14 kp=1,nol
      do 18 kpp=1,kp-1
      sp=0.0d0
      do 16 k=1,nmo
16    sp=sp+u(kp,k)*u(kpp,k)
      do 18 k=1,nmo
18    u(kp,k)=u(kp,k)-sp*u(kpp,k)
      anorm=0.0d0
      do 15 k=1,nmo
15    anorm=anorm+u(kp,k)**2
      anorm=1.0d0/sqrt(anorm)
      do 14 k=1,nmo
14    u(kp,k)=u(kp,k)*anorm
      write(3,*)'Us have been reorthogonalized'
c
      open(89,file='UKKP.SCR', form='unformatted')
      write(89)nmo,nol
      write(89)((u(j,i),i=1,nmo),j=1,nol)
      if(levprint)then
       write(3,*)'Orthogonalized coefficients MO-LMO:'
       do k=1,nol
        write(3,*)k
        write(3,3001)(u(k,i),i=1,nmo)
       enddo
      endif
      close(89)
c
      return
      end
