      SUBROUTINE mitin5(M,NE,ELMAX,D,IERR,MV,J1,N,ist)
clbej
C
C     by Petr Bour, Prague 1994
C
C     This subroutine finds few of lowest eigenvectors for a
C     very large matrix A, elements done on the fly
C     Diagonal terms are already divided by two in A
C     M is soft dimension of the subspace where direct diagonalization is done
C     NE is number of eigenvectors to be found
c     ELAMX is maximal eigenvalue
c     D is string of eigenvalues
c     IERR is >0 when maximum of iterations is reached
C     MV is the number of eigenvectors that have been found
c     J1 ... start from this eigenvalue
C
C     For details look at
C     Alexander V. Mitin, J.Comp.Chem., Vol. 15, No.7, (1994), 747-751
C     (Warning: The paper is full of missprints; the recommended procedure
C      is modified here.)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (NSS=10,nhcir=100000,NM0=nhcir)
      common/sklad1/X(NM0,NSS)
      common/sklad2/AXV(NM0,NSS)
      common/sklad3/Y(NM0),YNEW(NM0),j33(NM0),a33(NM0),Y7(NM0)
      DIMENSION E(NSS),F(NSS,NSS),DUM(1),
     1D(NE),Z(NSS,NSS),ZZ(NSS),ESEND(NSS)
      common/iopts/iopt(300)
      equivalence (igradc,iopt(18))
      LOGICAL lex
c
      write(6,*)'mitind-5 -experimental (semi-direct) starts'
      write(3,*)'mitind-5 -experimental (semi-direct) starts'
c
      AMACH=1.0d-14
      GRADCONV=exp(-dble(igradc)*log(10.0d0))
      OLIMIT=1.0d-6
c
      ELAST=-1.0d6
      IERR=0
      ANORM=0.0d0
      DIAG=0.0d0
c
      if(ist.eq.1)OPEN(45,FILE='EV.SCR',FORM='UNFORMATTED')
      if(ist.eq.3)OPEN(45,FILE='EVT.SCR',FORM='UNFORMATTED')
      amax=0.0d0
      if(ist.eq.1)inquire(file='A.SCR',exist=lex)
      if(ist.eq.3)inquire(file='AT.SCR',exist=lex)
      if(.not.lex.and.ist.eq.1)call report('A.SCR not found')
      if(.not.lex.and.ist.eq.3)call report('AT.SCR not found')
      if(ist.eq.1)open(49,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(49,file='AT.SCR',form='unformatted')
      read(49)nd
      if(nd.ne.N)call report('nd<>N')
      DO 2229 I=1,N
      read(49)nn,(a33(ii),ii=1,nn),(j33(ii),ii=1,nn)
      DIAG=DIAG+ABS(a33(1))
      d(i)=a33(1)
      DO 2229 ii=1,nn
      if(abs(a33(ii)).gt.amax)amax=a33(ii)
2229  ANORM=ANORM+ABS(a33(ii))
      close(49)
c
      write(6,*)'passed dimension of subspace: ',M
      IF(N.LT.M.OR.NSS.LT.M)THEN
       M=MIN(N,NSS)
       WRITE(6,*)' Sub-space dimension decreased to = ',M
       WRITE(3,*)' Sub-space dimension decreased to = ',M
      ENDIF
      MSAVE=M
      ANORM=2.0d0*ANORM/(REAL(N*(N-1)))
      DIAG=DIAG/REAL(N)*2.0d0
      ALCONV=GRADCONV*MAX(DIAG,ANORM)*REAL(N)
      MAXIT=1000+(N/M)*(N/M)
      WRITE(3,3003)ANORM,DIAG,amax,ALCONV,OLIMIT,MAXIT,N,M,J1,NE,ELMAX
      WRITE(6,3003)ANORM,DIAG,amax,ALCONV,OLIMIT,MAXIT,N,M,J1,NE,ELMAX
3003  FORMAT(' Average magnitude of matrix el. :',F20.10,/,
     1       ' Average diagonal element        :',F20.10,/,
     1       ' Maximum component of A          :',F20.10,/,
     2       ' Convergence criterium           :',F20.10,/,
     3       ' Cut-off norm for subspace       :',F20.10,/,
     4       ' Maximum number of iterations    :',I20,/,
     5       ' Dimension of the matrix space   :',I20,/,
     6       ' Dimension of the iterative space:',I20,/,
     8       ' Start from eigenvalue           :',I20,/,
     8       ' Number of vectors to be found   :',I20,/,
     8       ' Upper limit for eigenvalues     :',F20.10,/,/)
c
      if(ist.eq.1)inquire(file='ECI.SCR',exist=lex)
      if(ist.eq.3)inquire(file='ECIT.SCR',exist=lex)
      if(ist.eq.1)OPEN(4,FILE='ECI.SCR',FORM='UNFORMATTED')
      if(ist.eq.3)OPEN(4,FILE='ECIT.SCR',FORM='UNFORMATTED')
      if(lex)then
       READ(4)NDONE
       write(6,*)NDONE, ' eigenvalues found on disk'
       write(3,*)NDONE, ' eigenvalues found on disk'
       DO 444 IEE=1,NDONE
444    READ(4)D(IEE)
       J1=NDONE+1
      endif
      close(4)
c
C     Starting dimension of the subspace:
      MSTART=M
      IC7=0
c
      DO 5555 IE=J1,MIN(N,NE)
c
C     Estimate starting eigenvalue and eigenvector:
      EL=D(i)
      do i=1,n
       YNEW(i)=1.0d0
      enddo
      if(IC7.ne.0)then
       EL=E7
       do i=1,n
        YNEW(i)=Y7(i)
       enddo
      endif
c
C     Orthonormalize to previous eigenvectors Y1..YIE-1:
      REWIND 45
      DO 71 IN=1,IE-1
      READ(45)(Y(I),I=1,N)
      SN=0.0d0
      DO 61 I=1,N
61    SN=SN+Y(I)*YNEW(I)
      DO 71 I=1,N
71    YNEW(I)=YNEW(I)-SN*Y(I)
c
      ANORM=0.0d0
      DO 101 I=1,N
101   ANORM=ANORM+YNEW(I)**2
      ANORM=1.0d0/SQRT(ANORM)
      DO 51 I=1,N
      YNEW(I)=YNEW(I)*ANORM
51    X(I,1)=YNEW(I)
c
      ITER=0
      DELL=0.0d0
      M=MSTART
C
C     Start of the iterative cycle:
C
9999  ITER=ITER+1
      IF(ITER.GT.MAXIT)THEN
       call w36(' Maximum number of iterations exceeded')
       IERR=8888
       GOTO 8888
      ENDIF
      IF(M+IE-1.GT.N)THEN
       WRITE(3,*)' Subspace-dimension has to be decreased'
       M=N-IE+1
       IF(M.LT.1)THEN
        WRITE(3,*)'  No subspace for the eigenvector left !'
        WRITE(3,*)' Try to increase the subspace-dimension.'
        GOTO 6666
       ENDIF
      ENDIF
C     Form gradient vectors Xk,k=2..M, new basis: {X1,..,Xk}
C     Xk+1=AXk-EL.Xk  (Xk,K>1 generated by X1)
      DO 201 I=1,N
      DO 201 K=1,M
201   AXV(I,K)=0.0d0
      DO 3 K=2,M
c
      if(ist.eq.1)open(49,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(49,file='AT.SCR',form='unformatted')
      read(49)ndum
      DO 20 I=1,N
c     read non-zero components
      read(49)nn,(a33(ii),ii=1,nn),(j33(ii),ii=1,nn)
      DO 20 ii=1,nn
      J=j33(ii)
      AXV(J,K-1)=AXV(J,K-1)+a33(ii)*X(I,K-1)
20    AXV(I,K-1)=AXV(I,K-1)+a33(ii)*X(J,K-1)
      close(49)
c
C     Gradient vectors
      DO 2031 I=1,N
2031  X(I,K)=AXV(I,K-1)-EL*X(I,K-1)
c
C     Orthogonalize vector XK to vectors XIN, IN=1..K-1 (including trial eigv):
      DO 7 IN=1,K-1
      SN=0.0d0
      DO 6 I=1,N
6     SN=SN+X(I,IN)*X(I,K)
      DO 7 I=1,N
7     X(I,K)=X(I,K)-SN*X(I,IN)
c
C     Orthogonalize vector XK to previous eigenvectors Xin, in=1..IE-1
      REWIND 45
      DO 72 IN=1,IE-1
      READ(45)(Y(I),I=1,N)
      SN=0.0d0
      DO 62 I=1,N
62    SN=SN+Y(I)*X(I,K)
      DO 72 I=1,N
72    X(I,K)=X(I,K)-SN*Y(I)
c
C     Normalize vector K:
      ANORM=0.0d0
      DO 10 I=1,N
10    ANORM=ANORM+X(I,K)*X(I,K)
c
C     Check on convergence on gradient=norm of second trial vector:
      IF(K.EQ.2)THEN
       CONV=ANORM
       IF(CONV.LT.ALCONV)GOTO 8888
      ENDIF
      ANORM=1.0d0/SQRT(ANORM)
      DO 5 I=1,N
5     X(I,K)=X(I,K)*ANORM
3     CONTINUE
      if(ist.eq.1)open(49,file='A.SCR',form='unformatted')
      if(ist.eq.3)open(49,file='AT.SCR',form='unformatted')
      read(49)ndum
      DO 204 I=1,N
      read(49)nn,(a33(ii),ii=1,nn),(j33(ii),ii=1,nn)
      DO 204 ii=1,nn
      J=j33(ii)
      AXV(I,M)=AXV(I,M)+a33(ii)*X(J,M)
204   AXV(J,M)=AXV(J,M)+a33(ii)*X(I,M)
      close(49)
C     Now looking for new eigenvector in the subspace of {Xk}
C     Form the sub-space matrix F=X.A.X:
      DO 21 II=1,M
      DO 21 JJ=1,II
      SUM=0.0d0
      DO 211 I=1,N
211   SUM=SUM+AXV(I,II)*X(I,JJ)
21    F(II,JJ)=SUM
c
C     Diagonalize the sub-space directly:
      IEIG=2
      call TRED12(M,F,Z,E,IEIG,IERR,NSS,ESEND)
C     Take the lowest eigenvalue:
      EL=E(1)
      IC7=1
      E7=E(2)
      DO 25 I=1,M
25    ZZ(I)=Z(I,1)
      WRITE(6,6007)ITER,EL,CONV,M
6007  FORMAT(' It=',I4,' Lambda=',F20.10,' Grad=',F20.10,' M=',I3)
      DELL=ABS(ELAST-EL)
      ELAST=EL
c
C     New approximation to the eigenvector:
      DO 24 I=1,N
      SUM=0.0d0
      SUM7=0.0d0
      DO 13 J=1,M
      XIJ=X(I,J)
      SUM7=SUM7+Z(J,2)*XIJ
13    SUM=SUM+ZZ(J)*XIJ
      X(I,1)=SUM
      Y7(I)=SUM7
24    YNEW(I)=SUM
c
C     Check occasional fault of direct diagonalization:
      ANORM=0.0d0
      DO 224 I=1,N
224   ANORM=ANORM+YNEW(I)**2
      IF(ANORM.LT.AMACH)THEN
       DO 225 I=1,N
       X(I,1)=1.0d0/SQRT(REAL(N))
225    YNEW(I)=X(I,1)
      ENDIF
c
      IF(M.EQ.1)THEN
       WRITE(3,*)'Last eigenvector left'
       GOTO 8888
      ENDIF
C
      GOTO 9999
8888  WRITE(3,6000)IE,ITER-1,CONV,EL,ALCONV,DELL
      WRITE(6,6000)IE,ITER-1,CONV,EL,ALCONV,DELL
6000  Format(
     1' *************** The ',I3,'. eigenvalue ******************',/,
     2' Iter',I6,' Gradient   : ',F20.10,' Lambda  : ',F20.10,/,
     3'     ',6X,' Limit grad.: ',F20.10,' Del Lam.: ',F20.10,/,/)
6001  format(' Diagonalization time: ',I10,' sec.')
      MV=IE
      D(IE)=EL
C     Save values & vectors into scratch-files:
      REWIND 45
      DO 1003 J=1,IE-1
1003  READ(45)
      WRITE(45)(YNEW(I),I=1,N)
      if(ist.eq.1)OPEN(4,FILE='ECI.SCR',FORM='UNFORMATTED')
      if(ist.eq.3)OPEN(4,FILE='ECIT.SCR',FORM='UNFORMATTED')
      WRITE(4)IE
      DO IEE=1,IE
       WRITE(4)D(IEE)
      ENDDO
      CLOSE(4)
c
      j1a=1
      y1a=abs(YNEW(1))
      do J=2,N
       if(abs(YNEW(J)).gt.y1a)then
        j1a=J
        y1a=abs(YNEW(J))
       endif
      enddo
      j2a=1
      y2a=abs(YNEW(1))
      if(j2a.eq.j1a)then
       j2a=2
       y2a=abs(YNEW(2))
      endif
      do J=2,N
       if(abs(YNEW(J)).gt.y2a.and.J.ne.j1a)then
        j2a=J
        y2a=abs(YNEW(J))
       endif
      enddo
      write(6,9006)YNEW(j1a),j1a,YNEW(j2a),j2a
      write(3,9006)YNEW(j1a),j1a,YNEW(j2a),j2a
9006  format(' Maximum contributions: ',2(F8.4,' of ',i6,';   '))
c
      IF(EL.GT.ELMAX) GOTO 6666
5555  CONTINUE
6666  M=MSAVE
      CLOSE(45)
      RETURN
      END
c
