      subroutine mu
c     calculates dipole moment
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension pix(nort),piy(nort),piz(nort)
      amux=z0
      amuy=z0
      amuz=z0
      write(3,3000)nao,nsa,nsb,ndo
3000  format('nao nsa nsb ndo:',4i12)
      open(33,file='P.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(pix(j),j=1,nao)
      read(33)(piy(j),j=1,nao)
      read(33)(piz(j),j=1,nao)

      do 1 j=1,nao
      do 111 imo=1,ndo
      ff=cij(imo,i)*cij(imo,j)*2.0d0
      amux=amux-ff*pix(j)
      amuy=amuy-ff*piy(j)
111   amuz=amuz-ff*piz(j)
      do 11 imo=1,nsa
      ff=cij(imo,i)*cij(imo,j)
      amux=amux-ff*pix(j)
      amuy=amuy-ff*piy(j)
11    amuz=amuz-ff*piz(j)
      do 1 imo=1,nsb
      ff=bij(imo,i)*bij(imo,j)
      amux=amux-ff*pix(j)
      amuy=amuy-ff*piy(j)
1     amuz=amuz-ff*piz(j)

      close(33)
      ax=z0
      ay=z0
      az=z0
      do 2 i=1,noa
      ax=ax+xv(1,i)*z(i)
      ay=ay+xv(2,i)*z(i)
2     az=az+xv(3,i)*z(i)
      dx=amux+ax
      dy=amuy+ay
      dz=amuz+az
      dd=sqrt(dx*dx+dy*dy+dz*dz)
      write(3,*)
      write(3,*)' Dipole moment in atomic units:'
      write(3,4000)amux,amuy,amuz,ax,ay,az,dx,dy,dz,dd
4000  format(/,'                          ',15x,'X',15x,'Y',15x,'Z',/,
     1         '               electronic ',3F16.8,/,
     1         '                  nuclear ',3F16.8,/,
     2         '                          ',48(1H-),/,
     3         '                    total ',3F16.8,/,
     4         '                      |u| ', F16.8,/)
      write(3,*)' Dipole moment in Debyes:'
      debye=2.541765d0
      write(3,4000)amux*debye,amuy*debye,amuz*debye,
     1ax*debye,ay*debye,az*debye,dx*debye,dy*debye,dz*debye,dd*debye
c
      return
      end
C     ============
      subroutine charge(ic)
c     calculates charge, for debugging
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      logical lopt,lnno
      common/opts/lopt(300),icha,n1
      equivalence (lopt(57),lnno)
      dimension s(nort)
c
      qn=z0
      do 2 i=1,noa
2     qn=qn+z(i)
c
      qe=0.0d0
c
      open(33,file='SAO.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(s(j),j=1,i)
      do 11 k=1,ndo
      do 11 j=1,i
      if(j.eq.i)then
       ff=2.0d0
      else
       ff=4.0d0
      endif
11    qe=qe-cij(k,i)*cij(k,j)*s(j)*ff
      do 12 k=1,nsa
      do 12 j=1,i
      if(j.eq.i)then
       ff=1.0d0
      else
       ff=2.0d0
      endif
12    qe=qe-cij(k,i)*cij(k,j)*s(j)*ff
      do 13 k=1,nsb
      do 13 j=1,i
      if(j.eq.i)then
       ff=1.0d0
      else
       ff=2.0d0
      endif
13    qe=qe-bij(k,i)*bij(k,j)*s(j)*ff
1     continue
      close(33)

      dt=qn+qe
      write(6,4000)nsa,nsb,ndo,nao,qe,qn,dt
      write(3,4000)nsa,nsb,ndo,nao,qe,qn,dt
4000  format(/,'nsa nsb ndo nao:',4i12,/,
     1       /,' Charge        electronic ',F16.8,/,
     1         '                  nuclear ',F16.8,/,
     2         '   [a.u.]                 ',16(1H-),/,
     3         '                    total ',F16.8,/)
      if(abs(dt-icha).gt.0.001d0.and.ic.eq.0)
     1call report('Non-zero charge')
      return
      end
C     ============
      subroutine normc
c     re-normalizes MOs
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension s(nort),cnorm(nort),bnorm(nort)
      call vz(cnorm,z0,nmo)
      call vz(bnorm,z0,nmo)
      open(33,file='SAO.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(s(j),j=1,i)
      do 1 imo=1,nmo
      cnorm(imo)=cnorm(imo)+cij(imo,i)*cij(imo,i)*s(i)
      bnorm(imo)=bnorm(imo)+bij(imo,i)*bij(imo,i)*s(i)
      s1=0.0d0
      s2=0.0d0
      do j=1,i-1
       s1=s1+cij(imo,j)*s(j)
       s2=s2+bij(imo,j)*s(j)
      enddo
      cnorm(imo)=cnorm(imo)+s1*two*cij(imo,i)
      bnorm(imo)=bnorm(imo)+s2*two*bij(imo,i)
1     continue
      close(33)
      do 2 i=1,nmo
      sf=sqrt(one/cnorm(i))
      sfb=sqrt(one/bnorm(i))
      do 2 j=1,nao
      cij(i,j)=cij(i,j)*sf
2     bij(i,j)=bij(i,j)*sfb
      write(3,*)' MOs have been re-normalized'
      return
      end
c    ===========
