      function oc4d(nxi,nyi,nzi,nxj,nyj,nzj,
     1eep, xij,yij,zij,pqx,pqy,pqz, hsp,aa,bb,ider)
c
c      derivative of the coulomb integral (ij||k=0 l=0) (AO) according
c      to the ider-coordinate of the center of the l orbital.
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (mmax=21,lx4=100000)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension eep(mmax),p(lx4),mp(lx4),nm(lx4,6),
     1nder(lx4)
      logical lder
c
      if(nxi.lt.0.or.nyi.lt.0.or.nzi.lt.0.or.
     1   nxj.lt.0.or.nyj.lt.0.or.nzj.lt.0)then
       oc4d=z0
       return
      endif
c
      l=1
      p(1)=one
      nm(1, 1)=nxi
      nm(1, 2)=nyi
      nm(1, 3)=nzi
      nm(1, 4)=nxj
      nm(1, 5)=nyj
      nm(1, 6)=nzj
c
c     mp is the kind of the error function + 1 (!!!!)
      mp(1)=1
c
c     nder: the power of (PQ)_ider in the coef of [ab|cd](m) term
      nder(1)=0
c
      do 1 itoa=1,6
      goto(101,102,103,104,105,106)itoa
101   if(nxi.eq.0)goto 1
      itob=4
      ri=pqx
      tbe=bb*xij*hsp
      lder=ider.eq.1
      goto 50
102   if(nyi.eq.0)goto 1
      itob=5
      ri=pqy
      tbe=bb*yij*hsp
      lder=ider.eq.2
      goto 50
103   if(nzi.eq.0)goto 1
      itob=6
      ri=pqz
      tbe=bb*zij*hsp
      lder=ider.eq.3
      goto 50
104   if(nxj.eq.0)goto 1
      itob=1
      ri=pqx
      tbe=-aa*xij*hsp
      lder=ider.eq.1
      goto 50
105   if(nyj.eq.0)goto 1
      itob=2
      ri=pqy
      tbe=-aa*yij*hsp
      lder=ider.eq.2
      goto 50
106   if(nzj.eq.0)goto 1
      itob=3
      ri=pqz
      tbe=-aa*zij*hsp
      lder=ider.eq.3
c
50    continue
c
      ic=0
      newl=l
      do 3 il=1,l
      if(nm(il,itoa).gt.0)then
c
c      expand [a+1i b|c d](m) (c=d=0)
c
c      [ab|cd](m)
       nai=nm(il,itoa)
       if(nai.gt.1)ic=1
       pold=p(il)
       mpold=mp(il)
       nm(il,itoa)=nai-1
       nderold=nder(il)
c
c  (8 and 7 never, c=d=0)
c
c  (6,5)
       if(nm(il,itob).gt.0)then
        p1=pold*dble(nm(il,itob))*hsp
        p2=-p1*hsp
c
c       [ab-1|cd](m)
        newl=newl+1
        p(newl)=p1
        mp(newl)=mpold
        do 96 i1=1,6
96      nm(newl,i1)=nm(il,i1)
        nm(newl,itob)=nm(newl,itob)-1
        nder(newl)=nderold
c
c       [ab-1|cd](m+1)
        newl=newl+1
        p(newl)=p2
        mp(newl)=mpold+1
        do 95 i1=1,6
95      nm(newl,i1)=nm(il,i1)
        nm(newl,itob)=nm(newl,itob)-1
        nder(newl)=nderold
       endif
c  (4,3)
       if(nai.gt.1)then
        p1=pold*dble(nm(il,itoa))*hsp
        p2=-p1*hsp
c
c       [a-1b|cd](m)
        newl=newl+1
        p(newl)=p1
        mp(newl)=mpold
        do 94 i1=1,6
94      nm(newl,i1)=nm(il,i1)
        nm(newl,itoa)=nm(newl,itoa)-1
        nder(newl)=nderold
c
c       [a-1b|cd](m+1)
        newl=newl+1
        p(newl)=p2
        mp(newl)=mpold+1
        do 93 i1=1,6
93      nm(newl,i1)=nm(il,i1)
        nm(newl,itoa)=nm(newl,itoa)-1
        nder(newl)=nderold
       endif
c
c  (2)
       p1=pold*hsp
       newl=newl+1
       if(lder)then
        nder(newl)=nderold+1
       else
        p1=p1*ri
        nder(newl)=nderold
       endif
c
c      [ab|cd](m+1)
       p(newl)=p1
       mp(newl)=mpold+1
       do 92 i1=1,6
92     nm(newl,i1)=nm(il,i1)
c  (1)
c
c      [ab|cd](m)
       p1=pold*tbe
       p(il)=p1
      endif
3     continue
      l=newl
      if(l+8.ge.lx4)goto 9999
      if(ic.eq.1)goto 50
c
1     continue
c
      sum=z0
      if(ider.eq.1)ri=pqx
      if(ider.eq.2)ri=pqy
      if(ider.eq.3)ri=pqz
      lder=ider.gt.0
      if(.not.lder)then
       do 22 i1=1,l
c      write(3,*)i1,p(i1),mp(i1),eep(mp(i1))
22     sum=sum+p(i1)*eep(mp(i1))
       goto 23
      endif
c
      do 2 i1=1,l
c     V=sum of p(i1)*eep(mp(i1)) where p(i1)~(R_ider)^nder(i1)
c
c      now, we need derivative according to the R_ider
       nr=nder(i1)
c
c      differentiate polynom, add the power
      if(nr.gt.0)then
       if(nr.eq.1)then
        sum=sum+eep(mp(i1))*p(i1)
       else
        sum=sum+eep(mp(i1))*dble(nr)*p(i1)*ri**(nr-1)
       endif
      endif
c
c     differentiate EE(T,m)
2     sum=sum-eep(mp(i1)+1)*p(i1)*ri**(nr+1)
23    oc4d=sum
      return
9999  write(6,6666) nxi,nyi,nzi,nxj,nyj,nzj,ider,
     1xij,yij,zij,pqx,pqy,pqz,hsp,aa,bb,eep
      write(6,*)nzi
6666  format('(',3i2,1x,3i2,'// ',i1,'. der',/,5g16.5,/,4g16.5,
     1/,'eep:',/,5g16.5,/,5g16.5,/,3g16.5)
      call report('expansion overflow in oc4d - OS RR')
      end
