      subroutine og
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,i00=201)
c
      character*2 at
      character*1 ok,ty
c
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      logical lr
      character*80 name
      dimension b(3),bb(3),c(3),a(3),r0(3),or(3),
     1lat(nat0),rt(3,nat0),dm(nort,nort),listo(nort)
      real*8 ro(i00,i00),fo(i00,i00),rofo(i00,i00,2),
     1rok(nort,i00)
c     rofo needed for stupid fortran compilers
c
      call inibe4
c
      inquire(file='BBB.INP',exist=lr)
      if(.not.lr)call report('BBB.INP not found')
      write(3,*)'Plotting options in BBB.INP'
      write(6,*)'Plotting options in BBB.INP'
      open(4,file='BBB.INP')
c
c Structure of the BBB.INP file with plotting options.
c line var
c ---------------------------------------------------
c   1  name
c   2  nd ios ioe iocc
c      nd ... dimension (2/3)
c      ios ... starting orbitals
c      ioe ... end orbitals
c      iocc ... occupation
c   3  ipar nsign
c      ipar=0  coords are defined as atoms
c      ipar=1  coords are defined as arbitrary vectors
c      ipar=2  coords are defined as gaussian cube
c      if nsign=-1 then signed density for individual orbitals plotted
c      if nsign=-2 then individual orbitals are plotted (works for ipar2)
c
c       For ipar=0:
c   4   na1,na2,nb1,nb2,(nc1,nc2)
c       atoms defining vectors a,b (c for 3-dimensional)
c   5   del,dd,ox     cage width, tick, first point offset
c
c       For ipar=1:
c   4   ax,ay,az,bx,by,bz,x0x,x0y,x0z
c       vectors a b and origin
c   5   del,dd,ox     cage width, tick, first point offset
c
c       For ipar=2:
c   4   igg,orx,ory,orz
c   5   ita,ax,ay,az
c   6   itb,bx,by,bz
c   7   itc,cx,cy,cz
c   8   list of orbitals
c       origin, vectors a b c; ticks
c
      read(4,'(a)')name
      read(4,*)nd,ios,ioe,iocc
      write(3,*)nd,' dimensional plotting'
      write(6,*)nd,' dimensional plotting'
      if(ioe.lt.1.or.ioe.gt.nori)call report('ioe out of bounds')
      if(ios.lt.1.or.ios.gt.nori)call report('ios out of bounds')
      read(4,*)ipar,nsign
      if(ios.ne.ioe.and.nsign.eq.-1)call report('no sence/signed ro')
      if(ipar.lt.0.or.ipar.gt.2)call report('ipar out of bounds')
c
c     111111111111111111111111111111111111111111111111111111111111111111111
c     1-dimensional plotting:
      if(nd.eq.1)then
       if(ipar.eq.0)then
        read(4,*)nal
        if(nal.gt.nat)call report('too many atoms')
        if(nal.lt.2)call report('too few atoms')
        read(4,*)(lat(i),i=1,nal)
        read(4,*)nl,ox
        close(4)
        dtot=-ox-ox
        do 6 i=1,nal-1
6       dtot=dtot+sqrt((xv(1,lat(i))-xv(1,lat(i+1)))**2+
     1                 (xv(2,lat(i))-xv(2,lat(i+1)))**2+
     2                 (xv(3,lat(i))-xv(3,lat(i+1)))**2)
        dx=dtot/(nl-1)
        write(3,3004)dtot,nl,dx,ox
        write(6,3004)dtot,nl,dx,ox
3004    format('Total distance of ',F5.2,
     1          ' devided ',I5,' times; tick ',F5.3,'; offset ',F5.2)
        open(4,file='BBB.PRN')
        a(1)=xv(1,lat(2))-xv(1,lat(1))
        a(2)=xv(2,lat(2))-xv(2,lat(1))
        a(3)=xv(3,lat(2))-xv(3,lat(1))
        call norm(a)
        b(1)=xv(1,lat(1))+a(1)*ox
        b(2)=xv(2,lat(1))+a(2)*ox
        b(3)=xv(3,lat(1))+a(3)*ox
        dd=sqrt((b(1)-xv(1,lat(2)))**2+
     1          (b(2)-xv(2,lat(2)))**2+
     2          (b(3)-xv(3,lat(2)))**2)
        x=-dx
        xt=-dx
        iat=1
        do 7 i=1,nl
        x=x+dx
        xt=xt+dx
        if(iat.gt.1)then
         dd=sqrt((xv(1,lat(iat))-xv(1,lat(iat+1)))**2+
     1           (xv(2,lat(iat))-xv(2,lat(iat+1)))**2+
     2           (xv(3,lat(iat))-xv(3,lat(iat+1)))**2)
         b(1)=xv(1,lat(iat))
         b(2)=xv(2,lat(iat))
         b(3)=xv(3,lat(iat))
         a(1)=xv(1,lat(iat+1))-xv(1,lat(iat))
         a(2)=xv(2,lat(iat+1))-xv(2,lat(iat))
         a(3)=xv(3,lat(iat+1))-xv(3,lat(iat))
         call norm(a)
        endif
        if(x.gt.dd.and.iat.lt.nal-1)then
         iat=iat+1
         x=x-dd
         if(x.gt.dd)call report('tick too big')
         a(1)=xv(1,lat(iat+1))-xv(1,lat(iat))
         a(2)=xv(2,lat(iat+1))-xv(2,lat(iat))
         a(3)=xv(3,lat(iat+1))-xv(3,lat(iat))
         call norm(a)
        endif
        rix=b(1)+x*a(1)
        riy=b(2)+x*a(2)
        riz=b(3)+x*a(3)
        i0=0
        call froxp(rr,rix,riy,riz,ios,ioe,iocc,i0,nsign)
        write(6,600)i,rr
600     format(I5,F20.9)
7       write(4,4004)(xt+ox)*0.529177D0,rr,iat,x,dd
4004    format(F10.4,F15.7,I3,5F10.4)
        close(4)
       else
        call report('only ipar=0 supported')
       endif
       write(3,*)'File BBB.PRN written'
       write(6,*)'File BBB.PRN written'
       return
      endif
c     111111111111111111111111111111111111111111111111111111111111111111111
c
c     2- and 3-dimensional plottings:
      if(ipar.eq.0)then
       read(4,*)na1,na2,nb1,nb2
       do 11 i=1,3
       b(i)=xv(i,nb2)-xv(i,nb1)
11     a(i)=xv(i,na2)-xv(i,na1)
       read(4,*)del,dd,ox
      endif
      if(ipar.eq.1)then
       read(4,*)(a(i),i=1,3),(b(i),i=1,3),(or(i),i=1,3)
       read(4,*)del,dd,ox
      endif
c
c     GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
      if(ipar.eq.2)then
       read(4,*)igg,(r0(i),i=1,3)
       read(4,*)i0,(a(i),i=1,3)
       read(4,*)j0,(b(i),i=1,3)
       read(4,*)k0,(c(i),i=1,3)
       if(nsign.eq.-2)then
        read(4,*)(listo(i),i=ios,ioe)
       endif
       close(4)
       bohr=0.529177d0
       do i=1,3
        r0(i)=r0(i)/bohr
        a(i)=a(i)/bohr
        b(i)=b(i)/bohr
        c(i)=c(i)/bohr
       enddo
       if(max(i0,j0,k0).gt.i00)call report('too many points selected')
       if(nd.ne.3.and.nd.ne.4)call report('nd must be 3 or 4 for ipar2')
c
c      prepare density matrix
       call ppot(0,dm,fi,rix,riy,riz)
c
       open(4,file='DENSITY.BBB')
       write(4,4000)name
       if(nsign.eq.-2)then
        write(4,4100)
4100    format(' SCF Molecular Orbitals')
       else
        write(4,4200)name
4200    format(' Density')
       endif
4000   format(a80)
       write(4,4001)iabs(igg),(r0(i),i=1,3)
4001   format(i5,4f12.6)
       write(4,4001)i0,(a(i),i=1,3)
       write(4,4001)j0,(b(i),i=1,3)
       write(4,4001)k0,(c(i),i=1,3)
       do ia=1,nat
        iq=nint(q(ia))
        write(4,4001)iq,q(ia),(xv(i,ia),i=1,3)
       enddo
       qtot=0.0D0
c
c      ooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
       if(nsign.eq.-2)then
        write(4,4005)ioe-ios+1,(listo(i),i=ios,ioe)
4005    format(10i5)
        do i=1,i0
         write(6,*)i
         rix=r0(1)+a(1)*dble(i-1)
         riy=r0(2)+a(2)*dble(i-1)
         riz=r0(3)+a(3)*dble(i-1)
         do j=1,j0
          rjx=rix+b(1)*dble(j-1)
          rjy=riy+b(2)*dble(j-1)
          rjz=riz+b(3)*dble(j-1)
          do k=1,k0
           rkx=rjx+c(1)*dble(k-1)
           rky=rjy+c(2)*dble(k-1)
           rkz=rjz+c(3)*dble(k-1)
           do ii=ios,ioe
            io=listo(ii)
            call forbxp(density,rkx,rky,rkz,io)
            qtot=qtot+density**2
            rok(ii,k)=density
           enddo
          enddo
          write(4,4003)((rok(ii,k),ii=ios,ioe),k=1,k0)
         enddo
        enddo
c
c      oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
       else
        do i=1,i0
         write(6,*)i
         rix=r0(1)+a(1)*dble(i-1)
         riy=r0(2)+a(2)*dble(i-1)
         riz=r0(3)+a(3)*dble(i-1)
         do j=1,j0
          rjx=rix+b(1)*dble(j-1)
          rjy=riy+b(2)*dble(j-1)
          rjz=riz+b(3)*dble(j-1)
          do k=1,k0
           rkx=rjx+c(1)*dble(k-1)
           rky=rjy+c(2)*dble(k-1)
           rkz=rjz+c(3)*dble(k-1)
           call froxp(density,rkx,rky,rkz,ios,ioe,iocc,i0,nsign)
           qtot=qtot+abs(density)
           ro(i,k)=density
           if(nd.eq.4)then
            call ppot(1,dm,fi,rix,riy,riz)
            fo(i,k)=fi
           endif
          enddo
          if(nd.eq.4)then
           do 3331 k=1,j0
           rofo(i,k,2)=fo(i,k)
3331       rofo(i,k,1)=ro(i,k)
           write(4,4003)((rofo(i,k,l),l=1,2),k=1,k0)
4003       format(6e13.5)
          endif
          if(nd.eq.3)write(4,4003)(ro(i,k),k=1,k0)
         enddo
        enddo
       endif
c
c      Only for rectangular grids:
       dx=a(1)
       dy=b(2)
       dz=c(3)
       write(3,*)'charge ',qtot*dx*dy*dz
       write(6,*)'charge ',qtot*dx*dy*dz
c
       close(4)
       write(6,*)'File DENSITY.BBB written'
       write(3,*)'File DENSITY.BBB written'
       return
      endif
c     GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
      close(4)
      i0=int(del/dd)
      if(i0.gt.i00-1)call report('too many points selected')
      j0=i0
      dx=dd
      dy=dd
      call vp(a,b,c)
      call vp(c,a,bb)
      call norm(a)
      call norm(bb)
      call norm(c)
      open(4,file='DENSITY.BBB',form='unformatted')
c
      if(nd.eq.2)then
       x0=0
       y0=0
       write(3,33)i0,j0,del,dd,ox
       write(6,33)i0,j0,del,dd,ox
33     format(I4,'x',I4,' span ',F10.2,' A; tick ',F8.3,' A.',F8.3)
c
       if (ipar.eq.0)then
        do 2 i=1,3
        or(i)=xv(i,na1)
2       r0(i)=xv(i,na1)+(a(i)+bb(i))*ox
       else
        do 21 i=1,3
21      r0(i)=or(i)+(a(i)+bb(i))*ox
       endif
c
       do 3 j=0,i0
       rjx=r0(1)+dble(j)*bb(1)*dd
       rjy=r0(2)+dble(j)*bb(2)*dd
       rjz=r0(3)+dble(j)*bb(3)*dd
       do 3 i=0,i0
       rix=rjx+dble(i)*a(1)*dd
       riy=rjy+dble(i)*a(2)*dd
       riz=rjz+dble(i)*a(3)*dd
       call froxp(density,rix,riy,riz,ios,ioe,iocc,i0,nsign)
       if(density.gt.1.0d30)density=1.0d30
       if(density.lt.-1.0d30)density=-1.0d30
       if(abs(density).lt.1.0d-30)density=0.0D0
3      ro(i+1,j+1)=density
       write(4)name,nd,i0,j0,x0,y0,dx,dy,
     1 ((ro(i,j),i=1,i0+1),j=1,j0+1)
c
c      rt ... coordinates with respect to the a bb c system
       do 43 l=1,noa
       do 53 i=1,3
53     b(i)=xv(i,l)-r0(i)
       rt(1,l)=sp(a,b)
       rt(2,l)=sp(bb,b)
43     rt(3,l)=sp(c,b)
      endif
c
c     prepare density matrix for potential plotting:
      call ppot(0,dm,fi,rix,riy,riz)
c
      if(nd.eq.3.or.nd.eq.4)then
       k0=i0
       dz=dd
       write(3,331)i0,j0,k0,del,dd,ox
       write(6,331)i0,j0,k0,del,dd,ox
331    format(I4,'x',I4,'x',I4,' span ',
     1 F10.2,' A; tick ',F8.3,' A.',F8.3)
c
       if (ipar.eq.0)then
        do 211 i=1,3
        or(i)=xv(i,na1)
211     r0(i)=xv(i,na1)+(a(i)+bb(i)+c(i))*ox
       else
        if(ipar.eq.1)then
         do 212 i=1,3
212      r0(i)=or(i)+(a(i)+bb(i)+c(i))*ox
        else
        endif
       endif
c
       write(4)name,nd,i0,j0,k0,(r0(i),i=1,3),dx,dy,dz
c
       qtot=0.0D0
       do 31 k=0,k0
       write(6,*)k
       rk=dble(k)*dd
       rkx=r0(1)+c(1)*rk
       rky=r0(2)+c(2)*rk
       rkz=r0(3)+c(3)*rk
       do 32 j=0,j0
       rj=dble(j)*dd
       rjx=rkx+bb(1)*rj
       rjy=rky+bb(2)*rj
       rjz=rkz+bb(3)*rj
       do 32 i=0,i0
       ri=dble(i)*dd
       rix=rjx+a(1)*ri
       riy=rjy+a(2)*ri
       riz=rjz+a(3)*ri
       call froxp(density,rix,riy,riz,ios,ioe,iocc,i0,nsign)
       qtot=qtot+abs(density)
       if(density.gt.1.0d30)density=1.0d30
       if(density.lt.-1.0d30)density=-1.0d30
       if(abs(density).lt.1.0d-30)density=0.0D0
       if(nd.eq.4)then
        call ppot(1,dm,fi,rix,riy,riz)
        fo(i+1,j+1)=fi
c       if(density.gt.0.01.and.density.lt.0.1)write(6,*)fi
       endif
32     ro(i+1,j+1)=density
       if(nd.eq.4)then
        do 333 i=1,i0+1
        do 333 j=1,j0+1
        rofo(i,j,2)=fo(i,j)
333     rofo(i,j,1)=ro(i,j)
        write(4)(((rofo(i,j,l),l=1,2),i=1,i0+1),j=1,j0+1)
c       write(4)(((ro(i,j),fo(i,j)),i=1,i0+1),j=1,j0+1)
       endif
       if(nd.eq.3)write(4)((ro(i,j),i=1,i0+1),j=1,j0+1)
31     continue
       write(3,*)'charge ',qtot*dx*dy*dz
       write(6,*)'charge ',qtot*dx*dy*dz
c
c      rt ... coordinates with respect to the a bb c system
       do 4 l=1,noa
       do 5 i=1,3
5      b(i)=xv(i,l)-r0(i)
       rt(1,l)=sp(a,b)
       rt(2,l)=sp(bb,b)
4      rt(3,l)=sp(c,b)
      endif
c
      write(4)noa,((rt(i,l),i=1,3),l=1,noa),(q(i),i=1,noa)
      close(4)
      write(3,*)'File BBB.SCR written'
      write(6,*)'File BBB.SCR written'
      stop
      end

