      function oi(m,ni,nj,ai,aj,xij,t,xi,xj)
c
c     calculates integrals of the type
c
c       infinity
c          /
c         |       ni  m       nj  -ai*(x-xi)^2  -aj*(x-xj)^2
c      i= | (x-xi)   x  (x-xj)   e             e             dx
c         |
c        /
c     -infinity
c
c      i = sqrt(pi) * oi * exp(-ai*aj*xij^2/(ia+aj))
c
c       xij=(xj-xi); ai>0; aj>0
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      parameter (nd=24)
      common/poly/pp(nd,nd)
c
      fac=one
      do 1 i=1,ni+nj+m+1
1     fac=fac*t
c
      sum=z0
      ci=aj*xij*t
      cj=-ai*xij*t
      cm=(ai*xi+aj*xj)*t
      do 2 l=0,ni
      pi=pp(ni+1,l+1)
      do 3 ll=1,ni-l
3     pi=pi*ci
      do 2 k=0,nj
      pj=pi*pp(nj+1,k+1)
      do 4 kk=1,nj-k
4     pj=pj*cj
      do 2 n=0,m
      pm=pj*pp(m+1,n+1)
      do 5 nn=1,m-n
5     pm=pm*cm
2     sum=sum+pm*ei(n+l+k)
      oi=fac*sum
      return
      end
c
      function ei(N)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c       infinity
c          /              2
c         |          N  -y
c      i= |         y  e     dy
c         |
c        /
c     -infinity
c
c       i=sqrt(pi)*ei
c
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
c
      nt=N/2
      if(nt+nt.ne.N)then
       ei=z0
       return
      endif
      ho=-one
      zl=one
      do 1 i=1,nt
      ho=ho+two
1     zl=zl*ho*half
      ei=zl
      return
      end
