      function ooi(ni,nj,nk,ai,aj,ak,xi,xj,xk,aa,t)
c
c     calculates integrals of the type
c
c     infinity
c        /
c       |       ni       nj      nk  -ai*(x-xi)^2  -aj*(x-xj)^2  -aj*(x-xk)^2
c    i= | (x-xi)   (x-xj)  (x-xk)   e             e             e            dx
c       |
c      /
c   -infinity
c
c    i = sqrt(pi) * ooi * exp((-ai*aj*xij^2-ai*ak*xik^2-aj*ak*xjk^2)/(ia+aj+ak))
c
c      ai>0; aj>0; ak>0; aa=ai+aj+ak;
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nd=24)
      common/poly/pp(nd,nd)
c
      sum=0.0d0
      b=(ai*xi+aj*xj+ak*xk)/aa
      ci = (b-xi) / t
      cj = (b-xj) / t
      ck = (b-xk) / t
      do 2 i=0,ni
      pi=   pp(ni+1,i+1)
      do 3 ii=1,ni-i
3     pi=pi*ci
      do 2 j=0,nj
      pj=pi*pp(nj+1,j+1)
      do 4 jj=1,nj-j
4     pj=pj*cj
      do 2 k=0,nk
      pk=pj*pp(nk+1,k+1)
      do 5 kk=1,nk-k
5     pk=pk*ck
2     sum=sum+pk*ei(i+j+k)
c
      do 1 i=1,ni+nj+nk+1
1     sum=sum*t
      ooi=sum
      return
      end
