      function oooi(ni,nj,nk,nl,ai,aj,ak,al,xi,xj,xk,xl,aa,t)
c
c     calculates integrals of the type
c
c     infinity
c        /
c       |       ni       nj      nk      nl
c    i= | (x-xi)   (x-xj)  (x-xk)  (x-xl)
c       |
c      /
c   -infinity
c
c                -ai*(x-xi)^2  -aj*(x-xj)^2  -ak*(x-xk)^2  -al*(x-xl)^2
c               e             e             e             e             dx
c
c
c    i = sqrt(pi) * oooi * exp(c)
c
c      c= (-ai*aj*xij^2-ai*ak*xik^2-ai*al*xil^2
c          -aj*ak*xjk^2-aj*al*xjl^2-ak*al*xkl^2)/(ia+aj+ak+al))
c
c      ai>0; aj>0; ak>0; al>0; aa=ai+aj+ak+al;
c
c      t=1/sqrt(aa)
c
      implicit none
      integer*4 nd,ni,nj,nk,nl,i,j,k,l
      parameter (nd=24)
      real*8 ai,aj,ak,al,xi,xj,xk,xl,aa,t,pp,cis(nd),cjs(nd),cks(nd),
     1cls(nd),b,ci,cj,ck,cl,sum,oooi,ei,pi,pj,pk
      common/poly/pp(nd,nd)
c
      b=(ai*xi+aj*xj+ak*xk+al*xl)/aa
      ci=(b-xi)/t
      cj=(b-xj)/t
      ck=(b-xk)/t
      cl=(b-xl)/t

      do 31 i=0,ni
31    cis(i+1)=ci**i
      do 32 j=0,nj
32    cjs(j+1)=cj**j
      do 33 k=0,nk
33    cks(k+1)=ck**k
      do 34 l=0,nl
34    cls(l+1)=cl**l
c
      sum=0.0d0
      do 2 i=0,ni
      pi=   pp(ni+1,i+1)*cis(ni-i+1)
      do 2 j=0,nj
      pj=pi*pp(nj+1,j+1)*cjs(nj-j+1)
      do 2 k=0,nk
      pk=pj*pp(nk+1,k+1)*cks(nk-k+1)
      do 2 l=0,nl
2     sum=sum+ei(i+j+k+l)*pk*pp(nl+1,l+1)*cls(nl-l+1)
c
      oooi=sum*t**(ni+nj+nk+nl+1)

      return
      end
