      subroutine ordnbo(ioe)
c     alpha, A and G' tensors (static limits), chi
c     with NBO correction
c
      implicit none
      integer*4 nat0,nor,nort,nr,Nro,Nro3,nfiles,j,k,
     1nsubst0,nsubst,n2,i1,i2,iind,j1,j2,k1,k2
      parameter (nat0=190,nor=80,nort=700,nr=100,
     1Nro=15,Nro3=Nro**3,nfiles=4,nsubst0=100)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nr     something for fitro1
c
      character*2 at
      character*1 ok,ty
      real*8 etol,delG,ejk,a10,a8,alpha,be,bij,cc,cij,ddg,
     3e,escf,five,four,fw4,half,one,qua,tw,
     1rcp,ropt,six,sp,three,two,umi,umw,uui,uuv,
     6uuw,wexc,xr0,xx,xy,xz,yr0,yy,yz,un(3),ue(3),
     7z0,zr0,zz,sum,sum1,sum2,amg,suma,sumb,APT(nat0,3,3)
      integer*4 i,i0,icha,ichm,ifil,ii,ioe,ione,ish,ix,jj,
     1jstart,jx,kk,mj,mk,mtp,n1,nao,nat,ndo,nmo,noa,noe,
     1nop,nori,npx,npy,npz,nsa,nsb,nzz,N,NM,idum,iip,jjp,iq
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      real*8 alp(3,3),a(3,6),g(3,3),eps,gv(3,3),anbo(3,3),
     1ac(3,3,3),alpv(3,3),dk(nr),dj(nr),alk(nr),
     2alj(nr),rlk(3,nr),rlj(3,nr),chip(3,3),chid(3,3),ort(3,3),
     3gnbo(3,3),gbo(3,3),abo(3,3)
c
      logical lscf,lres,lrec,lopt,lsp,lmoscr,lall,luvcd,lpro,
     1lconfig ,lmp2,lmpn4,lonly,gconfig,lsubst,lsprint,lex
      common/opts/lopt(300),icha,n1
      common/ropts/ropt(300)
      equivalence (lopt(21),lscf),(lopt(22),lres),(lopt(25),lrec),
     1(lopt(19),lsp),(lopt(43),lall),(lopt(55),luvcd),
     1(lopt(65),lconfig),(lopt(61),lmp2),(lopt(64),lmpn4),
     1(lopt(69),lonly),(lopt(66),gconfig),(lopt(88),lsubst),
     1(ropt(1),wexc),(lsprint,lopt(1)),(lpro,lopt(39))
c
c     variables for the density-grid calculations:
      real*8 rrx(Nro),rry(Nro),rrz(Nro),es(nsubst0)
      integer*4 ijkk(3,Nro3),ijkj(3,Nro3),is1(nsubst0),is2(nsubst0)
      common/ro2/delG,xr0,yr0,zr0,npx,npy,npz
      character*7 fm(nfiles,3)
      data fm/'PMO.SCR','QMO.SCR','LMO.SCR','VMO.SCR',
     1        'PMO.SCR','QMO.SCR','LMO.SCR','VMO.SCR',
     1        'PMB.SCR','QMB.SCR','LMB.SCR','VMB.SCR'/
      integer*4 id(nfiles)
      data id/3,6,3,3/
      real*8 am
      common/mass/am(nat0)
      real*8 z,zsum,xv
      common/atoms/z(nat0),zsum,xv(3,nat0)

      real*8,dimension(:),allocatable::ee,u,d,dipr,dipv,amag,quad,ured,
     1er,f,amau,h,el,mac,elc,mag,dp,dr,mr,mp,temmoment,elrr,magrr,
     1s1,e1,elcrr,macrr,temo,temp,tm
c

      call w36('Ordnbo')
      call w36('^^^^^^')
      call w36(' ')

      write(6,6009)ndo,nmo
6009  format(' ndo =',i4,' nmo =',i4)
      I0=0
      Ione=1
      etol=0.00001d0
      N=3*nat
      n2=nmo*nmo
      if(lconfig)then
       write(3,*)'Warning: un-restricted open shell defined'
       write(3,*)'some features are not implemented yet'
       nzz=2*nmo
      else
       nzz=nmo
      endif

      if(lsubst)then
       write(6,*)'Substitute certain transitions'
       open(88,file='SUBST.LST',status='old')
       read(88,*)nsubst
       if(nsubst.gt.nsubst0)call report('nsubst.gt.nsubst0')
       do i=1,nsubst
        read(88,*)is1(i),is2(i),es(i)
       enddo
       close(88)
      endif
c
      inquire(file='VMO.SCR',exist=lmoscr)
      if(.not.lmoscr)call makemos2(nao,cij,nmo)
      if(.not.lmoscr.and.nsb.gt.0)call makemosb(nao,bij,nmo)
c
      call vz(alp ,z0,9)
      call vz(anbo,z0,9)
      call vz(abo,z0,9)
      call vz(gnbo,z0,9)
      call vz(gbo,z0,9)
      call vz(alpv,z0,9)
      call vz(chid,z0,9)
      call vz(chip,z0,9)
      call vz(g   ,z0,9)
      call vz(gv  ,z0,9)
      call vz(a   ,z0,18)
c
      allocate(u(2*n2*N),ee(n2),dipr(3*n2),
     1dipv(3*n2),amag(3*n2),quad(6*n2),d(n2*N**2),
     1er(n2*N),ured(n2),amau(3*nat0),f(n2*N),h(n2*N*N),
     1mac(n2*3),elc(n2*3),dp(3*n2*N),dr(3*n2*N),mp(3*n2*N),mr(3*n2*N),
     1macrr(n2*3),elcrr(n2*3))

      open(44,file='Ucp.A.SCR.TXT',status='old')
      allocate(tm(nmo*nmo))
      do 47 I=1,N
      read(44,*)
      call rdu(tm,nmo,nmo)
      do 47 j=1,nmo
      do 47 k=1,nmo
47    u(k+nmo*(j-1)+nmo*nmo*(I-1))=tm(j+nmo*(k-1))
      do 48 I=1,N
      read(44,*)
      call rdu(tm,nmo,nmo)
      do 48 j=1,nmo
      do 48 k=1,nmo
48    u(N*nmo*nmo+k+nmo*(j-1)+nmo*nmo*(I-1))=tm(j+nmo*(k-1))
      close(44)
      call w36('Ucp.A.SCR.TXT')

      if(lsprint)then
       sum1=0.0d0
       sum2=0.0d0
       do 36 i=1,ndo
       do 36 j=1,ndo
36     call sumro(u,nat,nmo,i,j,sum1,sum2)
       write(3,6004)sum1,sum2
       write(6,6004)sum1,sum2
6004   format('First deri. error: ',f12.4,/,
     1        'Second der. error: ',f12.4)
       write(6,*)'Uij/dR11:'
       write(3,*)'Uij/dR11:'
       do 37 i=1,max(ndo,9)
       write(3,6002)i,(u(i+nmo*(j-1)),j=1,min(ndo,9))
37     write(6,6002)i,(u(i+nmo*(j-1)),j=1,min(ndo,9))
6002   format(i4,'>>',9f11.5)

       write(6,*)'Uij/d^2R11:'
       write(3,*)'Uij/d^2R11:'
       do 38 i=1,max(ndo,9)
       write(3,6003)i,(u(N*nmo**2+i+nmo*(j-1)),j=1,min(ndo,9))
38     write(6,6003)i,(u(N*nmo**2+i+nmo*(j-1)),j=1,min(ndo,9))
6003   format(i4,'#>',9f11.5)
      endif

      do 43 ii=1,N
      do 43 i=1,nmo
      do 43 j=i,nmo
      sum=u(i+(j-1)*nmo+n2*(ii-1))-u(j+(i-1)*nmo+n2*(ii-1))
      u(i+(j-1)*nmo+n2*(ii-1))= sum/2.0d0
43    u(j+(i-1)*nmo+n2*(ii-1))=-sum/2.0d0
      call w36('First derivatives have been symmetrized')

      if(lpro)then
       call projectU(u,nmo,nat,xv,nat0)
       call w36('Translations and Rotations projected')
       if(lsprint)then
        sum1=0.0d0
        sum2=0.0d0
        do 361 i=1,ndo
        do 361 j=1,ndo
361     call sumro(u,nat,nmo,i,j,sum1,sum2)
        write(3,6004)sum1,sum2
        write(6,6004)sum1,sum2
        write(6,*)'Uij/dR11:'
        write(3,*)'Uij/dR11:'
        do 371 i=1,max(ndo,9)
        write(3,6002)i,(u(i+nmo*(j-1)),j=1,min(ndo,9))
371     write(6,6002)i,(u(i+nmo*(j-1)),j=1,min(ndo,9))
        write(6,*)'Uij/d^2R11:'
        write(3,*)'Uij/d^2R11:'
        do 381 i=1,max(ndo,9)
        write(3,6003)i,(u(N*nmo**2+i+nmo*(j-1)),j=1,min(ndo,9))
381     write(6,6003)i,(u(N*nmo**2+i+nmo*(j-1)),j=1,min(ndo,9))
       endif
      endif
c
      amg=0.0d0
      do 41 ii=1,N
      amg=amg+am((ii+2)/3)
41    amau(ii)=am((ii+2)/3)*1822.88d0
      amg=amg/3.0d0
      write(3,4008)amg
4008  format(' Molecular mass ',f12.2,' g/mol')
c
c     get the one-electron energy differences
c     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
      call eeget(ee,ioe,1,nmo,ndo,lscf,nori,1,nmo,lall,
     1lres,lmp2,lmpn4,nzz,lonly,gconfig,Nro,half,xr0,ddG,Nro3,
     1yr0,zr0,delG,rrx,rry,rrz,ijkk,ijkj,is1,is2,Z0,one,lsp,nsa,nsb,
     1dk,mk,alk,rlk,dj,mj,alj,rlj,nr,2.0d0,I0,lsubst,nsubst,es,e,nao,
     1nmo,Ione)
c
c     read up one electron MO integrals:
c     length dipole, quadrupole, magnetic moment, velocity dipole:
      do 500 ifil=1,4
      open(36,file=fm(ifil,1),form='unformatted')
      do 501 ix=1,id(ifil)
      do 501 k=1,nmo
      if(ifil.eq.1)read(36)(dipr(j+(k-1)*nmo+n2*(ix-1)),j=1,nmo)
      if(ifil.eq.2)read(36)(quad(j+(k-1)*nmo+n2*(ix-1)),j=1,nmo)
      if(ifil.eq.3)read(36)(amag(j+(k-1)*nmo+n2*(ix-1)),j=1,nmo)
501   if(ifil.eq.4)read(36)(dipv(j+(k-1)*nmo+n2*(ix-1)),j=1,nmo)
500   close(36)
      call w36('one-electron integrals read')


      do 40 j=1,nmo
      do 40 k=1,nmo
      ured(k+(j-1)*nmo)=0.0d0
      do 40 ii=1,N
40    ured(k+(j-1)*nmo)=ured(k+(j-1)*nmo)+
     1u(n2*N+k+(j-1)*nmo+n2*(ii-1))/amau(ii)
      call w36('ured done')

c     coordinate and momentum second derivatives of the wavefunction:
c     |J_RP>=sum(K) D_JRPK |K>
c     D_JRPK=(sum(K')U_KRK'UJRK'/M+W_JRRK/M)/(eK-eJ)
c     |J_RR>=sum(K) H_JRRK |K>
c     D_JRPK=URR + (sum(K')U_KRK'sum(n)UJRnRnK/Mn/(eK-eJ)/2
c     |J_R>=U+(sum(K')U_KRK'sum(n)U2JRnK'/Mn/2(eK-eJ) = eJKR |K>
c     |J_P>=(sum(K)<K|dJ/dRM>|K./Ejk = FJKR |K>

      call vzt(er,N*n2)
      call vzt(f,N*n2)
      call vzt(d,n2*N**2)
      call vzt(h,n2*N**2)

      inquire(file='HD.SCR',exist=lex)
      if(lex)then
       open(36,file='HD.SCR',form='unformatted')
       read(36)(h(j),j=1,n2*N*N)
       read(36)(d(j),j=1,n2*N*N)
       read(36)(er(j),j=1,n2*N)
       read(36)(f(j),j=1,n2*N)
       close(36)
       call w36('HD read from HD.SCR')
      else
       do 34 ii=1,N
       do 34 jj=1,N
       do 34 j=1,nmo
       do 34 k=1,nmo
       i1=k+(j-1)*nmo+(ii-1)*n2+(jj-1)*n2*N
c      first index (k) equilibrium, secon d(j) is expanded
       if(ii.eq.jj)h(i1)=u(n2*N+k+nmo*(j-1)+n2*(ii-1))
       if(k.ne.j)then
        ejk=ee(j+(k-1)*nmo)
        if(dabs(ejk).le.1.0d-10)then
         write(6,*)j,k,nmo
         call report('Zero energy difference')
        endif
        sum1=0.0d0
c       <dK/dR|dJ/drM>
        do 35 kk=1,nmo
        if(ii.eq.jj)h(i1)=h(i1)-
     1  u(n2*N+kk+nmo*(k-1)+n2*(ii-1))*ured(kk+(j-1)*nmo)/2.0d0/ejk
c       first index (kk) equilibrium, second (k) is expanded
35      sum1=sum1+u(kk+nmo*(k-1)+n2*(ii-1))*u(kk+nmo*(j-1)+n2*(jj-1))
        sum1=sum1/amau(jj)
        sum2=0.0d0
c       <K|d^2J/dRdMR>
        if(ii.eq.jj)sum2=u(n2*N+k+(j-1)*nmo+n2*(jj-1))/amau(jj)
        d(i1)=-(sum1+sum2)/ejk
       endif
34     continue
       do 39 ii=1,N
       do 39 j=1,nmo
       do 39 k=1,nmo
       if(j.ne.k)then
        i1=k+(j-1)*nmo+n2*(ii-1)
        sum=0.0d0
c       <dK/dR|d^2J/dr^2nMn>
        do 42 kk=1,nmo
42      sum=sum+u(kk+nmo*(k-1)+n2*(ii-1))*ured(kk+nmo*(j-1))
        sum=sum/2.0d0/ee(j+(k-1)*nmo)
        er(i1)=u(i1)-sum*0.0
        f(i1)=-u(i1)/amau(ii)/ee(j+(k-1)*nmo)
       endif
39     continue
       open(36,file='HD.SCR',form='unformatted')
       write(36)(h(j),j=1,n2*N*N)
       write(36)(d(j),j=1,n2*N*N)
       write(36)(er(j),j=1,n2*N)
       write(36)(f(j),j=1,n2*N)
       close(36)
       call w36('HD written to HD.SCR')
      endif
c
c     transition electric and magnetic moment second RP and RR derivatives
      inquire(file='EM.SCR',exist=lex)
      if(lex)then
       open(44,file='EM.SCR',form='unformatted')
       read(44)elc
       read(44)mac
       read(44)elcrr
       read(44)macrr
       read(44)dr
       read(44)mr
       read(44)dp
       read(44)mp
       close(44)
       call w36('EM read from EM.SCR')
      else

c      read S-matrix:
       allocate(s1(3*nat*3*nat),e1(3*nat))
       inquire(file='F.INP',exist=lex)
       if(lex)then
        open(4,file='F.INP')
        READ(4,*)NM,nat,nat
        DO 24 I=1,nat
24      READ(4,*)
        read(4,*)
        do 25 I=1,nat
        do 25 iq=1,NM
25      read(4,*)idum,idum,(s1(3*(I-1)+ix+(iq-1)*N),ix=1,3)
        read(4,*)
        read(4,*)(e1(iq),iq=1,NM)
        close(4)
        CLOSE(4)
        do 26 i=1,N
        do 26 iq=1,NM
26      s1(i+(iq-1)*N)=s1(i+(iq-1)*N)*dsqrt(am((i+2)/3))
c       now transpose is inverted
        call w36('S-matrix read in')
       else
        call w36('Warning: S-matrix not found!!')
        stop
        NM=0
       endif

       do 44 ix=1,3
c
       allocate(elrr(n2*N*N),el(n2*N*N),mag(n2*N*N),temmoment(n2),
     1 magrr(n2*N*N),temo(N*N),temp(N*N))
c      put <J|ux|K> (MO) into temmoment
       call ptm(temmoment,dipr,nmo,ix)
c      calculate <J|ux|K>RP, put it to el:
       call ttm(temmoment,el,nmo,N,f,er,d)
c      calculate <J|ux|K>RR, put it to elrr:
       call ttm(temmoment,elrr,nmo,N,er,er,h)
c      the same with magnetic moment and mag
       call ptm(temmoment,amag,nmo,ix)
       call ttm(temmoment,mag,nmo,N,f,er,d)
       call ttm(temmoment,magrr,nmo,N,er,er,h)
c      contract R.P and R.S.S.R:
       do 446 j=1,nmo
       do 446 k=1,nmo
       i1=j+(k-1)*nmo+(ix-1)*n2
       mac(i1)=0.0d0
       elc(i1)=0.0d0
       macrr(i1)=0.0d0
       elcrr(i1)=0.0d0
c      R.S, first index:
       do 4461 ii=1,NM
       do 4461 jj=1,N
       temo(ii+(jj-1)*N)=0.0d0
       temp(ii+(jj-1)*N)=0.0d0
       do 4461 iip=1,N
       iind=iip+N*(jj-1)-1
       temo(ii+(jj-1)*N)=temo(ii+(jj-1)*N)
     1 +s1(iip+(ii-1)*N)*magrr(j+(k-1)*nmo+n2*iind)
4461   temp(ii+(jj-1)*N)=temp(ii+(jj-1)*N)
     1 +s1(iip+(ii-1)*N)*elrr(j+(k-1)*nmo+n2*iind)
     2 /dsqrt(amau(iip))
c      R.S, second index:
       do 4462 ii=1,NM
       do 4462 jj=1,NM
       magrr(j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))=0.0d0
       elrr( j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))=0.0d0
       do 4462 jjp=1,N
       magrr(j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))=
     1 magrr(j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))
     1 +s1(jjp+(jj-1)*N)*temo(ii+N*(jjp-1))/dsqrt(amau(jjp))
4462   elrr( j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))=
     1 elrr( j+(k-1)*nmo+n2*(ii+N*(jj-1)-1))
     1 +s1(jjp+(jj-1)*N)*temp(ii+N*(jjp-1)-1)/dsqrt(amau(jjp))
c      R.S.S.R contract
       do 4463 ii=1,NM
       if(e1(ii).gt.1.0d0)then
        tw=1.0d0/(2.0d0*e1(ii)/219470.0d0)
        iind=ii+N*(ii-1)-1
        macrr(i1)=macrr(i1)+magrr(j+(k-1)*nmo+n2*iind)*tw
        elcrr(i1)=elcrr(i1)+elrr( j+(k-1)*nmo+n2*iind)*tw
       endif
4463   continue
c      contract R.P:
       do 446 ii=1,N
       iind=ii+N*(ii-1)-1
       mac(i1)=mac(i1)+mag(j+(k-1)*nmo+n2*iind)
446    elc(i1)=elc(i1)+el( j+(k-1)*nmo+n2*iind)

       deallocate(el,mag,temmoment,elrr,magrr,temo,temp)
c
c      transition electric and magnetic moment first R and P derivatives
       do 45 ii=1,N
       iind=ix+3*(ii-1)-1
       do 45 j=1,nmo
       do 45 k=1,nmo
       i1=j+(k-1)*nmo+n2*iind
       mr(i1)=0.0d0
       mp(i1)=0.0d0
       dr(i1)=0.0d0
       dp(i1)=0.0d0
       do 45 kk=1,nmo
       j1=j+(kk-1)*nmo+n2*(ix-1)
       k1=kk+(k-1)*nmo+n2*(ix-1)
       k2=kk+(k-1)*nmo+n2*(ii-1)
       j2=kk+(j-1)*nmo+n2*(ii-1)
c      M_JKR=<J|m|K_R>+<J_R|m|K>, etc
       dr(i1)=dr(i1)+dipr(j1)*er(k2)+er(j2)*dipr(k1)
       mr(i1)=mr(i1)+amag(j1)*er(k2)+er(j2)*amag(k1)
       dp(i1)=dp(i1)+dipr(j1)*f (k2)+f (j2)*dipr(k1)
45     mp(i1)=mp(i1)+amag(j1)*f (k2)+f (j2)*amag(k1)

44     continue

       open(44,file='EM.SCR',form='unformatted')
       write(44)elc
       write(44)mac
       write(44)elcrr
       write(44)macrr
       write(44)dr
       write(44)mr
       write(44)dp
       write(44)mp
       close(44)
       call w36('EM written into EM.SCR')
       deallocate(s1,e1)
      endif

c     atomic polar tensor
      do 27 i=1,nat
      do 27 ix=1,3
      do 271 jx=1,3
271   APT(i,ix,jx)=0.0d0
27    APT(i,ix,ix)=z(i)

      do 28 i=1,nat
      do 28 ix=1,3
      ii=ix+3*(i-1)
      do 28 jx=1,3
      iind=jx+3*(ii-1)-1
      do 28 k=1,ndo
      i1=k+(k-1)*nmo+n2*iind
28    APT(i,ix,jx)=APT(i,ix,jx)-4.0d0*dr(i1)
      open(15,file='FILE.TEN')
      call WRITETEN(nat0,APT,APT,nat)
      call w36(' Dipole derivatives written into FILE.TEN')

      do 29 ix=1,3
      un(ix)=0.0d0
      ue(ix)=0.0d0
      do 291 k=1,ndo
291   ue(ix)=ue(ix)-dipr(k+(k-1)*nmo+n2*(ix-1))*2.0d0
      do 29 i=1,nat
29    un(ix)=un(ix)+z(i)*xv(ix,i)
      write(6,6019)ue
      write(6,6019)un
6019  format(3f12.4)
c
c     calculate SOS tensors
      xx=z0
      xy=z0
      xz=z0
      yy=z0
      yz=z0
      zz=z0


      do 5 k=1,ndo
      jstart=ndo+1
      if(lall)jstart=1
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
      ejk=ee(j+(k-1)*nmo)
      if(abs(ejk).lt.etol)goto 6
      if(abs(ejk-wexc).lt.etol)goto 6
      fw4=4.0d0/((ejk-wexc)*(ejk+wexc))
c     4 = 2 from definition x 2 from singlets
      do 10 ix=1,3
      uui= dipr(k+(j-1)*nmo+n2*(ix-1))*fw4
      uuw=uui*ejk
      umi=-amag(k+(j-1)*nmo+n2*(ix-1))*fw4
      umw=umi*ejk
      uuv=-dipv(k+(j-1)*nmo+n2*(ix-1))*fw4/ejk
      do 10 jx=1,3
c     # alpha
c         + non-BO part
c     # alphav, second index -velocity
c     # G full, first index - elctric, second - magnetic
c         + non-BO part
c     # A first index dipole, second quadrupole
c     # chi(para) full
      alp( ix,jx  )=alp( ix,jx  )+uuw*dipr(j+(k-1)*nmo+n2*(jx-1))
      alpv(ix,jx  )=alpv(ix,jx  )+uui*dipv(j+(k-1)*nmo+n2*(jx-1))
      g(   ix,jx  )=g(   ix,jx  )-uui*amag(j+(k-1)*nmo+n2*(jx-1))
      gv(  ix,jx  )=gv(  ix,jx  )-uuv*amag(j+(k-1)*nmo+n2*(jx-1))
      a(   ix,jx  )=a(   ix,jx  )+uuw*quad(j+(k-1)*nmo+n2*(jx-1))
      a(   ix,jx+3)=a(   ix,jx+3)+uuw*quad(j+(k-1)*nmo+n2*(jx+2))
      chip(ix,jx  )=chip(ix,jx  )+umw*amag(j+(k-1)*nmo+n2*(jx-1))
c
c     BO and non-BO parts of G,alpha:
      suma=0.0d0
      sumb=0.0d0
      sum=0.0d0
      sum2=0.0d0
      do 46 ii=1,N
      i1=k+(j-1)*nmo+n2*(ix+3*(ii-1)-1)
      i2=j+(k-1)*nmo+n2*(jx+3*(ii-1)-1)
c     contract R.R mkjR.ujkR + mkjR.ujkR:
      suma=suma+mr(i1)*dr(i2)+mr(i1)*dr(i2)
c     contract R.P mkjR.ujkP - mkjP.ujkR:
      sum=sum+mr(i1)*dp(i2)-mp(i1)*dr(i2)
c     contract R.R ukjR.ujkR - ukjR.ujkR
      sumb=sumb+dr(i1)*dr(i2)+dr(i1)*dr(i2)
c     contract R.P ukjR.ujkP - ukjP.ujkR
46    sum2=sum2+dr(i1)*dp(i2)-dp(i1)*dr(i2)
      i1=k+(j-1)*nmo+(ix-1)*n2
      i2=j+(k-1)*nmo+(jx-1)*n2
c     add mkjR.R ujk+mkj ujkR.R
      gbo(ix,jx)=gbo(ix,jx)
     1-fw4*(suma+macrr(i1)*dipr(j+(k-1)*nmo+n2*(jx-1))
     2          +amag(k+(j-1)*nmo+n2*(ix-1))*elcrr(i2))/2.0d0
c     add ukjR.R ujk+ukj ujkR.R:
      abo(ix,jx)=abo(ix,jx)
     1-fw4*(sumb+elcrr(i1)*dipr(j+(k-1)*nmo+n2*(jx-1))
     2          +dipr(k+(j-1)*nmo+n2*(ix-1))*elcrr(i2))/2.0d0*ejk
c     add mkjR.P ujk+mkj ujkR.P
      gnbo(ix,jx)=gnbo(ix,jx)
     1-fw4*(sum +mac(i1)*dipr(j+(k-1)*nmo+n2*(jx-1))
     2          +amag(k+(j-1)*nmo+n2*(ix-1))*elc(i2))/2.0d0
c     add ukjR.P ujk+ukj ujkR.P:
      anbo(ix,jx)=anbo(ix,jx)
     1-fw4*(sum2+elc(i1)*dipr(j+(k-1)*nmo+n2*(jx-1))
     2          +dipr(k+(j-1)*nmo+n2*(ix-1))*elc(i2))/2.0d0*ejk
c
10    continue
c     ix,jx
c
      xx=xx+2.0d0*quad(j+(k-1)*nmo+n2*0)
      xy=xy+2.0d0*quad(j+(k-1)*nmo+n2*1)
      xz=xz+2.0d0*quad(j+(k-1)*nmo+n2*2)
      yy=yy+2.0d0*quad(j+(k-1)*nmo+n2*3)
      yz=yz+2.0d0*quad(j+(k-1)*nmo+n2*4)
      zz=zz+2.0d0*quad(j+(k-1)*nmo+n2*5)
c
6     continue
5     continue
c
c     traceless quadrupole?
      chid(1,1)=-qua*(yy+zz)
      chid(2,2)=-qua*(xx+zz)
      chid(3,3)=-qua*(yy+xx)
      chid(1,2)=qua*xy
      chid(2,1)=qua*xy
      chid(1,3)=qua*xz
      chid(3,1)=qua*xz
      chid(2,3)=qua*yz
      chid(3,2)=qua*yz
c
c     construct the traceless A:
      do 8 ix=1,3
      xx=a(ix,1)
      xy=a(ix,2)
      xz=a(ix,3)
      yy=a(ix,4)
      yz=a(ix,5)
      zz=a(ix,6)
      a(ix,1)=half*(2.0d0*xx-zz-yy)
      a(ix,2)=half*three*xy
      a(ix,3)=half*three*xz
      a(ix,4)=half*(2.0d0*yy-zz-xx)
      a(ix,5)=half*three*yz
8     a(ix,6)=half*(2.0d0*zz-xx-yy)
c

      write(3,4000)wexc,219470.0d0*wexc,1.0d7/219470.0d0/wexc
4000  format(/,' wexc = ',f12.6,' au',f12.2,' cm-1',f12.2,' nm')

      write(3,4006)
     1'Alpha rv  (au):                                             ',
     1' X',' Y',' Z',((alpv(ix,jx),ix=1,3),jx=1,3),
     1(alpv(1,1)+alpv(2,2)+alpv(3,3))/three

      write(3,4006)
     1'Alpha rr  (au):                                             ',
     1' X',' Y',' Z',((alp(ix,jx),ix=1,3),jx=1,3),
     1(alp(1,1)+alp(2,2)+alp(3,3))/three

      write(3,4006)
     1'Alpha  BO rr  (au):                                         ',
     1' X',' Y',' Z',((abo(ix,jx),ix=1,3),jx=1,3),
     1(abo(1,1)+abo(2,2)+abo(3,3))/three

      write(3,4006)
     1'Alpha NBO rr  (au):                                         ',
     1' X',' Y',' Z',((anbo(ix,jx),ix=1,3),jx=1,3),
     1(anbo(1,1)+anbo(2,2)+anbo(3,3))/three

      do 23 i=1,3
      do 23 j=1,3
23    alp(i,j)=alp(i,j)+abo(i,j)+anbo(i,j)

      write(3,4006)
     1'Alpha TOTAL rr  (au):                                        ',
     1' X',' Y',' Z',((alp(ix,jx),ix=1,3),jx=1,3),
     1(alp(1,1)+alp(2,2)+alp(3,3))/three

      sp=(gv(1,1)+gv(2,2)+gv(3,3))/three
      write(3,4006)
     1'G-tensor rxv v (G/w, static limit, in au):                  ',
     1'BX','BY','BZ',((gv(i,j),j=1,3),i=1,3),sp
      write(3,4007)sp*1.3423d-4*wexc*219470.0d0/amg
4007  format(' [Alpha]  ',F16.8/)

c
      sp=(g(1,1)+g(2,2)+g(3,3))/three
      write(3,4006)
     1'G-tensor rxv r (G/w, static limit, in au):                  ',
     1'BX','BY','BZ',((g(i,j),j=1,3),i=1,3),sp
      write(3,4007)sp*1.3423d-4*wexc*219470.0d0/amg
c
      sp=(gbo(1,1)+gbo(2,2)+gbo(3,3))/three
      write(3,4006)
     1'G-tensor  BO rxv r (G/w, static limit, in au):              ',
     1'BX','BY','BZ',((gbo(i,j),j=1,3),i=1,3),sp
      write(3,4007)sp*1.3423d-4*wexc*219470.0d0/amg
c
      sp=(gnbo(1,1)+gnbo(2,2)+gnbo(3,3))/three
      write(3,4006)
     1'G-tensor NBO rxv r (G/w, static limit, in au):              ',
     1'BX','BY','BZ',((gnbo(i,j),j=1,3),i=1,3),sp
      write(3,4007)sp*1.3423d-4*wexc*219470.0d0/amg

      do 22 i=1,3
      do 22 j=1,3
22    g(i,j)=g(i,j)+gbo(i,j)+gnbo(i,j)

      sp=(g(1,1)+g(2,2)+g(3,3))/three
      write(3,4006)
     1'G-tensor TOTAL rxv r (G/w, static limit, in au):             ',
     1'BX','BY','BZ',((g(i,j),j=1,3),i=1,3),sp
      write(3,4007)sp*1.3423d-4*wexc*219470.0d0/amg
      write(3,*)sp,wexc*219470,amg
c
      open(33,file='A.TEN')
      write(33,4003)a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1              a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1              a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
      write(3,4003) a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1              a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1              a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
4003  format(' Electric dipole - electric quadrupole polarizability',/,
     1       ' (A, in atomic units)',/,
     1        11x,'XX',11x,'YY',11x,'ZZ',11x,'XY',11x,'XZ',11x,'YZ',/,
     2       3(6F18.8,/),/)
      close(33)

      write(3,4006)
     1'Susceptibility, paramagnetic, static limit, atomic units:   ',
     1' X',' Y',' Z',
     1((chip(i,j),i=1,3),j=1,3),
     1(chip(1,1)+chip(2,2)+chip(3,3))/three
4006  format(/,A60,/,/,
     1         '        ',14x,a2,14x,a2,14x,a2,/,
     1         '   X    ',3F16.8,/,
     1         '   Y    ',3F16.8,/,
     2         '   Z    ',3F16.8,/,
     3         '        ',16(1H-),/,
     3         '  Sp    ',F16.8,/,/)
c
      write(3,4006)
     1'Susceptibility, diamagnetic, in atomic units:               ',
     1'BX','BY','BZ',((chid(i,j),i=1,3),j=1,3),
     1(chid(1,1)+chid(2,2)+chid(3,3))/three

      do 14 i=1,3
      do 14 j=1,3
14    chid(i,j)=chid(i,j)+chip(i,j)

      write(3,4006)
     1'Susceptibility, total, in atomic units:                     ',
     1'BX','BY','BZ',((chid(i,j),i=1,3),j=1,3),
     1(chid(1,1)+chid(2,2)+chid(3,3))/three

      ii=0
      do 21 i=1,3
      do 21 j=i,3
      ii=ii+1
      do 21 k=1,3
      ac(k,i,j)=a(k,ii)
21    ac(k,j,i)=a(k,ii)

      do 15 i=1,3
      do 15 j=1,3
      sum=0.0d0
      do 151 ii=1,3
      do 151 jj=1,3
151   sum=sum+eps(i,ii,jj)*ac(ii,jj,j)+eps(j,ii,jj)*ac(ii,jj,i)
15    ort(i,j)=0.5d0*(g(i,j)+g(j,i)-wexc*sum/3.0d0)
      sp=(ort(1,1)+ort(2,2)+ort(3,3))/three
      write(3,4006)
     1'Optical Rotation Tensor, in atomic units:                   ',
     1' X',' Y',' Z',((ort(i,j),i=1,3),j=1,3),sp
c
      deallocate(u,ee,dipr,dipv,amag,quad,d,er,ured,amau,f,h,
     1elcrr,macrr,elc,mac,dp,dr,mr,mp)

      call w36('Ordnmo-ok')
      return
      end
c     ============================================================
      subroutine sumro(u,nat,nmo,iorb,j,sum1,sum2)
      implicit none
      real*8 u(*),sx,sy,sz,sum1,sum2
      integer*4 nat,nmo,j,i,ii,N,iorb
      N=3*nat
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      ii=iorb+nmo*(j-1)
      do 33 i=2,nat
      sx=sx+u(ii+nmo*nmo*(3*(i-1)+1-1))
      sy=sy+u(ii+nmo*nmo*(3*(i-1)+2-1))
33    sz=sz+u(ii+nmo*nmo*(3*(i-1)+3-1))
      sum1=sum1+dabs(sx+u(ii))+dabs(sy+u(ii+nmo*nmo))+
     1          dabs(sz+u(ii+nmo*nmo*2))
      write(6,6001)iorb,j,sx,sy,sz,u(ii),u(ii+nmo*nmo),u(ii+nmo*nmo*2)
      write(3,6001)iorb,j,sx,sy,sz,u(ii),u(ii+nmo*nmo),u(ii+nmo*nmo*2)
6001  format('U sum rules',i4,' to',i4,',first derivatives:',/,
     12(3f15.6,/))

      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      ii=N*nmo*nmo+iorb+nmo*(j-1)
      do 3 i=2,nat
      sx=sx+u(ii+nmo*nmo*(3*(i-1)+1-1))
      sy=sy+u(ii+nmo*nmo*(3*(i-1)+2-1))
3     sz=sz+u(ii+nmo*nmo*(3*(i-1)+3-1))
      sum2=sum2+dabs(sx+u(ii))+dabs(sy+u(ii+nmo*nmo))+
     1          dabs(sz+u(ii+nmo*nmo*2))
      write(6,6002)iorb,j,sx,sy,sz,u(ii),u(ii+nmo*nmo),u(ii+nmo*nmo*2)
      write(3,6002)iorb,j,sx,sy,sz,u(ii),u(ii+nmo*nmo),u(ii+nmo*nmo*2)
6002  format('U sum rules',i4,' to',i4,',second derivatives:',/,
     12(3f15.6,/),/)

      return
      end
c     ============================================================
      subroutine ptm(t,d,nmo,ix)
      real*8 t(*),d(*)
      integer*4 nmo,ix,j,k
      do 1 j=1,nmo
      do 1 k=1,nmo
1     t(j+(k-1)*nmo)=d(j+(k-1)*nmo+nmo*nmo*(ix-1))
      return
      end
c     ============================================================
      subroutine ttm(u,el,nmo,N,f,e,d)
      implicit none
      real*8 u(*),el(*),f(*),e(*),d(*),sum
      integer*4 nmo,N,iind,ii,jj,k,j,n2,kk
      real*8,dimension(:,:,:),allocatable::temft,temet
      real*8,dimension(:,:),allocatable::temef,temfe
c
      allocate(temft(nmo,nmo,N),temet(nmo,nmo,N),temfe(nmo,nmo),
     1temef(nmo,nmo))
      n2=nmo*nmo

      do 442 ii=1,N
      do 442 k=1,nmo
      do 442 j=1,nmo
      temft(j,k,ii)=0.0d0
      temet(j,k,ii)=0.0d0
      do 442 kk=1,nmo
c     <J|u|K_P>:
      temft(j,k,ii)=temft(j,k,ii)
     1+u(j+(kk-1)*nmo)*f(kk+(k-1)*nmo+n2*(ii-1))
c     <J|u|K_R>:
442   temet(j,k,ii)=temet(j,k,ii)+u(j
     1+(kk-1)*nmo)*e(kk+(k-1)*nmo+n2*(ii-1))

      do 5 ii=1,N
      do 5 jj=1,N
      iind=n2*(ii+N*(jj-1)-1)
c     first orbital derivatives f(P) e(R)

      do 443 k=1,nmo
      do 443 j=1,nmo
      temef(j,k)=0.0d0
      temfe(j,k)=0.0d0
      do 443 kk=1,nmo
c     <J_R|u|K_P>:
      temef(j,k)=temef(j,k)+e(kk+(j-1)*nmo+n2*(ii-1))*temft(kk,k,jj)
c     <J_P|u|K_R>:
443   temfe(j,k)=temfe(j,k)+f(kk+(j-1)*nmo+n2*(ii-1))*temet(kk,k,jj)

      do 445 j=1,nmo
      do 445 k=1,nmo
      sum=2.0d0*(temef(j,k)+temfe(j,k))
      if(j.eq.k)then
       do 444 kk=1,nmo
c      second orbitals derivatives D(RP)
c      <J_RP|u|K>+<J|u|K_RP>:
444    sum=sum+d(kk+(j-1)*nmo+iind)*u(kk+(k-1)*nmo)
     1        +u(j+(kk-1)*nmo)*d(kk+(k-1)*nmo+iind)
      endif
c     uJK_RP=(i/2)(<J_RP|u|K>+2(<JR|u|KP>+<JP|u|KR>)+<J|u|K_RP>)
445   el( j+(k-1)*nmo+iind)=sum/2.0d0
5     continue

      deallocate(temfe,temef,temft,temet)

      return
      end
c     ============================================================
      subroutine rdu(U,N,M)
      implicit none
      integer*4 i,j,N,M,is,ie,i5,n5
      real*8 U(*)
      n5=M/5
      if(M.gt.n5*5)n5=n5+1
      is=-4
      do 1 i5=1,n5
      is=is+5
      ie=min(is+4,M)
      read(44,*)
c440   format(i18,4i14)
      do 1 j=1,N
1     read(44,*)U(is+M*(j-1)),(U(i+M*(j-1)),i=is,ie)
      return
      end
