      subroutine ortog
c     re-ortonormalizes MOs
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension s(nort,nort),oldvec(nort),oldveb(nort),
     1tb(nort),tc(nort)
c
c     read in overlap matrix for AO
      open(33,file='SAO.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(s(i,j),j=1,i)
      do 2 j=1,i-1
2     s(j,i)=s(i,j)
1     continue
      close(33)
c
c     orthonormalize
      do 3 i=1,nmo
c
      do 6 ii=1,nao
      oldveb(ii)=bij(i,ii)
6     oldvec(ii)=cij(i,ii)

      do 41 jj=1,nao
      tb(jj)=0.0d0
      tc(jj)=0.0d0
      do 41 ii=1,nao
      tb(jj)=tb(jj)+oldveb(ii)*s(ii,jj)
41    tc(jj)=tc(jj)+oldvec(ii)*s(ii,jj)

c
      do 4 j=1,i-1
      aij=vecpro2(j,cij,s,nao,tc)
      aib=vecpro2(j,bij,s,nao,tb)
      do 4 ii=1,nao
      oldveb(ii)=oldveb(ii)-aib*bij(j,ii)
4     oldvec(ii)=oldvec(ii)-aij*cij(j,ii)
c
      an=one/vecnor(oldvec,s,nao)
      bn=one/vecnor(oldveb,s,nao)
      do 3 ii=1,nao
      bij(i,ii)=oldveb(ii)*bn
3     cij(i,ii)=oldvec(ii)*an
      write(3,*)' MOs have been re-ortonormalized'
      return
      end
c     =============================================================
      function vecpro2(j,cij,s,nao,t)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700)
      dimension cij(nort,nao),s(nort,nao),t(*)
c
      sum=0.0D0
      do 1 jj=1,nao
1     sum=sum+cij(j,jj)*t(jj)
      vecpro2=sum
      return
      end
c     =============================================================

c     =============================================================
      function vecpro(i,j,cij,s,nao)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700)
      dimension cij(nort,nao),s(nort,nao)
c
      sum=0.0D0
      do 1 ii=1,nao
      d1=cij(i,ii)
      do 1 jj=1,nao
1     sum=sum+d1*cij(j,jj)*s(ii,jj)
      vecpro=sum
      return
      end
c     =============================================================
      function vecnor(c,s,n)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700)
      dimension c(n),s(nort,n)
c
      sum=0.0d0
      do 1 ii=1,n
      do 1 jj=1,n
1     sum=sum+c(ii)*c(jj)*s(ii,jj)
      vecnor=sqrt(sum)
      return
      end
