      subroutine overla66(fjk)
c
c     calculates all three-orbital overlap integrals and
c     writes them to ABC.SCR
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,nopr0=10)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),cci(u0),
     3aai(u0,u0),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     3aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical ld5,lf7,lopt,special,lex
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4 ),ld5),(lopt(8),lf7)
      common/atoms/q(nat0),zsum,xv(3,nat0)
      dimension b6(nopr0,nopr0,nopr0),nopr(nort)
      dimension ialo(nort),nxo(nort),nyo(nort),nzo(nort),
     1cor(nort,nopr0),alpr(nort,nopr0),bt(nopr0,nopr0),
     1b1(nort),b(nort),ib(nort),fjk(nort,nort),ib2(nort)
      data tol/23.0D0/
c
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overla66')
c
      inquire(file='JKL.SCR',exist=lex)
      IF(.not.lex)THEN
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c     number of primitive functions on orbitals:
      do io=1,nmo
       nopr(io)=0
      enddo
      ios=1
      do ia=1,noa
       do ip=1,nop(ia)
        call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1  aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
        special=npi.ne.npii
        if(special)call report('special not implemented in ovela66')
c       primitive angular function - contributions to orbitals ios...ios+npi-1
        do ii=1,npi
         io=ios+ii-1
         nopr(io)=nopr(io)+1
         if(nopr(io).gt.nopr0)call report('too many prim functions')
         alpr(io,nopr(io))=alpha(ia,ip)
         cor(io,nopr(io))=cci(ii)
         if(nopr(io).eq.1)then
          nxo(io)=nxi(ii)
          nyo(io)=nyi(ii)
          nzo(io)=nzi(ii)
          ialo(io)=ia
         endif
        enddo
        if(ish(ia,ip+1).gt.ish(ia,ip))ios=ios+npi
       enddo
      enddo
      write(3,*)' orbital from to primitive of atom '
      do io=1,nmo
       write(3,3444)io,ialo(io),nxo(io),nyo(io),nzo(io),nopr(io)
3444   format('orb:',i4,' at:',i4,1x,3i1,2x,i2,' of primitives')
       do ip=1,nopr(io)
        write(3,3445)ip,alpr(io,ip),cor(io,ip)
3445    format(i2,' al=',f10.5,' c = ',f10.5)
       enddo
      enddo
c
      spi=sqrt(pi*pi*pi)
      open(45,file='ABC.SCR',form='unformatted')
c     ====================================================================
      do 2 io=1,nao
      ia=ialo(io)
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
      nix=nxo(io)
      niy=nyo(io)
      niz=nzo(io)
      do 2 jo=1,nao
      ja=ialo(jo)
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      njx=nxo(jo)
      njy=nyo(jo)
      njz=nzo(jo)
      xij2=(xj-xi)**2
      yij2=(yj-yi)**2
      zij2=(zj-zi)**2
      rij2=xij2+yij2+zij2
      nib=0
      do 21 ko=1,nao
      ka=ialo(ko)
      xk=xv(1,ka)
      yk=xv(2,ka)
      zk=xv(3,ka)
      nkx=nxo(ko)
      nky=nyo(ko)
      nkz=nzo(ko)
      rjk2=(xk-xj)**2+(yk-yj)**2+(zk-zj)**2
      rik2=(xk-xi)**2+(yk-yi)**2+(zk-zi)**2
c
c     make (ijk) in primitives
      do 6 ip=1,nopr(io)
      ai=alpr(io,ip)
      do 6 jp=1,nopr(jo)
      aj=alpr(jo,jp)
      do 6 kp=1,nopr(ko)
      ak=alpr(ko,kp)
      aa=ai+aj+ak
      t=one/sqrt(aa)
      ecp=(ai*aj*rij2+ai*ak*rik2+aj*ak*rjk2)/aa
      if(ecp.lt.tol)then
       b6(ip,jp,kp)=spi*exp(-ecp)*
     1 ooi(nix,njx,nkx,ai,aj,ak,xi,xj,xk,aa,t)*
     2 ooi(niy,njy,nky,ai,aj,ak,yi,yj,yk,aa,t)*
     3 ooi(niz,njz,nkz,ai,aj,ak,zi,zj,zk,aa,t)
      else
       b6(ip,jp,kp)=0.0d0
      endif
6     continue
c
c     Transform into AO basis
c     1)first index (io jp kp) = c(io,ip) (ip,jp,kp)
      do 61 jp=1,nopr(jo)
      do 61 kp=1,nopr(ko)
      sum=0.0d0
      do 62 ip=1,nopr(io)
62    sum=sum+b6(ip,jp,kp)*cor(io,ip)
61    bt(jp,kp)=sum
c
c     2)second index (io jo kp) = c(jo,jp) (io,jp,kp)
      do 63 kp=1,nopr(ko)
      b1(kp)=0.0d0
      do 63 jp=1,nopr(jo)
63    b1(kp)=b1(kp)+bt(jp,kp)*cor(jo,jp)
c
c     3)third index (io jo ko) = c(ko,kp) (io,jo,kp)
      sum=0.0d0
      do 65 kp=1,nopr(ko)
65    sum=sum+b1(kp)*cor(ko,kp)
      if(abs(sum).gt.1.0d-10)then
       nib=nib+1
       ib(nib)=ko
       b(nib)=sum
      endif
21    continue
      write(45)nib,(b(kk),kk=1,nib),(ib(kk),kk=1,nib)
2     continue
c     ====================================================================
c
c     transform into MOs and multiply by fjk
      open(46,file='JKL.SCR',form='unformatted')
c     1)first index (Ijjkk)=c(I,ii)(iijjkk)
      do 71 I=1,nmo
      rewind 45
      do 71 jj=1,nao
      do 73 kk=1,nao
      read(45)nib,(b(ik),ik=1,nib),(ib(ik),ik=1,nib)
      bIjjkk=0.0d0
      do 72 ii=1,nib
72    bIjjkk=bIjjkk+cij(I,ib(ii))*b(ii)
73    b1(kk)=bIjjkk
71    write(46)(b1(kk),kk=1,nao)
c
      rewind 45
c     2)second index (IJkk)=c(J,jj)(Ijjkk)
      do 81 J=1,nmo
      rewind 46
      do 81 I=1,nmo
      do 83 kk=1,nao
      read(46)(b(jj),jj=1,nao)
      bIJkk=0.0d0
      do 82 jj=1,nao
82    bIJkk=bIJkk+cij(J,jj)*b(jj)
83    b1(kk)=bIJkk
81    write(45)(b1(kk),kk=1,nao)
c
      rewind 46
c     3)third index (IJK)=c(K,kk)(IJkk)
      do 91 K=1,nmo
      rewind 45
      do 91 J=1,nmo
      n1=0
      do 93 I=1,nmo
      read(45)(b(jj),jj=1,nao)
      bIJK=0.0d0
      do 92 kk=1,nao
92    bIJK=bIJK+cij(K,kk)*b(kk)
c     call testi(-K,I,J,aint,noa,100,1)
c     write(6,6777)i,j,k,aint,bIJK
c777  format(3i3,2f15.8)
      if(abs(bIJK).gt.1.0d-10)then
       n1=n1+1
       b1(n1)=bIJK
       ib(n1)=I
      endif
93    continue
91    write(46)n1,(b1(I),I=1,n1),(ib(I),I=1,n1)
      call w36('JKL.SCR written')
c     ====================================================================
c
c     multiply by fjk (IJ|K)=(IJkk)(kk|K)
c
      open(47,file='FJKL.SCR',form='unformatted')
      do 41 K=1,nmo
      rewind 46
      do 41 I=1,nmo
      nj=0
      do 42 J=1,nmo
      read(46)n1,(b1(k1),k1=1,n1),(ib(k1),k1=1,n1)
      sum=0.0d0
      do 43 k1=1,n1
      kk=ib(k1)
43    sum=sum+fjk(K,kk)*b1(k1)
      if(abs(sum).gt.1.0d-10)then
       nj=nj+1
       b(nj)=sum
       ib2(nj)=J
      endif
42    continue
41    write(47)nj,(b(jj),jj=1,nj),(ib2(jj),jj=1,nj)
c
      rewind 45
      close(45)
      close(46)
      close(47)
      call w36('FJKL.SCR written')
c
      ELSE
c
      call w36('JKL.SCR found on disk')
c
      ENDIF
c
      return
      end
