      subroutine overla67(r2)
c
c     calculates  <i**2|r|j**2>/<i**2|j**2>, in AO
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension s(nort,nort),nxi(u0),nyi(u0),nzi(u0),
     1cci(u0),
     3aai(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,lopt,ldisk,ld5,lf7
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint)
      dimension r2(3,nort,nort)
      dimension n_n(nort),n_x(nort,u0),n_y(nort,u0),n_z(nort,u0),
     1i_a(nort),
     2a_a(nort,u0),c_c(nort,u0)
c
      inquire(file='R2.SCR',exist=ldisk)
      if(ldisk)then
       call w36('R2 read from R2.SCR')
       open(33,file='R2.SCR',form='unformatted')
       read(33)(((r2(i,j,k),i=1,3),j=1,nao),k=1,nao)
       close(33)
       return
      endif
c
c     for each orbital io assign primitives 1...npio(io)
      ld5=.false.
      lf7=.false.
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      call inipoly
      i0=0
      tol=200.0
      spi=sqrt(pi*pi*pi)
c
      io=0
      ipr=0
c
c     loop over atoms
      do ia=1,noa
c
c      primitive exponents on atom ia:
       do ip=1,nop(ia)
        ipr=ipr+1
        ai=alpha(ia,ip)
        call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1  aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
        if(npi.ne.npii)call report('only npi=npii allowed in overla67')
c
C       Loop over orbitals to which the primitives ip, jp contribute
        do ioo=1,npi
         a_a(io+ioo,ipr)=ai
         c_c(io+ioo,ipr)=cci(ioo)
         n_x(io+ioo,ipr)=nxi(ioo)
         n_y(io+ioo,ipr)=nyi(ioo)
         n_z(io+ioo,ipr)=nzi(ioo)
        enddo
C
        if(ish(ia,ip+1).gt.ish(ia,ip))then
         do ioo=1,npi
          n_n(io+ioo)=ipr
          i_a(io+ioo)=ia
         enddo
         io=io+npii
         ipr=0
        endif
       enddo
      enddo
c
c     control list:
      do io=1,nao
       write(3,*)'Orbital ',io, '; ',n_n(io),' primitives:'
       write(3,*)'             coef            exp   nx ny nz atom'
       do ip=1,n_n(io)
        write(3,3000)ip,c_c(io,ip),a_a(io,ip),
     1  n_x(io,ip),n_y(io,ip),n_z(io,ip),i_a(io)
3000    format(i2,2f15.7,3i2,i4)
       enddo
      enddo
c
c     loop over all orbitals:
      do 1 i=1,nao
      xi=xv(1,i_a(i))
      yi=xv(2,i_a(i))
      zi=xv(3,i_a(i))
      do 2 j=1,nao
      xj=xv(1,i_a(j))
      yj=xv(2,i_a(j))
      zj=xv(3,i_a(j))
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     overlap <i|j> = c(i,ip) c(j,jp) <ip|jp>
c
      sum=0.0d0
      do ip=1,n_n(i)
       ai=a_a(i,ip)
       nix=n_x(i,ip)
       niy=n_y(i,ip)
       niz=n_z(i,ip)
       ciip=c_c(i,ip)
       do jp=1,n_n(j)
        aj=a_a(j,jp)
        njx=n_x(j,jp)
        njy=n_y(j,jp)
        njz=n_z(j,jp)
        aij=ai+aj
        tt=one/aij
        t=sqrt(tt)
        ec=ai*aj*r2ij*tt
        ef=z0
        if(ec.lt.tol)then
         ef=spi*exp(-ec)
         sx=oi(i0,nix,njx,ai,aj,xij,t,xi,xj)
         sy=oi(i0,niy,njy,ai,aj,yij,t,yi,yj)
         sz=oi(i0,niz,njz,ai,aj,zij,t,zi,zj)
         sum=sum+ef*sx*sy*sz*ciip*c_c(j,jp)
        endif
       enddo
      enddo
      s(i,j)=sum
c
c     quadratic overlap without prefactor
c     <i**2|j**2> =  c(i,ip)c(i,ipp)c(j,jp)c(j,jpp) <ip ipp|jp jpp>
c     quadratic dipole without prefactor
c     <i**2|r|j**2> =  c(i,ip)c(i,ipp)c(j,jp)c(j,jpp) <ip ipp|r|jp jpp>
c     <ip ipp|r|jp jpp>=<ip+1 ipp|r|jp jpp>-xi<ip ipp|r|jp jpp>
c
      sum=0.0d0
      sumx=0.0d0
      sumy=0.0d0
      sumz=0.0d0
      do ip=1,n_n(i)
       ai =a_a(i,ip)
       nix=n_x(i,ip)
       niy=n_y(i,ip)
       niz=n_z(i,ip)
       cc1=c_c(i,ip)
       npx=nix+1
       npy=niy+1
       npz=niz+1
       do ipp=1,n_n(i)
        aip =a_a(i,ipp)
        nixp=n_x(i,ipp)
        niyp=n_y(i,ipp)
        nizp=n_z(i,ipp)
        cc2=cc1*c_c(i,ipp)
        do jp=1,n_n(j)
         aj =a_a(j,jp)
         njx=n_x(j,jp)
         njy=n_y(j,jp)
         njz=n_z(j,jp)
         cc3=cc2*c_c(j,jp)
         do jpp=1,n_n(j)
          ajp =a_a(j,jpp)
          njxp=n_x(j,jpp)
          njyp=n_y(j,jpp)
          njzp=n_z(j,jpp)
          cc4=cc3*c_c(j,jpp)
          aa=ai+aj+aip+ajp
          tt=one/aa
          t=sqrt(tt)
          ec=(ai+aip)*(aj+ajp)*r2ij/(ai+aip+aj+ajp)
          if(ec.lt.tol)then
           ef=spi*exp(-ec)*cc4
           sx=oi(0,nix+nixp,njx+njxp,ai+aip,aj+ajp,xij,t,xi,xj)
           sy=oi(0,niy+niyp,njy+njyp,ai+aip,aj+ajp,yij,t,yi,yj)
           sz=oi(0,niz+nizp,njz+njzp,ai+aip,aj+ajp,zij,t,zi,zj)
           px=oi(1,nix+nixp,njx+njxp,ai+aip,aj+ajp,xij,t,xi,xj)
           py=oi(1,niy+niyp,njy+njyp,ai+aip,aj+ajp,yij,t,yi,yj)
           pz=oi(1,niz+nizp,njz+njzp,ai+aip,aj+ajp,zij,t,zi,zj)
           sum =sum +ef*sx*sy*sz
           sumx=sumx+ef*px*sy*sz
           sumy=sumy+ef*sx*py*sz
           sumz=sumz+ef*sx*sy*pz
          endif
         enddo
        enddo
       enddo
      enddo
c     if(sum.lt.1.0d-199)then
       r2(1,i,j)=(xi+xj)/2.0d0
       r2(2,i,j)=(yi+yj)/2.0d0
       r2(3,i,j)=(zi+zj)/2.0d0
c     else
c      r2(1,i,j)=sumx/sum
c      r2(2,i,j)=sumy/sum
c      r2(3,i,j)=sumz/sum
c     endif
c
2     continue
c     orbital j
c
1     continue
c     orbital i
c
      anumel=0.0d0
      do k=1,ndo
       do m=1,nao
        do l=1,nao
         anumel=anumel+cij(k,m)*s(m,l)*cij(k,l)
        enddo
       enddo
      enddo
      write(3,*)'Check / number of electrons: ',anumel*2.0d0
c
      if(lsprint)then
       call wmtr(s,nort,nao,'S matrix by overla67, AO',i0)
       do 101 i=1,nao
       do 101 j=1,nao
101    s(i,j)=r2(1,i,j)
       call wmtr(s,nort,nao,'Local matrix x, AO',i0)
       do 102 i=1,nao
       do 102 j=1,nao
102    s(i,j)=r2(2,i,j)
       call wmtr(s,nort,nao,'Local matrix y, AO',i0)
       do 103 i=1,nao
       do 103 j=1,nao
103    s(i,j)=r2(3,i,j)
       call wmtr(s,nort,nao,'Local matrix z, AO',i0)
      endif
      open(33,file='R2.SCR',form='unformatted')
      write(33)(((r2(i,j,k),i=1,3),j=1,nao),k=1,nao)
      close(33)
      call w36('leaving overla67')
      return
      end
