      subroutine overlagg(il,ix,buff)
c
c     calculates AO overlap integrals of gradients
c     <a||r-rL|^(-3) (r-rL)_ix       |b> , store in buff
c
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,mmax=21)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(u0,nort),b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),t(mmax),buff(nort,nort),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5t1(mmax)
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4 ),ld5),(lopt(8),lf7)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      data i0,tol/0,23.0D0/
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overlagg')
C
c     define atomic coordinates
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
c
      call vz(sv,z0,u0*nort)
      call vz(buff,z0,nort*nort)
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ty(ia,ip).eq.'S')mi=0
      if(ty(ia,ip).eq.'P')mi=1
      if(ty(ia,ip).eq.'L')mi=1
      if(ty(ia,ip).eq.'D')mi=2
      if(ty(ia,ip).eq.'F')mi=3

c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      r2ij= xij*xij+yij*yij+zij*zij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      if(ty(ja,jp).eq.'S')mj=0
      if(ty(ja,jp).eq.'P')mj=1
      if(ty(ja,jp).eq.'L')mj=1
      if(ty(ja,jp).eq.'D')mj=2
      if(ty(ja,jp).eq.'F')mj=3
      mij=mi+mj
      aij=ai+aj
      bb=aj+aj
      sigmap=one/aij
      hsp=half*sigmap
      ecp=ai*aj*sigmap*r2ij
c
      if(ecp.lt.tol)then
       upp=pi*sigmap
       up0=sqrt(upp*upp*upp)*exp(-ecp)*z(il)
       px=(ai*xi+aj*xj)*sigmap
       py=(ai*yi+aj*yj)*sigmap
       pz=(ai*zi+aj*zj)*sigmap
       ad=100000.0d0
       dd=ad+ad
       hsq=half/dd
       nxl=0
       nyl=0
       nzl=0
       if(ix.eq.1)nxl=1
       if(ix.eq.2)nyl=1
       if(ix.eq.3)nzl=1
       call iactivate(mij+1,i0,xl,yl,zl,px,py,pz,t,
     1               pqx,pqy,pqz,hsp,z0,tol)
       call iactivate(mij+1,i0,xl,yl,zl,px,py,pz,t1,
     1               pqx,pqy,pqz,hsp,hsq,tol)
c
C      Loop over orbitals to which the primitives ip, jp contribute
       do 71 joo=1,npj
       njx=nxj(joo)
       njy=nyj(joo)
       njz=nzj(joo)
       up1=up0*ccj(joo)
       do 71 ioo=1,npi
       nix=nxi(ioo)
       niy=nyi(ioo)
       niz=nzi(ioo)
c      mmx=nix+niy+niz+njx+njy+njz+1
       up=up1*cci(ioo)
c
c      uq multiplied by sqrt((al/pi)^3), to have a delta-function
c      V=(a| z(il)(r-r_il)^-1|b)
c
       oo1=oc4d(nix,niy,niz,njx,njy,njz  ,
     1 t, xij,yij,zij,pqx,pqy,pqz, hsp,aa,bb,ix)

c      oo2=four*ad*
c    1 oce2(nix,niy,niz,njx,njy,njz,0,0,0,nxl,nyl,nzl,
c    1xij,yij,zij,z0,z0,z0,pqx,pqy,pqz, hsp,hsq,aa,bb,z0,dd,
c    2mmx,t1,1.0d-55,.false.,.false.,.false.)

c      if(ia.eq.1.and.ja.eq.1.and.il.eq.1.and.ix.eq.1.and.joo.eq.1
c    1 .and.ioo.eq.2.and.ip.eq.7.and.jp.eq.7)then
c      write(6,6777)ia,ja,il,ix,joo,ioo,ip,jp
c      write(6,6777)nix,niy,niz,njx,njy,njz,nxl,nyl,nzl
c6777   format(8i4)
c      oo3=four*ad*
c    1ocedeb(nix,niy,niz,njx,njy,njz,0,0,0,nxl,nyl,nzl,
c    1xij,yij,zij,z0,z0,z0,pqx,pqy,pqz,hsp,hsq
c    1,aa,bb,z0,dd,
c    2mmx,t1,1.0d-55)
c      write(6,*)'der (ab00):',oo1
c      write(6,*)'   d(ab01):',oo2
c      write(6,*)'   d(ab01):',oo3
c      write(6,*)xij,yij,zij,pqx,pqy,pqz
c      write(6,*)hsp,hsq,aa,bb,dd,mij,t1(1),t1(2)
c      read(5,*)iooo
c      endif

71     b6(ioo,joo)=-up*oo1
      else
       do 72 joo=1,npj
       do 72 ioo=1,npi
72     b6(ioo,joo)=z0
      endif
c
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 33 jj=1,nao
33     buff(io+ii,jj)=sv(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       call vz(sv,z0,u0*nort)
      endif
2     continue
c
      return
      end
c
      function ocedeb(nxi,nyi,nzi,nxj,nyj,nzj,nxk,nyk,nzk,nxl,nyl,nzl,
     1xij,yij,zij,xkl,ykl,zkl,pqx_1,pqy_1,pqz_1, hsp_1,hsq_1
     1,aa_1,bb_1,cc_1,dd_1,
     2mmx,eep_1,atol)
c
c     The coulomb integral (ij||kl) (AO) by the eight-term reccurence
c     relationship/for debug purposses from oce5
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      parameter (mmax=21,lx4=1000,npb0=10000,npbe=500)
c
      integer*4 nm(12*lx4),mp(lx4),mt(lx4),nu(12),nmil(12),
     1nai,nbi,nci,ndi,mold,mpold,i1z0,i1z1,i1z2
c
      logical lic,l_R
      dimension id(lx4),issn(12),w(6),ihsp(12),itobb(12),
     1itocb(12),itodb(12),irib(12),ibbb(12),ixb(12),rl(3)
      dimension pqx(npb0),pqy(npb0),pqz(npb0),hsp(npb0),hsq(npb0),
     1aa(npb0),bb(npb0),cc(npb0),dd(npb0),eep(npb0,mmax)
      dimension ww(npbe*15),P(npbe*lx4),p1(npbe),p2(npbe),
     1riasi(npbe),tbe(npbe),pold(npbe),eeq(npbe*mmax),o4d(npbe),
     2asiani(npbe),asi(npbe),eep_1(mmax)
c
c
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      data issn/1,4,16,64,256,1024,4096,16384,65536,262144,1048576,
     14194304/
      data rl/1.0d0,2.0d0,3.0d0/
      data ihsp/10,10,10, 10,10,10, 11,11,11, 11,11,11/
      data itobb/ 4, 5, 6,  1, 2, 3, 10,11,12,  7, 8, 9/
      data itocb/ 7, 8, 9,  7, 8, 9,  1, 2, 3,  1, 2, 3/
      data itodb/10,11,12, 10,11,12,  4, 5, 6,  4, 5, 6/
      data irib / 7, 8, 9,  7, 8, 9, -7,-8,-9, -7,-8,-9/
      data ibbb /13,13,13, 12,12,12, 15,15,15, 14,14,14/
      data ixb  / 1, 2, 3, -1,-2,-3,  4, 5, 6, -4,-5,-6/
      data i1z0,i1z1,i1z2/0,1,2/
      data i224/16777216/
c
      if(mmx.eq.0)then
       ocedeb=eep_1(1)
       return
      endif
c
      npbstart=1
      npbend=1
      pqx(1)=pqx_1
      pqy(1)=pqy_1
      pqz(1)=pqz_1
      hsp(1)=hsp_1
      hsq(1)=hsq_1
      aa(1)=aa_1
      bb(1)=bb_1
      cc(1)=cc_1
      dd(1)=dd_1
      do ii=1,mmx+1
       eep(1,ii)=eep_1(ii)
      enddo
      do ii=npbstart,npbend
       o4d(ii-npbstart+1)=z0
      enddo
c
      l=1
c
      npbt=npbend-npbstart+1
      do 4444 ii=1,(mmx+1)*npbt
4444  eeq(ii)=z0
c
      nu( 1)=nxi
      nu( 2)=nyi
      nu( 3)=nzi
      nu( 4)=nxj
      nu( 5)=nyj
      nu( 6)=nzj
      nu( 7)=nxk
      nu( 8)=nyk
      nu( 9)=nzk
      nu(10)=nxl
      nu(11)=nyl
      nu(12)=nzl
      write(6,*)'inside ocedeb',mmx
      write(6,7878)(nu(ioo),ioo=1,12)
7878  format(12i2)
      do ii=1,12
       nm(ii)=nu(ii)
      enddo
      mt(1)=mmx
      w( 1)=xij
      w( 2)=yij
      w( 3)=zij
      w( 4)=xkl
      w( 5)=ykl
      w( 6)=zkl
      npbt7 = 6*npbt
      npbt8 = npbt7 +npbt
      npbt9 = npbt8 +npbt
      npbt10= npbt9 +npbt
      npbt11= npbt10+npbt
      npbt12= npbt11+npbt
      npbt13= npbt12+npbt
      npbt14= npbt13+npbt
      npbt15= npbt14+npbt
      do ii=1,npbt
       P(ii)=one
       ww(ii+npbt7)=pqx(ii+npbstart-1)
       ww(ii+npbt8)=pqy(ii+npbstart-1)
       ww(ii+npbt9)=pqz(ii+npbstart-1)
       ww(ii+npbt10)=hsp(ii+npbstart-1)
       ww(ii+npbt11)=hsq(ii+npbstart-1)
       ww(ii+npbt12)=aa(ii+npbstart-1)
       ww(ii+npbt13)=bb(ii+npbstart-1)
       ww(ii+npbt14)=cc(ii+npbstart-1)
       ww(ii+npbt15)=dd(ii+npbstart-1)
       asiani(ii)=hsp(ii+npbstart-1)*hsq(ii+npbstart-1)
      enddo
c
c     mp is the kind of the error function + 1 (!!!!)
      mp(1)=i1z1
c
c     ID: indentification number, for each [ab|cd](m), m included as m*2^24
      ID(1)=nxi+4*(nyi+4*(nzi+4*(nxj+4*(nyj+4*(nzj+
     14*(nxk+4*(nyk+4*(nzk+4*(nxl+4*(nyl+4*nzl))))))))))
c
c
      do 1 itoa=1,12
      write(6,*)'itoa=',itoa
      if(nu(itoa).gt.i1z0)THEN
      iri=irib(itoa)
      iriabs=abs(iri)
      ii1=ihsp(itoa)
      itob=itobb(itoa)
      itoc=itocb(itoa)
      itod=itodb(itoa)
      ix=ixb(itoa)
      ixabs=abs(ix)
      ii3=ibbb(itoa)
      iid=issn(itoa)
      l_R=.false.
      RX=w(ixabs)
      i11=(ii1-1)*npbt
      i33=(ii3-1)*npbt
      irr=(iriabs-1)*npbt
      do ii=1,npbt
       asic=ww(ii+i11)
       asi(ii)=asic
       riasi(ii)=ww(ii+irr)*asic
       if(abs(riasi(ii)).gt.atol)l_R=.true.
       tbe(ii)=ww(ii+i33)*RX*asic
      enddo
      if(iri.lt.0)then
       do ii=1,npbt
        riasi(ii)=-riasi(ii)
       enddo
      endif
      if(ix.lt.0)then
       do ii=1,npbt
        tbe(ii)=-tbe(ii)
       enddo
      endif
c
      istart=1
50    lic=.false.
      newl=l
      do 3 il=istart,l
      if(nm(itoa+(il-1)*12).gt.i1z0)then
       write(6,7878)(nm(ii+12*(il-1)),ii=1,12)
c
c      expand [a+1i ...](m)
c
c      ID for [ab|cd](m)
       ida=id(il)-iid
c
c      write abcd into temporary buffer and record mp,m
       do ii=1,12
        nmil(ii)=nm(ii+12*(il-1))
       enddo
       nai=nmil(itoa)
       nbi=nmil(itob)
       nci=nmil(itoc)
       ndi=nmil(itod)
       naim=nai-i1z1
       nmil(itoa)=naim
       if(nai.gt.i1z1)then
        if(.not.lic)then
         istart=il
         lic=.true.
        endif
       endif
       isr=(il-1)*npbt
       do ii=1,npbt
        pold(ii)=P(ii+isr)
       enddo
       mpold=mp(il)
       mpoldp=mpold+i1z1
       mold=mt(il)
       moldm=mold-i1z1
       moldmm=moldm-i1z1
c  (8)
       if(ndi.gt.i1z0)then
        rlndi=rl(ndi)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlndi*asiani(ii)
         write(6,*)pold(ii),rlndi,asiani(ii)
         write(6,*)mold,i1z2
        enddo
        if(mold.eq.i1z2)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(isr+ii)=eeq(isr+ii)+p1(ii)
          write(6,*)eeq(isr+ii),p1(ii)
         enddo
        else
c
c        ID for [ab|cd-1](m+1)
         idd=ida-issn(itod)+i224
c        look, if it already exists
         do 80 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 81
         endif
80       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(newl)=idd
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itod+(newl-1)*12)=nmil(itod)-i1z1
81       continue
        endif
       endif
c  (7)
       if(nci.gt.i1z0)then
        rlnci=rl(nci)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnci*asiani(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(isr+ii)=eeq(isr+ii)+p1(ii)
         enddo
        else
c
c        ID for [ab|c-1d](m+1)
         idd=ida-issn(itoc)+i224
         do 82 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 83
         endif
82       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p1(ii)
         enddo
         id(newl)=idd
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoc+(newl-1)*12)=nmil(itoc)-i1z1
83       continue
        endif
       endif
c  (6,5)
       if(nbi.gt.i1z0)then
        rlnbi=rl(nbi)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnbi*asi(ii)
         p2(ii)=-p1(ii)*asi(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the terms [00|00][m]
         istart1=(mpold -1)*npbt
         istart2=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+istart1)=eeq(ii+istart1)+p1(ii)
          eeq(ii+istart2)=eeq(ii+istart2)+p2(ii)
         enddo
        else
c
c        ID for [ab-1|cd](m)
         idd1=ida-issn(itob)
         do 72 i1=newl,1,-1
         if(idd1.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 73
         endif
72       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(newl)=idd1
         mp(newl)=mpold
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itob+(newl-1)*12)=nmil(itob)-i1z1
73       continue
c
c        ID for [ab-1|cd](m+1)
         idd=idd1+i224
         do 74 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p2(ii)
          enddo
          goto 75
         endif
74       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p2(ii)
         enddo
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itob+(newl-1)*12)=nmil(itob)-i1z1
75       continue
        endif
       endif
c  (4,3)
       if(nai.gt.i1z1)then
        rlnaim=rl(naim)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnaim*asi(ii)
         p2(ii)=-p1(ii)*asi(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the terms [00|00][m]
         istart1=(mpold -1)*npbt
         istart2=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+istart1)=eeq(ii+istart1)+p1(ii)
          eeq(ii+istart2)=eeq(ii+istart2)+p2(ii)
         enddo
        else
c
c        ID for [a-1b|cd](m)
         idd=ida-iid
         do 76 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 77
         endif
76       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(newl)=idd
         mp(newl)=mpold
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoa+(newl-1)*12)=nmil(itoa)-i1z1
77       continue
c
c        ID for [a-1b|cd](m+1)
         idd=ida-iid+i224
         do 78 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p2(ii)
          enddo
          goto 79
         endif
78       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p2(ii)
         enddo
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoa+(newl-1)*12)=nmil(itoa)-i1z1
79       continue
        endif
       endif
c
c  (2)
       do ii=1,npbt
        p1(ii)=pold(ii)*riasi(ii)
       enddo
       if(l_R)then
        if(mold.eq.i1z1)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+isr)=eeq(ii+isr)+p1(ii)
         enddo
        else
c
c        ID for [ab|cd](m+1)
         idd=ida+i224
         do 70 i1=newl,1,-1
         if(idd.eq.id(i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 71
         endif
70       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
71       continue
        endif
       endif
c  (1)
c
c      ID for [ab|cd](m)
       do ii=1,npbt
        p1(ii)=pold(ii)*tbe(ii)
       enddo
       if(mold.eq.i1z1)then
        isr=(mpold-1)*npbt
        do ii=1,npbt
         eeq(ii+isr)=eeq(ii+isr)+p1(ii)
        enddo
        goto 300
       endif
       if(abs(RX).lt.atol)goto 300
       do 68 i1=newl,1,-1
       if(ida.eq.id(i1))then
        if(i1.ne.il)then
         isr=(i1-1)*npbt
         do ii=1,npbt
          P(ii+isr)=P(ii+isr)+p1(ii)
         enddo
         goto 300
        endif
       endif
68     continue
       id(il)=ida
       isr=(il-1)*npbt
       do ii=1,npbt
        P(ii+isr)=p1(ii)
       enddo
       mt(il)=moldm
c      mp(il)the same
       nm(itoa+(il-1)*12)=naim
      endif
3     continue
      goto 301
300   do 302 i1=il,newl-1
      ip=i1+1
      isr=(i1-1)*npbt
      isr2=(ip-1)*npbt
      do ii=1,npbt
       P(ii+isr)=p(ii+isr2)
      enddo
      id(i1)=id(ip)
      mp(i1)=mp(ip)
      mt(i1)=mt(ip)
      do 302 ii=1,12
302   nm(ii+(i1-1)*12)=nm(ii+(ip-1)*12)
      newl=newl-1
      if(.not.lic)then
       istart=il
       lic=.true.
      endif
301   l=newl
      if(l+8.ge.lx4)goto 9999
      if(lic)goto 50
c
      ENDIF
1     continue
c
      do 2 i1=1,mmx+1
      isr=(i1-1)*npbt
      do 2 ii=1,npbt
      write(6,*)'eeq eep',eeq(ii+isr),eep(ii+npbstart-1,i1)
2     o4d(ii)=o4d(ii)+eeq(ii+isr)*eep(ii+npbstart-1,i1)
      ocedeb=o4d(1)
      return
9999  call report('expansion overflow in ocE5 - OS RR')
      end
