      subroutine overlall(buff)
c
c     calculates AO overlap integrals
c       /
c      | X(r)X'(r')/|r-r'| dr dr'
c     /
c     and stores them in buff
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,mmax=21)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(u0,nort),b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),t(mmax),buff(nort,nort),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical ld5,lf7,lopt,lsx,lsy,lsz
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4 ),ld5),(lopt(8),lf7)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      data i0,tol,atol/0,23.0D0,1.0D-10/
c
      lsx=.false.
      lsy=.false.
      lsz=.false.
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overlall')
C
      call vz(sv,z0,u0*nort)
      call vz(buff,z0,nort*nort)
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      hsp=one/aa
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ty(ia,ip).eq.'S')mi=0
      if(ty(ia,ip).eq.'P')mi=1
      if(ty(ia,ip).eq.'L')mi=1
      if(ty(ia,ip).eq.'D')mi=2
      if(ty(ia,ip).eq.'F')mi=3
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      r2ij= xij*xij+yij*yij+zij*zij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      bb=aj+aj
      aij=ai+aj
      hsq=one/bb
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      if(ty(ja,jp).eq.'S')mj=0
      if(ty(ja,jp).eq.'P')mj=1
      if(ty(ja,jp).eq.'L')mj=1
      if(ty(ja,jp).eq.'D')mj=2
      if(ty(ja,jp).eq.'F')mj=3
      mij=mi+mj
      ecp=ai*aj/aij*r2ij
c
      if(ecp.lt.tol)then
       uu=(pi/ai)*(pi/aj)
       up0=sqrt(uu*uu*uu)
       call iactivate(mi,mj,xj,yj,zj,xi,yi,zi,t,
     1               xij,yij,zij,hsp,hsq,tol)
c
C      Loop over orbitals to which the primitives ip, jp contribute
       do 71 joo=1,npj
       njx=nxj(joo)
       njy=nyj(joo)
       njz=nzj(joo)
       up1=up0*ccj(joo)
       do 71 ioo=1,npi
       nix=nxi(ioo)
       niy=nyi(ioo)
       niz=nzi(ioo)
71     b6(ioo,joo)=up1*cci(ioo)*
     1 oce2(nix,niy,niz, i0,i0,i0,i0,i0,i0, njx,njy,njz,
     1 xi,yi,zi,xj,yj,zj,xij,yij,zij,hsp,hsq,aa,z0,z0,bb,
     2 mij,t,atol,lsx,lsy,lsz)
      else
       do 72 joo=1,npj
       do 72 ioo=1,npi
72     b6(ioo,joo)=z0
      endif
c
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 33 jj=1,nao
33     buff(io+ii,jj)=sv(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       call vz(sv,z0,u0*nort)
      endif
2     continue
c
      return
      end
