      subroutine overlap6
c     the "true" d-orbitals are included here
c     calculates overlap matrix and other one electron integrals
c     symmetry properties of overlaps are not used, because of control
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,n1e=28)
c n1e:
c      1 <i|j>
c      2 <i|x|j>
c      3 <i|y|j>
c      4 <i|z|j>
c      5 <i|xx|j>
c      6 <i|xy|j>
c      7 <i|xz|j>
c      8 <i|yy|j>
c      9 <i|yz|j>
c     10 <i|zz|j>
c     11 <i|dx|j>
c     12 <i|dy|j>
c     13 <i|dz|j>
c     14 <i|r x grad|j>
c     15 <i|r x grad|j>
c     16 <i|r x grad|j>
c     17  (1/2) (r-rj) x grad              W
c     18  (1/2) (r-rj) x grad
c     19  (1/2) (r-rj) x grad
c     20  (1/2) (r-(ri+rj)/2) x grad       T
c     21  (1/2) (r-(ri+rj)/2) x grad
c     22  (1/2) (r-(ri+rj)/2) x grad
c     23  (1/2) rj x r / 2                 D
c     24  (1/2) rj x r / 2
c     25  (1/2) rj x r / 2
c     26  (1/2) ri x r / 2                 E
c     27  (1/2) ri x r / 2
c     28  (1/2) ri x r / 2
      integer*4 u0
      parameter (u0=28)
c     n1e ... number of kinds of one-electron integrals
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension s(nort,nort),nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(n1e,u0,nort),b6(n1e,u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt,lnno,ldisk,leat,lskip,lskipj
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   ),
     1(lopt(57),lnno   ),(lopt(102),leat  )
      integer*4, allocatable::ial(:)
c
      call inipoly
      i0=0
      ione=1
      itwo=2
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      inquire(file='V.SCR',exist=ldisk)
      if(ldisk)return
c
      if(leat)then

       open(40,file='EA.LST',status='old')
       read(40,*)nae
       allocate(ial(abs(nae)))
       read(40,*)(ial(i),i=1,abs(nae))
       close(40)

       if(nae.gt.0)then
        write(6,*)nae,' atoms to be deleted found in EA.LST'
       else
        write(6,*)abs(nae),' atoms found in EA.LST will be conserved'
       endif

      endif

      tol=100.0
      spi=sqrt(pi*pi*pi)
      do 10 i=1,nao
      do 10 j=1,u0
      do 10 k=1,n1e
10    sv(k,j,i)=z0
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms')
C
      open(33,file='SAO.SCR',form='unformatted')
      open(34,file='P.SCR',form='unformatted')
      open(35,file='Q.SCR',form='unformatted')
      open(36,file='V.SCR',form='unformatted')
      open(37,file='L.SCR',form='unformatted')
      open(38,file='W.SCR',form='unformatted')
      open(39,file='T.SCR',form='unformatted')
      open(40,file='D.SCR',form='unformatted')
      open(41,file='E.SCR',form='unformatted')
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa

      lskip=.false.
      if(leat)then
       ic=0
       do 101 i=1,abs(nae)
101    if(ial(i).eq.ia)ic=1
c      ic=0 ... atoms was not found
c      ic=1 ... atoms was found
c      atom on list, skip:
c      atom not on list, skip:
       lskip=(nae.gt.0.and.ic.eq.1).or.(nae.lt.0.and.ic.eq.0)
      endif

      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa

      lskipj=.false.
      if(leat)then
       ic=0
       do 102 i=1,abs(nae)
102    if(ial(i).eq.ja)ic=1
       lskipj=(nae.gt.0.and.ic.eq.1).or.(nae.lt.0.and.ic.eq.0)
      endif

      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
      xx=(xi+xj)*half
      yy=(yi+yj)*half
      zz=(zi+zj)*half
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      anjx=dble(nxj(joo))
      anjy=dble(nyj(joo))
      anjz=dble(nzj(joo))
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      sx=oi(i0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      sy=oi(i0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      sz=oi(i0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      sxm=z0
      sym=z0
      szm=z0
      if(nxj(joo).gt.0)
     1sxm=oi(i0,nxi(ioo),nxj(joo)-1,ai,aj,xij,t,xi,xj)
      sxp=oi(i0,nxi(ioo),nxj(joo)+1,ai,aj,xij,t,xi,xj)
      if(nyj(joo).gt.0)
     1sym=oi(i0,nyi(ioo),nyj(joo)-1,ai,aj,yij,t,yi,yj)
      syp=oi(i0,nyi(ioo),nyj(joo)+1,ai,aj,yij,t,yi,yj)
      if(nzj(joo).gt.0)
     1szm=oi(i0,nzi(ioo),nzj(joo)-1,ai,aj,zij,t,zi,zj)
      szp=oi(i0,nzi(ioo),nzj(joo)+1,ai,aj,zij,t,zi,zj)
      ox =oi(ione,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      oy =oi(ione,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      oz =oi(ione,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      oxx=oi(itwo,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      oyy=oi(itwo,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      ozz=oi(itwo,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      dx=anjx*sxm-two*aj*sxp
      dy=anjy*sym-two*aj*syp
      dz=anjz*szm-two*aj*szp
c     overlap
      b6(1,ioo,joo)=sx*sy*sz
c     electric dipole
      b6(2,ioo,joo)=ox*sy*sz
      b6(3,ioo,joo)=sx*oy*sz
      b6(4,ioo,joo)=sx*sy*oz
c     electric quadrupole xx,xy,xz,yy,yz,zz:
      b6(5,ioo,joo)=oxx*sy*sz
      b6(6,ioo,joo)=ox*oy*sz
      b6(7,ioo,joo)=ox*sy*oz
      b6(8,ioo,joo)=oyy*sz*sx
      b6(9,ioo,joo)=sx*oy*oz
      b6(10,ioo,joo)=ozz*sx*sy
c     gradient/velocity  d/dx, d/dy, d/dz
      b6(11,ioo,joo)=dx*sy*sz
      b6(12,ioo,joo)=dy*sz*sx
      b6(13,ioo,joo)=dz*sx*sy
c     angular momentum lx,ly,lz = (1/2) r x grad
      b6(14,ioo,joo)=(oy*dz-oz*dy)*sx*half
      b6(15,ioo,joo)=(oz*dx-ox*dz)*sy*half
      b6(16,ioo,joo)=(ox*dy-oy*dx)*sz*half
c     angular momentum (1/2) (r - rj) x grad
      b6(17,ioo,joo)=((oy-yj*sy)*dz-(oz-zj*sz)*dy)*sx*half
      b6(18,ioo,joo)=((oz-zj*sz)*dx-(ox-xj*sx)*dz)*sy*half
      b6(19,ioo,joo)=((ox-xj*sx)*dy-(oy-yj*sy)*dx)*sz*half
c     angular momentum (1/2) (r - (ri+rj)/2) x grad
      b6(20,ioo,joo)=((oy-yy*sy)*dz-(oz-zz*sz)*dy)*sx*half
      b6(21,ioo,joo)=((oz-zz*sz)*dx-(ox-xx*sx)*dz)*sy*half
      b6(22,ioo,joo)=((ox-xx*sx)*dy-(oy-yy*sy)*dx)*sz*half
c     GIAO like r x rj /2
      b6(23,ioo,joo)=(oy*zj*sz-oz*yj*sy)*sx*half
      b6(24,ioo,joo)=(oz*xj*sx-ox*zj*sz)*sy*half
      b6(25,ioo,joo)=(ox*yj*sy-oy*xj*sx)*sz*half
c     GIAO like r x ri /2
      b6(26,ioo,joo)=(oy*zi*sz-oz*yi*sy)*sx*half
      b6(27,ioo,joo)=(oz*xi*sx-ox*zi*sz)*sy*half
      b6(28,ioo,joo)=(ox*yi*sy-oy*xi*sx)*sz*half
      do 71 k=1,n1e
71    b6(k,ioo,joo)=b6(k,ioo,joo)*coe
c
      if(.not.(lskip.or.lskipj))then
       if(npi.ne.npii.or.npjj.ne.npj)then
        do 74 ioo=1,npii
        do 74 joo=1,npjj
        ioj=joo+jo
        do 74 ipp=1,npi
        aiii=aai(ioo,ipp)
        do 74 jpp=1,npj
        ajjj=aaj(joo,jpp)*aiii
        do 74 k=1,n1e
74      sv(k,ioo,ioj)=sv(k,ioo,ioj)+ajjj*b6(k,ipp,jpp)
       else
        do 7 ioo=1,npi
        do 7 joo=1,npj
        ioj=joo+jo
        do 7 k=1,n1e
7       sv(k,ioo,ioj)=sv(k,ioo,ioj)+b6(k,ioo,joo)
       endif
      else
       if(npi.ne.npii.or.npjj.ne.npj)then
        do 741 ioo=1,npii
        do 741 joo=1,npjj
        ioj=joo+jo
        do 741 ipp=1,npi
        aiii=aai(ioo,ipp)
        do 741 jpp=1,npj
        ajjj=aaj(joo,jpp)*aiii
741     sv(1,ioo,ioj)=sv(1,ioo,ioj)+ajjj*b6(1,ipp,jpp)
       else
        do 711 ioo=1,npi
        do 711 joo=1,npj
        ioj=joo+jo
711     sv(1,ioo,ioj)=sv(1,ioo,ioj)+b6(1,ioo,joo)
       endif
      endif

777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
       write(33)(sv(1,ii,jj),jj=1,iorb)
c
c      check the normalization condition - orbital iorb
       anorm=one/sqrt(sv(1,ii,iorb))
       if(abs(anorm-one).gt.0.001D0)then
        write(3,*)anorm,iorb
        if(.not.lnno)call report('Non-normalized aos')
       endif
       if(lsprint)write(3,*)iorb,anorm
       do 331 kk=2,4
331    write(34)(sv(kk,ii,jj),jj=1,nao)
       do 332 kk=5,10
332    write(35)(sv(kk,ii,jj),jj=1,nao)
       do 333 kk=11,13
333    write(36)(sv(kk,ii,jj),jj=1,nao)
       do 334 kk=14,16
334    write(37)(sv(kk,ii,jj),jj=1,nao)
       do 335 kk=17,19
335    write(38)(sv(kk,ii,jj),jj=1,nao)
       do 336 kk=20,22
336    write(39)(sv(kk,ii,jj),jj=1,nao)
       do 337 kk=23,25
337    write(40)(sv(kk,ii,jj),jj=1,nao)
       do 338 kk=26,28
338    write(41)(sv(kk,ii,jj),jj=1,nao)
33     continue
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       do 9 kk=1,n1e
9      sv(kk,ii,jj)=z0
      endif
3     continue
2     continue

      do 11 kk=33,41
11    close(kk)

      if(leat)deallocate(ial)
c
      if(lsprint)then
      open(33,file='SAO.SCR',form='unformatted')
      do 34 i=1,nao
34    read(33)(s(i,j),j=1,i)
      do 35 i=1,nao
      do 35 j=1,i-1
35    s(j,i)=s(i,j)
      close(33)
      call wmtr(s,nort,nao,'Overlap matrix, AO',i0)
      endif
c
      if(lpprint)call wff('P.SCR','Dipole, AO, P',nao,s,nort)
c
      if(lqprint)then
      open(33,file='Q.SCR',form='unformatted')
      do 41 i=1,nao
      read(33)(s(i,j),j=1,nao)
      read(33)
      read(33)
      read(33)
      read(33)
41    read(33)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, XX',ione)
      rewind 33
      do 42 i=1,nao
      read(33)
      read(33)(s(i,j),j=1,nao)
      read(33)
      read(33)
      read(33)
42    read(33)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, XY',ione)
      rewind 33
      do 43 i=1,nao
      read(33)
      read(33)
      read(33)(s(i,j),j=1,nao)
      read(33)
      read(33)
43    read(33)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, XZ',ione)
      rewind 33
      do 44 i=1,nao
      read(33)
      read(33)
      read(33)
      read(33)(s(i,j),j=1,nao)
      read(33)
44    read(33)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, YY',ione)
      rewind 33
      do 45 i=1,nao
      read(33)
      read(33)
      read(33)
      read(33)
      read(33)(s(i,j),j=1,nao)
45    read(33)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, YZ',ione)
      rewind 33
      do 46 i=1,nao
      read(33)
      read(33)
      read(33)
      read(33)
      read(33)
46    read(33)(s(i,j),j=1,nao)
      call wmtr(s,nort,nao,'Quadrupole Overlaps, AO, ZZ',ione)
      close(33)
      endif
c
      if(lvprint)then
      call wff('V.SCR','Dipole velocities, AO, M',nao,s,nort)
      call wff('W.SCR','Angular GIAO w, AO, M',nao,s,nort)
      call wff('T.SCR','Angular GIAO t, AO, M',nao,s,nort)
      call wff('D.SCR','Angular GIAO d, AO, M',nao,s,nort)
      call wff('E.SCR','Angular GIAO e, AO, M',nao,s,nort)
      endif
c
      if(llprint)call wff('L.SCR','Angular moment, AO, L',nao,s,nort)
c
c
      write(6,*)' One electron integrals calculated by overlap6'
      return
      end
c
      subroutine inipoly
c
c     initializes the Pascal triangle up to the degree nd
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nd=24)
      common/poly/pp(nd,nd)
      one=dble(1)
      do 1 i=1,nd
      pp(i,1)=one
1     pp(i,i)=one
      do 2 i=3,nd
      do 2 j=2,i-1
2     pp(i,j)=pp(i-1,j-1)+pp(i-1,j)
      return
      end

      subroutine wff(s1,s2,nao,s,nort)
      character*(*) s1,s2
      integer*4 nao,nort,i,j
      real*8 s(nort,nort)
      open(33,file=s1,form='unformatted')
      do 53 i=1,nao
      read(33)(s(i,j),j=1,nao)
      read(33)
53    read(33)
      call wmtr(s,nort,nao,s2//'X',1)
      rewind 33
      do 54 i=1,nao
      read(33)
      read(33)(s(i,j),j=1,nao)
54    read(33)
      call wmtr(s,nort,nao,s2//'Y',1)
      rewind 33
      do 55 i=1,nao
      read(33)
      read(33)
55    read(33)(s(i,j),j=1,nao)
      call wmtr(s,nort,nao,s2//'Z',1)
      close(33)
      return
      end
