      subroutine overlapponly(P,nat0,xvi,xvj,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)
c     Ao dipole matrix
      implicit none
      integer*4 u0
      parameter (u0=28)

      integer*4 nat0,nor,noa,ish(nat0,nor),nop(*),nao
      real*8 P(3,nao,nao),xvi(3,nat0),xvj(3,nat0),alpha(nat0,nor)
      character*1 ty(nat0,nor)

      real*8 pi,clau,spt,bohr,debye
      common/const/pi,clau,spt,bohr,debye

      real*8 z0,one,two,three,four,five,six,half,qua,a8,a10
      common/numbers/z0,one,two,three,four,five,six,half,qua,a8,a10

      real*8 tol
      data tol/23.0d0/

      real*8 cci(u0),ccj(u0),b6(3,u0,u0),aai(u0,u0),
     1aaj(u0,u0),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),aag(u0,u0),aah(u0,u0),
     2aaii(u0,u0),spi,ai,aj,tt,t,ef,aij,r2ij,ec,
     4con,coe,xi,yi,zi,xj,yj,zj,xij,yij,zij,
     4x2ij,y2ij,z2ij,oi,sx,sy,sz,ox,oy,oz,
     4aiii,ajjj
      integer*4 nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),ia,
     1io,ioj,ioo,ip,ipp,ja,jo,joo,jp,jpp,npi,npii,npj,npjj
      logical ld5,lf7
c
      call inipoly
      call initfd(aa1,aad,aaf,aag,aah,aaii)

      spi=sqrt(pi*pi*pi)
      call vz(P,z0,nao*nao*3)
C
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa

      xi=xvi(1,ia)
      yi=xvi(2,ia)
      zi=xvi(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa

      xj=xvj(1,ja)
      yj=xvj(2,ja)
      zj=xvj(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      sx=oi(0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      sy=oi(0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      sz=oi(0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      ox =oi(1,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      oy =oi(1,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      oz =oi(1,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
c     electric dipole
      b6(1,ioo,joo)=ox*sy*sz*coe
      b6(2,ioo,joo)=sx*oy*sz*coe
71    b6(3,ioo,joo)=sx*sy*oz*coe
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       P(1,io+ioo,ioj)=P(1,io+ioo,ioj)+ajjj*b6(1,ipp,jpp)
       P(2,io+ioo,ioj)=P(2,io+ioo,ioj)+ajjj*b6(2,ipp,jpp)
74     P(3,io+ioo,ioj)=P(3,io+ioo,ioj)+ajjj*b6(3,ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       P(1,io+ioo,ioj)=P(1,io+ioo,ioj)+b6(1,ioo,joo)
       P(2,io+ioo,ioj)=P(2,io+ioo,ioj)+b6(2,ioo,joo)
7      P(3,io+ioo,ioj)=P(3,io+ioo,ioj)+b6(3,ioo,joo)
      endif

777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip)) io=io+npii
c     if last primitive of the orbitals io+1 ... io+npii, then write them
      
3     continue
2     continue

      return
      end
