      subroutine overlaps(il,icon)
c
c     calculates AO overlap integrals of the types (index L over atoms)
c     1) <a||r-rL|^(-3) (r-rL)_i       |b> i=1..3            F1.SCR
c     2) <a||r-rL|^(-3)((r-rL)xgrad)_i |b> i=1..3            F2.SCR
c     3) <a||r-rL|^(-3) (r-rL)_i r_j   |b> i=1..3, j=1..3    F3.SCR
c
c     icon=0 ... calculates all F1, F2, F3
c     icon=1 ... calculates only F1 multiplied by atomic charges
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,n1e=15,mmax=21)
      integer*4 u0
      parameter (u0=28)
c     n1e ... number of kinds of one-electron integrals
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),st(nort,nort),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(n1e,u0,nort),b6(n1e,u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),t(mmax),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,ld5,lf7,lopt,lgiao
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4 ),ld5),(lopt(8),lf7),
     1(lopt(32),lgiao)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      data i0,ione,itwo,ithree,tol/0,1,2,3,23.0D0/
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overlaps')
      if(lgiao)write(3,*)' Gauge invariant (London) atomic orbitals'
C
      open(33,file='F1.SCR',form='unformatted')
      if(icon.eq.0)then
      open(34,file='F2.SCR',form='unformatted')
      open(35,file='F3.SCR',form='unformatted')
      endif
c
c     define atomic coordinates
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
c
      do 10 i=1,nao
      do 10 j=1,u0
      do 10 k=1,n1e
10    sv(k,j,i)=z0
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ty(ia,ip).eq.'S')mi=0
      if(ty(ia,ip).eq.'P')mi=1
      if(ty(ia,ip).eq.'L')mi=1
      if(ty(ia,ip).eq.'D')mi=2
      if(ty(ia,ip).eq.'F')mi=3

c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      r2ij= xij*xij+yij*yij+zij*zij
c
c     Q=Ri x Rj
      Qnlx=yi*zj-zi*yj
      Qnly=zi*xj-xi*zj
      Qnlz=xi*yj-yi*xj
c
c     R=Ri-Rj    (notation:R.Ditchfield,Mol. Phys., 1974, 27/4,789-807)
      Rnlx=-xij
      Rnly=-yij
      Rnlz=-zij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      if(ty(ja,jp).eq.'S')mj=0
      if(ty(ja,jp).eq.'P')mj=1
      if(ty(ja,jp).eq.'L')mj=1
      if(ty(ja,jp).eq.'D')mj=2
      if(ty(ja,jp).eq.'F')mj=3
      mij=mi+mj
      aij=ai+aj
      bb=aj+aj
      sigmap=one/aij
      hsp=half*sigmap
      ecp=ai*aj*sigmap*r2ij
c
c     thenthen**************************************************
c
      if(ecp.lt.tol)then
      upp=pi*sigmap
      up0=sqrt(upp*upp*upp)*exp(-ecp)
      px=(ai*xi+aj*xj)*sigmap
      py=(ai*yi+aj*yj)*sigmap
      pz=(ai*zi+aj*zj)*sigmap
      call iactivate(mij+2,i0,xl,yl,zl,px,py,pz,t,
     1               pqx,pqy,pqz,hsp,z0,tol)
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      anjx=dble(njx)
      anjy=dble(njy)
      anjz=dble(njz)
      up1=up0*ccj(joo)
      do 71 ioo=1,npi
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)
      up=up1*cci(ioo)
c
c     uq multiplied by sqrt((al/pi)^3), to have a delta-function
c
c     V=(a| z(il)(r-r_il)^-1|b)
c     V=up*oc4d(nix,niy,niz,njx,njy,njz,t, xij,yij,zij,
c    1pqx,pqy,pqz, hsp,aa,bb, i0)
c
c     1) <a||r-rL|^(-3) (r-rL)_i |b>  = dV/drL_i
c
c     2) <a||r-rL|^(-3)((r-rL)xgrad)_i |b> = jk - kj
c        <a||r-rL|^(-3) (r-rL)_j grad_k |b> =
c        bk dV(b-1k)/drL_j - 2 beta dV(b+1k)/drL_j
c
c     3) <a||r-rL|^(-3) (r-rL)_j r_k   |b> = dV(b+1k)+ B_k dV/drL_j
c
      Vx  =up*oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      Vy  =up*oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      Vz  =up*oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
c
      if(icon.eq.1)then
       b6( 1,ioo,joo)=-Vx*z(il)
       b6( 2,ioo,joo)=-Vy*z(il)
       b6( 3,ioo,joo)=-Vz*z(il)
      endif
c
      if(icon.eq.0)T H E N
      b6( 1,ioo,joo)=Vx
      b6( 2,ioo,joo)=Vy
      b6( 3,ioo,joo)=Vz
      Vxmy=up*oc4d(nix,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      Vxmz=up*oc4d(nix,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      Vxpx=up*oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      Vxpy=up*oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      Vxpz=up*oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
c
      Vymx=up*oc4d(nix,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      Vymz=up*oc4d(nix,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      Vypx=up*oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      Vypy=up*oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      Vypz=up*oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
c
      Vzmx=up*oc4d(nix,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      Vzmy=up*oc4d(nix,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      Vzpx=up*oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      Vzpy=up*oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      Vzpz=up*oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
c
      if(lgiao)THEN
      VXxmy=up*oc4d(nix+1,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VXxmz=up*oc4d(nix+1,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VXxpy=up*oc4d(nix+1,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VXxpz=up*oc4d(nix+1,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
c
      VXymx=up*oc4d(nix+1,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VXymz=up*oc4d(nix+1,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VXypx=up*oc4d(nix+1,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VXypz=up*oc4d(nix+1,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
c
      VXzmx=up*oc4d(nix+1,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VXzmy=up*oc4d(nix+1,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VXzpx=up*oc4d(nix+1,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VXzpy=up*oc4d(nix+1,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
c
      VYxmy=up*oc4d(nix,niy+1,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VYxmz=up*oc4d(nix,niy+1,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VYxpy=up*oc4d(nix,niy+1,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VYxpz=up*oc4d(nix,niy+1,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
c
      VYymx=up*oc4d(nix,niy+1,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VYymz=up*oc4d(nix,niy+1,niz,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VYypx=up*oc4d(nix,niy+1,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VYypz=up*oc4d(nix,niy+1,niz,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
c
      VYzmx=up*oc4d(nix,niy+1,niz,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VYzmy=up*oc4d(nix,niy+1,niz,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VYzpx=up*oc4d(nix,niy+1,niz,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VYzpy=up*oc4d(nix,niy+1,niz,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
c
      VZxmy=up*oc4d(nix,niy,niz+1,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VZxmz=up*oc4d(nix,niy,niz+1,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VZxpy=up*oc4d(nix,niy,niz+1,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
      VZxpz=up*oc4d(nix,niy,niz+1,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ione)
c
      VZymx=up*oc4d(nix,niy,niz+1,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VZymz=up*oc4d(nix,niy,niz+1,njx,njy,njz-1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VZypx=up*oc4d(nix,niy,niz+1,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
      VZypz=up*oc4d(nix,niy,niz+1,njx,njy,njz+1,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,itwo)
c
      VZzmx=up*oc4d(nix,niy,niz+1,njx-1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VZzmy=up*oc4d(nix,niy,niz+1,njx,njy-1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VZzpx=up*oc4d(nix,niy,niz+1,njx+1,njy,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      VZzpy=up*oc4d(nix,niy,niz+1,njx,njy+1,njz,t, xij,yij,zij,
     1pqx,pqy,pqz, hsp,aa,bb,ithree)
      ENDIF
c
c     L=(r-rL) x grad
      alx =anjz*Vymz -anjy*Vzmy -bb*(Vypz -Vzpy )
      aly =anjx*Vzmx -anjz*Vxmz -bb*(Vzpx -Vxpz )
      alz =anjy*Vxmy -anjx*Vymx -bb*(Vxpy -Vypx )
      aXlx=anjz*VXymz-anjy*VXzmy-bb*(VXypz-VXzpy)
      aXly=anjx*VXzmx-anjz*VXxmz-bb*(VXzpx-VXxpz)
      aXlz=anjy*VXxmy-anjx*VXymx-bb*(VXxpy-VXypx)
      aYlx=anjz*VYymz-anjy*VYzmy-bb*(VYypz-VYzpy)
      aYly=anjx*VYzmx-anjz*VYxmz-bb*(VYzpx-VYxpz)
      aYlz=anjy*VYxmy-anjx*VYymx-bb*(VYxpy-VYypx)
      aZlx=anjz*VZymz-anjy*VZzmy-bb*(VZypz-VZzpy)
      aZly=anjx*VZzmx-anjz*VZxmz-bb*(VZzpx-VZxpz)
      aZlz=anjy*VZxmy-anjx*VZymx-bb*(VZxpy-VZypx)
c
c x=yz-zy   first index-nuclear coordinate, changed in dnmr output
      b6( 4,ioo,joo)=alx
c y=zx-xz
      b6( 5,ioo,joo)=aly
c z=xy-yx
      b6( 6,ioo,joo)=alz
c xx xy xz  yx yy yz  zx zy zz
      if(lgiao)then

       oxx=Qnlx*alx+Rnly*aZlx -Rnlz*aYlx
       oxy=Qnlx*aly+Rnly*aZly -Rnlz*aYly
       oxz=Qnlx*alz+Rnly*aZlz -Rnlz*aYlz
       oyx=Qnly*alx+Rnlz*aXlx -Rnlx*aZlx
       oyy=Qnly*aly+Rnlz*aXly -Rnlx*aZly
       oyz=Qnly*alz+Rnlz*aXlz -Rnlx*aZlz
       ozx=Qnlz*alx+Rnlx*aYlx -Rnly*aXlx
       ozy=Qnlz*aly+Rnlx*aYly -Rnly*aXly
       ozz=Qnlz*alz+Rnlx*aYlz -Rnly*aXlz
       b6( 7,ioo,joo)=oxx+Vypy+Vzpz
       b6( 8,ioo,joo)=oxy-Vxpy
       b6( 9,ioo,joo)=oxz-Vxpz
       b6(10,ioo,joo)=oyx-Vypx
       b6(11,ioo,joo)=oyy+Vxpx+Vzpz
       b6(12,ioo,joo)=oyz-Vypz
       b6(13,ioo,joo)=ozx-Vzpx
       b6(14,ioo,joo)=ozy-Vzpy
       b6(15,ioo,joo)=ozz+Vypy+Vxpx
      else
       b6( 7,ioo,joo)= Vzpz+zj*Vz+Vypy+yj*Vy
       b6( 8,ioo,joo)=-Vxpy-yj*Vx
       b6( 9,ioo,joo)=-Vxpz-zj*Vx
c
       b6(10,ioo,joo)=-Vypx-xj*Vy
       b6(11,ioo,joo)= Vxpx+xj*Vx+Vzpz+zj*Vz
       b6(12,ioo,joo)=-Vypz-zj*Vy
c
       b6(13,ioo,joo)=-Vzpx-xj*Vz
       b6(14,ioo,joo)=-Vzpy-yj*Vz
       b6(15,ioo,joo)= Vxpx+xj*Vx+Vypy+yj*Vy
      endif
      E L S E
       b6( 7,ioo,joo)=z0
       b6( 8,ioo,joo)=z0
       b6( 9,ioo,joo)=z0
       b6(10,ioo,joo)=z0
       b6(11,ioo,joo)=z0
       b6(12,ioo,joo)=z0
       b6(13,ioo,joo)=z0
       b6(14,ioo,joo)=z0
       b6(15,ioo,joo)=z0
      E N D I F
c
71    continue
c
c     thenthen ***********************************
      else
c
      do 72 joo=1,npj
      do 72 ioo=1,npi
      do 72 k=1,n1e
72    b6(k,ioo,joo)=z0
c
      endif
c     thenthen ***********************************
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       do 74 k=1,n1e
74     sv(k,ioo,ioj)=sv(k,ioo,ioj)+ajjj*b6(k,ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
       do 7 k=1,n1e
7      sv(k,ioo,ioj)=sv(k,ioo,ioj)+b6(k,ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iind=0
       do 33 k=1,3
       write(33)(sv(k,ii,jj),jj=1,nao)
       if(icon.eq.0)write(34)(sv(3+k,ii,jj),jj=1,nao)
       do 33 l=1,3
       iind=iind+1
33     if(icon.eq.0)write(35)(sv(6+iind,ii,jj),jj=1,nao)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       do 9 kk=1,n1e
9      sv(kk,ii,jj)=z0
      endif
2     continue
c
      close(33)
      if(icon.eq.0)then
      close(34)
      close(35)
      endif
c
      if(lsprint)then
c
      open(33,file='F1.SCR',form='unformatted')
      do 40 i=1,nao
      read(33)(st(i,j),j=1,nao)
      read(33)
40    read(33)
      call wmtr(st,nort,nao,'F1-x, AO',ione)
      rewind(33)
      do 45 i=1,nao
      read(33)
      read(33)(st(i,j),j=1,nao)
45    read(33)
      call wmtr(st,nort,nao,'F1-y, AO',ione)
      rewind(33)
      do 47 i=1,nao
      read(33)
      read(33)
47    read(33)(st(i,j),j=1,nao)
      call wmtr(st,nort,nao,'F1-z, AO',ione)
      close(33)
c
      if(icon.eq.0)then
      open(34,file='F2.SCR',form='unformatted')
      do 43 i=1,nao
      read(34)(st(i,j),j=1,nao)
      read(34)
43    read(34)
      call wmtr(st,nort,nao,'F2-x, AO',ione)
      rewind(34)
      do 41 i=1,nao
      read(34)
      read(34)(st(i,j),j=1,nao)
41    read(34)
      call wmtr(st,nort,nao,'F2-y, AO',ione)
      rewind(34)
      do 48 i=1,nao
      read(34)
      read(34)
48    read(34)(st(i,j),j=1,nao)
      call wmtr(st,nort,nao,'F2-z, AO',ione)
      close(34)
c
      open(35,file='F3.SCR',form='unformatted')
      do 44 i=1,nao
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
44    read(35)
      call wmtr(st,nort,nao,'F3-xx, AO',ione)
      rewind(35)
      do 46 i=1,nao
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
46    read(35)
      call wmtr(st,nort,nao,'F3-xy, AO',ione)
      rewind(35)
      do 49 i=1,nao
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
49    read(35)
      call wmtr(st,nort,nao,'F3-xz, AO',ione)
      rewind(35)
      do 51 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
      read(35)
      read(35)
51    read(35)
      call wmtr(st,nort,nao,'F3-yx, AO',ione)
      rewind 35
      do 53 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
      read(35)
53    read(35)
      call wmtr(st,nort,nao,'F3-yy, AO',ione)
      rewind 35
      do 55 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
      read(35)
55    read(35)
      call wmtr(st,nort,nao,'F3-yz, AO',ione)
      rewind 35
      do 57 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
      read(35)
57    read(35)
      call wmtr(st,nort,nao,'F3-zx, AO',ione)
      rewind 35
      do 59 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)(st(i,j),j=1,nao)
59    read(35)
      call wmtr(st,nort,nao,'F3-zy, AO',ione)
      rewind 35
      do 61 i=1,nao
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
      read(35)
61    read(35)(st(i,j),j=1,nao)
      call wmtr(st,nort,nao,'F3-zz, AO',ione)
      close(35)
      endif
      endif
c
      if(icon.eq.0)then
       write(6,900)
       write(3,900)
      else
       write(6,901)
       write(3,901)
      endif
900   format('NMR and coordinate derivative AO integrals by overlaps')
901   format('coordinate derivative AO integrals by overlaps')
c
      return
      end
