      subroutine overlazz(il,ix,buff)
c
c     calculates AO overlap integrals of gradients
c     <a||r-rL|^(-3) (r-rL)_ix       |b> , store in buff
c     with fuzzy nuclear charge distributions
c      d/dx_l_ix (a b | 0(al) 0) =2*al (a b 1 0)
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,mmax=21)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),t(mmax),buff(nort,nort),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4 ),ld5),(lopt(8),lf7),(ropt(2),rfuz)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/ropts/ropt(300)
      data atol,tol/1.0d-20,29.0D0/
      logical lsx,lsy,lsz
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
C
c     define atomic coordinates
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
      al=one/rfuz**2
      AAc=-two*al*z(il)
      dd=al+al
      hsq=one/dd
      nxl=0
      nyl=0
      nzl=0
      if(ix.eq.1)nxl=1
      if(ix.eq.2)nyl=1
      if(ix.eq.3)nzl=1
      gg=0.0d0
      lsx=.false.
      lsy=.false.
      lsz=.false.
c
      call vz(buff,z0,nort*nort)
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ty(ia,ip).eq.'S')mi=0
      if(ty(ia,ip).eq.'P')mi=1
      if(ty(ia,ip).eq.'L')mi=1
      if(ty(ia,ip).eq.'D')mi=2
      if(ty(ia,ip).eq.'F')mi=3

c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      r2ij= xij*xij+yij*yij+zij*zij
c
c     primitive functions on atom ja:
      do 4 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      if(ty(ja,jp).eq.'S')mj=0
      if(ty(ja,jp).eq.'P')mj=1
      if(ty(ja,jp).eq.'L')mj=1
      if(ty(ja,jp).eq.'D')mj=2
      if(ty(ja,jp).eq.'F')mj=3
      mij=mi+mj
      aij=ai+aj
      bb=aj+aj
      sigmap=one/aij
      hsp=half*sigmap
      ecp=ai*aj*sigmap*r2ij
c
      if(ecp.lt.tol)then
       upp=pi*sigmap
       up0=sqrt(upp*upp*upp)*exp(-ecp)*AAc
       px=(ai*xi+aj*xj)*sigmap
       py=(ai*yi+aj*yj)*sigmap
       pz=(ai*zi+aj*zj)*sigmap
       call iactivate(mij,1,xl,yl,zl,px,py,pz,t,
     1               pqx,pqy,pqz,hsp,hsq,tol)
c
C      Loop over orbitals to which the primitives ip, jp contribute
       do 71 ioo=1,npi
       nix=nxi(ioo)
       niy=nyi(ioo)
       niz=nzi(ioo)
       up1=up0*cci(ioo)
       do 71 joo=1,npj
       njx=nxj(joo)
       njy=nyj(joo)
       njz=nzj(joo)
       mmx=njx+njy+njz+nix+niy+niz+1
       fac=up1*ccj(joo)*oce2(nix,niy,niz,njx,njy,njz,0,0,0,nxl,nyl,nzl,
     1xij,yij,zij,xl,yl,zl,pqx,pqy,pqz, hsp,hsq,aa,bb,gg,dd,
     2mmx,t,atol,lsx,lsy,lsz)
c
       if(il.eq.1.and.ix.eq.1)then
       if(ia.eq.1.and.ja.eq.1.
     1 and.joo.eq.2.and.ioo.eq.1.and.ip.eq.1.and.jp.eq.7)then
c       write(6,*)'fac',fac
        endif
        endif

71     b6(ioo,joo)=fac
      else
       do 72 joo=1,npj
       do 72 ioo=1,npi
72     b6(ioo,joo)=z0
      endif
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     buff(io+ioo,ioj)=buff(io+ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
7      buff(io+ioo,ioj)=buff(io+ioo,ioj)+b6(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip)) io=io+npii
c
2     continue
c
      return
      end
