      subroutine overnmr(il,icon)
c
c     calculates AO overlap integrals of the types (index L over atoms)
c     1) <a||r-rL|^(-3) (r-rL)_i          |b>i=1..3         F1.SCR 33  1.. 3
c     2) <a||r-rL|^(-3)((r-rL)xgrad)_i    |b>i=1..3         F2.SCR 34  4.. 6
c     3) <a||r-rL|^(-3) (r-rL)_i r_j      |b>i=1..3, j=1..3 F3.SCR 35  7..15
c     4) <a||r-rL|^(-3) r_i [(r-rL) x r]_j|b>i=1..3, j=1..3 F4.SCR 36 16..24
c     5) giao part to F3                                    F5.SCR 37 25..33
c
c     icon=0 ... calculates all F1, F2, F3, F4, F5
c     icon=1 ... calculates only F1 multiplied by atomic charges
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,n1e=33,mmax=21,
     1ntypes=5)
      integer*4 u0
      parameter (u0=28)
c     n1e ... number of kinds of one-electron integrals
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),st(nort,nort),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(n1e*u0*nort),b6(n1e*u0*u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),t(mmax),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,ld5,lf7,lopt,lgiao
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4 ),ld5),(lopt(8),lf7),
     1(lopt(32),lgiao)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      data i0,ione,itwo,ithree,tol/0,1,2,3,23.0D0/
      character*6 fao(ntypes)
      data fao/'F1.SCR','F2.SCR','F3.SCR','F4.SCR','F5.SCR'/
      dimension jxd(ntypes)
      data jxd/3,3,9,9,9/
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overlaps')
      if(lgiao)write(3,*)' Gauge invariant (London) atomic orbitals'
      if(lgiao)write(6,*)' Gauge invariant (London) atomic orbitals'
C
      open(33,file='F1.SCR',form='unformatted')
      if(icon.eq.0)then
       do i=2,ntypes
        open(32+i,file=fao(i),form='unformatted')
       enddo
      endif
c
c     define atomic coordinates
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
c
      do i=1,n1e*u0*nort
       sv(i)=0.0d0
      enddo
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ty(ia,ip).eq.'S')mi=0
      if(ty(ia,ip).eq.'P')mi=1
      if(ty(ia,ip).eq.'L')mi=1
      if(ty(ia,ip).eq.'D')mi=2
      if(ty(ia,ip).eq.'F')mi=3
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      r2ij= xij*xij+yij*yij+zij*zij
c
c     Q=Ri x Rj
      Qnlx=yi*zj-zi*yj
      Qnly=zi*xj-xi*zj
      Qnlz=xi*yj-yi*xj
c
c     R=Ri-Rj    (notation:R.Ditchfield,Mol. Phys., 1974, 27/4,789-807)
      Rnlx=-xij
      Rnly=-yij
      Rnlz=-zij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      if(ty(ja,jp).eq.'S')mj=0
      if(ty(ja,jp).eq.'P')mj=1
      if(ty(ja,jp).eq.'L')mj=1
      if(ty(ja,jp).eq.'D')mj=2
      if(ty(ja,jp).eq.'F')mj=3
      mij=mi+mj
      aij=ai+aj
      bb=aj+aj
      sigmap=one/aij
      hsp=half*sigmap
      ecp=ai*aj*sigmap*r2ij
      do joo=1,npj
       do ioo=1,npi
        ijoo=n1e*(ioo+(joo-1)*u0-1)
        do k=1,n1e
         b6(k+ijoo)=0.0d0
        enddo
       enddo
      enddo
      if(ecp.lt.tol)then
       upp=pi*sigmap
       up0=sqrt(upp*upp*upp)*exp(-ecp)
       px=(ai*xi+aj*xj)*sigmap
       py=(ai*yi+aj*yj)*sigmap
       pz=(ai*zi+aj*zj)*sigmap
       call iactivate(mij+2,i0,xl,yl,zl,px,py,pz,t,
     1 pqx,pqy,pqz,hsp,z0,tol)
c
C      Loop over orbitals to which the primitives ip, jp contribute
       do 71 joo=1,npj
       njx=nxj(joo)
       njy=nyj(joo)
       njz=nzj(joo)
       anjx=dble(njx)
       anjy=dble(njy)
       anjz=dble(njz)
       up1=up0*ccj(joo)
       do 71 ioo=1,npi
       ijoo=n1e*(ioo+(joo-1)*u0-1)
       do 72 k=1,n1e
72     b6(k+ijoo)=z0
       nix=nxi(ioo)
       niy=nyi(ioo)
       niz=nzi(ioo)
       up=up1*cci(ioo)
c
c      uq multiplied by sqrt((al/pi)^3), to have a delta-function
c
c      V=(a| z(il)(r-r_il)^-1|b)
c      V=oc4d(nix,niy,niz,njx,njy,njz,t, xij,yij,zij,
c     1pqx,pqy,pqz, hsp,aa,bb, i0)
c
c     1) <a||r-rL|^(-3) (r-rL)_i |b>  = dV/drL_i
c
c     2) <a||r-rL|^(-3)((r-rL)xgrad)_i |b> = jk - kj
c        <a||r-rL|^(-3) (r-rL)_j grad_k |b> =
c        bk dV(b-1k)/drL_j - 2 beta dV(b+1k)/drL_j
c
c     3) <a||r-rL|^(-3) (r-rL)_j r_k   |b> = dV(b+1k)+ B_k dV/drL_j
c
       Vx  =oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1 pqx,pqy,pqz, hsp,aa,bb,ione)
       Vy  =oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1 pqx,pqy,pqz, hsp,aa,bb,itwo)
       Vz  =oc4d(nix,niy,niz,njx,njy,njz  ,t, xij,yij,zij,
     1 pqx,pqy,pqz, hsp,aa,bb,ithree)
c
       if(icon.eq.1)THEN
        b6( 1+ijoo)=-Vx*z(il)
        b6( 2+ijoo)=-Vy*z(il)
        b6( 3+ijoo)=-Vz*z(il)
       ELSE
        b6( 1+ijoo)=Vx
        b6( 2+ijoo)=Vy
        b6( 3+ijoo)=Vz
        Vxmy=oc4d(nix,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ione)
        Vxmz=oc4d(nix,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ione)
        Vxpx=oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ione)
        Vxpy=oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ione)
        Vxpz=oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ione)
c
        Vymx=oc4d(nix,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,itwo)
        Vymz=oc4d(nix,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,itwo)
        Vypx=oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,itwo)
        Vypy=oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,itwo)
        Vypz=oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,itwo)
c
        Vzmx=oc4d(nix,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ithree)
        Vzmy=oc4d(nix,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ithree)
        Vzpx=oc4d(nix,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ithree)
        Vzpy=oc4d(nix,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ithree)
        Vzpz=oc4d(nix,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1  pqx,pqy,pqz, hsp,aa,bb,ithree)
c
c       L=(r-rL) x grad
        alx =anjz*Vymz -anjy*Vzmy -bb*(Vypz -Vzpy )
        aly =anjx*Vzmx -anjz*Vxmz -bb*(Vzpx -Vxpz )
        alz =anjy*Vxmy -anjx*Vymx -bb*(Vxpy -Vypx )
        b6( 4+ijoo)=alx
        b6( 5+ijoo)=aly
        b6( 6+ijoo)=alz
c       xx xy xz  yx yy yz  zx zy zz, without giao:
        b6( 7+ijoo)= Vzpz+zj*Vz+Vypy+yj*Vy
        b6( 8+ijoo)=-Vxpy-yj*Vx
        b6( 9+ijoo)=-Vxpz-zj*Vx
        b6(10+ijoo)=-Vypx-xj*Vy
        b6(11+ijoo)= Vxpx+xj*Vx+Vzpz+zj*Vz
        b6(12+ijoo)=-Vypz-zj*Vy
        b6(13+ijoo)=-Vzpx-xj*Vz
        b6(14+ijoo)=-Vzpy-yj*Vz
        b6(15+ijoo)= Vxpx+xj*Vx+Vypy+yj*Vy
c
        if(lgiao)THEN
         VXxmy=oc4d(nix+1,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VXxmz=oc4d(nix+1,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VXxpy=oc4d(nix+1,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VXxpz=oc4d(nix+1,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
c
         VXymx=oc4d(nix+1,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VXymz=oc4d(nix+1,niy,niz,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VXypx=oc4d(nix+1,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VXypz=oc4d(nix+1,niy,niz,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
c
         VXzmx=oc4d(nix+1,niy,niz,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VXzmy=oc4d(nix+1,niy,niz,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VXzpx=oc4d(nix+1,niy,niz,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VXzpy=oc4d(nix+1,niy,niz,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
c
         VYxmy=oc4d(nix,niy+1,niz,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VYxmz=oc4d(nix,niy+1,niz,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VYxpy=oc4d(nix,niy+1,niz,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VYxpz=oc4d(nix,niy+1,niz,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
c
         VYymx=oc4d(nix,niy+1,niz,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VYymz=oc4d(nix,niy+1,niz,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VYypx=oc4d(nix,niy+1,niz,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VYypz=oc4d(nix,niy+1,niz,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
c
         VYzmx=oc4d(nix,niy+1,niz,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VYzmy=oc4d(nix,niy+1,niz,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VYzpx=oc4d(nix,niy+1,niz,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VYzpy=oc4d(nix,niy+1,niz,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
c
         VZxmy=oc4d(nix,niy,niz+1,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VZxmz=oc4d(nix,niy,niz+1,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VZxpy=oc4d(nix,niy,niz+1,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
         VZxpz=oc4d(nix,niy,niz+1,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ione)
c
         VZymx=oc4d(nix,niy,niz+1,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VZymz=oc4d(nix,niy,niz+1,njx,njy,njz-1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VZypx=oc4d(nix,niy,niz+1,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
         VZypz=oc4d(nix,niy,niz+1,njx,njy,njz+1,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,itwo)
c
         VZzmx=oc4d(nix,niy,niz+1,njx-1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VZzmy=oc4d(nix,niy,niz+1,njx,njy-1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VZzpx=oc4d(nix,niy,niz+1,njx+1,njy,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
         VZzpy=oc4d(nix,niy,niz+1,njx,njy+1,njz,t, xij,yij,zij,
     1   pqx,pqy,pqz, hsp,aa,bb,ithree)
c
         aXlx=anjz*VXymz-anjy*VXzmy-bb*(VXypz-VXzpy)
         aXly=anjx*VXzmx-anjz*VXxmz-bb*(VXzpx-VXxpz)
         aXlz=anjy*VXxmy-anjx*VXymx-bb*(VXxpy-VXypx)
         aYlx=anjz*VYymz-anjy*VYzmy-bb*(VYypz-VYzpy)
         aYly=anjx*VYzmx-anjz*VYxmz-bb*(VYzpx-VYxpz)
         aYlz=anjy*VYxmy-anjx*VYymx-bb*(VYxpy-VYypx)
         aZlx=anjz*VZymz-anjy*VZzmy-bb*(VZypz-VZzpy)
         aZly=anjx*VZzmx-anjz*VZxmz-bb*(VZzpx-VZxpz)
         aZlz=anjy*VZxmy-anjx*VZymx-bb*(VZxpy-VZypx)
c
         oxx=Qnlx*alx+Rnly*aZlx -Rnlz*aYlx
         oxy=Qnlx*aly+Rnly*aZly -Rnlz*aYly
         oxz=Qnlx*alz+Rnly*aZlz -Rnlz*aYlz
         oyx=Qnly*alx+Rnlz*aXlx -Rnlx*aZlx
         oyy=Qnly*aly+Rnlz*aXly -Rnlx*aZly
         oyz=Qnly*alz+Rnlz*aXlz -Rnlx*aZlz
         ozx=Qnlz*alx+Rnlx*aYlx -Rnly*aXlx
         ozy=Qnlz*aly+Rnlx*aYly -Rnly*aXly
         ozz=Qnlz*alz+Rnlx*aYlz -Rnly*aXlz
c        xx xy xz  yx yy yz  zx zy zz, giao:
c        paramagnetic contribution to effective diamagnetic shielding:
         b6(25+ijoo)=oxx-zj*Vz-yj*Vy
         b6(26+ijoo)=oxy+yj*Vx
         b6(27+ijoo)=oxz+zj*Vx
         b6(28+ijoo)=oyx+xj*Vy
         b6(29+ijoo)=oyy-xj*Vx-zj*Vz
         b6(30+ijoo)=oyz+zj*Vy
         b6(31+ijoo)=ozx+xj*Vz
         b6(32+ijoo)=ozy+yj*Vz
         b6(33+ijoo)=ozz-xj*Vx-yj*Vy
c
c        xx xy xz  yx yy yz  zx zy zz, with giao to SOS:
c        first index - r, second -angular
         b6(16+ijoo)=anjz*(VXymz+xi*Vymz)-bb*(VXypz+xi*Vypz)
     1              -anjy*(VXzmy+xi*Vzmy)+bb*(VXzpy+xi*Vzpy)
         b6(17+ijoo)=anjx*(VXzmx+xi*Vzmx)-bb*(VXzpx+xi*Vzpx)
     1              -anjz*(VXxmz+xi*Vxmz)+bb*(VXxpz+xi*Vxpz)
         b6(18+ijoo)=anjy*(VXxmy+xi*Vxmy)-bb*(VXxpy+xi*Vxpy)
     1              -anjx*(VXymx+xi*Vymx)+bb*(VXypx+xi*Vypx)
c
         b6(19+ijoo)=anjz*(VYymz+yi*Vymz)-bb*(VYypz+yi*Vypz)
     1              -anjy*(VYzmy+yi*Vzmy)+bb*(VYzpy+yi*Vzpy)
         b6(20+ijoo)=anjx*(VYzmx+yi*Vzmx)-bb*(VYzpx+yi*Vzpx)
     1              -anjz*(VYxmz+yi*Vxmz)+bb*(VYxpz+yi*Vxpz)
         b6(21+ijoo)=anjy*(VYxmy+yi*Vxmy)-bb*(VYxpy+yi*Vxpy)
     1              -anjx*(VYymx+yi*Vymx)+bb*(VYypx+yi*Vypx)
c
         b6(22+ijoo)=anjz*(VZymz+zi*Vymz)-bb*(VZypz+zi*Vypz)
     1              -anjy*(VZzmy+zi*Vzmy)+bb*(VZzpy+zi*Vzpy)
         b6(23+ijoo)=anjx*(VZzmx+zi*Vzmx)-bb*(VZzpx+zi*Vzpx)
     1              -anjz*(VZxmz+zi*Vxmz)+bb*(VZxpz+zi*Vxpz)
         b6(24+ijoo)=anjy*(VZxmy+zi*Vxmy)-bb*(VZxpy+zi*Vxpy)
     1              -anjx*(VZymx+zi*Vymx)+bb*(VZypx+zi*Vypx)
        ENDIF
c       giao
       ENDIF
c      con
c
       do k=1,n1e
        b6(k+ijoo)=b6(k+ijoo)*up
       enddo
c
71     continue
c
      endif
c     ecp.gt.tol
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       ijoo=n1e*(ioo+(ioj-1)*u0-1)
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ijpp=n1e*(ipp+(jpp-1)*u0-1)
       ajjj=aaj(joo,jpp)*aiii
       do 74 k=1,n1e
74     sv(k+ijoo)=sv(k+ijoo)+ajjj*b6(k+ijpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
       ijos=n1e*(ioo+(ioj-1)*u0-1)
       ijoo=n1e*(ioo+(joo-1)*u0-1)
       do 7 k=1,n1e
7      sv(k+ijos)=sv(k+ijos)+b6(k+ijoo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 331 k=1,3
331    write(33)(sv(k+n1e*(ii+(jj-1)*u0-1)),jj=1,nao)
       if(icon.eq.0)then
        do 332 k=4,6
332     write(34)(sv(k+n1e*(ii+(jj-1)*u0-1)),jj=1,nao)
        do 333 k=7,15
333     write(35)(sv(k+n1e*(ii+(jj-1)*u0-1)),jj=1,nao)
        do 334 k=16,24
334     write(36)(sv(k+n1e*(ii+(jj-1)*u0-1)),jj=1,nao)
        do 335 k=25,33
335     write(37)(sv(k+n1e*(ii+(jj-1)*u0-1)),jj=1,nao)
       endif
33     continue
c
       io=io+npii
c
c      zero-out temporary buffer:
       do i=1,n1e*u0*nort
        sv(i)=0.0d0
       enddo
      endif
c
2     continue
c
      close(33)
      if(icon.eq.0)then
       do kk=2,ntypes
        close(32+kk)
       enddo
      endif
c
      if(lsprint)then
       if(icon.eq.0)then
        kend=5
       else
        kend=1
       endif
       do k=1,kend
        open(34,file=fao(k),form='unformatted')
        do jx=1,jxd(k)
         rewind(34)
         do i=1,nao
          do ii=1,jx-1
           read(34)
          enddo
          read(34)(st(i,j),j=1,nao)
          do ii=jx+1,jxd(k)
           read(34)
          enddo
         enddo
         if(k.eq.1)then
          if(jx.eq.1)call wmtr(st,nort,nao,'F1-x, AO',ione)
          if(jx.eq.2)call wmtr(st,nort,nao,'F1-y, AO',ione)
          if(jx.eq.3)call wmtr(st,nort,nao,'F1-z, AO',ione)
         endif
         if(k.eq.2)then
          if(jx.eq.1)call wmtr(st,nort,nao,'F2-x, AO',ione)
          if(jx.eq.2)call wmtr(st,nort,nao,'F2-y, AO',ione)
          if(jx.eq.3)call wmtr(st,nort,nao,'F2-z, AO',ione)
         endif
         if(k.eq.3)then
          if(jx.eq.1)call wmtr(st,nort,nao,'F3-xx, AO',ione)
          if(jx.eq.2)call wmtr(st,nort,nao,'F3-xy, AO',ione)
          if(jx.eq.3)call wmtr(st,nort,nao,'F3-xz, AO',ione)
          if(jx.eq.4)call wmtr(st,nort,nao,'F3-yx, AO',ione)
          if(jx.eq.5)call wmtr(st,nort,nao,'F3-yy, AO',ione)
          if(jx.eq.6)call wmtr(st,nort,nao,'F3-yz, AO',ione)
          if(jx.eq.7)call wmtr(st,nort,nao,'F3-zx, AO',ione)
          if(jx.eq.8)call wmtr(st,nort,nao,'F3-zy, AO',ione)
          if(jx.eq.9)call wmtr(st,nort,nao,'F3-zz, AO',ione)
         endif
         if(k.eq.4)then
          if(jx.eq.1)call wmtr(st,nort,nao,'F4-xx, AO',ione)
          if(jx.eq.2)call wmtr(st,nort,nao,'F4-xy, AO',ione)
          if(jx.eq.3)call wmtr(st,nort,nao,'F4-xz, AO',ione)
          if(jx.eq.4)call wmtr(st,nort,nao,'F4-yx, AO',ione)
          if(jx.eq.5)call wmtr(st,nort,nao,'F4-yy, AO',ione)
          if(jx.eq.6)call wmtr(st,nort,nao,'F4-yz, AO',ione)
          if(jx.eq.7)call wmtr(st,nort,nao,'F4-zx, AO',ione)
          if(jx.eq.8)call wmtr(st,nort,nao,'F4-zy, AO',ione)
          if(jx.eq.9)call wmtr(st,nort,nao,'F4-zz, AO',ione)
         endif
        enddo
        close(34)
       enddo
      endif
c
      if(icon.eq.0)then
       write(6,900)
       write(3,900)
      else
       write(6,901)
       write(3,901)
      endif
900   format('NMR and coordinate derivative AO integrals by overnmr')
901   format('coordinate derivative AO integrals by overnmr')
c
      return
      end
