      subroutine rehf(ehf,noa,en,et,ev,ej,ek,lconfig,hkin,hpot,bkin,
     1 bpot,nsorb,isomo,isos,ist,aj,ak)
c
c     hf energy
c     noa .number of atoms
c     en nuclear repulsion
c     et kinetic energy
c     ev nuclear-electron atraction
c     ej electron repulsion
c     ek electron correlation
c     nsorb  ... number of occupied spin-orpbitals
c     isomo ... molecular orbital
c     isos ... spin
c     ist ... link to ground state if lconfig=.true.

      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nort=700)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      logical lconfig
      dimension hkin(nort,nort),bkin(nort,nort),hpot(nort,nort),
     1bpot(nort,nort),isomo(2*nort),isos(2*nort),ist(2*nort),
     2aj(nort,nort),ak(nort,nort)
c
      en=z0
      do 1001 i=1,noa
      xi=xv(1,i)
      yi=xv(2,i)
      zi=xv(3,i)
      zzi=z(i)
      do 1001 j=i+1,noa
      ar=sqrt((xi-xv(1,j))**2+(yi-xv(2,j))**2+(zi-xv(3,j))**2)
1001  en=en+zzi*z(j)/ar
c
      et=z0
      ev=z0
      do 38 ks=1,nsorb
      k=isomo(ks)
      if(isos(ks).eq.1)then
       et=et+hkin(k,k)
       ev=ev+hpot(k,k)
      else
       et=et+bkin(k,k)
       ev=ev+bpot(k,k)
      endif
38    continue
c
      ej=z0
      ek=z0
      IF(LCONFIG)THEN
       do 1004 ks=1,nsorb
       k=ist(ks)
       ej=ej+aj(k,k)
       ek=ek-ak(k,k)
       do 1004 ls=ks+1,nsorb
       l=ist(ls)
       ej=ej+aj(k,l)
1004   if(isos(ks).eq.isos(ls))ek=ek-ak(k,l)
      ELSE
       do 1005 ks=1,nsorb
       k=isomo(ks)
       ej=ej+aj(k,k)
       ek=ek-ak(k,k)
       do 1005 ls=ks+1,nsorb
       l=isomo(ls)
       ej=ej+aj(k,l)
1005   if(isos(ks).eq.isos(ls))ek=ek-ak(k,l)
      ENDIF
c
      ehf=en+et+ev+ej+ek
      return
      end

