      subroutine roapp(kmo,ro,Nro3,ijk,Nro,nk)
c     writes the density of an orbital kmo into ro
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension ijk(3,Nro3),ro(Nro3)
      common/ro2/delG,xr0,yr0,zr0,npx,npy,npz
c
      write(6,*)'recording density in MO ',kmo
      I1=1
      I0=0
      nr=0
      sum=z0
      rolim=0.001D0
      dd=half*delG
      delV=delG**3
      x=xr0-dd
      do 4 ix=1,npx
      write(6,*)ix,'of',Nro
      x=x+delG
      y=yr0-dd
      do 4 iy=1,npy
      y=y+delG
      z=zr0-dd
      do 4 iz=1,npz
      z=z+delG
      call frox(u,x,y,z,kmo,kmo,I1,I0)
      if(u.gt.rolim)then
       nr=nr+1
       ro(nr)=u
       ijk(1,nr)=ix
       ijk(2,nr)=iy
       ijk(3,nr)=iz
       sum=sum+u
      endif
4     continue
      nk=nr
      sum=sum*delV
      write(3,*)' Sum of charge',sum
      write(6,*)' Sum of charge',sum
      write(6,*)nk,'points of',npx*npy*npz
      write(3,*)nk,'points of',npx*npy*npz
      return
      end
c
      subroutine setlr(Nro)
c     sets limits for density calculation
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nort=700,nor=80)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/ro2/delG,xr0,yr0,zr0,npx,npy,npz
      character*1 ok,ty
      character*2 at
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      dimension imax(nat0),imin(nat0),amax(nat0),amin(nat0)
c
c     loop over x,y,z:
      do 1 ix=1,3
c
c     find atoms with maximum and minimum values:
      imax(ix)=1
      imin(ix)=1
      amax(ix)=xv(ix,1)
      amin(ix)=xv(ix,1)
      do 2 ia=2,noa
      if(xv(ix,ia).gt.amax(ix))then
       amax(ix)=xv(ix,ia)
       imax(ix)=ia
      endif
      if(xv(ix,ia).lt.amin(ix))then
       amin(ix)=xv(ix,ia)
       imin(ix)=ia
      endif
2     continue
c
c     look for the most diffuse exponent and adjust the limits
      ia=imax(ix)
      almin=alpha(ia,1)
      ial=1
      do 3 ip=2,nop(ia)
      a=alpha(ia,ip)
      if(almin.gt.a)then
       almin=a
       ial=ip
      endif
3     continue
      ane=z0
      try=six
      if(ty(ia,ial).eq.'P')ane=one
      if(ty(ia,ial).eq.'L')ane=one
      if(ty(ia,ial).eq.'D')ane=two
      if(ty(ia,ial).eq.'F')ane=three
      if(ty(ia,ial).eq.'P')try=three
      if(ty(ia,ial).eq.'L')try=three
      if(ty(ia,ial).eq.'D')try=two
      if(ty(ia,ial).eq.'F')try=two
c
c     the biggest inversion point for x^ane *exp(-a*x**2)
      ri=sqrt((one+two*ane+sqrt(one+a8*ane))/four/almin)
      space=min(a10,try*ri)
      amax(ix)=amax(ix)+space
c
c     the same thing for min
      ia=imin(ix)
      almin=alpha(ia,1)
      ial=1
      do 5 ip=2,nop(ia)
      a=alpha(ia,ip)
      if(almin.gt.a)then
       almin=a
       ial=ip
      endif
5     continue
      ane=z0
      try=six
      if(ty(ia,ial).eq.'P')ane=one
      if(ty(ia,ial).eq.'L')ane=one
      if(ty(ia,ial).eq.'D')ane=two
      if(ty(ia,ial).eq.'F')ane=three
      if(ty(ia,ial).eq.'P')try=three
      if(ty(ia,ial).eq.'L')try=three
      if(ty(ia,ial).eq.'D')try=two
      if(ty(ia,ial).eq.'F')try=two
      ri=sqrt((one+two*ane+sqrt(one+a8*ane))/four/almin)
      space=min(a10,try*ri)
      amin(ix)=amin(ix)-space
1     continue
c
      xr0=amin(1)
      yr0=amin(2)
      zr0=amin(3)
      delx=(amax(1)-amin(1))/dble(Nro)
      dely=(amax(2)-amin(2))/dble(Nro)
      delz=(amax(3)-amin(3))/dble(Nro)
      delG=1.0000001D0*max(delx,dely,delz)
      npx=int(amax(1)-amin(1)/delG)
      npy=int(amax(2)-amin(2)/delG)
      npz=int(amax(3)-amin(3)/delG)
      amax(1)=amin(1)+dble(npx)*delG
      amax(2)=amin(2)+dble(npy)*delG
      amax(3)=amin(3)+dble(npz)*delG
      write(6,3000)amin(1),amax(1),delG,npx,amin(2),amax(2),delG,npy,
     1amin(3),amax(3),delG,npz
      write(3,3000)amin(1),amax(1),delG,npx,amin(2),amax(2),delG,npy,
     1amin(3),amax(3),delG,npz
3000  format(' Cage limits: X: ', F10.5,' - ',F10.5,'; step:',F8.6,
     1';',I3,' points,',/,
     1       '              Y: ', F10.5,' - ',F10.5,'; step:',F8.6,
     1';',I3,' points,',/,
     1       '              Z: ', F10.5,' - ',F10.5,'; step:',F8.6,
     1';',I3,' points.',/)
c
      return
      end
