      program simcap
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nmaxh=30,nemx=100000,npmax=10000)
      byte state(nemx,nmaxh)
      dimension cc(nmaxh,nmaxh),shi(nmaxh),en(nemx),sp(npmax),
     1x(npmax),ps(npmax)
      character*1 peaktype
c
      open(2,file='SIMCAP.INP')
      read(2,*)Hz
      read(2,*)ri,rx
      read(2,*)bw
      read(2,'(A)')peaktype
      read(2,*)np
      write(6,*)np,' points'
      read(2,*)nh
      if(nh.gt.nmaxh)then
       write(6,*)'too many atoms'
       close(1)
       stop
      endif
      if(np.gt.npmax)then
       write(6,*)'too many points'
       close(1)
       stop
      endif
      do 1 i=1,nh
      read(2,*)shi(i)
1     shi(i)=shi(i)*Hz*1d-6
      read(2,*)npa
      do 3 i=1,nh
      do 3 j=1,nh
3     cc(i,j)=0.0d0
      do 2 i=1,npa
      read(2,*)i1,i2,cc(i1,i2)
2     cc(i2,i1)=cc(i1,i2)
      close(1)
c
      nstate=2**nh
      if(nstate.gt.nemx)then
       write(6,*)'too many states'
       stop
      endif
c
      do 6 ih=1,nh
      icl=2**ih
      ninv=nstate/icl
      ig=0
8     continue
      do 7 ii=1,ninv
      state(ig+ii     ,ih)=1
7     state(ig+ii+ninv,ih)=0
      ig=ig+ninv+ninv
      if(ig.lt.nstate)goto 8
6     continue
c
       write(6,*)nstate,' states'
c      do 9 is=1,nstate
c9     write(6,6000)is,(state(is,ii),ii=1,nh)
c6000  format(I10,'  ',60I1)
c
      do 13 is=1,nstate
      e=0.0d0
      do 15 ih=1,nh
      spini=dble(state(is,ih)*2-1)
      e=e+0.5d0*shi(ih)*spini
      do 15 jh=1,nh
15    if(jh.ne.ih)e=e+cc(jh,ih)*spini*dble(state(is,jh)*2-1)*0.25d0
13    en(is)=e
      bkthz=293.15*1.38d-23/6.626d-34
      do 23 is=1,nstate
23    ps(is)=exp(-(Hz+en(is))/bktHz)
c
      do 20 ii=1,np
      x(ii)=ri+dble(ii-1)*(rx-ri)/real(np-1)
20    sp(ii)=0.0d0
c
      amax=0.0d0
      do 10 ih=1,nh
      do 10 is1=1,nstate
      if(state(is1,ih).eq.0)then
       e1=en(is1)
       p1=ps(is1)
       do 101 is2=1,nstate
       if(state(is2,ih).eq.1)then
        p2=ps(is2)
        de=en(is2)-e1
        istart=int((de-5.0d0*bw-ri)/(rx-ri)*dble(np-1))+1
        iend  =int((de+5.0d0*bw-ri)/(rx-ri)*dble(np-1))+1
        if(istart.lt.1)istart=1
        if(iend.gt.np)iend=np
        ampl=abs(p1-p2)
        if(ampl.gt.amax)amax=ampl
        if(peaktype.eq.'G')then
         do 21 i3=istart,iend
21       sp(i3)=sp(i3)+ampl*exp(-((x(i3)-de)/bw)**2)
        else
         do 22 i3=istart,iend
22       sp(i3)=sp(i3)+ampl*bw**2/((x(i3)-de)**2+bw**2)
        endif
       endif
101    continue
      endif
10    continue
c
      open(3,file='SIMCAP.PRN')
      do i3=1,np
       write(3,3000)x(i3),sp(i3)/amax
      enddo
3000  format(2f15.5)
      close(3)
c
      write(6,*)' Spectrum written into SIMCAP.PRN'
      stop
      end
