      subroutine ssupcor(ioe)
c     97-6-24-13:00
c
c     atomic polar and atomic axial tensors via modified super-excitation scheme
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15,ndm=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c     ndm    maximum degree of degeneracy
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension dmo(nel,nort),
     6ak(nort,nort),aj(nort,nort),apt(nat0,3,3),aat(nat0,3,3),
     7aatlab(nat0,3,3),esossk(nort,3,3),
     8grade(3),gradn(3),dipe(3),dipn(3),esossr(nort,3,3)
      logical lopt,lscr,lcomb,lpro,ldisk
      common/opts/lopt(300),icha,n1
      equivalence (lopt(38),lcomb),(lopt(39),lpro),
     1(lopt(53),ldisk)
      dimension jdeg(nort,ndm),buff(nort,nort),temi(nort),temj(nort),
     1dipm(3,nort,nort),ndeg(nort),tg(3),am(3,3),bm(3,3,3,3),
     2cm(3,3),fm(3,3,3,3),aa(18,18),al(18),ccm(18),em(18,36),ai(18,18),
     3alt(3,3),alr(3,3),th(3,3),
     5oo(nort,nort),eee(nort,3,3),ijk(3)
      data ithree,etol,ijk/3,0.00001D0,2,3,1/
c
      ctol=1.0d-5
      rnoa=dble(noa)
c
      write(3,4001)nmo,nao
4001  format(' Invariant Super (APT, AAT); NMO = ',I3,' NAO = ',I3)
c
c     read-in the coulomb and exchange terms
      if(ioe.eq.0)call inibe4
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       inquire(file='AKJK.SCR',exist=lscr)
       if(.not.lscr)call report('AKJK.SCR not found')
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
c
c      check the degeneracy of MO energies
       do 1 j=1,nmo
       ndeg(j)=0
       do 2 jj=1,nmo
       if(abs(e(j)-e(jj)).lt.0.001d0)then
        ndeg(j)=ndeg(j)+1
        jdeg(j,ndeg(j))=jj
       endif
2      continue
       if(ndeg(j).gt.2)write(3,3001)
3001   format(2I4,' warning: check the code for the degeneracy !!')
c     energy difference  dE=ej-ek-Jjk+2Kjk, ei Fock energies
       if(ndeg(j).gt.ndm)call report('degeneracy > ndm')
1      continue
c
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     <I|o|J>=cIi*cJj<i|o|j> 1-15 in MO.SCR
c     MO.SCR should have been allready created in dqmpol3
c         r         rr                 rxgrad/2  grad      (R-used only here)
c     k=  1  2  3   4  5  6  7  8  9   10 11 12  13 14 15  16 17 18
c         x  y  z   xx xy xz yy yz zz  x  y  z   x  y  z   x  y  z
c
      inquire(file='MO.SCR',exist=lscr)
      if(.not.lscr)call report('MO.SCR not found')
c
c     read in electric dipole MOs
      open(36,file='MO.SCR',form='unformatted',status='old')
      do k=1,nmo
       read(36)((dmo(kk,j),kk=1,15),j=1,nmo)
       do j=1,nmo
        dipm(1,k,j)=dmo(1,j)
        dipm(2,k,j)=dmo(2,j)
        dipm(3,k,j)=dmo(3,j)
       enddo
      enddo
      close(36)
c
c     calculate static dipole
      call vz(dipe,z0,ithree)
      call vz(dipn,z0,ithree)
      do 1515 ix=1,3
      do 1616 ia=1,noa
1616  dipn(ix)=dipn(ix)+z(ia)*xv(ix,ia)
      do 1515 k=1,ndo
1515  dipe(ix)=dipe(ix)-two*dipm(ix,k,k)
      write(3,*)' Static dipole'
      write(3,3009)(dipe(ix),ix=1,3),(dipn(ix),ix=1,3),
     1dipe(1)+dipn(1),dipe(2)+dipn(2),dipe(3)+dipn(3)
3009  format(' Electronic: ',3F15.8,/,
     1       ' Nuclear   : ',3F15.8,/,
     2       '             ',45(1H-),/,
     3       ' Total     : ',3F15.8,/)
c
c     if ldisk option on, write gradients into GR.SCR, so that
c     the transformation is called only one cycle over atomic coordinates
      if(ldisk)open(37,file='GR.SCR',form='unformatted')
c
      call vz(esossk,z0,9*nort)
      call vz(esossr,z0,9*nort)
c
c     Loop over atoms (pre-calculate the necessary sums):
      do 1212 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      call vz(eee,z0,3*3*nort)
c
      do 1213 jx=1,3
      grade(jx)=z0
c
c     calculate ao integrals (i|grad_lat_jxH|j), put them in buff
      call overlagg(lat,jx,buff)
c
c     transform into MO basis and write into oo
      call taomo(buff,oo,cij,nort,nort,nmo,nao,temi,temj,ctol)
c
      if(ldisk)write(37)((oo(i,j),i=j,nmo),j=1,nmo)
c
c     sum over doubly-occupied orbitals:
      do 5 k=1,ndo
      wk=e(k)
      grade(jx)=grade(jx)+two*oo(k,k)
c
c     sum over excited states = virtual orbitals
      do 6 j=ndo+1,nmo
      wj=e(j)
      ejk0=wj-wk
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(j))
       do ideg=1,ndeg(j)
        ckj=ckj+aj(k,jdeg(j,ideg))*afac
        ekj=ekj+ak(k,jdeg(j,ideg))*aex*afac
       enddo
      endif
      wnj=ejk0-ckj+two*ekj
      if(wnj.lt.etol)goto 6
      e4i=four/wnj
c
      do 10 ix=1,3
      ag=dipm(ix,k,j)*e4i*oo(k,j)
      esossk(k,jx,ix)=esossk(k,jx,ix)+ag
10    eee(k,jx,ix)=eee(k,jx,ix)+ag
c
6     continue
c     J cycle
c
5     continue
c     K cycle
c
      gradn(jx)=z0
      do 4 ia=1,noa
      if(ia.ne.lat)then
       r=sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2)
       gradn(jx)=gradn(jx)-z(lat)*z(ia)*(xv(jx,lat)-xv(jx,ia))/(r*r*r)
      endif
4     continue
c
1213  continue
c     (jx)
c
      do 103 k=1,ndo
      do 103 ia=1,3
      do 103 ib=1,3
      do 103 ig=1,3
      do 103 id=1,3
103   esossr(k,ia,ib)=esossr(k,ia,ib)+eps(ib,ig,id)*xv(ig,lat)*
     1eee(k,id,ia)
c
      write(3,*)' Gradient'
      write(3,3009)(grade(ix),ix=1,3),(gradn(ix),ix=1,3),
     1grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
c
1212  continue
c     (lat)
c
c     Calculate center and theta
      call vz(tg,z0,ithree)
      call vz(th,z0,ithree*ithree)
      do 58 l=1,noa
      do 58 ib=1,3
      tg(ib)=tg(ib)+xv(ib,l)/rnoa
      th(ib,ib)=th(ib,ib)+(xv(1,l)**2+xv(2,l)**2+xv(3,l)**2)/rnoa
      do 58 if=1,3
58    th(ib,if)=th(ib,if)-xv(ib,l)*xv(if,l)/rnoa
c
c
      call vz(apt,z0,9*nat0)
      call vz(aat,z0,9*nat0)
c
      if(ldisk)rewind 37
      if(ldisk)write(3,*)'LDISK ON'
c
c     new loop over all atoms
      open(36,file='ft.inp')
      do 12122 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      do 1214 jx=1,3
c
      if(ldisk)then
       read(37)((oo(i,j),i=j,nmo),j=1,nmo)
       do 3 j=1,nmo
       do 3 i=j+1,nmo
3      oo(j,i)=oo(i,j)
      else
c
c      calculate ao integrals (i|grad_lat_jxH|j), put them in buff
c      transform into MO basis and write into oo
       call overlagg(lat,jx,buff)
       call taomo(buff,oo,cij,nort,nort,nmo,nao,temi,temj,ctol)
      endif
c
c     sum over doubly-occupied orbitals:
      do 500 k=1,ndo
      wk=e(k)
c
c     the expansion coefficients
c     fitting the nuclear derivatives of |K>
c
      do 511 ib=1,3
      do 511 ie=1,3
      am(ib,ie)=z0
      do 511 l=ndo+1,nmo
511   am(ib,ie)=am(ib,ie)+a8*rnoa*dipm(ib,k,l)*dipm(ie,l,k)
c
      do 53 ia=1,3
      do 53 ib=1,3
      do 53 id=1,3
      do 53 ie=1,3
      bm(ia,ib,id,ie)=z0
      do 53 ig=1,3
53    bm(ia,ib,id,ie)=bm(ia,ib,id,ie)+eps(ie,ig,ia)*tg(ig)*am(ib,id)
c
      call vz(cm,z0,3*ithree)
      do 54 ia=1,3
      cm(ia,ia)=-two
      do 54 ib=1,3
54    cm(ia,ib)=cm(ia,ib)-esossk(k,ia,ib)
c
      do 56 ia=1,3
      do 56 ib=1,3
      do 56 ie=1,3
      do 56 if=1,3
56    fm(ia,ib,ie,if)=th(ib,if)*am(ie,ia)
c
      iv=9
      do 59 ia=1,3
      do 59 ib=1,3
      iv=iv+1
      ccm(iv)=-esossr(k,ia,ib)
      do 59 ig=1,3
59    ccm(iv)=ccm(iv)-two*eps(ia,ib,ig)*dipm(ig,k,k)
c
c     setup the linear equation AA.AL=CC
      iv=0
      do 60 ia=1,3
      do 60 ib=1,3
      iv=iv+1
      ccm(iv)=cm(ia,ib)
      iw=0
      do 60 id=1,3
      do 60 ie=1,3
      iw=iw+1
      aa(iv,iw+9)= bm(ia,ib,id,ie)
      aa(iv+9,iw)=-bm(ib,ia,ie,id)
      aa(iv+9,iw+9)=fm(ia,ib,id,ie)
      if(ia.eq.id)then
       aa(iv,iw)=am(ib,ie)
      else
       aa(iv,iw)=z0
      endif
60    continue
c
c     check the symmetricity
      do 63 i=1,18
      do 63 j=i+1,18
      if(abs(aa(i,j)-aa(j,i)).gt.0.0006D0)then
       write(3,36363)i,j,aa(i,j),aa(j,i)
36363  format('Matrix not symmetric',2I4,2F12.7)
      endif
63    continue
c
c     invert the matrix
      call inv(18,aa,ai,18,1.0d-9,em,ierr)
      do i=1,18
      do j=1,18
      aa(i,j)=ai(i,j)
      enddo
      enddo
c
      i18=18
      call vz(al,z0,i18)
      if(ierr.gt.0)then
       write(3,*)'Matrix cannot be inverted'
       call wmtr(aa,18,18,'matrix to invert',0)
      else
       do 61 i=1,18
       do 61 j=1,18
61     al(i)=al(i)+aa(i,j)*ccm(j)
      endif
c
      iv=0
      do 62 ia=1,3
      do 62 ib=1,3
      iv=iv+1
      alt(ia,ib)=al(iv)
62    alr(ia,ib)=al(iv+9)
c
c     sum over MOs
      do 600 l=ndo+1,nmo
      elk0=e(l)-wk
      ckl=z0
      ekl=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(l))
       do ideg=1,ndeg(l)
        ckl=ckl+aj(k,jdeg(l,ideg))*afac
        ekl=ekl+ak(k,jdeg(l,ideg))*aex*afac
       enddo
      endif
      wnl=elk0-ckl+two*ekl
      if(abs(wnl).lt.etol)goto 600
c
c     calculate the expansion coefficients C_K,L,jx,lat
      ckll=-oo(k,l)/wnl
c     cold=ckll
      do 601 ib=1,3
      ckll=ckll-two*alt(jx,ib)*dipm(ib,k,l)
      do 601 ia=1,3
      do 601 ig=1,3
601   ckll=ckll-two*alr(ia,ib)*eps(ib,ig,jx)*xv(ig,lat)*dipm(ia,k,l)
c     if(abs(ckll+cold).gt.1.0d-5)write(36,36368)ckll,cold
c 36368 format(2F16.8)
c
      do 100 ix=1,3
100   apt(lat,jx,ix)=apt(lat,jx,ix)-ckll*four*dipm(ix,l,k)
c
c     super exc - loop over all LP
      do 1107 lp=1,nmo
      fac=(e(lp)-wk)/wnl*ckll
      do 1107 ix=1,3
      ixj=ijk(ix )
      ixk=ijk(ixj)
1107  aat(lat,jx,ix)=aat(lat,jx,ix)+fac*
     1 (dipm(ixj,l,lp)*dipm(ixk,lp,k)-dipm(ixk,l,lp)*dipm(ixj,lp,k))
c
600     continue
c     L cycle
c
500     continue
c     K cycle
c
1214  continue
c
c     add the nuclear parts to apt; local aat does not have nuclear part
      do 240 i=1,3
240   apt(lat,i,i)=apt(lat,i,i)+z(lat)
c
      write(3,*)
      write(3,*)'Atomic polar tensor - R/cor'
      write(3,4006)((apt(lat,j,i),i=1,3),j=1,3)
      write(3,*)'Local atomic axial tensor - R/cor'
      write(3,4006)((aat(lat,j,i),i=1,3),j=1,3)
      write(3,4007)
4006  format(/,'                       ',14x,'FX',14x,'FY',14x,'FZ',/,
     1         '           Rx          ',3F16.8,/,
     1         '           Ry          ',3F16.8,/,
     2         '           Rz          ',3F16.8,/,
     3         '                       ',16(1H-),/)
4007  format(80(1h*))
c
12122 continue
c     (lat)
      close(36)
c
      if(ldisk)close(37)
c
      open(15,file='RAW.TEN')
c
c     transform aat into laboratory origin with SOS apt
      call vcdd1(aat,apt,xv,noa,aatlab)
      call writeten(nat0,apt,aatlab,noa)
      write(6,*)' File RAW.TEN written.. '
      write(3,*)' File RAW.TEN written.. '
c
      if(lcomb)then
       write(3,*)' APT read from APT.TEN'
       open(33,file='APT.TEN',status='old')
       read(33,*) NATF
       if(NATF.NE.NOA)call report(' Number of atoms differs')
       DO 7 L=1,NOA
       DO 7 J=1,3
7      read(33,*)(apt(L,J,I),I=1,3)
       close(33)
      endif
c
      write(3,*)' Distributed origin gauge ...'
c
c     transform aat into laboratory origin with SOS or external apt
      call vcdd1(aat,apt,xv,noa,aatlab)
      OPEN(15,FILE='FILE.TEN')
      call writeten(nat0,apt,aatlab,noa)
      WRITE(6,*)' FILE.TEN written ...'
      WRITE(3,*)' FILE.TEN written ...'
      call rules(xv,dipn,dipe,apt,aatlab,nat0,noa)
c
      return
      end
