      subroutine super(ioe)
c
c     atomic polar and atomic axial tensors via super-excitation scheme
c
      implicit real*8    (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=18,ndm=4)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c     ndm    maximum degree of degeneracy
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension dmo(nel,nort),dmt(nort),
     6ak(nort,nort),aj(nort,nort),apt(nat0,3,3),aat(nat0,3,3),
     7vel(nat0,3,3),aatlab(nat0,3,3),aas(nat0,3,3),
     8grade(3),gradn(3),dipe(3),dipn(3)
      logical ldo,lopt,lscr,lcomb,lpro,lsuper
      common/opts/lopt(300),icha,n1
      equivalence (lopt(17),ldo),(lopt(38),lcomb),(lopt(39),lpro),
     1(lopt(43),lsuper)
      dimension jdeg(nort,ndm),buff(nort,nort),temi(nort),temj(nort),
     1dipm(3,nort,nort),ndeg(nort)
c
      Ithree=3
      etol=0.00001D0
      write(3,4001)nmo,nao
4001  format(' Super derivatives (APT, AAT); NMO = ',I3,' NAO = ',I3)
      if(nao.gt.nort)call report('Too many orbitals for super')
c
c     read-in the coulomb and exchange terms
      if(ioe.eq.0)call inibe4
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       inquire(file='AKJK.SCR',exist=lscr)
       if(.not.lscr)call report('AKJK.SCR not found')
       open(23,file='AKJK.SCR',form='unformatted')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
c
c      check the degeneracy of MO energies
       do 1 j=1,nmo
       ndeg(j)=0
       do 2 jj=1,nmo
       if(abs(e(j)-e(jj)).lt.0.001d0)then
        ndeg(j)=ndeg(j)+1
        jdeg(j,ndeg(j))=jj
       endif
2      continue
       if(ndeg(j).gt.2)write(3,3001)
3001   format(2I4,' warning: check the code for the degeneracy !!')
       if(ndeg(j).gt.ndm)call report('degeneracy > ndm')
1      continue
c
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     <I|o|J>=cIi*cJj<i|o|j> 1-15 in MO.SCR
c     MO.SCR should have been allready created in dqmpol3
c         r         rr                 rxgrad/2  grad      (R-used only here)
c     k=  1  2  3   4  5  6  7  8  9   10 11 12  13 14 15  16 17 18
c         x  y  z   xx xy xz yy yz zz  x  y  z   x  y  z   x  y  z
c
      inquire(file='MO.SCR',exist=lscr)
      if(.not.lscr)call report('MO.SCR not found')
      open(36,file='MO.SCR',form='unformatted',status='old')
      open(37,file='MOX.SCR',form='unformatted',status='unknown')
      open(38,file='MOY.SCR',form='unformatted',status='unknown')
      open(39,file='MOZ.SCR',form='unformatted',status='unknown')
c
c     read in electric dipole MOs
      do k=1,nmo
       read(36)((dmo(kk,j),kk=1,15),j=1,nmo)
       do j=1,nmo
        dipm(1,k,j)=dmo(1,j)
        dipm(2,k,j)=dmo(2,j)
        dipm(3,k,j)=dmo(3,j)
       enddo
      enddo
c
      call vz(apt,z0,9*nat0)
      call vz(vel,z0,9*nat0)
      call vz(aas,z0,9*nat0)
      call vz(aat,z0,9*nat0)
c
c     calculate static dipole
      call vz(dipe,z0,ithree)
      call vz(dipn,z0,ithree)
      do 1515 ix=1,3
      do 1616 ia=1,noa
1616  dipn(ix)=dipn(ix)+z(ia)*xv(ix,ia)
      do 1515 k=1,ndo
1515  dipe(ix)=dipe(ix)-two*dipm(ix,k,k)
      write(3,*)' Static dipole'
      write(3,3009)(dipe(ix),ix=1,3),(dipn(ix),ix=1,3),
     1dipe(1)+dipn(1),dipe(2)+dipn(2),dipe(3)+dipn(3)
3009  format(' Electronic: ',3F15.8,/,
     1       ' Nuclear   : ',3F15.8,/,
     2       '             ',45(1H-),/,
     3       ' Total     : ',3F15.8,/)
c
c     Loop over atoms:
      do 1212 lat=1,noa
      write(3,*)' Atom ',lat
      write(6,*)' Atom ',lat
      xl=xv(1,lat)
      yl=xv(2,lat)
      zl=xv(3,lat)
      rewind 37
      rewind 38
      rewind 39
      do ix=1,3
c
c     calculate ao integrals (i|grad_lat_ixH|j), put them in buff
      call overlagg(lat,ix,buff)
c
c     transform into MO basis and write into MOXi.SCR:
c
      ctol=1.0d-5
      do imo=1,ndo
       do i=1,nao
        temi(i)=cij(imo,i)
       enddo
       do jmo=imo,nmo
        do i=1,nao
         temj(i)=cij(jmo,i)
        enddo
        sum=z0
        do i=1,nao
         cimoi=temi(i)
         cimoj=temj(i)
         sum=sum+cimoi*cimoj*buff(i,i)
         if(abs(cimoi).gt.ctol)then
          st=z0
          do j=1,i-1
           st=st+temj(j)*buff(j,i)
          enddo
          sum=sum+st*cimoi
         endif
         if(abs(cimoj).gt.ctol)then
          st=z0
          do j=1,i-1
           st=st+temi(j)*buff(j,i)
          enddo
          sum=sum+st*cimoj
         endif
        enddo
        dmt(jmo)=sum
       enddo
       write(37+ix-1)(dmt(jmo),jmo=imo,nmo)
      enddo
c     imo
c
      enddo
c     ix
c
      rewind 36
      rewind 37
      rewind 38
      rewind 39
c
      call vz(grade,z0,ithree)
c
c     sum over doubly-occupied orbitals:
      do 5 k=1,ndo
      wk=e(k)
      read(36)((dmo(kk,j),kk=1,15),j=1,nmo)
      read(37)(dmo(16,j),j=k,nmo)
      read(38)(dmo(17,j),j=k,nmo)
      read(39)(dmo(18,j),j=k,nmo)
      do 3 ix=1,3
3     grade(ix)=grade(ix)+two*dmo(ix+15,k)
c
c     sum over excited states = virtual orbitals
      do 6 j=ndo+1,nmo
      wj=e(j)
      ejk0=wj-wk
      ckj=z0
      ekj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(j))
       do ideg=1,ndeg(j)
        ckj=ckj+aj(k,jdeg(j,ideg))*afac
        ekj=ekj+ak(k,jdeg(j,ideg))*aex*afac
       enddo
      endif
c
c     energy difference  dE=ej-ek-Jjk+2Kjk, ei Fock energies
      wnj=ejk0-ckj+two*ekj
      if(wnj.lt.etol)goto 6
      ei=one/wnj
      e2i=ei+ei
      e4i=e2i+e2i
      do 10 ix=1,3
      ixj=ix+1
      if(ixj.eq.4)ixj=1
      ixk=ixj+1
      if(ixk.eq.4)ixk=1
      adnj  =dmo(ix   ,j)*e4i
      avnj  =dmo(12+ix,j)*e4i*ei
      alocal=dmo(9+ix,j)-
     1 half*(xv(ixj,lat)*dmo(12+ixk,j)-xv(ixk,lat)*dmo(12+ixj,j))
      ama=alocal*e2i*ei
      aaaa=((-dipe(ixj)-dipm(ixj,k,k)+dipm(ixj,j,j))*dmo(ixk,j)
     1     -(-dipe(ixk)-dipm(ixk,k,k)+dipm(ixk,j,j))*dmo(ixj,j))
     2      *ei/dble(2*ndo)
     3     -(xv(ixj,lat)*dmo(ixk,j)-xv(ixk,lat)*dmo(ixj,j))*ei
c     dmo(12+ixj,j) ~ dmo(ixj,j)*wnj  (virial theorem)
      do 10 jx=1,3
      grjn=dmo(15+jx,j)
      apt(lat,jx,ix)=apt(lat,jx,ix)+adnj*grjn
      vel(lat,jx,ix)=vel(lat,jx,ix)+avnj*grjn
      aas(lat,jx,ix)=aas(lat,jx,ix)+aaaa*grjn
10    aat(lat,jx,ix)=aat(lat,jx,ix)+ama *grjn
c
c     super exc - loop over J'<> J, K=K'
      do 1313 jp=ndo+1,nmo
      if(jp.eq.j)goto 1313
      wjp=e(jp)
      ckjp=z0
      ekjp=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(jp))
       do ideg=1,ndeg(jp)
        ckjp=ckjp+aj(k,jdeg(jp,ideg))*afac
        ekjp=ekjp+ak(k,jdeg(jp,ideg))*aex*afac
       enddo
      endif
      wnjp=wjp-wk-ckjp+two*ekjp
      fac=wnjp*ei*ei/dble(2*ndo)
      do 11 ix=1,3
      ixj=ix+1
      if(ixj.eq.4)ixj=1
      ixk=ixj+1
      if(ixk.eq.4)ixk=1
      alocal=dipm(ixj,j,jp)*dipm(ixk,jp,k)-
     1       dipm(ixk,j,jp)*dipm(ixj,jp,k)
      ama=alocal*fac
      do 11 jx=1,3
11    aas(lat,jx,ix)=aas(lat,jx,ix)+ama *dmo(15+jx,j)
c
1313  continue
c
c     super exc - loop over K'<>K (J=J')
      do 1414 kp=1,ndo
      if(kp.eq.k)goto 1414
      wkp=e(kp)
      ckpj=z0
      ekpj=z0
      if(ioe.gt.0)then
       afac=one/dble(ndeg(kp))
       do ideg=1,ndeg(kp)
        ckpj=ckpj+aj(jdeg(kp,ideg),j)*afac
        ekpj=ekpj+ak(jdeg(kp,ideg),j)*aex*afac
       enddo
      endif
      wnjp=wj-wkp-ckpj+two*ekpj
      fac=wnjp*ei*ei/dble(2*ndo)
      do 12 ix=1,3
      ixj=ix+1
      if(ixj.eq.4)ixj=1
      ixk=ixj+1
      if(ixk.eq.4)ixk=1
      alocal=dipm(ixj,k,kp)*dipm(ixk,j,kp)-
     1       dipm(ixk,k,kp)*dipm(ixj,j,kp)
      ama=alocal*fac
      do 12 jx=1,3
12    aas(lat,jx,ix)=aas(lat,jx,ix)+ama *dmo(15+jx,j)
1414  continue
c
6     continue
c     J cycle
c
5     continue
c     K cycle
c
      call vz(gradn,z0,ithree)
      do 4 ia=1,noa
      if(ia.ne.lat)then
       r=sqrt((xl-xv(1,ia))**2+(yl-xv(2,ia))**2+(zl-xv(3,ia))**2)
       do 7 ix=1,3
7      gradn(ix)=gradn(ix)-z(lat)*z(ia)*(xv(ix,lat)-xv(ix,ia))/(r*r*r)
      endif
4     continue
      write(3,*)' Gradient'
      write(3,3009)(grade(ix),ix=1,3),(gradn(ix),ix=1,3),
     1grade(1)+gradn(1),grade(2)+gradn(2),grade(3)+gradn(3)
c
      do 24 i=1,3
      vel(lat,i,i)=vel(lat,i,i)+z(lat)
24    apt(lat,i,i)=apt(lat,i,i)+z(lat)
c
      write(3,*)
      write(3,*)'Atomic polar tensor - R'
      write(3,4006)((apt(lat,j,i),i=1,3),j=1,3)
4006  format(/,'                        ',14x,'FX',14x,'FY',14x,'FZ',/,
     1         '           Rx           ',3F16.8,/,
     1         '           Ry           ',3F16.8,/,
     2         '           Rz           ',3F16.8,/,
     3         '                        ',16(1H-),/)
      write(3,*)'Atomic polar tensor - V'
      write(3,4006)((vel(lat,j,i),i=1,3),j=1,3)
      write(3,*)'Local atomic axial tensor'
      write(3,4006)((aat(lat,j,i),i=1,3),j=1,3)
      write(3,*)'Local atomic axial super tensor'
      write(3,4006)((aas(lat,j,i),i=1,3),j=1,3)
      write(3,4007)
4007  format(80(1h*))
c
1212  continue
c
      close(37)
      close(38)
      close(39)
      do k=ndo+1,nmo
       read(36)
      enddo
      close(36)
c
      n=3*noa
      open(15,file='RAW.TEN')
      call vcdd1(aas,apt,xv,noa,aatlab)
      call writeten(nat0,apt,aatlab,noa)
      write(6,*)' File RAW.TEN written.. '
      write(3,*)' File RAW.TEN written.. '
      if(lpro)then
       write(3,*)'projection of zero-frequency modes ON'
       do ix=1,3
c
c      project partially three rotations:
        call project3(apt,n,xv,ix)
        write(3,*)ix,' projected from P'
        do lat=1,noa
         write(3,4006)((apt(lat,i,j),i=1,3),j=1,3)
        enddo
       enddo
c      project 3 translations:
       call projectp(apt,n)
       call projectp(aat,n)
       call projectp(vel,n)
      else
       write(3,*)'projection of zero-frequency modes OFF'
      endif
      if(lcomb)then
       write(3,*)' APT read from APT.TEN'
       open(33,file='APT.TEN',status='old')
       read(33,*) NATF
       if(NATF.NE.NOA)call report(' Number of atoms differs')
       DO L=1,NOA
        DO J=1,3
         read(33,*)(apt(L,J,I),I=1,3)
        endDO
       endDO
       close(33)
      endif
      write(3,*)' Distributed origin gauge ...'
      if(lopt(297))then
       write(3,*)' Projection of space coordinates from local AAT:'
       call project6(aat,n,xv)
      endif
      call vcdd1(aas,apt,xv,noa,aatlab)
      OPEN(15,FILE='FILE.TEN')
      call writeten(nat0,apt,aatlab,noa)
      WRITE(6,*)' FILE.TEN written ...'
      WRITE(3,*)' FILE.TEN written ...'
c
      return
      end
c
