      subroutine tdhf
c
c     calculate core hamiltonian (AO)

      implicit none
      integer*4 nat0,nor,nort
      parameter (nat0=190,nor=80,nort=700)

      real*8 escf,cc,alpha,rcp,cij,bij,e,be
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,noa,nori,nop,ish
      character*1 ty,ok
      character*2 at
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok

      real*8 z0,one,two,three,four,five,six,half,qua,a8,a10
      common/numbers/z0,one,two,three,four,five,six,half,qua,a8,a10

      real*8 pi,clau,spt,bohr,debye
      common/const/pi,clau,spt,bohr,debye

      real*8 en,xi,yi,zi,zzi,ar,WMIN,WMAX,WEAU,EX,EY,EZ,dw,GAMMAAU,zz,
     1uu(3),cp,cw,cm,sw,sp,sm,ti,DT,w,anorm,Z1,Z2,m1,m2,zmin,zmax,dz
      integer*4 i,j,IERR,NP,istep,NSTEP,ISTEP0,ix,nb,m,ne,MM,n100
      logical lsprint,ld5,lf7,lrec,lmp2,lmpdisk,lmp1,lmpn4,lnuclear,
     1lex

      logical lopt
      integer*4 icha,n1
      common/opts/lopt(300),icha,n1

      equivalence (lopt(1),lsprint),(lopt(4 ),ld5),
     1(lopt(8),lf7),(lopt(25),lrec),(lopt(61),lmp2),(lopt(62),lmp1),
     1(lopt(63),lmpdisk),(lopt(64),lmpn4)

      real*8 z,zsum,xv
      common/atoms/z(nat0),zsum,xv(3,nat0)

      integer*4 iopt
      common/iopts/iopt(300)
      equivalence (iopt(33),NP),(iopt(34),NSTEP),(iopt(35),ISTEP0)

      real*8 ropt
      common/ropts/ropt(300)
      equivalence (ropt(23),WMIN),(ropt(24),WMAX),(ropt(25),WEAU),
     1(ropt(26),DT),(ropt(27),EX),(ropt(28),EY),(ropt(29),EZ),
     1(ropt(30),GAMMAAU)

      real*8,allocatable::TK(:,:),V(:,:),S(:,:),F(:),U(:,:),
     1H(:,:),L(:),C(:,:),D(:,:),EE(:),P(:,:,:),CI(:),
     1CR(:),SI(:,:),einv(:,:),CRm(:),CRp(:),CIm(:),CIp(:),
     1HP(:,:),HT(:,:),HCR(:),HCI(:),HCSR(:),HCSI(:),
     1ur(:,:),ui(:,:),xvi(:,:),xvj(:,:),alj(:),dj(:),
     1hbig(:,:),sbig(:,:),xvq(:,:),hbigt(:,:),Pao(:,:,:),
     1Zao(:,:),zzao(:,:),Zmo(:,:),ZZmo(:,:),PMO(:,:,:),we(:),
     1Dmo(:,:,:),ss(:,:),hh(:,:),co(:,:),pz(:),pn(:),zzs(:)
      integer*4, allocatable::map(:),imap(:)

      logical,allocatable::btake(:)
c
      call w36('    ')
      call w36('Tdhf')
      call w36('^^^^')
      call w36('    ')

c     calculate nuclear repulsion energy:
      en=z0
      do 1001 i=1,noa
      xi=xv(1,i)
      yi=xv(2,i)
      zi=xv(3,i)
      zzi=z(i)
      do 1001 j=i+1,noa
      ar=sqrt((xi-xv(1,j))**2+(yi-xv(2,j))**2+(zi-xv(3,j))**2)
1001  en=en+zzi*z(j)/ar

      write(6,6001)en
      write(3,6001)en
6001  format(' Nuclear repuslion energy ',f20.9)

      allocate(TK(nao,nao),V(nao,nao),S(nao,nao),EE(nao),F(nao),
     1U(nao,nao),H(nao,nao),L(nao),C(nao,nao),D(nao,nao),
     2P(3,nao,nao),CI(nao),CR(nao),SI(nao,nao),einv(nao,2*nao),
     2CIm(nao),CRm(nao),CIp(nao),CRp(nao),HT(nao,nao),HP(nao,nao),
     1HCI(nao),HCR(nao),HCSI(nao),HCSR(nao))

      call TKV(TK,V,nat0,xv,xv,xv,nor,alpha,z,noa,ish,ld5,lf7,nop,
     1ty,nao,1)
      call overlapsonly(S,nat0,xv,xv,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)

c     make H:
      do 1 i=1,nao
      do 1 j=1,nao
1     H(i,j)=TK(i,j)+V(i,j)+en*S(i,j)

c     diagonalize S:
      IERR=0
      call TRED12(nao,S,U,L,2,IERR,nao,EE)
      if(IERR.ne.0)call report('Cannot diagonalize S')
      do 100 i=1,nao
100   if(L(i).le.0.0d0)call report(' Dependent basis')

c     trafo H to normalized S eigenvectors :
      call trh(nao,H,HT,U,L)

c     diagonalize HT:
      IERR=0
      call TRED12(nao,HT,D,F,2,IERR,nao,EE)
      if(IERR.ne.0)call report('Cannot diagonalize HT')
      call w36(' energies:')
      write(6,601)F
      write(3,601)F
601   format(6f12.6)
c     get true orbital coefficients:
      call CUD(nao,C,U,D,L)
      call wmtr(C,nao,nao,' MO coefficients:',1)
c     calculate AO dipoles:
      call overlapponly(P,nat0,xv,xv,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)
c     transform dipoles to MOs:
      allocate(PMO(3,nao,nao))
      call tpmo(nao,P,PMO,C)
c     make polarizability
      call tpal(nao,PMO,F,GAMMAAU,WEAU,0)

c     TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
      IF(NSTEP.GT.0)THEN
c     Time-propagation variables:
c     NP number of spectral points 
c     NSTEP Number of time steps
c     ISTEP0 Update norm each ISTEP0
c     WMIN,WMAX spectrum limits, in AU
c     WEAU excitation frequency, au
c     DT integration time step, au
c     EX EY EZ external intenzity of electric field, au

      dw=(WMAX-WMIN)/dble(NP-1)
      allocate(ur(3,np),ui(3,np))

c     real and imaginary parts of dipole moment dependent on w:
      do 12 ix=1,3
      do 12 i=1,NP
      ur(ix,i)=0.0d0
12    ui(ix,i)=0.0d0

c     invert overlap matrix:
      IERR=0
      call INV(nao,S,SI,nao,1.0d-9,einv,IERR)
      if(IERR.ne.0)call report('Cannot invert S')
      do 5 i=1,nao
      CR(i)=C(i,1)
      CI(i)=0.0d0
      CRm(i)=C(i,1)
5     CIm(i)=0.0d0
      ti=0.0d0
      cw=1.0d0
      sw=0.0d0
      cm=cw
      sm=sw

c     start time propagation:
c
      do 6 istep=1,NSTEP
      ti=ti+DT
c     propagate sin(wt) and cos(wt):
      cp=cm-(DT+DT)*WEAU*sw
      sp=sm+(DT+DT)*WEAU*cw
c     total hamiltonian:
      do 8 i=1,nao
      do 8 j=1,nao
8     HP(i,j)=H(i,j)-cp*(EX*P(1,i,j)+EY*P(2,i,j)+EZ*P(3,i,j))
      do 9 i=1,nao
      HCR(i)=0.0d0
      HCI(i)=0.0d0
      do 9 j=1,nao
      HCR(i)=HCR(i)+HP(i,j)*CR(j)
9     HCI(i)=HCI(i)+HP(i,j)*CI(j)
      do 10 i=1,nao
      HCSR(i)=0.0d0
      HCSI(i)=0.0d0
      do 10 j=1,nao
      HCSR(i)=HCSR(i)+HCR(j)*SI(j,i)
10    HCSI(i)=HCSI(i)+HCI(j)*SI(j,i)
c     propagate CI and CR:
      do 7 i=1,nao
      CRp(i)=CRm(i)+(DT+DT)*HCSI(i)
7     CIp(i)=CIm(i)-(DT+DT)*HCSR(i)
c     dipole moment:
      do 11 ix=1,3
      uu(ix)=0.0d0
      do 11 i=1,nao
      uu(ix)=uu(ix)+(CRp(i)**2+CIp(i)**2)*P(ix,i,i)
      do 11 j=1,i-1
11    uu(ix)=uu(ix)+2.0d0*(CRp(i)*CRp(j)+CIp(i)*CIp(j))*P(ix,i,j)
c     slwo Fourier transform of dipole momentL
      w=WMIN
      do 13 ix=1,3
      do 13 i=1,np
      w=w+dw
      ur(ix,i)=ur(ix,i)+uu(ix)*cos(w*ti)
13    ui(ix,i)=ui(ix,i)+uu(ix)*sin(w*ti)

      if(mod(istep,ISTEP0).eq.0)then
       anorm=cp**2+sp**2
       if(dabs(1.0d0-anorm).gt.0.1d0)call report('Norm cs too high')
       anorm=1.0d0/dsqrt(anorm)
       cp=cp*anorm
       sp=sp*anorm
       anorm=0.0d0
       do 15 i=1,nao
       anorm=anorm+(CRp(i)**2+CIp(i)**2)*S(i,i)
       do 15 j=1,i-1
15     anorm=anorm+2.0d0*(CRp(i)*CRp(j)+CIp(i)*CIp(j))*S(i,j)
       if(dabs(1.0d0-anorm).gt.0.1d0)call report('Norm c too high')
       anorm=1.0d0/dsqrt(anorm)
       do 16 j=1,nao
       CIp(i)=CIp(i)*anorm
16     CRp(i)=CRp(i)*anorm

       write(6,*)istep,uu(1)**2+uu(2)**2+uu(3)**2

      endif
c     store cos(w(t-del)), cos(wt), etc ... for the next step:
      cm=cw
      cw=cp
      sm=sw
      sw=sp
      do 6 i=1,nao
      CRm(i)=CR(i)
      CR(i)=CRp(i)
      CIm(i)=CI(i)
 6    CI(i)=CIp(i)

      open(9,file='D.PRN')
      w=WMIN-dw
      do 14 i=1,NP
      w=w+dw
14    write(9,1400)w,ur(1,i)**2+ur(2,i)**2+ur(3,i)**2
     1              +ui(1,i)**2+ui(2,i)**2+ui(3,i)**2
1400  format(f12.6,' ',g12.5)
      close(9)


      ENDIF
c     TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

      inquire(file='NB.TXT',exist=lnuclear)
c     so far H2+ supposed
c     along z-axis
      if(lnuclear)then
       Z1=1.d0
       Z2=1.d0
       call w36('NB.TXT exists')
c      read nuclear basis set (gaussian bands):
       open(11,file='NB.TXT')
       read(11,*)nb,m1,m2,ne
       allocate(alj(nb),dj(nb),we(ne))
       do 17 i=1,nb
17     read(11,*)alj(i),alj(i),dj(i)
       do 19 i=1,ne
19     read(11,*)we(i)
       close(11)
       write(6,603)
603    format('  j       alphj          Dj')
       do 18 i=1,nb
18     write(6,602)i,alj(i),dj(i)
602    format(i3,2f12.4)

c      electronic polarizabilities and Raman:
       open(17,file='pole.txt')
       write(17,1700)
1700   format(' freq polarizability Raman',/,/,/)
       do 20 i=1,ne
20     call tpal(nao,PMO,F,GAMMAAU,we(i),i)
       write(17,1701)
1701   format('---')
       close(17)
c
c      get <z> and <z^2>:
       M=nb*nao
       allocate(Zao(M,M),zzao(M,M),Pao(3,M,M))
       call nucz(nb,alj,dj,Pao,Zao,zzao,M,
     1 nao,xv,nat0,noa,m1,m2,nor,alpha,ish,ld5,lf7,nop,ty)
       call analm(Zao,M,'Zao:')
       call analm(zzao,M,'ZZao:')

       write(6,604)m1,m2,nb,nao,M
604    format(' m1:',f7.2,' m2:',f7.2,/,
     1 i3,' nuclear functions,',i4,' AOs,',i5,' total')
       allocate(hbig(M,M),xvi(3,nat0),xvj(3,nat0),
     1 sbig(M,M),xvq(3,nat0),btake(M))

c      make basis overlap matrix and the Hamiltonian:
       call dohbig(M,nat0,nao,noa,nb,hbig,sbig,xvi,xvj,xvq,
     1 xv,alj,S,z,TK,V,nor,alpha,ish,ld5,lf7,nop,ty,
     1 dj,pi,Z0,one,two,m1,m2,Z1,Z2)

       deallocate(U,L,EE,D,F,C)

       inquire(file='TAKE.SCR',exist=lex)
       open(88,file='TAKE.SCR',form='unformatted')
       if(lex)then
        read(88)MM
        read(88)btake
        write(6,*)'TAKE.SCR read'
       else
c       test linera independence of the basis:
        call bftest(M,sbig,btake,MM)
        write(88)MM
        write(88)btake
        write(6,*)'TAKE.SCR written'
       endif
       close(88)

       allocate(ss(MM,MM),hh(MM,MM),map(MM),imap(M))
       call purge(M,MM,sbig,hbig,btake,ss,hh,map,imap)
       deallocate(sbig,hbig)
       allocate(U(MM,MM),L(MM),EE(MM),D(MM,MM),F(MM),co(MM,MM),
     1 hbigt(MM,MM))

       inquire(file='EC.SCR',exist=lex)
       open(88,file='EC.SCR',form='unformatted')
       if(lex)then
        read(88)F
        read(88)co
        write(6,*)'Energies and vectors read from EC.SCR'
       else
c       limited space:
c       diagonalize S:
        IERR=0
        call TRED12(MM,ss,U,L,2,IERR,MM,EE)
        if(IERR.ne.0)call report('Cannot diagonalize Sbig')
        write(3,*)' s-eigenvalues:'
        write(3,601)L
        do 22  i=1,MM
22      if(L(i).le.0.0d0)call report(' Dependent basis')
c       trafo H to normalized S eigenvectors :
        call trh(MM,hh,hbigt,U,L)
c       diagonalize transformed hamiltonian:
        IERR=0
        call TRED12(MM,hbigt,D,F,2,IERR,MM,EE)
        if(IERR.ne.0)call report('Cannot diagonalize HbigT')
        call w36(' Non-BO energies:')
        write(6,601)F
        write(3,601)F
c       get true orbital coefficients:
        call CUD(MM,co,U,D,L)
        call analm(co,MM,'Cmo:')
        call wmtr(co,MM,MM,' MO coefficients:',1)
        write(88)F
        write(88)co
        write(6,*)'Energies and vectors read from EC.SCR'
       endif
       close(88)

       allocate(C(M,MM))
       call assc(co,C,MM,M,map)

c      get dipoles and <(Z-<Z>)^2> for the states
c      trafo to MO basis:
       allocate(Zmo(MM,MM),ZZmo(MM,MM),Dmo(3,MM,MM))
       call trg(C,MM,M,Zao,Zmo,ZZao,ZZmo)
       call analm(zzmo,MM,'ZZmo:')
       call analm(zzmo,MM,'Zmo:')
       call trg1(C,MM,M,Pao,Dmo)
       write(6,*)'<Z>   dsqrt<(Z-<Z>)^2>  [A]'
       do 23 i=1,MM
23     write(6,6004)i,Zmo(i,i)*bohr,
     1 dsqrt(dabs(ZZmo(i,i)-Zmo(i,i)**2))*bohr
6004   format(i3,2g12.4)
       deallocate(Pao,Zao,ZZao)

c      ground state (<1 1> polarizability and Raman:
       open(17,file='polt.txt')
       write(17,1700)
       do 24 i=1,ne
24     call tpalt(MM,Dmo,F,GAMMAAU,we(i),i,1,1)
       write(17,1701)
       close(17)

c      transition polarizability 1-2 and Raman:
       open(17,file='pol01.txt')
       write(17,1700)
       do 25 i=1,ne
25     call tpalt(MM,Dmo,F,GAMMAAU,we(i),i,1,2)
       write(17,1701)
       close(17)

c      transition polarizability G-3 and Raman:
       open(17,file='pol02.txt')
       write(17,1700)
       do 26 i=1,ne
26     call tpalt(MM,Dmo,F,GAMMAAU,we(i),i,1,3)
       write(17,1701)
       close(17)

c      absorption spectrum
       call wabs(MM,Dmo,F)

c      nuclear probability
       n100=200
       zmin=0.0d0
       zmax=4.5d0
       dz=(zmax-zmin)/dble(n100-1)
       allocate(zzs(n100),pz(n100),pn(n100))
       zz=zmin-dz
       do 27 i=1,n100
       zz=zz+dz
27     zzs(i)=zz

       open(17,file='pn1.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,1,n100)
       do 28 i=1,n100
28     write(17,1709)zzs(i),pz(i),pn(i)
1709   format(f12.4,2g12.4)
       close(17)
       open(17,file='pn2.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,2,n100)
       do 29 i=1,n100
29     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn3.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,3,n100)
       do 30 i=1,n100
30     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn28.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,28,n100)
       do 31 i=1,n100
31     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn29.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,29,n100)
       do 32 i=1,n100
32     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn30.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,30,n100)
       do 33 i=1,n100
33     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn31.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,31,n100)
       do 34 i=1,n100
34     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)
       open(17,file='pn32.prn')
       call pps(zzs,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1 nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,32,n100)
       do 35 i=1,n100
35     write(17,1709)zzs(i),pz(i),pn(i)
       close(17)

      else
       call w36('NB.TXT not found')
      endif
      call report('tdhf finished, stop')
      return
      end

      subroutine trh(M,H,HT,U,L)
c     trafo H to normalized S eigenvectors :
      implicit none
      integer*4 M,i,j,k
      real*8 H(M,M),U(M,M),L(*),li,lj,HT(M,M)
      real*8,allocatable::T(:,:)
      allocate(T(M,M))
c     first index:
      do 2 i=1,M
      li=dsqrt(L(i))
      do 2 j=1,M
      T(i,j)=0.0d0
      do 2 k=1,M
2     T(i,j)=T(i,j)+U(k,i)*H(k,j)/li
c     second index:
      do 3 i=1,M
      do 3 j=1,M
      lj=dsqrt(L(j))
      HT(i,j)=0.0d0
      do 3 k=1,M
3     HT(i,j)=HT(i,j)+U(k,j)*T(i,k)/lj
      return
      end

      subroutine CUD(M,C,U,D,L)
      implicit none
      integer*4 M,i,j,k
      real*8 C(M,M),U(M,M),D(M,M),L(*)
      do 23 i=1,M
      do 23 j=1,M
      C(i,j)=0.0d0
      do 23 k=1,M
23    C(i,j)=C(i,j)+U(i,k)*D(k,j)/dsqrt(L(k))
      return
      end

      subroutine nucz(nb,alj,dj,Pao,Zao,zzao,M,
     1nao,xv,nat0,noa,m1,m2,nor,alpha,ish,ld5,lf7,nop,ty)
      implicit none
      integer*4 nb,i,j,M,nao,nat0,noa,ia,ix,nor,ii,it,jj,jt
      real*8 alj(*),dj(*),Q,spi,ec,ef,aij,sij,
     1Ai,Aj,zao(M,M),zzao(M,M),Pao(3,M,M)
      real*8 pi,clau,spt,bohr,debye,xv(3,nat0),m1,m2
      common/const/pi,clau,spt,bohr,debye
      real*8 alpha(nat0,nor)
      integer*4 nop(*),ish(nat0,nor)
      character*1 ty(nat0,nor)
      logical ld5,lf7
      real*8,allocatable::S(:,:),xvi(:,:),xvj(:,:),
     1za(:,:),zza(:,:),P(:,:,:)
      allocate(za(nb,nb),zza(nb,nb),P(3,nao,nao))
      spi=dsqrt(pi)
      allocate(xvi(3,nat0),xvj(3,nat0),S(nao,nao))
      do 20 ia=1,noa
      do 20 ix=1,3
      xvi(ix,ia)=xv(ix,ia)
20    xvj(ix,ia)=xv(ix,ia)

      do 1 i=1,nb
      Ai=dsqrt(dsqrt((alj(i)+alj(i))/pi))
      xvi(3,1)= m2/(m1+m2)*dj(i)
      xvi(3,2)=-m1/(m1+m2)*dj(i)
      do 1 j=1,nb
      Aj=dsqrt(dsqrt((alj(j)+alj(j))/pi))
      xvj(3,1)= m2/(m1+m2)*dj(j)
      xvj(3,2)=-m1/(m1+m2)*dj(j)
c     calculate electronic overlap for di dj distances:
      call overlapsonly(S,nat0,xvi,xvj,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)
c     calculate AO dipoles dor di dj distances:
      call overlapponly(P,nat0,xv,xv,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)
      aij=alj(j)+alj(j)
      Q=(alj(i)*dj(i)+alj(j)*dj(j))/aij
      ec=alj(i)*alj(j)*(dj(i)-dj(j))**2/aij
      if(ec.lt.23.0d0)then
       ef=exp(-ec)
c      <i|j>:
       sij=Ai*Aj*spi/dsqrt(aij)*ef
c      <i|Z|j>:
       za(i,j)=Sij*Q
       zza(i,j)=Sij*(0.5d0/aij+Q*Q)
       do 2 ii=1,nao
       it=ii+nao*(i-1)
       do 2 jj=1,nao
       jt=jj+nao*(j-1)
       Pao(1,it,jt)=sij*P(1,ii,jj)
       Pao(2,it,jt)=sij*P(2,ii,jj)
       Pao(3,it,jt)=sij*P(3,ii,jj)
       zao( it,jt)=za( i,j)*S(ii,jj)
2      zzao(it,jt)=zza(i,j)*S(ii,jj)
      else
       za(i,j)=0.0d0
       zza(i,j)=0.0d0
       do 3 ii=1,nao
       it=ii+nao*(i-1)
       do 3 jj=1,nao
       jt=jj+nao*(j-1)
       Pao(1,it,jt)=0.0d0
       Pao(2,it,jt)=0.0d0
       Pao(3,it,jt)=0.0d0
       zao( it,jt)=0.0d0
3      zzao(it,jt)=0.0d0
      endif
 1    continue
      return
      end

      subroutine trg1(C,MM,M,Pao,Pmo)
      integer*4 MM,M,i,j,k,ix
      real*8 C(M,MM),Pao(3,M,M),Pmo(3,MM,MM)
      real*8 ,allocatable::t(:,:),t2(:,:)
      allocate(t(M,M),t2(MM,M))
      do 3 ix=1,3
      do 31 i=1,M
      do 31 j=1,M
31    t(i,j)=Pao(ix,i,j)
      do 1 i=1,MM
      do 1 j=1,M
      t2(i,j)=0.0d0
      do 1 k=1,M
1     t2(i,j)=t2(i,j)+C(k,i)*t(k,j)
      do 2 i=1,MM
      do 2 j=1,MM
      t( i,j)=0.0d0
      do 2 k=1,M
2     t(i,j)=t(i,j)+C(k,j)*t2(i,k)
      do 3 i=1,MM
      do 3 j=1,MM
3     Pmo(ix,i,j)=t(i,j)
      return
      end

      subroutine trg(C,MM,M,Zao,Zmo,ZZao,ZZmo)
      integer*4 MM,M,i,j,k
      real*8 C(M,MM),Zao(M,M),Zmo(MM,MM),ZZao(M,M),ZZmo(MM,MM)
      real*8 ,allocatable::t(:,:),t2(:,:)
      allocate(t(MM,M),t2(MM,M))
      do 1 i=1,MM
      do 1 j=1,M
      t( i,j)=0.0d0
      t2(i,j)=0.0d0
      do 1 k=1,M
      t2(i,j)=t2(i,j)+C(k,i)*ZZao(k,j)
1     t( i,j)=t( i,j)+C(k,i)*Zao( k,j)
      do 2 i=1,MM
      do 2 j=1,MM
      Zmo( i,j)=0.0d0
      ZZmo(i,j)=0.0d0
      do 2 k=1,M
      Zmo( i,j)=Zmo( i,j)+C(k,j)*t( i,k)
2     ZZmo(i,j)=ZZmo(i,j)+C(k,j)*t2(i,k)
      return
      end

      subroutine tpmo(n,PAO,PMO,C)
      implicit none
      integer*4 n,i,j,ii,jj,ix
      real*8 PAO(3,n,n),PMO(3,n,n),C(n,n)
      real*8,allocatable::t(:,:)
      allocate(t(n,n))
      do 2 ix=1,3

      do 1 i=1,n
      do 1 jj=1,n
      t(i,jj)=0.0d0
      do 1 ii=1,n
1     t(i,jj)=t(i,jj)+C(ii,i)*PAO(ix,ii,jj)
c
      do 2 i=1,n
      do 2 j=1,n
      PMO(ix,i,j)=0.0d0
      do 2 jj=1,n
2     PMO(ix,i,j)=PMO(ix,i,j)+C(jj,j)*t(i,jj)

      return
      end

      subroutine tpal(n,P,E,G,w,ic)
      implicit none
      integer*4 n,j,ix,jx,ic
      real*8 P(3,n,n),E(*),ar(3,3),G,ai(3,3),r,q,d,w,CM,Ram
      CM=219474.0d0
      do 1 ix=1,3
      do 1 jx=1,3
      ar(ix,jx)=0.0d0
      ai(ix,jx)=0.0d0
      do 1 j=2,n
      d=E(j)-E(1)
      r=(d**2-w**2)/((d**2-w**2)**2+(w*G)**2)
      q= w*G       /((d**2-w**2)**2+(w*G)**2)
      ar(ix,jx)=ar(ix,jx)+2.0d0*d*r*P(ix,1,j)*P(jx,j,1)
1     ai(ix,jx)=ai(ix,jx)+2.0d0*d*q*P(ix,1,j)*P(jx,j,1)
      if(ic.eq.0)write(6,600)G,G*CM,w,w*CM,
     1((ar(ix,jx),ix=1,3),jx=1,3),((ai(ix,jx),ix=1,3),jx=1,3)
600   format(/,' Ground state polarizability:',/,/,
     1'   Gamma   : ',F12.6,' a.u. ',F12.2,' cm-1',/,/,
     1'   wexc    : ',F12.6,' a.u. ',F12.2,' cm-1',/,/,
     1'   Real    : ',/,/,
     13('             ',3f12.6,/),/,
     1'   Imaginary: ',/,/,
     13('             ',3f12.6,/),/)
      if(ic.ne.0)then
       Ram=9.0d0*(ar(1,1)*ar(1,1)+ai(1,1)*ai(1,1))
     1 +   2.0d0*(ar(1,1)*ar(3,3)+ai(1,1)*ai(3,3))
     1 +   4.0d0*(ar(3,3)*ar(3,3)+ai(3,3)*ai(3,3))
       write(17,1700)ic,w*CM,Ram,ar(1,1),ai(1,1),ar(3,3),ai(3,3)
1700   format(i4,f12.2,5g12.4)
      endif
      return
      end

      subroutine tpalt(n,P,E,G,w,ic,i,f)
c     transition polarizability i -> f
      implicit none
      integer*4 n,j,ix,jx,ic,i,f
      real*8 P(3,n,n),E(*),ar(3,3),G,ai(3,3),r,q,d,w,CM,Ram,t
      CM=219474.0d0
      do 1 ix=1,3
      do 1 jx=1,3
      ar(ix,jx)=0.0d0
      ai(ix,jx)=0.0d0
      do 1 j=2,n
      d=E(j)-E(1)
      r=(d**2-w**2)/((d**2-w**2)**2+(w*G)**2)
      q= w*G       /((d**2-w**2)**2+(w*G)**2)
      t=2.0d0*d*P(ix,i,j)*P(jx,j,f)
      ar(ix,jx)=ar(ix,jx)+t*r
1     ai(ix,jx)=ai(ix,jx)+t*q
      if(ic.eq.0)write(6,600)i,f,G,G*CM,w,w*CM,
     1((ar(ix,jx),ix=1,3),jx=1,3),((ai(ix,jx),ix=1,3),jx=1,3)
600   format(/,' Polarizability <',i3,' ',i3,'> :',/,/,
     1'   Gamma   : ',F12.6,' a.u. ',F12.2,' cm-1',/,/,
     1'   wexc    : ',F12.6,' a.u. ',F12.2,' cm-1',/,/,
     1'   Real    : ',/,/,
     13('             ',3f12.6,/),/,
     1'   Imaginary: ',/,/,
     13('             ',3f12.6,/),/)
      if(ic.ne.0)then
       Ram=9.0d0*(ar(1,1)*ar(1,1)+ai(1,1)*ai(1,1))
     1 +   2.0d0*(ar(1,1)*ar(3,3)+ai(1,1)*ai(3,3))
     1 +   4.0d0*(ar(3,3)*ar(3,3)+ai(3,3)*ai(3,3))
       write(17,1700)ic,w*CM,Ram,ar(1,1),ai(1,1),ar(3,3),ai(3,3)
1700   format(i4,f12.2,5g12.4)
      endif
      return
      end

      subroutine wabs(n,P,E)
c     absorption spectrim
      implicit none
      integer*4 n,i
      real*8 P(3,n,n),E(*),d,wcm,CM,debye
      CM=219474.0d0
      debye=0.393456d0 
      open(9,file='D.TAB')
      write(9,*)
      write(9,*)'Dipole strengths (debye^2'
      write(9,90)
90    format(60(1h-))
      do 1 i=2,n
      wcm =(E(i)-E(1))*CM
      d=P(1,1,i)*P(1,i,1)+P(3,1,i)*P(3,i,1)+P(2,1,i)*P(2,i,1)
1     write(9,600)i,wcm,d/debye**2
600   format(i5,f12.2,f12.6)
      write(9,90)
      close(9)
      return
      end

      subroutine bftest(M,sbig,btake,MM)
      implicit none
      integer*4 M,ic,i,j,MM,k,l
      real*8  itol,sbig(M,M),inorm,sij
      logical btake(*)
      real*8,allocatable::c(:,:)
      write(6,*)'Linear independence test'
      itol=1.0d-2
      ic=0
      allocate(c(M,M))
      MM=M
      do 1 i=1,M
      do 1 j=1,M
1     c(i,j)=0.0d0
      do 2 j=1,M
2     c(j,j)=1.0d0

      do 3 i=1,M
      inorm=1.0d0
      do 4 j=1,i-1
      sij=0.0d0
      do 5 l=1,M
5     sij=sij+sbig(i,l)*c(j,l)
      inorm=inorm-sij**2
      do 4 k=1,M
4     c(i,k)=c(i,k)-sij*c(j,k)       
      btake(i)=inorm.gt.itol
      if(btake(i))then
       inorm=1.0d0/dsqrt(inorm)
       do 9 k=1,M
9      c(i,k)=c(i,k)*inorm
      else
       do 7 k=1,M
7      c(i,k)=0.0d0
       ic=ic+1
       MM=MM-1
      endif
3     continue
      if(ic.gt.0)write(6,*)ic,' base functions ignored'
      write(6,*)MM,' base functions left'
c      
      return
      end

      subroutine dohbig(M,nat0,nao,noa,nb,hbig,sbig,xvi,xvj,xvq,
     1xv,alj,S,z,TK,V,nor,alpha,ish,ld5,lf7,nop,ty,
     1dj,pi,Z0,one,two,m1,m2,Z1,Z2)
      implicit none
      integer*4 M,nat0,nao,noa,nb,ia,i,j,nor,nop(*),it,ii,jt,jj,ix,
     1ish(nat0,nor)
      real*8 hbig(M,M),xvi(3,nat0),xvj(3,nat0),xv(3,nat0),one,
     1sbig(M,M),xvq(3,nat0),pi,Z0,spi,tol,m1,m2,Z1,Z2,U,li,lj,
     1Ai,Aj,alj(*),dj(*),raa,saa,aij,d2,ec,ef,Q,sij,kij,nij,two,mr,
     1S(nao,nao),alpha(nat0,nor),TK(nao,nao),V(nao,nao),z(*)
      character*1 ty(nat0,nor)
      logical ld5,lf7,lex
      write(6,*)'Dohbig:'
      inquire(file='HBS.SCR',exist=lex)
      if(lex)then
       open(45,file='HBS.SCR',form='unformatted')
       read(45)sbig,hbig
       close(45)
       write(6,*)'Hbig read from HBS.SCR'
      else
       call vz(sbig,z0,nao*nao*nb*nb)
       call vz(hbig,z0,nao*nao*nb*nb)
       tol=23.0d0
       U=m1+m2
c      reduce mass in atomic units:
       mr=m1*m2/U*1837.098d0
       spi=dsqrt(pi)
       do 20 ia=1,noa
       do 20 ix=1,3
       xvq(ix,ia)=xv(ix,ia)
       xvi(ix,ia)=xv(ix,ia)
20     xvj(ix,ia)=xv(ix,ia)

       do 19 i=1,nb
       xvi(3,1)= m2/U*dj(i)
       xvi(3,2)=-m1/U*dj(i)
       li=alj(i)
       Ai=dsqrt(dsqrt((li+li)/pi))
       do 19 j=1,nb
       xvj(3,1)= m2/U*dj(j)
       xvj(3,2)=-m1/U*dj(j)
       lj=alj(j)
       Aj=dsqrt(dsqrt((lj+lj)/pi))
       raa=dsqrt(li*lj)
       saa=li+lj
       aij=li*lj/(li+lj)
       d2=(dj(i)-dj(j))**2
       ec=aij*d2
       if(ec.lt.tol)then
        ef=exp(-ec)
       else
        goto 19
       endif
       Q=(li*dj(i)+lj*dj(j))/saa
       xvq(3,1)= m2/U*Q
       xvq(3,2)=-m1/U*Q
c      overlap -nuclear:
       sij=dsqrt(two*raa/saa)*ef
c      kinetic-nuclear:
       kij=aij*Ai*Aj/mr*spi/dsqrt(saa)*(one-two*aij*d2)*ef
c      nuclear-nuclear:
       nij=Z1*Z2/Q
       call overlapsonly(S,nat0,xvi,xvj,nor,alpha,noa,ish,ld5,
     1 lf7,nop,ty,nao)
       call TKV(TK,V,nat0,xvi,xvj,xvq,nor,alpha,z,noa,ish,ld5,lf7,nop,
     1 ty,nao,0)
       do 21 ii=1,nao
       it=ii+nao*(i-1)
       do 21 jj=1,nao
       jt=jj+nao*(j-1)
c      kinetic-nuclear:
       hbig(it,jt)=kij*S(ii,jj)
c      kinetic-electron:
       hbig(it,jt)=hbig(it,jt)+sij*TK(ii,jj)
c      nuclea-nuclear:
       hbig(it,jt)=hbig(it,jt)+nij*sij*S(ii,jj)
c      nuclear-electron:
       hbig(it,jt)=hbig(it,jt)+sij*V(ii,jj)
c      overlap:
21     sbig(it,jt)=sij*S(ii,jj)
19     continue
       call analm(hbig,M,'H:')
       call analm(sbig,M,'S:')
       open(45,file='HBS.SCR',form='unformatted')
       write(45)sbig,hbig
       close(45)
       write(6,*)'Hbig written to HBS.SCR'
      endif
      return
      end
 
      subroutine analm(a,M,s)
      integer*4 M,it,jt,ii,jj
      real*8 a(M,M),t
      character*(*) s
      write(6,*)
      write(6,*)s
      write(6,600)'          ',1,1,a(1,1)
      write(6,600)'          ',M,M,a(M,M)
      t=a(1,1)
      it=1
      jt=1
      do 1 ii=1,M
      do 1 jj=1,M
      if(dabs(a(ii,jj)).gt.dabs(t))then
       t=a(ii,jj)
       it=ii
       jt=jj
      endif
1     continue
      write(6,600)' biggest  ',it,jt,a(it,jt)
600   format(a10,2i5,g12.4)

      t=a(1,1)
      it=1
      jt=1
      do 2 ii=1,M
      do 2 jj=1,M
      if(dabs(a(ii,jj)).lt.dabs(t))then
       t=a(ii,jj)
       it=ii
       jt=jj
      endif
2     continue
      write(6,600)' smallest ',it,jt,a(it,jt)
      write(6,*)
      return
      end

      subroutine purge(M,MM,sbig,hbig,btake,ss,hh,map,imap)
      implicit none
      integer*4 M,MM,map(*),imap(*),i,j,icol,iline
      real*8 sbig(M,M),hbig(M,M),ss(MM,MM),hh(MM,MM)
      logical btake(*)
      iline=0
      do 1 i=1,M
      if(btake(i))then
       iline=iline+1
       map(iline)=i
       imap(i)=iline
       icol=0
       do 2 j=1,M
       if(btake(j))then
        icol=icol+1
        ss(iline,icol)=sbig(i,j)
        hh(iline,icol)=hbig(i,j)
       endif
2      continue
      endif
1     continue
      return
      end

      subroutine assc(CC,C,MM,M,map)
      integer*4 MM,M,i,j,map(*)
      real*8 CC(MM,MM),C(M,MM)
      do 2 j=1,MM
      do 1 i=1,M
1     C(i,j)=0.0d0
      do 2 i=1,MM
2     C(map(i),j)=CC(i,j)
      return
      end

      subroutine pps(z,pz,pn,m1,m2,pi,xv,xvi,xvj,dj,alj,S,nat0,
     1nor,alpha,noa,ish,ld5,lf7,nop,ty,nao,nb,M,C,ic,npz)
c     probabilities of some nucleus (pn) and distance (pz) at z
c     and state ic; distances in a string z(1....npz)
      implicit none
      integer*4 ia,ix,noa,nat0,nao,nor,ish(nat0,nor),nop(*),i,ii,j,jj,
     1nb,it,jt,M,ic,npz,k
      real*8 pz(*),z(*),pn(*),m1,m2,pi,tol,xvi(3,nat0),xvj(3,nat0),
     1xv(3,nat0),dj(*),Ai,Aj,alj(*),ec,hij,
     1S(nao,nao),alpha(nat0,nor),C(M,M),U,e1,e2
      logical ld5,lf7
      character*1 ty(nat0,nor)
      real*8,allocatable::H(:,:),V(:,:),V1(:,:),V2(:,:)
      tol=23.0d0
      U=m1+m2
      do 1 ia=1,noa
      do 1 ix=1,3
      xvi(ix,ia)=xv(ix,ia)
1     xvj(ix,ia)=xv(ix,ia)

c     Pre-calculate H:
      allocate(H(nb,nb))
      call vz(H,0.0d0,nb*nb)
      do 2 i=1,nb
      xvi(3,1)= m2/U*dj(i)
      xvi(3,2)=-m1/U*dj(i)
      Ai=dsqrt(dsqrt((alj(i)+alj(i))/pi))
      do 2 j=1,nb
      xvj(3,1)= m2/U*dj(j)
      xvj(3,2)=-m1/U*dj(j)
      Aj=dsqrt(dsqrt((alj(j)+alj(j))/pi))
      call overlapsonly(S,nat0,xvi,xvj,nor,alpha,noa,ish,ld5,
     1lf7,nop,ty,nao)
      hij=0.0d0
      do 3 ii=1,nao
      it=ii+nao*(i-1)
      do 3 jj=1,nao
      jt=jj+nao*(j-1)
3     hij=hij+C(it,ic)*C(jt,ic)*S(ii,jj)
2     H(i,j)=Ai*Aj*hij

c     Pre-calculate V:
      allocate(V(nb,npz),V1(nb,npz),V2(nb,npz))
      call vz(V ,0.0d0,nb*npz)
      call vz(V1,0.0d0,nb*npz)
      call vz(V2,0.0d0,nb*npz)
      do 4 i=1,nb
      do 4 k=1,npz
      e1=alj(i)*(( z(k)-m2*dj(i)/U)*U/m2)**2
      e2=alj(i)*((-z(k)-m1*dj(i)/U)*U/m1)**2
      ec=alj(i)*(  z(k)-   dj(i)        )**2
      if(e1.lt.tol)V1(i,k)=exp(-e1)
      if(e2.lt.tol)V2(i,k)=exp(-e2)
 4    if(ec.lt.tol) V(i,k)=exp(-ec)

c     Contract with distances:
      call vz(pz,0.0d0,npz)
      call vz(pn,0.0d0,npz)
      do 5 i=1,nb
      do 5 j=1,nb
      do 5 k=1,npz
      pn(k)=pn(k)+V1(i,k)*H(i,j)*V1(j,k)+V2(i,k)*H(i,j)*V2(j,k)
5     pz(k)=pz(k)+ V(i,k)*H(i,j)* V(j,k)

      return
      end
