      subroutine tep
c
c     calculate core hamiltonian, write to disk (AO)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      integer*4 u0
      parameter (u0=28)
      parameter (nat0=190,nor=80,nort=700,mmax=21)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension cci(u0),ccj(u0),
     3sv1(u0,nort),sv2(u0,nort),b61(u0,u0),
     3b62(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0)
      logical lsprint,ld5,lf7,lrec,lopt,lmp2,lmpdisk,lmp1,lmpn4
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4 ),ld5),
     1(lopt(8),lf7),(lopt(25),lrec),(lopt(61),lmp2),(lopt(62),lmp1),
     1(lopt(63),lmpdisk),
     1(lopt(64),lmpn4)
      dimension eep(mmax)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      logical lex
      data i0,tol/0,23.0D0/
c
      write(3,4000)nao,noa
      write(6,4000)nao,noa
4000  format(' tep ',I4,' orbitals read in',I4,' atoms')
      inquire(file='LAPLACE.SCR',exist=lex)
      if(lex)return
c
      spi=sqrt(pi*pi*pi)
      call inipoly
      call inibe4
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      call vz(sv1,z0,u0*nort)
      call vz(sv2,z0,u0*nort)
      open(33,file='LAPLACE.SCR',form='unformatted')
      open(34,file='EP.SCR',form='unformatted')
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      bb=aj+aj
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      hsp=half*tt
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol) ef=spi*exp(-ec)
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      con=ef*ccj(joo)
      con2=ccj(joo)
      anjx=dble(njx)
      anx=anjx*(anjx-one)
      an2x=two*(two*anjx+one)
      anjy=dble(nyj(joo))
      any=anjy*(anjy-one)
      an2y=two*(two*anjy+one)
      anjz=dble(nzj(joo))
      anz=anjz*(anjz-one)
      an2z=two*(two*anjz+one)
      do 71 ioo=1,npi
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)
      mij=nix+niy+niz+njx+njy+njz
      coe=con*cci(ioo)
      coe2=con2*cci(ioo)
      sx=oi(i0,nix,njx,ai,aj,xij,t,xi,xj)
      sy=oi(i0,niy,njy,ai,aj,yij,t,yi,yj)
      sz=oi(i0,niz,njz,ai,aj,zij,t,zi,zj)
      sxmm=z0
      symm=z0
      szmm=z0
      if(nxj(joo).gt.1)
     1sxmm=oi(i0,nix,njx-2,ai,aj,xij,t,xi,xj)
      sxpp=oi(i0,nix,njx+2,ai,aj,xij,t,xi,xj)
      if(nyj(joo).gt.1)
     1symm=oi(i0,niy,njy-2,ai,aj,yij,t,yi,yj)
      sypp=oi(i0,niy,njy+2,ai,aj,yij,t,yi,yj)
      if(nzj(joo).gt.1)
     1szmm=oi(i0,niz,njz-2,ai,aj,zij,t,zi,zj)
      szpp=oi(i0,niz,njz+2,ai,aj,zij,t,zi,zj)
      ttx=-half*(anx*sxmm-an2x*aj*sx+four*aj*aj*sxpp)*sy*sz
      tty=-half*(any*symm-an2y*aj*sy+four*aj*aj*sypp)*sz*sx
      ttz=-half*(anz*szmm-an2z*aj*sz+four*aj*aj*szpp)*sx*sy
      ecp=ai*aj*tt*r2ij
      up=z0
      if(ecp.lt.tol)then
       up=pi*tt
       up=sqrt(up*up*up)*exp(-ecp)
      endif
      px=(ai*xi+aj*xj)*tt
      py=(ai*yi+aj*yj)*tt
      pz=(ai*zi+aj*zj)*tt
      V=z0
      do 1002 il=1,noa
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
c     uq multiplied by sqrt((al/pi)^3), to have a delta-function
c     u=up
      mij=nix+niy+niz+njx+njy+njz
      call iactivate(mij,i0,xl,yl,zl,px,py,pz,eep,
     1               pqx,pqy,pqz,hsp,z0,tol)
      var1=oc4d(nix,niy,niz,njx,njy,njz,
     1eep, xij,yij,zij,pqx,pqy,pqz,hsp,aa,bb,i0)
1002   V=V-z(il)*up*var1
c     (ab|cd), a=infinity, b=0, c= ai, d=aj, sigmap=0, sigmaq=1/(ai+aj)
c     kinetic energy
      b61(ioo,joo)=(ttx+tty+ttz)*coe
c     electronic-nuclear potential
71    b62(ioo,joo)=V*coe2
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       sv1(ioo,ioj)=sv1(ioo,ioj)+ajjj*b61(ipp,jpp)
74     sv2(ioo,ioj)=sv2(ioo,ioj)+ajjj*b62(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
       sv1(ioo,ioj)=sv1(ioo,ioj)+b61(ioo,joo)
7      sv2(ioo,ioj)=sv2(ioo,ioj)+b62(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       write(33)(sv1(ii,jj),jj=1,nao)
33     write(34)(sv2(ii,jj),jj=1,nao)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       sv1(ii,jj)=z0
9      sv2(ii,jj)=z0
      endif
2     continue
      close(33)
      close(34)
      write(6,*)'Leaving tep'
      return
      end
