      subroutine TKV(K,P,nat0,xvi,xvj,xvq,nor,alpha,z,noa,ish,ld5,lf7,
     1nop,ty,nao,ic)
c     calculates kinetic and potential AO integrals
      implicit none
      integer*4 u0,mmax
      parameter (u0=28,mmax=21)

      integer*4 nat0,nor,noa,ish(nat0,nor),nop(*),nao,ic
      real*8 K(nao,nao),P(nao,nao),xvi(3,nat0),alpha(nat0,nor),
     1z(*),xvj(3,nat0),xvq(3,nat0)
      character*1 ty(nat0,nor)

      real*8 pi,clau,spt,bohr,debye
      common/const/pi,clau,spt,bohr,debye

      real*8 z0,one,two,three,four,five,six,half,qua,a8,a10
      common/numbers/z0,one,two,three,four,five,six,half,qua,a8,a10

      integer*4 i0
      real*8 tol
      data i0,tol/0,23.0d0/

      real*8 cci(u0),ccj(u0),b61(u0,u0),b62(u0,u0),aai(u0,u0),
     1aaj(u0,u0),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),aag(u0,u0),aah(u0,u0),
     2aaii(u0,u0),spi,ai,aj,tt,hsp,t,ef,anjx,anx,an2x,anjy,any,an2y,
     3anjz,anz,an2z,sxmm,symm,szmm,ttx,tty,ttz,aa,bb,aij,r2ij,ec,
     4con,con2,coe,coe2,eep(mmax),xi,yi,zi,xj,yj,zj,xij,yij,zij,
     4x2ij,y2ij,z2ij,oi,sx,sy,sz,sxpp,sypp,szpp,ecp,up,px,py,pz,
     4xl,yl,zl,var1,aiii,ajjj,oc4d,pqx,pqy,pqz,V
      integer*4 nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),ia,
     1il,io,ioj,ioo,ip,ipp,ja,jo,joo,jp,jpp,mij,nix,niy,niz,njx,njy,
     2njz,npi,npii,npj,npjj
      logical ld5,lf7

      if(ic.eq.1)then
       call w36('   ')
       call w36('TKV')
       call w36('^^^')
       call w36('   ')
      endif

      spi=sqrt(pi*pi*pi)
      call inipoly
      call inibe4
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      call vz(K,z0,nao*nao)
      call vz(P,z0,nao*nao)
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xvi(1,ia)
      yi=xvi(2,ia)
      zi=xvi(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xvj(1,ja)
      yj=xvj(2,ja)
      zj=xvj(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      bb=aj+aj
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      hsp=half*tt
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol) ef=spi*exp(-ec)
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      con=ef*ccj(joo)
      con2=ccj(joo)
      anjx=dble(njx)
      anx=anjx*(anjx-one)
      an2x=two*(two*anjx+one)
      anjy=dble(nyj(joo))
      any=anjy*(anjy-one)
      an2y=two*(two*anjy+one)
      anjz=dble(nzj(joo))
      anz=anjz*(anjz-one)
      an2z=two*(two*anjz+one)
      do 71 ioo=1,npi
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)
      mij=nix+niy+niz+njx+njy+njz
      coe=con*cci(ioo)
      coe2=con2*cci(ioo)
      sx=oi(i0,nix,njx,ai,aj,xij,t,xi,xj)
      sy=oi(i0,niy,njy,ai,aj,yij,t,yi,yj)
      sz=oi(i0,niz,njz,ai,aj,zij,t,zi,zj)
      sxmm=z0
      symm=z0
      szmm=z0
      if(nxj(joo).gt.1)
     1sxmm=oi(i0,nix,njx-2,ai,aj,xij,t,xi,xj)
      sxpp=oi(i0,nix,njx+2,ai,aj,xij,t,xi,xj)
      if(nyj(joo).gt.1)
     1symm=oi(i0,niy,njy-2,ai,aj,yij,t,yi,yj)
      sypp=oi(i0,niy,njy+2,ai,aj,yij,t,yi,yj)
      if(nzj(joo).gt.1)
     1szmm=oi(i0,niz,njz-2,ai,aj,zij,t,zi,zj)
      szpp=oi(i0,niz,njz+2,ai,aj,zij,t,zi,zj)
      ttx=-half*(anx*sxmm-an2x*aj*sx+four*aj*aj*sxpp)*sy*sz
      tty=-half*(any*symm-an2y*aj*sy+four*aj*aj*sypp)*sz*sx
      ttz=-half*(anz*szmm-an2z*aj*sz+four*aj*aj*szpp)*sx*sy
      ecp=ai*aj*tt*r2ij
      up=z0
      if(ecp.lt.tol)then
       up=pi*tt
       up=sqrt(up*up*up)*exp(-ecp)
      endif
      px=(ai*xi+aj*xj)*tt
      py=(ai*yi+aj*yj)*tt
      pz=(ai*zi+aj*zj)*tt
      V=z0
      do 1002 il=1,noa
      xl=xvq(1,il)
      yl=xvq(2,il)
      zl=xvq(3,il)
c     uq multiplied by sqrt((al/pi)^3), to have a delta-function
c     u=up
      mij=nix+niy+niz+njx+njy+njz
      call iactivate(mij,i0,xl,yl,zl,px,py,pz,eep,
     1               pqx,pqy,pqz,hsp,z0,tol)
      var1=oc4d(nix,niy,niz,njx,njy,njz,
     1eep, xij,yij,zij,pqx,pqy,pqz,hsp,aa,bb,i0)
1002  V=V-z(il)*up*var1
c     (ab|cd), a=infinity, b=0, c= ai, d=aj, sigmap=0, sigmaq=1/(ai+aj)
c     kinetic energy
      b61(ioo,joo)=(ttx+tty+ttz)*coe
c     electronic-nuclear potential
71    b62(ioo,joo)=V*coe2
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       K(io+ioo,ioj)=K(io+ioo,ioj)+ajjj*b61(ipp,jpp)
74     P(io+ioo,ioj)=P(io+ioo,ioj)+ajjj*b62(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
       K(io+ioo,ioj)=K(io+ioo,ioj)+b61(ioo,joo)
7      P(io+ioo,ioj)=P(io+ioo,ioj)+b62(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
c     last primitive of the orbitals io+1 ... io+npii:
      if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      return
      end
