      SUBROUTINE TTTT(N,ALPHA,A,G,NAT,ICO,R)
C
C     ICO=1  ... transform A and G into local origins
C     ICO=2  ... transform A and G into common origin
C     ICO=3  ... zero out A and G 
C
C     R supposed to be passed in atomic units, G=G/w
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(N,3,3),G(N,3,3),A(N,3,3,3),R(3,NAT)
C
      IF(ICO.EQ.1)SIGN= 1.0D0
      IF(ICO.EQ.2)SIGN=-1.0D0
      IF(ICO.EQ.3)SIGN= 0.0D0
C
      DO 2 IA=1,3
      DO 2 IB=1,3
      DO 2 L=1,NAT
      DO 2 IE=1,3
      K=3*(L-1)+IE
      IF(ICO.EQ.3)THEN
       G(K,IA,IB)=0.0D0
      ELSE
       SUM=0.0D0
       DO 1 IG=1,3
       DO 1 ID=1,3
1      SUM=SUM+SIGN*0.5D0*EPS(IB,IG,ID)*R(IG,L)*ALPHA(K,IA,ID)
       G(K,IA,IB)=G(K,IA,IB)+SUM
      ENDIF
2     CONTINUE
      IF(ICO.EQ.1)WRITE(3,*)' G transformed into atomic origins'
      IF(ICO.EQ.2)WRITE(3,*)' G transformed into common origin'
      IF(ICO.EQ.3)WRITE(3,*)' G set to zero'
C
      DO 3 IA=1,3
      DO 3 IB=1,3
      DO 3 IC=1,3
      DO 3 L=1,NAT
      DO 3 IE=1,3
      K=3*(L-1)+IE
      SUM=0.0D0
      IF(IB.EQ.IC)THEN
       DO 4 ID=1,3
4      SUM=SUM+R(ID,L)*ALPHA(K,IA,ID)
      ENDIF
      A(K,IA,IB,IC)=A(K,IA,IB,IC)+SIGN*(SUM
     1-1.5D0*(R(IB,L)*ALPHA(K,IA,IC)+R(IC,L)*ALPHA(K,IA,IB)))
      IF(ICO.EQ.3)A(K,IA,IB,IC)=0.0D0
3     CONTINUE
      IF(ICO.EQ.1)WRITE(3,*)' A transformed into atomic origins'
      IF(ICO.EQ.2)WRITE(3,*)' A transformed into common origin'
      IF(ICO.EQ.3)WRITE(3,*)' A set to zero'
c
      RETURN
      END
c    ============================================================ 
      SUBROUTINE TTAI(N,ALPHA,AV,A,G,NAT,ICO,R)
C
C     ICO=1  ... transform A and G into local origins
C     ICO=2  ... transform A and G into common origin
C     ICO=3  ... zero out A and G 
C
C     R supposed to be passed in atomic units, G=G/w
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(N,3,3),G(N,3,3),A(N,3,3,3),R(3,NAT),AV(N,3,3)
C
      IF(ICO.EQ.1)SIGN= 1.0D0
      IF(ICO.EQ.2)SIGN=-1.0D0
      IF(ICO.EQ.3)SIGN= 0.0D0
C
      DO 1 IA=1,3
      DO 1 IB=1,3
      DO 1 L=1,NAT
      DO 1 IE=1,3
      K=3*(L-1)+IE
      DO 1 IG=1,3
      DO 1 ID=1,3
c     last index of G magnetic
1     G(K,IA,IB)=G(K,IA,IB)+SIGN*0.5D0*EPS(IB,IG,ID)*R(IG,L)*AV(K,IA,ID)
      IF(ICO.EQ.1)WRITE(3,*)' G transformed into atomic origins with AV'
      IF(ICO.EQ.2)WRITE(3,*)' G transformed into common origin with AV'
      IF(ICO.EQ.3)WRITE(3,*)' G set to zero'
C
      DO 3 IA=1,3
      DO 3 IB=1,3
      DO 3 IC=1,3
      DO 3 L=1,NAT
      DO 3 IE=1,3
      K=3*(L-1)+IE
      SUM=0.0D0
      IF(IB.EQ.IC)THEN
       DO 4 ID=1,3
4      SUM=SUM+R(ID,L)*ALPHA(K,IA,ID)
      ENDIF
      A(K,IA,IB,IC)=A(K,IA,IB,IC)+SIGN*(SUM
     1-1.5D0*(R(IB,L)*ALPHA(K,IA,IC)+R(IC,L)*ALPHA(K,IA,IB)))
      IF(ICO.EQ.3)A(K,IA,IB,IC)=0.0D0
3     CONTINUE
      IF(ICO.EQ.1)WRITE(3,*)' A transformed into atomic origins'
      IF(ICO.EQ.2)WRITE(3,*)' A transformed into common origin'
      IF(ICO.EQ.3)WRITE(3,*)' A set to zero'
c
      RETURN
      END
c     ============================================================= 
      SUBROUTINE covr(N,A,AV,nat)
C
C     compare velocity and length form of alpha
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION A(N,3,3),AV(N,3,3)
C
      write(3,3003)
3003  format('ATOM   C   A   B    LENGTH &VELOCITY   form of alpha',/,
     1       '------------------------------------')
      do 13 l=1,nat
      write(3,*) 
      do 13 i=1,3
      ii=3*(l-1)+i
      do 13 ia=1,3
      do 13 ib=1,3
13    write(3,3004)l,i,ia,ib,a(ii,ia,ib),av(ii,ia,ib)
3004  format(4I4,2F10.3)
      return
      END
