      SUBROUTINE ORBDIF22
c     Reads Gaussian output, cartesian differentiation),
c     ordered according to coordinates (0,x-,x+,y-,y+ etc)
      IMPLICIT none
      character*50 S50
      character*1 xyz(3),pm
      integer*4 nat0,nor,nort,NTT,line
      parameter (nat0=190,nor=80,nort=700,NTT=nort*(nort+1)/2)
      integer*4 I,ierr,ix,IA,IC,ibasis,ii,jj,ndeg,
     1n,icha,n1,nd,iil(nort),iopt,inormo,iilb(nort),nmo2 
      logical lopt,lzmat,lcmx,ld5,lf7,lex,lconfig,lexu,lsprint,lloc,
     1lmao
      real*8 r0(nat0,3),step,ff,r(nat0,3),etol,DMAO(NTT,3)
      common/opts/lopt(300),icha,n1
      equivalence (ld5,lopt(4)),(lf7,lopt(8)),(lex,lopt(20)),
     1 (lzmat,lopt(28)),(lcmx,lopt(99)),(lconfig,lopt(65)),
     1(lsprint,lopt(1)),(lloc,lopt(100)),(lmao,lopt(101))
      common/iopts/iopt(300)
      equivalence (inormo,iopt(2))
      data xyz/'x','y','z'/
      real*8,dimension(:,:),allocatable::cij0,cijt,smix,sm0,
     1bij0,bijt,ccu,bbu,bbm,sms,ccm
      real*8,dimension(:),allocatable::u,et,bet,ub
      real*8 ccs,ccp,ccd,ccf,cci_G,cci_H,cci_I
      integer*4 nxig,nyig,nzig,nxih,nyih,nzih,nxii,nyii,nzii
      common/spdfgh/ccs(nat0,nor),ccp(nat0,nor),ccd(nat0,nor,2),
     1ccf(nat0,nor,3),cci_G(nat0,nor,15),cci_H(nat0,nor,21),
     2cci_I(nat0,nor,28),nxig(15),nyig(15),nzig(15),
     2nxih(21),nyih(21),nzih(21),nxii(28),nyii(28),nzii(28)
      real*8 escf,cc,alpha,rcp,cij,bij,e,be
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,noa,nori,nop,
     1ish
      character*1 ty,ok
      character*2 at
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      real*8 pi,clau,spt,bohr,debye
      common/const/pi,clau,spt,bohr,debye
C
      call w36(' ')
      call w36('Orbdif22')
      call w36('^^^^^^^^')
      etol=0.003d0

      if(lloc.and.lmao)
     1call report('lloc and lmao are conflicting options')

      inquire(file='Ucp.TXT.SCR',exist=lexu)
      if(lexu)then
       call w36('Ucp.TXT.SCR found on disk')
       return
      endif

      inquire(file='Ucp.A.SCR.TXT',exist=lexu)
      if(lexu)then
       call w36('Ucp.A.SCR.TXT found on disk')
       return
      endif

      N=3*nat
      write(6,*)N,nmo,nao
      allocate(u(2*N*nmo**2),cij0(nao,nao),et(nao),
     1smix(nao,nao),cijt(nao,nao),sm0(nao,nao),
     1ccu(nmo,nmo),sms(nao,nao),ccm(nmo,nmo))

C
      close(2)
 
      write(6,*)' Orbital derivatives from FILE.OUT'
      open(2,file='FILE.OUT',status='old')
      ibasis=0
      line=0
C
c     ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
      write(6,*)' Looking for geometry'
c     read zero geometry to r0:
      call chkgeop(r,nat,lzmat,step,I,ff,ierr,ia,ix,r0,0,line)
      if(ierr.ne.0)call report('Program stopped')
      write(6,*)' line ',line,' Looking for basis set'
  201 READ(2,1111,END=202)S50
      line=line+1
1111  FORMAT(A50)
c
c     BASIS        GFInput
      if( S50(2:46).eq.'Basis set in the form of general basis input:'
     1.or.S50(2:46).eq.'AO basis set in the form of general basis inp'
     2  )then
        write(6,*)S50
        ibasis=ibasis+1
        call getbasis(nao,nat,nop,nor,ish,ld5,lf7,
     1  ty,cc,ccs,ccp,ccd,ccf,cci_G,cci_H,cci_I,alpha,nat0,
     1  nxig,nyig,nzig,nxih,nyih,nzih,nxii,nyii,nzii,rcp)
        if(nao.gt.nort)call report('too many orbitals')
        write(6,*)nao,'AOs'
        goto 300
      endif
      goto 201
202   write(6,*)' line ',line,' (end)'
      call report('BASis not found')

      N=3*nat
c
c     read-in zero point MO coefficients:
300   read(2,1111,end=203)S50

      if(S50(8:22).eq.'alpha electrons')then
       write(6,1111)S50
       read(S50(1:6),*)nsa
       read(S50(23:31),*)nsb
      endif
   

      if(S50(6:35).eq.'Molecular Orbital Coefficients'.or.
     1 S50(6:42).eq.'Alpha Molecular Orbital Coefficients:'.or.
     1 S50(2:11).eq.'Alpha MOs:') then
c      eigenvectors listed either as a result of IOP(6/7=1) or IOP(5/33=1)
c      or pop=full
       write(6,1111)S50
       write(3,1111)S50
       nori=ndo
       if(nmo.gt.0)nori=nmo
       if(nao.eq.0)nao=nmo
       call readorb(S50,nori,e,cij0,nao,nao)
       if(S50(6:42).eq.'Alpha Molecular Orbital Coefficients:'.or.
     1  S50(2:11).eq.'Alpha MOs:')then
c       open shell, look for beta:
        allocate(bij0(nao,nao),bijt(nao,nao),
     1  bet(nao),bbu(nmo,nmo),bbm(nmo,nmo),
     1  ub(2*N*nmo**2))
        goto 300
       else
c       closed shell, finished:
        goto 303
       endif
      endif

      if(S50(6:41).eq.'Beta Molecular Orbital Coefficients:'.or.
     1 S50(2:10).eq.'Beta MOs:')then
       write(6,1111)S50
       call readorb(S50,nori,be,bij0,nao,nao)
       goto 303
      endif

      goto 300
203   call report('Orbitals not found')
303   call w36('zero point finished')
c     ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg

c     get AO S-matrix:
      call csm(r0,r0,nat0,sm0,nao,noa,alpha,ty,nop,ish)
c     get AO electric dipoles:
      if(lloc)call edo(DMAO,r0,r0,nao,noa,alpha,ty,nop,ish)

c     Alpha or closed shell block:-----------------------------
c     orthogonalize
      if(inormo.eq.3)call ortog2(sm0,nao,cij0,nmo)
c
c     test for degeneracy
c     for ieach orbital ii how many degeneracies forward ->
      ndeg=0
      ii=1
1     nd=0
      do 2 jj=1,nmo
2     if(dabs(e(ii)-e(jj)).lt.etol)nd=nd+1
      if(nd.gt.1)then
       ndeg=ndeg+1
       if(lloc)then
        write(6,6001)ii,nd
        write(3,6001)ii,nd
6001    format(' Orbital ',2i5,'-times degenerate')
        call w36('Replacing by LMO')
        call boyson(ii,ii+nd-1,cij0,DMAO,nao)
       endif
      endif
      iil(ii)=nd
      ii=ii+1
      if(ii.lt.nmo)goto 1
      if(ndeg.gt.0)write(6,*)ndeg,' orbital degeneracies detected'
c

c     Alpha or closed shell block:-----------------------------

c     Beta block:----------------------------------------------
      if(nsa.ne.nsb)then
c     orthogonalize
      if(inormo.eq.3)call ortog2(sm0,nao,bij0,nmo)
c
c     test for degeneracy
      ndeg=0
      ii=1
25    nd=0
      do 24 jj=1,nmo
24    if(dabs(be(ii)-be(jj)).lt.etol)nd=nd+1
      if(nd.gt.1)then
       ndeg=ndeg+1
       if(lloc)then
        write(6,7001)ii,nd
        write(3,7001)ii,nd
7001    format(' Beta orbital ',2i5,'-times degenerate')
        call w36('Replacing by LMO')
        call boyson(ii,ii+nd-1,bij0,DMAO,nao)
       endif
      endif
      iilb(ii)=nd
      ii=ii+1
      if(ii.lt.nmo)goto 25
      if(ndeg.gt.0)write(6,*)ndeg,' beta orbital degeneracies detected'
c
      endif
c     Beta block:----------------------------------------------
c
c     Initialize u-matrix of first and second derivatives
c     diagonal second are the second part in U:
      nmo2=nmo**2
      call vzt(u,2*N*nmo2)
      if(nsa.ne.nsb)call vzt(ub,2*N*nmo2)
c
      IC=0
      step=0.0d0
c     333333333333333333333333333333333333333333333333333333333333
3333  IC=IC+1
c
c     read geometry and check the diff. step:
      call chkgeop(r0,nat,lzmat,step,I,ff,ierr,ia,ix,r,1,line)
      if(ierr.eq.99)goto 999
      if(ff.lt.0.0d0)then
       pm='-'
      else
       pm='+'
      endif
      write(6,6363)IC,step*bohr,I,ia,xyz(ix),pm
      write(3,6363)IC,step*bohr,I,ia,xyz(ix),pm
6363  format('Displacement:',I5,' Step(A):',f10.4,' Coord.:',I5,
     1' Atom:',I5,2a1)


c     8888
c     if(IC.eq.3)goto 999

      if(ix+3*(ia-1).ne.I)then
       write(6,*)ix,ia,I
       call report('Inconsistent differentiation')
      endif
c
c     read the orbitals
400   read(2,1111,end=403)S50
      if(S50(6:35).eq.'Molecular Orbital Coefficients'.or.
     1 S50(6:42).eq.'Alpha Molecular Orbital Coefficients:'.or.
     1 S50(2:11).eq.'Alpha MOs:') then
       write(6,1111)S50
       call readorb(S50,nori,et,cijt,nao,nao)
       if(S50(6:42).eq.'Alpha Molecular Orbital Coefficients:')then
        goto 400
       else
        goto 503
       endif
      endif
      if(S50(6:41).eq.'Beta Molecular Orbital Coefficients:'.or.
     1 S50(2:10).eq.'Beta MOs:')then
       write(6,1111)S50
       call readorb(S50,nori,bet,bijt,nao,nao)
       goto 503
      endif
      goto 400
403   call report('Orbitals not found')
503   continue
c
c     get AO S-matrix for shifted geometry:
      call csm(r,r,nat0,sms,nao,noa,alpha,ty,nop,ish)
c     get AO electric dipoles displaced...displaced:
      if(lloc)call edo(DMAO,r,r,nao,noa,alpha,ty,nop,ish)
c     calculate the overlap matrix smix between equilibrium and
c     displaced AOs sm = < x (r0) | x (r) >
      call csm(r0,r,nat0,smix,nao,noa,alpha,ty,nop,ish)

c     Alpha or closed shell block --------------------------
c     orthogonalize
      if(inormo.eq.3)call ortog2(sms,nao,cijt,nmo)
c
c     localize orbitals that were found degenerate at equilibrium geometry:
      if(lloc)then
       ii=1
16     if(iil(ii).gt.1)then
        write(6,6001)ii,iil(ii)
        write(3,6001)ii,iil(ii)
        call w36('boyson will be called')
        call boyson(ii,ii+iil(ii)-1,cijt,DMAO,nao)
       endif
       ii=ii+iil(ii)
       if(ii.lt.nmo)goto 16
      endif
c
      call digestc(ff,nmo,nao,ccm,ccu,smix,cij0,cijt,lmao,e,I,u,N,
     1etol)

c     Alpha or closed shell block --------------------------

c     Beta block --------------------------
      if(nsa.ne.nsb)then
       if(inormo.eq.3)call ortog2(sms,nao,bijt,nmo)
c
c      localize orbitals that were found degenerate at equilibrium geometry:
       if(lloc)then
        ii=1
26      if(iilb(ii).gt.1)then
         write(6,6001)ii,iilb(ii)
         write(3,6001)ii,iilb(ii)
         call w36('boyson will be called')
         call boyson(ii,ii+iilb(ii)-1,bijt,DMAO,nao)
        endif
        ii=ii+iilb(ii)
        if(ii.lt.nmo)goto 26
       endif

       call digestc(ff,nmo,nao,bbm,bbu,smix,bij0,bijt,lmao,be,I,ub,N,
     1 etol)
c
      endif
c     Beta block --------------------------
c
      goto 3333
c     333333333333333333333333333333333333333333333333333333333333
c
999   close(2)

C
      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
      call mmstep(N,nmo,u,step)
      call asymmetrize(N,nmo,u,'a')
      call wruu(N,nmo,u,'Ucp','A',1)

      if(nsa.ne.nsb)then
       call mmstep(N,nmo,ub,step)
       call asymmetrize(N,nmo,ub,'b')
       call wruu(N,nmo,ub,'Ucp','B',1)
      endif


      call w36('Orbdif22-ok')
      RETURN
      END
c     ============================================================
      subroutine trsc(s,c,N,nao,nmo,n1e,ab)
c     SJL = C(J,i) <i(y)|j(0)> C(L,j)
      implicit none
      integer*4 N,nao,nmo,I,J,L,ii,jj,M,ia,ix,n1e,k
      real*8 s(*),c(nao,nao),sum
      real*8,allocatable::t(:),tt(:,:)
      character*1 ab
      if(n1e.gt.7)call report('n1e>7 not implemented')
      M=N*nao
      allocate(t(nao*nao))
      do 2 k=1,n1e
      do 2 I=1,N
c     first index
c     TJj = C(J,i) <i(y)|j(0)>
      do 1 J=1,nmo
      do 1 jj=1,nao
      sum=0.0d0
      do 11 ii=1,nao
11    sum=sum+c(J,ii)*s(I+N*(ii-1)+M*(jj-1)+M*nao*(k-1))
c      sdm(a+3*(ia-1)+n3*(i-1)+n3*nao*(j-1)+n3*nao*nao*(kk-1))
c       I=a+3*(ia-1), a - a-coordinate of ia (derivas)
c        i - AO, differentiated , n3 = 3 x nat
c        j - the other AO
c        kk- 1..4, s and electric and magnetic dipoles
1     t(J+nao*(jj-1))=sum
c     second index
c     SJL = TJj C(L,j)
      do 2 J=1,nmo
      do 2 L=1,nmo
      sum=0.0d0
      do 22 jj=1,nao
22    sum=sum+t(J+nao*(jj-1))*c(L,jj)
2     s(I+N*(J-1)+M*(L-1)+M*nao*(k-1))=sum
      deallocate(t)

      allocate(tt(nmo,nmo))
      open(66,file='SX'//ab//'.SCR.TXT')
      do 8 k=1,n1e
      if(k.eq.1)write(66,*)'S-matrix derivatives in MOs'
      if(k.eq.2)write(66,*)'x-dipole derivatives in MOs'
      if(k.eq.3)write(66,*)'y-dipole derivatives in MOs'
      if(k.eq.4)write(66,*)'z-dipole derivatives in MOs'
      if(k.eq.5)write(66,*)'x-mag dipole derivatives in MOs'
      if(k.eq.6)write(66,*)'y-mag dipole derivatives in MOs'
      if(k.eq.7)write(66,*)'z-mag dipole derivatives in MOs'
      do 8 ia=1,N/3
      do 8 ix=1,3
      I=ix+3*(ia-1)+M*nao*(k-1)
      do 81 J=1,nmo
      do 81 L=1,nmo
81    tt(J,L)=s(I+N*(J-1)+M*(L-1))
      write(66,600)ia,ix
600   format(' Atom ',i6,' coordinate ',i1,':')
8     call wmtrio(66,tt,nmo,nmo)
      close(66)
c
      return
      end
c     ============================================================
      subroutine wdu(U,N,M)
      implicit none
      integer*4 i,j,N,M,is,ie,i5,n5
      real*8 U(*)
      n5=M/5
      if(M.gt.n5*5)n5=n5+1
      is=-4
      do 1 i5=1,n5
      is=is+5
      ie=min(is+4,M)
      write(44,440)(j,j=is,ie)
440   format(i18,4i14)
      do 1 j=1,N
1     write(44,441)j,(U(i+M*(j-1)),i=is,ie)
441   format(i7,5e14.6)
      return
      end
c     ============================================================
      subroutine chkgeop(r,nat,lzmat,step,ID,asign,ierr,ia,ix,ra,icon,
     1line)
      implicit none
      integer*4 nat0,nat,ig98,I,l,ic,ID,ierr,ia,ix,icon,ii,IZ,
     1line
      parameter (nat0=190)
      real*8 r(nat0,3),tol,step,asign,ra(nat0,3)
      character*50 S50
      logical lzmat,lcmx,lopt
      common/lop/lopt(300)
      equivalence (lcmx,lopt(33))
      real*8 pi,clau,spt,bohr,debye,x,y,z
      common/const/pi,clau,spt,bohr,debye
      real*8 am,amas
      integer*4 MENDELEV
      parameter (MENDELEV=89)
      common/mass/am(nat0)
      dimension amas(MENDELEV)
      data amas/1.008,4.003,
     2  6.941, 9.012,   10.810,12.011,14.007,15.999,18.998,20.179,
     3 22.990,24.305,   26.981,28.086,30.974,32.060,35.453,39.948,
     4 39.098,40.080,44.956,47.900,50.941,51.996,54.938,55.847,
     4 58.933,58.700,63.546,65.380,
     4                  69.720,72.590,74.922,78.960,79.904,83.800,
     5 85.468,87.620,88.906,91.220,92.906,95.940,98.906,101.070,
     5 102.906,106.400,107.868,112.410,
     5                 114.82,118.69,121.75,127.600,126.905,131.300,
     6 132.905,137.330,138.906,
     6                 140.120,140.908,144.240,145.000,150.400,
     6 151.960,157.250,158.925,162.500,164.930,167.260,168.934,
     6 173.040,174.970,
     6 178.490,180.948,183.850,186.207,190.200,192.220,195.090,
     6 196.967,207.590,204.370,207.200,208.980,210.000,210.001,
     6 222.02,
     7 223.000,226.025,227.028/
c
      ierr=0
      ID=0
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      line=line+1
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1 s50(27:44).EQ.'Input orientation:'.OR.
     1 s50(26:46).EQ.'Standard orientation:')ig98=1
       if(lcmx.and.s50(2:7).eq.'Charge')ig98=-1
       if(ig98.ne.-1)then
        DO 41 I=1,4
41      READ(2,*)
       endif
       tol=1.0d-4
       ic=0
       DO 1 l=1,nat

       if(ig98.eq.0)then
        READ(2,*)I,I,x,y,z
        am(l)=amas(I)
       else
        if(ig98.eq.-1)then
         READ(2,*)I,x,y,z
         am(l)=amas(I)
        else
         READ(2,*)I,IZ,I,x,y,z
         am(l)=amas(IZ)
        endif
       endif
       ra(l,1)=x/bohr
       ra(l,2)=y/bohr
       ra(l,3)=z/bohr

       if(icon.eq.1)then
        do 2 ii=1,3
        if(abs(ra(l,ii)-r(l,ii)).gt.tol)then
         ic=ic+1
         ID=3*(l-1)+ii
         ia=l
         ix=ii
         if(ra(l,ii).gt.r(l,ii))then
          asign=1.0d0
         else
          asign=-1.0d0
         endif
         step=dabs(ra(l,ii)-r(l,ii))
        endif
2       continue
       endif
1      continue
       if(icon.eq.0)then
        call w36('Geometry read')
       else
        if(ic.ne.1)then
         write(3,*)ic
         call report('defective differentiation found')
        endif
       endif
       return
      ENDIF
      goto 201
202   write(6,*)' line ',line
      call w36('Geometry not found')
      ierr=99
      return
      end
c     ============================================================
      subroutine vzt(u,N)
      implicit none
      real*8 u(*)
      integer*4 N,i
      do 1 i=1,N
   1  u(i)=0.0d0
      return
      end
c     ============================================================
      subroutine t12(nmo,nao,cc,sm,cij0,cijt)
      implicit none
      integer*4 nmo,nao,ii,jj,kk
      real*8 sm(nao,nao),cij0(nao,nao),cijt(nao,nao),cc(nmo,nmo)
      real*8,dimension(:,:),allocatable::t
      allocate(t(nao,nao))
c
c     transform first index "equilibrium"
      do 103 ii=1,nmo
      do 103 jj=1,nao
      t(ii,jj)=0.0d0
      do 103 kk=1,nao
103   t(ii,jj)=t(ii,jj)+cij0(ii,kk)*sm(kk,jj)
c
c     transform second index "displaced'
      do 104 ii=1,nmo
      do 104 jj=1,nmo
      cc(ii,jj)=0.0d0
      do 104 kk=1,nao
104   cc(ii,jj)=cc(ii,jj)+cijt(jj,kk)*t(ii,kk)
      return
      end
c     ============================================================
      subroutine ct12(nmo,sm,ind)
      implicit none
      integer*4 nmo,kp,k,ind(*),nc
      real*8 sm(nmo,nmo),amax
      logical,dimension(:),allocatable::iu
c
      allocate(iu(nmo))
      do 3 kp=1,nmo
3     iu(kp)=.false.
      do 1 k=1,nmo
      amax=0.0d0
      ind(k)=0
      do 2 kp=1,nmo
      if(dabs(sm(k,kp)).gt.amax.and..not.iu(kp))then
       amax=dabs(sm(k,kp))
       ind(k)=kp
      endif
2     continue
      iu(ind(k))=.true.
      if(amax.lt.0.8d0)then
       write(6,600)k,ind(k),amax
       write(3,600)k,ind(k),amax
600    format(' Warning: orbital',i5,' small largest overlap',i5,f9.4)
      endif
1     continue
      deallocate(iu)

c
      nc=0
      do 103 k=1,nmo
      if(sm(k,ind(k)).lt.0.0d0)then
       nc=nc+1
       do 1031 kp=1,nmo
1031   sm(kp,ind(k))=-sm(kp,ind(k))
      endif
103   continue

      write(6,601)nc
601   format(i5,' phase changes in ct12')

      return
      end
c     ============================================================
      subroutine movm(a,b,n,m)
      implicit none
      integer*4 i,j,n,m
      real*8 a(n,m),b(n,m)
      do 1 i=1,n
      do 1 j=1,m
1     b(i,j)=a(i,j)
      return
      end
c     ============================================================
      subroutine  mmstep(N,nmo,u,step)
      implicit none
      integer*4 N,nmo,i
      real*8 u(*),step
      DO 15 i=1,N*nmo*nmo
      u(i)=u(i)/(2.0d0*step)
15    u(N*nmo*nmo+i)=u(N*nmo*nmo+i)/step**2
      return
      end
c     ============================================================
      subroutine wruu(N,nmo,u,s1,s2,ic)
      implicit none
      integer*4 ic,nmo,N,I,jj,kk
      real*8 u(*)
      real*8,allocatable::tm(:)
      character*(*) s1,s2
      open(44,file=s1//'.'//s2//'.SCR.TXT')
      allocate(tm(nmo*nmo))
      do 17 I=1,N
      write(44,*)I,s2//', first'
      do 171 jj=1,nmo
      do 171 kk=1,nmo
171   tm(jj+nmo*(kk-1))=u(kk+nmo*(jj-1)+nmo*nmo*(I-1))
17    call wdu(tm,nmo,nmo)
      if(ic.eq.1)then
       do 18 I=1,N
       write(44,*)I,s2//', second'
       do 181 jj=1,nmo
       do 181 kk=1,nmo
181    tm(jj+nmo*(kk-1))=u(N*nmo*nmo+kk+nmo*(jj-1)+nmo*nmo*(I-1))
18     call wdu(tm,nmo,nmo)
      endif
      close(44)
      write(6,*)s1//'.'//s2//'.SCR.TXT written'
      return
      end
c     ============================================================
      subroutine asymmetrize(N,nmo,u,ab)
      implicit none
      integer*4 i,j,a,N,nmo,iii,aii,ki,kj,aij
      real*8 u(*),uii,uij,uji,uo,ue,eij,eji,de
      character*1 ab
      uii=0.0d0
      iii=0
      aii=0
      uij=0.0d0
      uji=0.0d0
      uo=0.0d0
      ki=0
      kj=0
      aij=0
      do 1 a=1,N
      do 1 i=1,nmo
      ue=u(i+nmo*(i-1)+nmo*nmo*(a-1))
      if(dabs(ue).gt.dabs(uii))then
       uii=ue
       iii=i
       aii=a
      endif
      do 1 j=i,nmo
      eij=u(i+nmo*(j-1)+nmo*nmo*(a-1))
      eji=u(j+nmo*(i-1)+nmo*nmo*(a-1))
      de=eij+eji
      if(i.ne.j.and.dabs(de).gt.uo)then
       uo=dabs(de)
       uij=eij
       uji=eji
       ki=i
       kj=j
       aij=a
      endif
      u(i+nmo*(j-1)+nmo*nmo*(a-1))= (eij-eji)/2.0d0
1     u(j+nmo*(i-1)+nmo*nmo*(a-1))=-(eij-eji)/2.0d0
      write(6,6001)ab,aii,iii,uii
6001  format(/,' Largest diagonal element ',a1,':',/,
     1         ' perturbation :',i4,' MO: ',i8,' Uoii: ',f12.6,/)
      write(6,6002)aij,ki,kj,uij,uji
6002  format(  ' Largest off-diagonal difference:',/,
     1         ' perturbation :',i4,' MO: ',2i4,' Uoij: ',f12.6,/,
     1         '               ',4x,'     ', 8x,' Uoji: ',f12.6,/)
      write(6,*)' U-matrix has been symmetrized'
      return
      end
c     ============================================================
      subroutine domao2(ii,cco,nmo,pm)
      implicit none
      integer*4 ii,j,nmo
      real*8 cco(nmo,nmo),t,fi1,cf,sf,f1,fi2,f2,fi,o11,o22,
     1o12,o21,phase1,phase2,oj1,oj2
      character*1 pm

      write(6,603)pm,
     1ii  ,ii,cco(ii  ,ii),   ii  ,ii+1,cco(ii  ,ii+1),
     2ii+1,ii,cco(ii+1,ii),   ii+1,ii+1,cco(ii+1,ii+1)
603   format(/,'<j0|k',a1,'> : ',2(2i5,f8.4),/,10x,2(2i5,f8.4))

c     rotate two states by fi:
      t=( cco(ii,ii+1)**2+cco(ii+1,ii  )**2
     1   -cco(ii,ii  )**2-cco(ii+1,ii+1)**2)/
     2(cco(ii+1,ii)*cco(ii+1,ii+1)-cco(ii,ii)*cco(ii,ii+1))
c     investigate the two solutions
      fi1=atan((-t+dsqrt(t**2+4))/2.0d0)
      cf=cos(fi1)
      sf=sin(fi1)
      f1=( cf*cco(ii  ,ii)+sf*cco(ii  ,ii+1))**2+
     1   (-sf*cco(ii+1,ii)+cf*cco(ii+1,ii+1))**2
      fi2=atan((-t-dsqrt(t**2+4))/2.0d0)
      cf=cos(fi2)
      sf=sin(fi2)
      f2=( cf*cco(ii  ,ii)+sf*cco(ii  ,ii+1))**2+
     1   (-sf*cco(ii+1,ii)+cf*cco(ii+1,ii+1))**2
c     compare overlaps and take the biggest one::
      if(f1.gt.f2)then
       fi=fi1
      else
       fi=fi2
      endif
      cf=cos(fi)
      sf=sin(fi)
c     first index-equilibrium
      o11= cf*cco(ii  ,ii)+sf*cco(ii  ,ii+1)
      o22=-sf*cco(ii+1,ii)+cf*cco(ii+1,ii+1)
      o12=-sf*cco(ii  ,ii)+cf*cco(ii  ,ii+1)
      o21= cf*cco(ii+1,ii)+sf*cco(ii+1,ii+1)
      if(o11.lt.0.0d0)then
       o11=-o11
       o21=-o21
       phase1=-1.0d0
      else
       phase1=1.0d0
      endif
      if(o22.lt.0.0d0)then
       o22=-o22
       o12=-o12
       phase2=-1.0d0
      else
       phase2=1.0d0
      endif
      write(6,*)ii,ii+1,' rotated'
      write(6,6103) phase1*cf,ii,phase1*sf,ii+1,o11
      write(6,6104)-phase2*sf,ii,phase2*cf,ii+1,o22
6103  format(f8.4,i4,'+',f8.4,i4, ' <ip|i  0> = ',f8.4)
6104  format(f8.4,i4,'+',f8.4,i4, ' <ip|i+10> = ',f8.4)
      do 1 j=1,nmo
      oj1= phase1*( cf*cco(j,ii)+sf*cco(j,ii+1))
      oj2= phase2*(-sf*cco(j,ii)+cf*cco(j,ii+1))
      cco(j,ii  )=oj1
1     cco(j,ii+1)=oj2
c
      return
      end
c     ============================================================
      subroutine digestc(ff,nmo,nao,ccm,ccu,smix,cij0,cijt,lmao,e,I,u,N,
     1etol)
      implicit none
      real*8 ff,ccm(nmo,nmo),smix(nao,nao),cij0(nao,nao),cijt(nao,nao),
     1ccu(nmo,nmo),e(*),u(*),etol,d1,d2,d3,cp,cm
      integer*4 nmo,nao,ii,jj,kk,I,nmo2,N,lj1,lj2,lj3,lk1,lk2,lk3
      logical lmao
      integer*4,allocatable::ind(:),indp(:)
      nmo2=nmo**2
      allocate(ind(nmo),indp(nmo))
c     make <K | K+-> first index equilibrium C(0) x S(0,+) x C(+)
      if(ff.lt.0.0d0)then
       call t12(nmo,nao,ccm,smix,cij0,cijt)
      else
       call t12(nmo,nao,ccu,smix,cij0,cijt)

       if(lmao)then

        ii=0
47      ii=ii+1

c       condition of three degenerate orbitals to be rotated:
        if(ii+2.le.nmo)then
        if(dabs(e(ii)-e(ii+2)).lt.etol)then
         if((dabs(ccu(ii  ,ii  )).lt.0.97d0.and.
     1       dabs(ccu(ii+1,ii+1)).lt.0.97d0.and.
     1       dabs(ccu(ii+2,ii+2)).lt.0.97d0).or.
     1      (dabs(ccm(ii  ,ii  )).lt.0.97d0.and.
     1       dabs(ccm(ii+1,ii+1)).lt.0.97d0.and.
     1       dabs(ccm(ii+2,ii+2)).lt.0.97d0))then
          call domao3(ii,ccu,nmo,'+')
          call domao3(ii,ccm,nmo,'-')
          ii=ii+2
          if(ii.lt.nmo-1)goto 47
         endif
        endif
        endif

c       condition of two degenerate orbitals to be rotated:
        if(dabs(e(ii)-e(ii+1)).lt.etol)then
         if((dabs(ccu(ii  ,ii  )).lt.0.97d0.and.
     1       dabs(ccu(ii+1,ii+1)).lt.0.97d0).or.
     1      (dabs(ccm(ii  ,ii  )).lt.0.97d0.and.
     1       dabs(ccm(ii+1,ii+1)).lt.0.97d0))then
          call domao2(ii,ccu,nmo,'+')
          call domao2(ii,ccm,nmo,'-')
          ii=ii+1
         endif
        endif
        if(ii.lt.nmo-1)goto 47

       endif
c      lmao
c
c      for each unperturbed orbital, find the most similar one, and
c      correct phase according to equilibrium and sign of diagonal elements:
       call ct12(nmo,ccm,ind)
       call w36('Orbital flips  - LMO:')
       do 40 ii=1,nmo
40     if(ind(ii).ne.ii)write(6,6009)ii,ind(ii)
6009   format(i5,' -> ',i5)
       call ct12(nmo,ccu,indp)
       call w36('Orbital flips + LMO:')
       do 41 ii=1,nmo
41     if(indp(ii).ne.ii)write(6,6009)ii,indp(ii)
c
c      expansion of |jj> into |kk>
c      first index-unperturbed
       lj1=1
       lk1=1
       d1=0.0d0
       lj2=1
       lk2=1
       d2=0.0d0
       lj3=1
       lk3=1
       d3=0.0d0
       do 101 jj=1,nmo
       do 101 kk=1,nmo
       cp=ccu(kk,indp(jj))
       cm=ccm(kk,ind(jj))
c      first derivatives X+ - X-:
c      fJa = UJa,K fK,   Uja,K=(<K|Ja+>-<K|Ja->)/2d
c      our matrix from direct overlaps:
       u(kk+nmo*(jj-1)+nmo2*(I-1))=cp-cm
       if(dabs(cp-cm).gt.d1)then
        d1=dabs(cp-cm)
        lj1=jj
        lk1=kk
       endif
c              Ukj  +Ujk
       if(dabs(cp-cm+ccu(jj,indp(kk))-ccm(jj,ind(kk))).gt.d3)then
        d3=dabs(cp-cm)
        lj3=jj
        lk3=kk
       endif
c      diagonal second X+ + X- -2:
       if(dabs(cp+cm-2.0d0).gt.d2)then
        d2=dabs(cp+cm-2.0d0)
        lj2=jj
        lk2=kk
       endif
101    u(N*nmo2+kk+nmo*(jj-1)+nmo2*(I-1))=cp+cm-2.0d0

       write(6,6003)lk1,lj1,ccu(lk1,indp(lj1)),ccm(lk1,ind(lj1))
6003   format(/,' Largest difference ',2i5,' plus ',f8.4,
     1 ' minus ',f8.4)
       write(6,6004)lk2,lj2,ccu(lk2,indp(lj2)),ccm(lk2,ind(lj2))
6004   format(/,' Largest second     ',2i5,' plus ',f8.4,
     1 ' minus ',f8.4)
       write(6,6005)lk3,lj3,ccu(lk3,indp(lj3)),ccu(lj3,indp(lk3)),
     1                      ccm(lk3,ind( lj3)),ccm(lj3,ind( lk3))
6005   format(/,' Largest off diagon ',2i5,'+',2f8.4,/,
     1          '                    ',10x,'-',2f8.4)
      endif
      return
      end
c     ============================================================
      subroutine domao3(ii,cco,nmo,pm)
      implicit none
      integer*4 ii,nmo,IERR,ITER,j
      real*8 cco(nmo,nmo),oj1,oj2,cc(3,3),oj3,
     1cnew(3,3),A(3,3)
      character*1 pm

c     first index-equilibrium
      write(6,6103)pm
6103  format(/,' <j',a1,'|k0> : ')
      do 2 j=ii,ii+2
      cc(j-ii+1,1)=cco(j,ii)
      cc(j-ii+1,2)=cco(j,ii+1)
      cc(j-ii+1,3)=cco(j,ii+2)
2     write(6,6102)j,ii,cco(j,ii),j,ii+1,cco(j,ii+1),j,ii+2,cco(j,ii+2)
6102  format(3(2i5,f8.4))

c     rotate three states to maximize the diagonal overlap
      call DOMATRIX(IERR,A,ITER,cc)
      write(6,*)ii,ii+1,ii+2,' rotated',ITER,' iterations'

      do 3 j=1,3
      cnew(j,1)=A(1,1)*cc(j,1)+A(1,2)*cc(j,2)+A(1,3)*cc(j,3)
      cnew(j,2)=A(2,1)*cc(j,1)+A(2,2)*cc(j,2)+A(2,3)*cc(j,3)
      cnew(j,3)=A(3,1)*cc(j,1)+A(3,2)*cc(j,2)+A(3,3)*cc(j,3)
3     write(6,6102)j,1,cnew(j,1),j,2,cnew(j,2),j,3,cnew(j,3)
      
      if(cnew(1,1).lt.0.0d0)then
       A(1,1)=-A(1,1)
       A(1,2)=-A(1,2)
       A(1,3)=-A(1,3)
      endif
      if(cnew(2,2).lt.0.0d0)then
       A(2,1)=-A(2,1)
       A(2,2)=-A(2,2)
       A(2,3)=-A(2,3)
      endif
      if(cnew(3,3).lt.0.0d0)then
       A(3,1)=-A(3,1)
       A(3,2)=-A(3,2)
       A(3,3)=-A(3,3)
      endif

      do 1 j=1,nmo
      oj1=A(1,1)*cco(j,ii)+A(1,2)*cco(j,ii+1)+A(1,3)*cco(j,ii+2)
      oj2=A(2,1)*cco(j,ii)+A(2,2)*cco(j,ii+1)+A(2,3)*cco(j,ii+2)
      oj3=A(3,1)*cco(j,ii)+A(3,2)*cco(j,ii+1)+A(3,3)*cco(j,ii+2)
      cco(j,ii  )=oj1
      cco(j,ii+1)=oj2
1     cco(j,ii+2)=oj3
c
      return
      end
c     ============================================================
      SUBROUTINE DOMATRIX(IERR,A,ITER,c)
C     This is a Fortran version of Petr Malon's SUBROUTINE Amoeba
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      real*8 ANG(3),P(4,3),Y(4),PBAR(3),PR(3),PRR(3),
     1A(3,3),c(3,3)
      IERR=0
C     STARTING VALUES FOR THE ITERATION:
      ANG(1)=2.1d0
      ANG(2)=0.0d0
      ANG(3)=0.0d0
      DO 1 I=1,3
1     P(1,I)=ANG(I)
      Y(1)=FU(A,c,ANG)

      ANG(1)=0.0d0
      ANG(2)=0.1d0
      ANG(3)=2.1d0
      DO 2 I=1,3
2     P(2,I)=ANG(I)
      Y(2)=FU(A,c,ANG)

      ANG(1)=0.2d0
      ANG(2)=2.1d0
      ANG(3)=0.0d0
      DO 3 I=1,3
3     P(3,I)=ANG(I)
      Y(3)=FU(A,c,ANG)

      ANG(1)=1.4d0
      ANG(2)=0.0d0
      ANG(3)=0.1d0
      DO 4 I=1,3
4     P(4,I)=ANG(I)
      Y(4)=FU(A,c,ANG)

      FTOL=1.0d-9
      ITMAX=1500
      ITER=0
99999 ILO=1
      IF(Y(1).GT.Y(2))THEN
       IHI=1
       INHI=2
      ELSE
       IHI=2
       INHI=1
      ENDIF
      DO 5 I=1,4
      IF(Y(I).LT.Y(ILO))ILO=I
      IF(Y(I).GT.Y(IHI))THEN
       INHI=IHI
       IHI=I
      ELSE
       IF(Y(I).GT.Y(INHI))THEN
        IF(I.NE.IHI)INHI=I
       ENDIF
      ENDIF
5     CONTINUE
      IF(ABS(Y(IHI))+ABS(Y(ILO)).LT.1.0d-10)THEN
       RTOL=0.0d0
      ELSE
       RTOL=ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))*2.0d0
      ENDIF
      IF(RTOL.LT.FTOL)then
       RETURN
      endif
      IF(ITER.EQ.ITMAX)THEN
       WRITE(6,*)' Rotation has not converged !'
       IERR=1
       RETURN
      ENDIF
      ITER=ITER+1
      DO 55 I=1,3
55    PBAR(I)=0.0d0
      DO 6 I=1,4
      IF(I.NE.IHI)THEN
       DO 7 J=1,3
7      PBAR(J)=PBAR(J)+P(I,J)
      ENDIF
6     CONTINUE
      DO 8 J=1,3
      PBAR(J)=PBAR(J)/3.0d0
8     PR(J)=2.0d0*PBAR(J)-P(IHI,J)
      YPR=FU(A,c,PR)
      IF(YPR.LE.Y(ILO))THEN
       DO 9 J=1,3
9      PRR(J)=2.0d0*PR(J)-PBAR(J)
       YPRR=FU(A,c,PRR)
       IF(YPRR.LT.Y(ILO))THEN
        DO 10 J=1,3
10      P(IHI,J)=PRR(J)
        Y(IHI)=YPRR
       ELSE
        DO 11 J=1,3
11      P(IHI,J)=PR(J)
        Y(IHI)=YPR
       ENDIF
      ELSE
       IF(YPR.GE.Y(INHI))THEN
        IF(YPR.LT.Y(IHI))THEN
         DO 12 J=1,3
12       P(IHI,J)=PR(J)
         Y(IHI)=YPR
        ENDIF
        DO 13 J=1,3
13      PRR(J)=0.5d0*P(IHI,J)+0.5d0*PBAR(J)
        YPRR=FU(A,c,PRR)
        IF(YPRR.LT.Y(IHI))THEN
         DO 14 J=1,3
14       P(IHI,J)=PRR(J)
         Y(IHI)=YPRR
        ELSE
         DO 15 I=1,4
         IF(I.NE.ILO)THEN
          DO 16 J=1,3
          PR(J)=0.5d0*(P(I,J)+P(ILO,J))
16        P(I,J)=PR(J)
          Y(I)=FU(A,c,PR)
         ENDIF
15       CONTINUE
        ENDIF
       ELSE
        DO 17 J=1,3
17      P(IHI,J)=PR(J)
        Y(IHI)=YPR
       ENDIF
      ENDIF
      GOTO 99999
      END

      FUNCTION FU(A,c,ANG)
      implicit none
      REAL*8 S1,S2,S3,C1,C2,C3,A(3,3),ANG(3),FU,c(3,3),
     1c11,c22,c33
      S1=SIN(ANG(1))
      S2=SIN(ANG(2))
      S3=SIN(ANG(3))
      C1=COS(ANG(1))
      C2=COS(ANG(2))
      C3=COS(ANG(3))
C     ang1 = theta
C     ang2 = phi
C     ang3 = cappa
      A(1,1)=C1*C2*C3-S2*S3
      A(1,2)=C1*S2*C3+C2*S3
      A(1,3)=-S1*C3
      A(2,1)=-C1*C2*S3-S2*C3
      A(2,2)=-C1*S2*S3+C2*C3
      A(2,3)=S1*S3
      A(3,1)=S1*C2
      A(3,2)=S1*S2
      A(3,3)=C1
c     <10|1new>
      c11=A(1,1)*c(1,1)+A(1,2)*c(1,2)+A(1,3)*c(1,3)
c     <20|2new>
      c22=A(2,1)*c(2,1)+A(2,2)*c(2,2)+A(2,3)*c(2,3)
c     <30|3new>
      c33=A(3,1)*c(3,1)+A(3,2)*c(3,2)+A(3,3)*c(3,3)
      FU=-c11**2-c22**2-c33**2
      RETURN
      END
C
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
c     ============================================================
